#!/usr/bin/perl
# *** P85x version 0.1          -- date: March 25 2017 ***
# *** ==version P85x version 0.085
# Philips P853/P854/P858/P859 emulator
#
# After boot, enter date (YYMMDD) and time (HHMM)
#
###p85x-0085.md (main)
my $version = "0.1";
#
# !!not implemented yet:
# !! - PAGE MODIFIED BIT (la2pa_store, extendedaddr_store)
# !! - PAGE FAULT trap
# !!
# modifications:
# ==============
# 
# 0.04 => TL* changed
#         TL..,TS changed for extended system mode
# 0.041 mmu routines
# 0.042 bigdisk cu changed / el-es-mvsu-mvus addressing changed
# 0.043 disk logging, cio ipl bd0: ic=1
# 0.044 UM = implicit ENB; LKM skips DATA if INH; RTN does not set EM on P856
#            >>>>>>>>>>>>>>>runs P856 with DOS5.img<<<<<<<<<<<<<<<<<<<<<<<<<
# 0.045 instruction decode for trace
# 0.046 print replaced by prlog; step, either s or S
# 0.047 $ea inserted, various errors and break code adapted for memory > 32kw
# 0.048 cdc disk cu: error removed from datachain code + various other errrors removed.
#            sst ty returns 0 even if not accepted
#            >>>>>>>>>>>>>> starts MASR,FCL,++     <<<<<<<<<<<<<<<<<<<<<<<<<
# 0.050 instruction decode (decode command)
# 0.051 TST bigdisk sets effective length for a read
#            another error removed from the bigdisk datachain code (string pointer was reset)
#            >>>>>>>>>>> now LIB is working as well <<<<<<<<<<<<<<<<<<<<<<<<
# 0.052 bigdisk: write home address (unit 1) + panel interrupt handling
#               ???? alleen een insert /D als bij de switch van 0=> een cio stop gegeven is ????
# 0.053 EL*/ES* extended indirect addressing changed (went wrong with Panel interrupt DM)
#           added to @BD1 TST and SST processor
#           boots now from bd0 and bd1 !
# 0.056 introduces a 2nd tty (TY1)
# 0.057 working with TY0(ty10) and TY1(ty11). Loads patchfile during init
#       attaches bd0 and lp.txt by default
# 0.058 improved cr/lf handling on consoles
# 0.059 (on/off ptr 1705) TY2 cio partly!! init/initstat weghalen? FCL herkenning ty0 weghalen?
# 0.060 old patch load mechanism removed
#       check abend: runs into a page fault >>> solved with next EL change
#       EM check added in EL/ES instructions (remove later)
#       EL/ES changed (diff system/extended mode)
#       lineprinter control character handling adapted (skip before)
#       win command, LOW function
# 0.061 Bigdisk write sector: working (with bd1), with debug code still included.
#       read from ptr, saves file to disk, print file from disk, file in dir
# 0.062 ty0 new line control
# 0.064 ty2
# 0.065 inserts ptp /30; (INH => switch to system mode (UM => 0)<< dit werkt NIET)
#       interrupt enable only with ENB (not UM)
# 0.066 inserts the ldhbased command
# 0.067 error in SUS, overflow reset in all instructions using overflow
#       >>>>>>>>>>>>>>>>>> working with MAS LKE <<<<<<<<<<<<<<<<<<<<<<
# 0.068 some editing
# 0.068a  -X1216 support added for X1216 MAS
#       -4 filenames added for the X1216 images
#       -the 4 X1216 files are attached to md0,md1,md2,md3 (boot from md1)
#       -read X1216 sector ident word changed: took 1 byte; now 2bytes to allow for 1024 cylinders
#       -X1216 A15 boot words added
#       -multiplexer code changed for memory > 32kw (code was wrong)
#       -boot code changed to allow for X1216 boot
#       -reset the MMU changed
#       -error removed from XRKL
#        note: 
#        ====
#        It is still possible to boot from a X1215 disk if the P856 config flag is set.
#        However it is not possible to boot a X1215 p856 DOS disk on a P854/8/9:
#        -implemented is then the P854/8/9 internal interrupt and psw layout, which differs from p856/57
#
# 0.068b -X1215/16 unit drives linked again => P859/Bigdisk boots, P856/DOS5 boots from md0/md1
#       -decode
#       -MVS adapted
# 0.068c -logical address input option for examine
#       -logical address input option for deposit
#       -adapt WER to allow 3 WER's for mpx channel setup
#       -multiplexer code changed to allow for 3 WER's     => P859 MASRA boots from md1
#       -new patchfile for MASR: TY1 got address 8 and TY2 address 9
#       -panel interrupt: P856/58/59 (DOS/MASR) use priority level 7; p854 (MASRA) uses level 3
# 0.07  -adds a Perl/Tk window environment (for P856 to start with)
#       -sysflag messages with * removed (* sometimes a problem)
#       -runs P856 in 3 windows: control panel, TY0, and LPT
# 0.071 -boot code for BD0 adapted for running in a window
#       -TY1 and TY2 added
#       -runs P856 (DOS) and P854/8/9 with 3 tty's each in a tty window (MASR)
# 0.072 -runs also MASRA on P854/8/9. All tests sofar under Linux.
#       -runs as well under Windows (XP)
# 0.073 -is 0.072 but split in modules
# 0.074 -start adding a floating point processor (P857/8/9 type)
#       -ptr interrupt level changed
#       -MASRA: loads patchfile => runs (3 tty + ptr)
#       -$RUN=0 moved to keyevent
#       -MASR: new patch file => runs
#       -DOS5 runs
# 0.075 -teletype backspace handling
#       -lineprinter lp07 inserted in the patch file
# 0.076 -control panel ptr attach file support
#       -FPP instructions added to the decoder.
#       -control panel buttons
# 0.078 -TY2 adds ANSI terminal functions (p85x-078.pm,wintk1.pm,ty2_1.pm)
# 0.079
# 0.080
# 0.081 
# 0.082 .pm => .md
# 0.083 -X1216 disk activity
#       -RUN=>STOP=>CONT | MC
#       -TY2 ANSI terminal function optional
# 0.084 -cleanup; TY2 fast TTY
# 0.085 -trace r option: only traces program instructions in a particular region, including
#        symbolic tracing
# 0.1   -1st published version (=0.085)

# note:
# dos boekje p855 blz 22 zegt dat RUN, ENB, LKM niet op de stack worden gesaved met een interrupt of een CF

########### TODO   ###########
# - Page modified bit to be set with "store" instructions
# - The TST instruction for the Big disk (result in register) :
#   cu busy => bit15 = 1
#   cu not busy => bits 1--14 transfered length (??? only with read ??? now always, which probably is wrong)
#   BIGD  cu bit0 = 0
#   BIGD2 cu bit0 = 1 (both in case of busy and not busy ??)
#   floating point not completed
#   ansi terminal not completed
################################################################################################
use strict;
use bytes;
use Term::ReadKey;
use Time::HiRes qw(gettimeofday tv_interval);
use IO::Handle;
use Tk;

my $filebd0;    # 80Mb CDC disk image
my $filebd1;    # 80Mb CDC disk image
my $filemd0;    # X1215/16 disk /02 cartridge image
my $filemd1;    # X1215/16 disk /22 fixed disk image
my $filemd2;    # X1215/16 disk /12 cartridge image
my $filemd3;    # X1215/16 disk /32 fixed disk image
my $patchmasr;  # MASR patchfile
my $patchmasra; # MASRA patchfile

# CONFIGURATION
# =============
# the bits in the internal interrupt register are allocated as follows (according PSW and P856/P857):
#     xxxxx
#     ^^^^0
#     ||||LKM
#     |||RTC
#     ||PWR
#     |CP
#
# 0n P853/P854/P858/P859
#     xxxxx
#     ^0^0^
#     | | |LKM
#     | |
#     | |PWR
#     |CP


use constant DEBUG_BD => 0;  # 1 shows CDC disk Control Unit messages
use constant DEBUG_EM => 0;  # 1 shows Extended Memory messages
use constant DEBUG_TY => 0;  # 1 shows TTY Control Unit messages
use constant DEBUG_FPP => 1; # 1 shows FPP messages
my $DEBUG   = 0;             # 1 to show debug information

# The simulator can either run as a P853/4/8/9 or as a P856 (not as a P857 because the
# two available MAS systems (MASR on bigdisk of MASRA on X1216 disk) are generated for
# P853/4/8/9. The internal interrupts / PSW of P853/4/8/9 are different from the P857)
# 
# To configure a P853/4/8/9, uncomment lines 190,192-195,215,216,220
# In case MASR should be used, also uncomment lines 199..204. (comment lines 207..212)
# In case MASRA should be used, uncomment lines 207..212 (comment lines 199,,204)
# Comment lines: 235,236,237,239,240,241,242,245,246,247,250,251

# To run the simulator as a P856:
# Uncomment lines: 235,236,237,239,240,241,242,245,246,247,250,251
# Comment lines: 190,192-195,199-204,207-212,215,216,220

# Default files for running the simulator are specified below.


### in case a P853/4/8/9 is to be configured:
#######################################################################################################
### to run p85x as a p853/4/8/59 with either bigdisks (MASR) or 4*X1216's (MASRA)

my $P856 = 0;               # to run p85x as a P853/4/8/59
# The internal interrupts as in the internal interrupt register (and in the PSW):
use constant CP   => 0x10;  # control panel interrupt
use constant PWR  => 0x04;  # power failure interrupt
use constant RTC  => 0x08;  # real time clock interrupt (not in psw)
use constant LKM  => 0x01;  # link monitor interrupt + stack overflow

### priority interrupts
### MASR is used (on cdc disk):
my $MASR   = 1;
my $MASRA  = 0;
use constant IFPP   => 0x08000000;     # Floating Point Processor    (4)
use constant IPTR   => 0x04000000;     # Papertape reader            (5)
use constant ICP    => 0x01000000;     # Panel interrupt             (7) internal interrupt
use constant IPTP   => 0x00020000;     # Papertape punch             (/E)

### MASRA is used (on X1216 disk):
#my $MASRA = 1;
#my $MASR  = 0;
#use constant ICP    => 0x10000000;     # Panel interrupt             (3) internal interrupt
#use constant IFPP   => 0x08000000;     # Floating Point Processor    (4)
#use constant IPTR   => 0x04000000;     # Papertape reader            (5)
#use constant IPTP   => 0x00020000;     # Papertape punch             (/E)

### The Memory size
use constant MEMSIZE => 0x00040000;     # 256 kbytes
use constant MAXADDR => 0x0003FFFE;

### no floating point processor if FPP==0
###                a p854/9 FPP if FPP==1
my $FPP = 0;       # floating point processor


### no ANSI functions in TY2
# (###insert ty2.md teletype)
# 

### ANSI functions in TY2
# (###insert ty2_2.md ###insert ty2_esc_1.md)
#

### in case a P856 is to be configured:
#######################################################################################################
### to run p85x as a p856 with 4*X1215's (DOS5)

#my $P856  = 1;               # to run p85x as a P856
#my $MASR  = 0;
#my $MASRA = 0;
### The internal interrupts as in the internal interrupt register (and in the PSW):
#use constant CP   => 0x10;  # control panel interrupt
#use constant PWR  => 0x08;  # power failure interrupt
#use constant RTC  => 0x04;  # real time clock interrupt (not in psw)
#use constant LKM  => 0x02;  # link monitor interrupt + stack overflow

### priority interrupts
#use constant IPTR   => 0x08000000;     # Papertape reader            (4)
#use constant IPTP   => 0x04000000;     # Papertape punch             (5)
#use constant ICP    => 0x01000000;     # Panel interrupt             (7) internal interrupt

### The Memory size
#use constant MEMSIZE    => 0x00010000;       # 32 kW;
#use constant MAXADDR    => 0x0000FFFE;

### no floating point processor if FPP==0
###                a p854/9 FPP if FPP==1
#my $FPP = 0;      # floating point processor
#######################################################################################################																											]

# Default attached files
if(! $P856)
{
	# For the P854/8/59 simulation
	$filebd0 = "mas900_1.cdc";        #                     <<< boot bd0 (MASR)
	$filebd1 = "";
	$filemd0 = "DATA.x16";            # disk /02 cartridge
	$filemd1 = "MAS812.x16";          # disk /22 fixed disk <<< boot md1 (MASRA)
	$filemd2 = "";                    # disk /12 cartridge
	$filemd3 = "";                    # disk /32 fixed disk
	$patchmasr  = "patch3b.hex";      # patchfile for MASR on bigdisk
	$patchmasra = "patchmasra1.hex";  # patchfile for MASRA on X1216
}
else
{
	# For P856 simulation
	$filemd0 = "dos5.img";            # disk /02 cartridge <<< boot md0
	$filemd1 = "emptyX1215pack.img";  # disk /22 fixed disk
	$filemd2 = "";                    # disk /12 cartridge
	$filemd3 = "";                    # disk /32 fixed disk
	$filebd0 = "";
	$filebd1 = "";
}

my $filelpt        = "lp.txt";            # lineprinter file (default)
my $logfile        = "log.txt";           # log file (default)
my $tracefile      = "";                  # tracefile name in case specified
my $StopOnIllInstr = 1;                   # stop on illegal instruction
my $StopOnIllDev   = 1;                   # stop on illegal device
my $StopOnMpxError = 1;                   # stop on an illegal mpx condition

# END CONFIGURATION
################################################################################################

# limitations:
#=============
# 1) there is no "user mode", the CPU operates always in "system mode".
#    (LKM, traps, interrupts switch to system mode by setting the UM flipflop to 0. 
#     The SMD operation sets the UM flopflop to 1. As the cpu operates always in 
#     system mode however: there is no checking on illegal use of registers and 
#     instructions in user mode)
# 2) high speed arithmetic and the multiplex channel (IOP) are implemented
# 3) no floating point unit
#
# version 0.00 is based on P856 version 0.41 -- date: June 18 2012
#
#
# Author: Theo Engel
# Info:   Info@theoengel.nl
#
# Usage:  p85x-xx.pl [<do-script-name>]  (where xx is some version number)
#
# The emulator is built as a prototype, because at least some hardware details of the original 
# P853/4/7/8/9 are still lacking. The emulator is partly based on concepts used in SIMH (e.g. the event 
# mechanism). Also the control commands mirror some of the SIMH scp commands.
# (for SIMH, look at simh.trailing-edge.com)
#
# Currently implemented control commands:
# - run [<paddress>]                                    (includes reset-all)
# - go  [<paddress>]                                    (like run, but no reset)
# - continue|c                                          (continue; eg. after a breakpoint stop)
# - step|s [<nbr of instructions to execute>]           (no argument = execute 1 instruction)
# - do <filename>                                       (filename is name of the do-script)
# - breakpoint|bp set|s   <breakpoint paddress>         (set breakpoint (physical address)
# - breakpoint|bp clear|c <breakpoint paddress>|all|a   (clear one or all breakpoints)
# - breakpoint|bp print|p                               (show active breakpoints)
# - examine|ex <register>                               (show register content)
# - examine|ex lm <laddress>                            (interactively shows content of <address>, <address>+2, .. until s is replied)
# - examine|ex m <paddress>                             (interactively shows content of <address>, <address>+2, .. until s is replied)
# - deposit|de <register> [<16 bit hex value>]          (in case no content specified, then it is requested from the keyboard)
# - deposit|de lm <laddress>                            (interactively changes content of <address>, <address>+2, .. until s is replied)
# - deposit|de lm <laddress> <16 bit hex value>         (put <value> at <address>
# - deposit|de m <paddress>                             (interactively changes content of <address>, <address>+2, .. until s is replied)
# - deposit|de m <paddress> <16 bit hex value>          (put <value> at <address>
# - reset [cpu|tty|rtc|ptr|ptp|lpt|crd|md0|md1|md2|md3|mem|power] (no argument = reset-all; reset power = reset-all + reset-mem + P=0)
# - trace [on|off] [<filename>]                         (no argument = on; traceoutput => file in case file is specified)
# - rtrace|rt on|off <pla> [<pba> <pea>] (p=physical)   (trace instructions executed between <pba> and <pea>; <pla>=load addr; <pba>,<pea> rel to <pla>)
#                                                       (no <pba>/<pea> => <pba>=start userarea batch machine (batch only running, no foreground)
# - load <filename.abs>                                 (load absolute (8*8 format) executable with an .abs extension)
# - load <filename.rel>|<filename.LM|lm> <address>|mon  (load relocatable with a .rel or .LM extension at <address>) (mon loads a monitor at address 0)
# - ldhex|ldh [s] <filename.hex>                        (load absolute (hex format); with s specified, file content is printed)
# - boot ptr [h|r]                                      (h=halt,r= run after load; no argument = run, starting at 1st address)
# - boot bd0|bd1 [h|r]                                  (ipl from bdx; h=halt,r= run after load; no argument = run)
# - boot md0|md1|md2|md3 [x1216] [h|r]                  (ipl from mdx; h=halt,r= run after load; no argument = run)
# - attach|att ptr|ptp|lpt|crd|md0|md1|md2|md3|bd0|bd1  <filename> (attach a simulated peripheral to a file)
# - detach|det ptr|ptp|lpt|crd|md0|md1|md2|md3|bd0|bd1  disconnect simulated peripheral from the attached file
# - state [cpu|mmu|tty|rtc|lpt|md0|md1|md2|md3|bd0|bd1|pcs] (no argument = state all simulated devices)
# - queue|q                                             (show event queue)
# - echo <string>                                       (character string is displayed on console)
# - dump|du <pba> <pea> [<fn.abs>]                      (dump in hex memory area on screen or on papertape in abs 8+8 format)
# - console 64|128                                      (select either 64 or 128 character set; 64 is default)
# - rtc [on|off]                                        (start/stop realtime clock; ask state in case of no argument)
# - log [on|off] | <file>                               (log command progress in a logfile; off switches logging off; on resumes logging)
# - decode|dec <lba> <lea>                              (show decoded instructions of the requested memory area)
# - exit
#
# |    means logical OR
# [..] means OPTIONAL argument
# <paddress> is a hex value of 0..FFFFF (physical address)
# <laddress> is a hex value of 0..FFFF  (logical address)
# <register> is P,A0..A15
# <string> is double quoted character string and may include codes like \n
# <pba> is physical begin address; <pea> is physical end address
# <lba> is logical begin address;  <lea> is logical end address
# The key combination CntrE stops the emulation
# The key combination CntrP simulates a Panel interrupt
# do-scripts do not support arguments
#
# The following devices are currently are supported:
#  1) TTY - keyboard/printer (ASR)
#  2) High speed papertape reader (PTR)  - Digitronics 25540EP, 333/600 cps
#  3) High speed papertape punch (PTP)   - Facit 4070, 75 cps
#  4) Real time clock (RTC)              - Variable frequency (set to 50Hz)
#  5) Line printer (LPT)                 - Data products, 132col, 245/670 lpm
#  6) Moving head disk (MD0,MD1,MD2,MD3) - 2 * Philips X1215/16 (two units, 4 spindels)
#  7) Moving head disk (BD0,BD1) on DMA  - 2 * CDC 80 Mb disk (2 units/2 spindels)
#  8) Single IOP (address 0), connecting: LTP, CRD and MD0/MD1/MD2/MD3 on 3 subchannels
#  9) A 2nd and 3rd TTY (TY1/TY2)
#
# Adaptions required to run another preconfigured monitor (without adding peripherals/iop's):
# 1) allocated priority interrupts (bit constants) 
# 2) allocated device addresses (%DEV)
#
# Questions/Remarks
# 1) which part of the PSW is stored/restored on/from the stack?
#    assumptions:
#    - CF           : whole PSW stored on the stack
#    - Interrupt    : whole PSW stored on the stack
#    - Depending on the register being used, part of the PSW is restored with RTN:
#      RTN always restores saved CR; 
#      RTN A15 also restores the saved PLR/UM-bit from stack and enables interrupt (P855,P860,P852)
#      (different on P856,P857: copies ENB bit from stack) 
#      However this implementation mimics the P855/P860/P852 behaviour at this moment: changed in version 0.32 to P856/57 behaviour
#
# 2) reset state? ENB=1? PL=00? 
#    The P856/57 Service Manual provides the answer (page 1-6 chapter 1.20) "At power-on time
#    and at every Master Clear from the control panel:
#    - the CPU is set to Enable interrupt mode,
#    - program level is set to 63
#    - all internal and external interrupts are reset
#    
#    However, Pushing the IPL button puts the CPU in inhibit state (P856/P857 System Handbook page 13-2)
#    This implementation has at this moment for debugging: ENB=0 an PL=63 as reset state
#
# 3) adapt LDKL, ADKL SUKL so they load proper A0?
#    CWK instruction changed to make it possible to compare the long constant
#    with the proper value of register P (instruction address + 4)
#    still adapt LDKL, ADKL SUKL ?? (other long constant instructions are not allowed to 
#    have A0 as r1)
#
# 4) The double shift instructions DLA,DRA,DLN,DRN bypass bit-0 of A2
#    On the P855/P860?? and certainly on P852/P856/P857 bit-0 of A2 is
#    not changed during shift actions. On later models P854 .. bit-0
#    of A2 is always reset to 0 (also in case of shift count = 0). In this
#    implementation bit-0 of A2 is always reset to 0 (at this moment)
#
# 5) For some instructions on the real machine the l/s bit is not significant 
#    and may contain a 0 or a 1. The assembler puts in those cases always a 0
#    in the l/s bit In this implementation (at this moment) a 0 is always assumed 
#    in the l/s bit in those cases. A 1 will result in the detection of an illegal
#    instruction.
#
# Todo:
# 1) The disk ready mechanism needs a change to make it possible to
#    change a disk (cartridge) after to system is booted
# 2) The trap mechanism needs a change: a trap is not a (priority) interrupt
#    and is also possible when the CPU is in inhibit mode. A trap does
#    not change the priority level (operates like a CFI A15,/7E)
#    (done in version 0.32)
#
# Differences P856 with the P855/860 (on hsi level)
# - interrupt system: 
#   -interrupt locations at other place in memory           V
#   -no common line: all interrupts handled by priority     V
#   -RTN A15 restores PLR, CR, ENB, SU from the stack
#    (on P855,860 and 852, ENB is always set to 1)          V
#   -remove P855/P860 set mask/read mask instructions       V
#   -on P855/860 a  stackoverflow interrupt is generated
#    when the A15 stackpointer is /100. On the P856/57
#    the stack overflow interrupt is generated when the
#    A15 stack becomes < /100                               V
#   -on the P855/860 an invalid instruction code generates
#    an LKM interrupt (when the interrupt is enabled). On the
#    P852/56/57 an invalid instruction generates a trap to
#    location /7E also when the interrupt is not enabled.   V
#    the trap acts like an interrupt: 
#    - invalid instruction not attemted to be executed
#    - instruction address and processpor state saved in stack
#    - interrupts are inhibited (if notyet inhibited)
#    - an indirect branche is made to location /7E: to the trap routine
#    - the program level (PLR) is NOT changed.
#    (a trap to /7E is also generated when a privileged instruction is
#     executed in User Mode or when the A15 stack is use in User Mode.
#     This behaviour is however not(yet) implemented)
# - multiplex channel replaced by IO processors
#   -IO processor channels controlled by WER instructions and external registers V
#   -BOOT from device using IOP iso MPX is different        V
# - device drivers
#   - other interrupt mechanism (priority iso common line)  V
#   - mpx => iop registers                                  V
# - a few additional instructions:
#   - 2-COMPLEMENT: NGR                                     V
#   - CLEAR MEMORY: CMR, CM, CM*                            V
#   - EXECUTE: EXR, EXR*, EXK, EX, EX*                      V
#   - WRITE EXTERNAL REGISTER: WER                          V
#   - READ  EXTERNAL REGISTER: RER                          V
# - RTC: no start/stop with CIO instruction but via
#   control panel                                           V
# - Moving head disk differs in several ways
#   -X1210 had 203 cylinders, the X1215 (connected to P856) had 204 cylinders
#   -CIO SEEK operation (absolute cylinder iso delta)       V
#   -2 disks/4 heads with single actuator position per unit V
#   -drive ready mechanism
#   -status word bits                                       V
#   -CU supports 2 units/4 drives                           V
#
# Differences P854/8/P859 with the P856 (on hsi level)
# - Commands: attach/detach, state, reset, ...              V
# - Adapt commands for 20 bit program counter               V
# - MMU to support memory > 32kwords                        V
# - 2nd WER format changed and/or 3rd WER (m>128kw)         V
# - + extended system mode (PSW, etc)                       V
# - layout psw/internal interrupts (LKMbit and EMbit!)      V
# - additional instructions:
#   - Load Address: LDA                                     V
#   - Extended Load: ELR, EL, EL*                           V
#   - Extended Store: ESR. ES, ES*                          V
#   - Test and Set Bit: TSBR, TSB, TSB*
#   - Test and Reset Bit: TRBR, TRB, TRB*
#   - segment Table Load: TLR, TL, TL*                      V
#   - segment Table Store: TSR, TS, TS*                     V
#   - Move Table Forward: MVF                               V
#   - Move Table Backward: MVB                              V
#   - Move Table from User to System area: MVUS             V
#   - Move Table from System to User area: MVSU             V
#   - Move string: MVS                                      V
#   - Move A1: MVA                                          V
#   - Compare String: CS                                    V
#   - Compare A1: CA                                        V
# - Big disk support (80M CDC)                              V
# - X1216 disk support (additional cylinders)               V
# 
#
#
# ascii conversion table
my %ch;
$ch{0x20}=' ';
$ch{0x21}='!';
$ch{0x22}="\"";
$ch{0x23}="\#";
$ch{0x24}='$';
$ch{0x25}='%';
$ch{0x26}='&';
$ch{0x27}="\'";
$ch{0x28}='(';
$ch{0x29}=')';
$ch{0x2a}='*';
$ch{0x2b}='+';
$ch{0x2c}=',';
$ch{0x2d}='-';
$ch{0x2e}='.';
$ch{0x2f}="\/";
$ch{0x30}='0';
$ch{0x31}='1';
$ch{0x32}='2';
$ch{0x33}='3';
$ch{0x34}='4';
$ch{0x35}='5';
$ch{0x36}='6';
$ch{0x37}='7';
$ch{0x38}='8';
$ch{0x39}='9';
$ch{0x3a}="\:";
$ch{0x3b}="\;";
$ch{0x3c}='<';
$ch{0x3d}='=';
$ch{0x3e}='>';
$ch{0x3f}='?';
$ch{0x40}='@';
$ch{0x41}='A';
$ch{0x42}='B';
$ch{0x43}='C';
$ch{0x44}='D';
$ch{0x45}='E';
$ch{0x46}='F';
$ch{0x47}='G';
$ch{0x48}='H';
$ch{0x49}='I';
$ch{0x4a}='J';
$ch{0x4b}='K';
$ch{0x4c}='L';
$ch{0x4d}='M';
$ch{0x4e}='N';
$ch{0x4f}='O';
$ch{0x50}='P';
$ch{0x51}='Q';
$ch{0x52}='R';
$ch{0x53}='S';
$ch{0x54}='T';
$ch{0x55}='U';
$ch{0x56}='V';
$ch{0x57}='W';
$ch{0x58}='X';
$ch{0x59}='Y';
$ch{0x5a}='Z';
$ch{0x5b}='[';
$ch{0x5c}="\\";
$ch{0x5d}=']';
$ch{0x5e}='^';
$ch{0x5f}='_';

 # digit conversion
my %cvdig;
$cvdig{'0'}=0x0;
$cvdig{'1'}=0x1;
$cvdig{'2'}=0x2;
$cvdig{'3'}=0x3;
$cvdig{'4'}=0x4;
$cvdig{'5'}=0x5;
$cvdig{'6'}=0x6;
$cvdig{'7'}=0x7;
$cvdig{'8'}=0x8;
$cvdig{'9'}=0x9;
$cvdig{'A'}=0xa;
$cvdig{'B'}=0xb;
$cvdig{'C'}=0xc;
$cvdig{'D'}=0xd;
$cvdig{'E'}=0xe;
$cvdig{'F'}=0xf;

# register conversion table
my %R16;
$R16{"P"}   = 0;        # 0000
$R16{"PC"}  = 0;        # 0000
$R16{"A0"}  = 0;        # 0000
$R16{"A1"}  = 0x2;      # 0010
$R16{'A2'}  = 0x4;      # 0100
$R16{'A3'}  = 0x6;      # 0110
$R16{'A4'}  = 0x8;      # 1000
$R16{'A5'}  = 0xA;      # 1010
$R16{'A6'}  = 0xC;      # 1100
$R16{'A7'}  = 0xE;      # 1110
$R16{'A8'}  = 0x1;      # 0001
$R16{'A9'}  = 0x3;      # 0011
$R16{'A10'} = 0x5;      # 0101
$R16{'A11'} = 0x7;      # 0111
$R16{'A12'} = 0x9;      # 1001
$R16{'A13'} = 0xB;      # 1011
$R16{'A14'} = 0xD;      # 1101
$R16{'A15'} = 0xF;      # 1111

# register index conversion table
my @A;
$A[0]  = 0x0;
$A[1]  = 0x2;
$A[2]  = 0x4;
$A[3]  = 0x6;
$A[4]  = 0x8;
$A[5]  = 0xA;
$A[6]  = 0xC;
$A[7]  = 0xE;
$A[8]  = 0x1;
$A[9]  = 0x3;
$A[10] = 0x5;
$A[11] = 0x7;
$A[12] = 0x9;
$A[13] = 0xB;
$A[14] = 0xD;
$A[15] = 0xF;

my @Reg;
$Reg[0]  = 'A0';
$Reg[1]  = 'A8';
$Reg[2]  = 'A1';
$Reg[3]  = 'A9';
$Reg[4]  = 'A2';
$Reg[5]  = 'A10';
$Reg[6]  = 'A3';
$Reg[7]  = 'A11';
$Reg[8]  = 'A4';
$Reg[9]  = 'A12';
$Reg[10] = 'A5';
$Reg[11] = 'A13';
$Reg[12] = 'A6';
$Reg[13] = 'A14';
$Reg[14] = 'A7';
$Reg[15] = 'A15';

# register symbols
use constant P   => 0x0;
use constant PC  => 0x0;
use constant A0  => 0x0;
use constant A1  => 0x2;
use constant A2  => 0x4;
use constant A3  => 0x6;
use constant A4  => 0x8;
use constant A5  => 0xA;
use constant A6  => 0xC;
use constant A7  => 0xE;
use constant A8  => 0x1;
use constant A9  => 0x3;
use constant A10 => 0x5;
use constant A11 => 0x7;
use constant A12 => 0x9;
use constant A13 => 0xB;
use constant A14 => 0xD;
use constant A15 => 0xF;

my $RUN=0;
my $ENB=0;

# instruction decoder tables
my %IDir;  # direct translated instruction codes
my %IDirl; # direct translated instruction codes
my %IL1;   # format 1 long constant instruction codes (r2=0)
my %ILS;   # format 1 instructions with r1=0
my %I1;    # format 1 instruction codes, using r1 and r2
my %IFPP;  # format 1 FPP instructions
my @R2;    # register strings: A0..A15
my @R3;    # register strings: A0..A7
my @CND;   # condition codes: (0)..(7)

###insert wintk2.md (the windows environment)
### wintk2.md
# The windows environment
#===============================================================================
# terminal 1 (TY1)
my $ty1w;                     # TY1 window
my $ty1;                      # TY1 textbox
my $ty1key=0;
my $ty1tty=1;                 # mode: 1=> tty mode;   0=>ansi mode
#
# terminal 2 (TY2)
my $ty2w;                     # TY2 window
my $ty2;                      # TY2 textbox
my $ty2key=0;
my $ty2tty=1;                 # mode: 1=> tty mode;   0=>ansi mode

# For the ansi mode option:
my $ty2escseq    = "TTY terminal mode";
my $ty2esccnt    = 0;         # esc sequence state
my $ty2echo      = 0;         # echo off
my $ty2efl;                   # visual echo flag
my $ty2ifl;                   # visual insert flag
my $ty2afl;                   # visual CtrlA flag
my $ty2tkl=1;   my $ty2tkc=0; # Tk cursor position numeric: initial values, line/colum
my $ty2pl;      my $ty2pc;    # program cursor position as strings
my $ty2tklsave; my $ty2tkcsave; # saved numeric cursor position
my $ty2CtrlA=0;               # Ctrl-A flag
my $ty2ix; my $ty2iy; my $ix; my $iy; # visial cursor position

# When the computer is switched on: insert mode.
my $ty2Insert=1;              # insert mode flag (0=>overstrike)
#
#
# Define, initiate and maintain the windows for runnning the simulator.
my $control=0;  # shared by all teletypes
my $key;        # shared by all teletypes
my $CtrlP=0;    # shared by all teletypes
my $CtrlE=0;    # shared by all teletypes
my $keyname=""; # shared by all teletypes
#
############################ the Control Panel ###################################

### the mainwindow: used as the Control Panel
my $mw;         # main window
my $panel;      # control panel textbox in main window
my $cmdstr="";  # commmand string
my $panelch;    # last character read from panel
my @w;          # itemized command string
my @W;
@w = @ARGV;     # optional initial do string
@W = @ARGV;

sub ExeCommand{
	@W = split(/ /, $cmdstr);
	$cmdstr = LOW($cmdstr);
	@w = split(/ /, $cmdstr);  #lowercase
	$panel->insert('end',"wo " . $w[0] . " w1 " . $w[1] . " w2 " . $w[2] . "\n");
	cmdlog($cmdstr);
	$panel->see('end');
	$panel->SetCursor('end ');
	$panel->focus;
	Command();                 # process command
	$cmdstr = "";              # reset
	prlog("> ");
}

# create the mainwindow
$mw=MainWindow -> new;
$mw -> title("P85x: Control Panel");
$panel=$mw->Scrolled("Text", -scrollbars=>'osoe') -> pack(-expand=>1,-fill=>'both');
$panel-> configure(-wrap=>'none');
$panel-> bind('<KeyPress>'   => \&cmdrecord);
$panel-> bind('<KeyRelease>' => \&panelkeyrelease);
$panel-> bind('<Button>'     => \&panelbutton);
$panel-> bind('<Destroy>'    => \&EmExit);
tie *STDOUT, 'Tk::Text', $panel->Subwidget('scrolled');

# read a command record and process the command
sub cmdrecord
{
	$key     =($Tk::event->N) & 0xFF; # code
	$panelch = $Tk::event->A;         # ASCII symbol
	$keyname = $Tk::event->K;         # keyname
	#$panel->insert('end',"key:" . prhex(8,$key) . " $keyname ");
	if(($key == 0xE3) || ($key == 0xE4))
	{
		# Control Key
		if($control)
		{
			# in in cotrol mode, ignore
			return;
		}
		$control = 1;   # set control mode
		return;
	}
	if($key == 0x65 && $control)
	{
		# CntrlE
		$panel->insert('end',"\nStop\n");
		$panel->see('end');
		$panel->SetCursor('end');
		$panel->focus;
		$RUN=0;
		$control=0;     # reset control mode
		return;
	}
	if($keyname eq 'BackSpace')
	{
		# Backspace: delete last cmdstr character
		my $l=length($cmdstr);
		if($l > 0)
		{
			$cmdstr = substr($cmdstr,0,$l-1);
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			return;
		}
	}
	else
	{
		if(($key == 0x0A) || ($key == 0x0D))
		{
            ExeCommand();
		}
		elsif($key > 0x1F && $key < 0x7B && $panelch ne "")
		{
			$cmdstr=$cmdstr . $panelch;
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
		}
	}
}

# keyrelease
sub panelkeyrelease
{
	$key=($Tk::event->N) & 0xFF; # code
	if(($key == 0xE3) || ($key == 0xE4))
	{
		$cmdstr="";              # reset
		$control = 0;            # reset control mode
	}
	return;
}

# mouse button press
sub panelbutton
{
	$panel->SetCursor('end');
	$panel->focus;
}

# wait for a single input record from the panel
sub waitforpanelrcd {
	my $s="";
	$panel-> bind('<KeyPress>' => \&waitkey);
	while(1)
	{
		$panelch = "";
		$panel->waitVariable(\$panelch);
		if($keyname eq 'BackSpace')
		{
			# Backspace: delete last character
			my $l=length($s);
			if($l > 0)
			{
				$s = substr($s,0,$l-1);
				$panel->see('end');
				$panel->SetCursor('end');
				$panel->focus;
			}
		}
		else
		{
			$s=$s . $panelch;
			$panel->insert('end', $panelch . "\n");
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			if($key == 0xA || $key == 0xD)
			{
				$panel-> bind('<KeyPress>' => \&cmdrecord);
				$panelch = "";
				return UP($s);
			}
		}
	}
}

# wait for a single input character from the panel
sub waitforpanelch{
	$panelch = "";
	$panel-> bind('<KeyPress>' => \&waitkey);
	$panel->waitVariable(\$panelch);
	$panel-> bind('<KeyPress>' => \&cmdrecord);
	if(UP($panelch) eq "S")
	{
		$panel->insert('end',"\n");
		$panelch = "";
		$panel->see('end');
		return "S";
	}
	$panel->see('end');
	return UP($panelch);
}
	
sub waitkey
{
	$key     =($Tk::event->N) & 0xFF;   # code
	$panelch = $Tk::event->A;           # ASCII symbol
	$keyname = $Tk::event->K;           # keyname
}

sub dummy
{
	; # ignore all keys
}

# ControlPanel support to attach a file to the papertape reader
my $ptrfname = "";     # ptr filename
my $ptrcode  = "XX";   # read bytecode

my $ptrframe = $mw->Frame(-borderwidth=>2,-relief=>'groove')->pack(-side=>'left');
$ptrframe->Button(-text =>'PTR',-justify=>'left',-command=>\&ptrattach)->grid
	($ptrframe->Entry(-justify=>'left',-width=>15,-textvariable=>\$ptrfname),
	 $ptrframe->Entry(-justify=>'left',-width=>3, -textvariable=>\$ptrcode));
 
sub ptrattach{
	if($ptrfname ne "")
	{
		$cmdstr="att ptr " . rtrim($ptrfname);
		ExeCommand();
	}
	else
	{
		$ptrcode = "XX";
	}
}

# ControlPanel: show disk activity
my $Bdsign;
my $Xdsign;
my $dskframe = $mw->Frame(-padx=>1,-borderwidth=>2,-relief=>'groove')->pack(-side=>'left',-padx=>5);
$Bdsign=$dskframe->Label(-justify=>'left',-width=>1,-background=>'gray'); # Bigdisk
$Xdsign=$dskframe->Label(-justify=>'left',-width=>1,-background=>'gray'); # X1216
Tk::grid($Bdsign,$Xdsign);

sub BdSon {
	$Bdsign->configure(-background=>'green');
}
sub BdSoff {
	$Bdsign->configure(-background=>'gray');
}
sub XdSon {
	$Xdsign->configure(-background=>'green');
}
sub XdSoff {
	$Xdsign->configure(-background=>'gray');
}

# ControlPanel buttons
my $diskname;
my $ctrlframe=$mw->Frame(-borderwidth=>2,-relief=>'groove')->pack(-side=>'right');
my $bt_mc   = $ctrlframe->Button(-text   =>'MC',  -justify=>'left',-command=>\&Mc);
my $bt_boot = $ctrlframe->Button(-text   =>'IPL', -justify=>'left',-command=>\&BootDev);
my $en_bdks = $ctrlframe->Entry (-justify=>'left',-width=>4,-textvariable=>\$diskname);
my $bt_int  = $ctrlframe->Button(-text   =>'INT', -justify=>'left',-command=>\&PnInterrupt);
my $bt_step = $ctrlframe->Button(-text   =>'STEP',-justify=>'left',-command=>\&ExeStep);
my $bt_stop = $ctrlframe->Button(-text   =>'     ',-justify=>'left',-background=>'red',-command=>\&dummy);
Tk::grid($bt_mc,$bt_boot,$en_bdks,$bt_int,$bt_step,$bt_stop);

# set the default boot drive
if($P856) {
	$diskname="MD0";
}
elsif($MASRA){
	$diskname="MD1";
}
else{
	$diskname="BD0";
}

sub BootDev{
	if($RUN==0)
	{
		$cmdstr="boot " . rtrim($diskname);
		ExeCommand();
	}
	else
	{
		prlog("Running!! 1st stop before IPL\n");
	}
}

sub ExeStop{
	if($RUN)
	{
		$RUN=0;
		$cmdstr="";   # reset
		$bt_stop->configure(-text=>'Cont',-background=>'red',-command=>\&ExeCont);
		$panel->configure(-state=>'normal');
		prlog("Program Stopped\n");
	}
}

sub ExeCont{
	if($RUN==0)
	{
		$cmdstr="continue";
		ExeCommand();
	}
}

sub ExeStep{
	if($RUN==0)
	{
		$cmdstr="step";
		ExeCommand();
	}
}

sub PnInterrupt{
	# if RUN & ENB trap CP
	if($RUN && $ENB)
	{
		prlog("Panel Interrupt\n");
		trap(CP);
	}
}

# Masterclear
sub Mc{
	if($RUN==0)
	{
		$cmdstr="reset"; #reset all
		ExeCommand();
		prlog("MasterClear\n");
	}
}
#################################### TY0 ########################################

### the window for TY0 (TY10); the operator typewriter
my $ty0w;  # TY0 window
my $ty0;   # TY0 textbox
$ty0w=$mw->Toplevel();
$ty0w->title("P85x: TY0 (Teletype TY10)");
$ty0=$ty0w->Scrolled("Text", -scrollbars=>'osoe') -> pack(-expand=>1,-fill=>'both');
$ty0->configure(-wrap=>'none', -state=>'disabled');
$ty0-> bind('<KeyPress>'   => \&ty0keypress );
$ty0-> bind('<KeyRelease>' => \&ty0keyrelease);
$ty0-> bind('<Button>'     => \&ty0button);
my $ty0key=0;

sub ty0keypress
{
	$key  =($Tk::event->N) & 0xFF;   # code
	my $ch= $Tk::event->A;           # ASCII symbol
	my $kn= $Tk::event->K;           # keyname
	if(($key == 0xE3) || ($key == 0xE4))
	{
		# Control Key
		if($control)
		{
			# in in control mode, ignore
			return;
		}
		$control = 1;	# set control mode
		return;
	}
	if(($key == 0x65 || $key == 0x70) && $control) # control mode
	{
		# CtrlE (Stop) or CtrlP (Panel Interrupt)
		if($key==0x65)
		{
			# CtrlE
			$ty0->insert('end',"\nStop(TY0)\n");
			$ty0->see('end');
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			$RUN=0;
		}
		else
		{
			# CtrlP
			$CtrlP = 1;
			$ty0->see('end');
			$ty0->SetCursor('end');
			$ty0->focus;
		}
		$ty0key = $key;
		$control=0;	# reset control mode
		return;
	}
	if( $kn eq 'BackSpace')
	{
		$ty0key = 0x5F;
		return;
	}
	if($key > 0x60 && $key < 0x7B) # lower case
	{
		# make upper case
		my $k=UP(chr($key));
		$ty0->delete('end - 2 chars');
		$ty0->insert('end',$k);
		$key=$key-0x20;
	}
	if(($key > 0x1F && $key < 0x60 && $ch ne "") || $key == 0xA || $key == 0xD)
	{
		# Valid character
		$ty0key = $key;
	}
}

sub ty0keyrelease
{
	$key=($Tk::event->N) & 0xFF; # code
	if(($key == 0xE3) || ($key == 0xE4))
	{
		$control=0;     # reset control mode
	}
	$key=0;
	return;
}

# mouse button press
sub ty0button
{
	$ty0->SetCursor('end');
	$ty0->focus;
}


if(! $P856) {
# 2 additional terminals (TY1 and TY2) on a P854/8/59
#################################### TY1 ########################################

### configure the window for TY1 (TY08); the 1st additional typewriter

$ty1w=$mw->Toplevel();
$ty1w->title("P85x: TY1 (Teletype TY08)");
$ty1=$ty1w->Scrolled("Text", -scrollbars=>'osoe') -> pack(-expand=>1,-fill=>'both');
$ty1->configure(-wrap=>'none', -state=>'disabled');
$ty1-> bind('<KeyPress>' => \&ty1keypress );
$ty1-> bind('<KeyRelease>' => \&ty1keyrelease);
$ty1-> bind('<Button>' => \&ty1button);

sub ty1keypress
{
	$key=($Tk::event->N) & 0xFF;     # code
	my $ch= $Tk::event->A;           # ASCII symbol
	my $kn= $Tk::event->K;           # keyname
	if(($key == 0xE3) || ($key == 0xE4))
	{
		# Control Key
		if($control)
		{
			# in in cotrol mode, ignore
			return;
		}
		$control = 1;	# set control mode
		return;
	}
	if(($key == 0x65 || $key == 0x70) && $control) # control mode
	{
		# CtrlE (Stop) or CtrlP (Panel Interrupt)
		if($key==0x65)
		{
			# CtrlE
			$ty1->insert('end',"\nStop(TY1)\n");
			$ty1->see('end');
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			$RUN=0;
		}
		else
		{
			# CtrlP
			$CtrlP = 1;
			$ty1->see('end');
			$ty1->SetCursor('end');
			$ty1->focus;
		}
		$ty1key = $key;
		$control=0;	# reset control mode
		return;
	}
	if( $kn eq 'BackSpace')
	{
		$ty1key = 0x5F;
		return;
	}
	if($key > 0x60 && $key < 0x7B) # lower case
	{
		# make upper case
		my $k=UP(chr($key));
		$ty1->delete('end - 2 chars');
		$ty1->insert('end',$k);
		$key=$key-0x20;
	}
	if(($key > 0x1F && $key < 0x60 && $ch ne "") || $key == 0xA || $key == 0xD)
	{
		# Valid character
		$ty1key = $key;
	}
}

sub ty1keyrelease
{
	$key=($Tk::event->N) & 0xFF; # code
	if(($key == 0xE3) || ($key == 0xE4))
	{
		$control=0;    # reset control mode
	}
	$key=0;
	return;
}

# mouse button press
sub ty1button
{
	$ty1->SetCursor('end');
	$ty1->focus;
}


} #if(! $P856)

################################# LPT #####################################

### The window for the LPT (LP07) : the lineprinter.
my $lptw;  # LPT window
my $lpt;   # LPT textbox
$lptw=$mw->Toplevel();
$lptw->title("P85x: LPT (Lineprinter LP07)");
$lpt=$lptw->Scrolled("Text", -scrollbars=>'osoe') -> pack(-expand=>1,-fill=>'both');
$lpt->configure(-wrap=>'none', -width=>135, -height=>15, -state=>'disabled');

###########################################################################

$panel->focus;
$panel->SetCursor('end');

#end wintk2.md ==============================================================

# CPU/MEMORY resources and state
#===============================

# MEMORY
# Max size for the P857 is 128kw; for the P859 512kw.
# For iop channel devices a 3rd WER is used to specify the buffer in case memory > 128kw (P854/59).
#
# For DMA channel coonected devices (like the Bigdisk) the document for the bigdisk (1977) only 
# specifies a buffer address for memory upto 128kw. So it is not known how to specify bigdisk 
# buffers for memory > 128kw.
# Analysis of the bigdisk driver in MASR may provide the anwser. <<<<<<<<<<<<<<<<<<<<<
# Until that 128kw is used.

my @M=();               # memory array
my $IR;                 # instruction register
my $PSW;                # status word
        my $PL;             # priority level            psw bit 0:5
        my $CR;             # condition register        psw bit 6:7
        my $overflow=0;     # (aid to set CR, must be 0)
#       my $RUN;            # run bit               	psw bit 8
#       my $ENB;            # interrupt enable bit	psw bit 9
#          CP               # control panel interrupt	psw bit 10
#          PWR              # power fail interrupt      psw bit 12
#          RTC              # real time clock interrupt (not in psw on p859)
#          LKM              # link monitor interrupt    psw bit 14
#                               + stack overflow 
        my $EM;             # extended mode indicator   psw bit 13 
        my $UM;             # user mode indicator       psw bit 15 (0=system mode, 1=user mode)
my @R;                  # registers A0..A15

# Floating Point Processor (FPP)
my $FPA1; my $FPA2; my $FPA3; # FPP accumulator
my $FPM1; my $FPM2; my $FPM3; # FPP memory buffer
my $FPB1; my $FPB2; my $FPB3; # 2nd FPP accumulator
my $fppstatus=0;              # FPP status register

# working registers for CPU, CU's, etc simulation
my $opc;                     # operation code bit1:4
my $r1;                      # r1 or cnd shifted 1 left	
my $r2;                      # r2
my $r3;                      # r3             (in format 0 instructions)
my $k;                       # short constant (in format 0 instructions)
my $sc;                      # shiftcount     (in format 0 instructions)
my $sfun;                    # shift function (in format 0 instructions)
my $md;                      # adressing mode (format 1)
my $ls;                      # load/store bit (format 1)
my $t1;                      # temporary 1 (value)
my $t2;                      # temporary 2 (value)
my $t3;                      # temporary 3 (value)
my $a;                       # temporary for logical effective address computation
my $pcp;                     # current program counter logical address (A0), translated to a physical address
my $pcl;                     # current program counter logical address (A0) (used by trace)
my $ea;                      # effective logical operand address translated to a physical addres
my $sea;                     # effective logical operand address translated to a physical addres (saved 1st value)

# masks
use constant mskf10 => 0x8000;                # format 1 instruction with ls bit 0
use constant SIGN    => 0x8000;               # sign bit short
use constant DPSIGN  => 0x40000000;           # 31 bit double precision sign (in 32 bit word)
use constant DMASK   => 0xFFFF;               # data mask short
use constant DPDMASK => 0x7FFFFFFF;           # 31 bit double precision data mask (in 32 bit word)
use constant MMASK   => DMASK & (~ SIGN);     # magnitude mask short
use constant DPMMASK => DPDMASK & (~ DPSIGN); # 31 bit magnitude mask (in 32 bit word)


###insert mmu.md (the memory management unit)
### mmu.md
# The memory management unit
#===============================================================================
# MMU: tranlates a 16 bit logical to a 18/20 bit physical address (18 bit currently)
    # page table entry
    # 0..5 6 7 8 9 10..15
    # PAL  E R M X PAM
    # ^    ^ ^ ^ ^ ^ Physical Page Address (most significal part (not used for 128kw)
    # |    | | | |not used
    # |    | | |Modified Page Indicator
    # |    | |Read Only Page Indicator (Usermode: protects writing to this page in Usermode)
    # |    |Page Error (access and E=1 => page fault)
    # | Physical Page Address (least significant part)
    #

my @MMU;

# Translate a 16 bit logical memory address (for a 128kw memory)
# to a physical memory address.
# Always returns a word address
sub la2pa
{
    my $addr=shift; # logical address
    my $t;
    my $s;
    $addr=$addr & 0xFFFE;
    if(($UM | $EM) && $P856==0)
    {
        #user or extended mode => translate logical address
        #prlog( "la2pa UM $UM or EM $EM set\n");
        $t = $MMU[($addr & 0xF000) >> 12];
        if($t & 0x200)
        {
            # page fault
            $s=prhex(16,$addr);
            prlog("La2Pa Read Page Fault: logical address " . $s . "\n");
            $RUN=0;
            return MEMSIZE; # some value outside memory
        }
        else
        {
            $addr = (($t & 0xFC00) << 2) | ($addr & 0x0FFE);
            return $addr;
        }
    }
    else
    {
        #system mode => physical address = logical address
        return $addr;
    }
}

# la2pa_store does check whether memory above 128kw is addressed
sub la2pa_store
{
    my $addr=shift; # logical address
    my $t;
    my $s;
    $addr=$addr & 0xFFFE;
    if(($UM | $EM) && $P856==0)
    {
        #user or extended mode => translate logical address
        $t = $MMU[($addr & 0xF000) >> 12];
        if($t & 0x3F) # MMU bits above 128 kw used?
        {
            # above 128K
            $addr = (($t & 0x3F) << 18) | (($t & 0xFC00) << 2) | ($addr & 0x0FFE);
            $s=prhex(24,$addr);
            emprlog("La2Pa Write: Memory addressed above MAXADDRESS (physical address " . $s . ")\n");
            #$RUN=0;
            return MEMSIZE; # some value outside memory
        }
        elsif($t & 0x300)
        {
            # page fault
            $s=prhex(16,$addr);
            prlog("La2Pa Write Page Fault: logical address " . $s . "\n");
            $RUN=0;
            return MEMSIZE; # some value outside memory
        }
        else
        {
            $addr = (($t & 0xFC00) << 2) | ($addr & 0x0FFE);
            return $addr;
        }
    }
    else
    {
        #system mode => physical address = logical address
        return $addr;
    }
}

# calculate the extended memory address (used in system mode by EL/ES)
sub extendedaddr
{
    my $addr=shift; # logical address
    my $t;
    my $s;
    $addr=$addr & 0xFFFE;
    # translate 16 bit address
    $t = $MMU[($addr & 0xF000) >> 12];
    if($t & 0x200)
    {
        # page fault
        $s=prhex(16,$addr);
        prlog("EA Read Page Fault: logical address " . $s . "\n");
        $RUN=0;
        return MEMSIZE; # some value outside memory
    }
    else
    {
        $addr = (($t & 0xFC00) << 2) | ($addr & 0x0FFE);
        return $addr;
    }
}

# The test to store a value above MAXADDR is necessary to determine the
# right memory size. A load from this (wrong) address should return a value
# which is different from the value stored at this (wrong) address
# If a store addresses a memory cell above MAXADDR then the value is
# stored at MEMSIZE (MAXADDR + 2). When a value is loaded from a cell above
# MAXADDR then a value is returned from a cell between 0 and MAXADDR.
# The check on memory size is done by LDMASR.
# >>>>>>>>>>>>>>>>> Only working now for a 128kw memory <<<<<<<<<<<<<<<<<<<<<<<
# For a bigger MEMSIZE the masks for the page bits have to be ajusted !!!!!!!!!!

# calculate the extended memory address (used in system mode by EL/ES)
sub extendedaddr_store
{
    my $addr=shift; # logical address
    my $t;
    my $s;
    $addr=$addr & 0xFFFE;
    # translate 16 bit address
    $t = $MMU[($addr & 0xF000) >> 12]; # mmu register content
    if($t & 0x3F) # MMU bits above 128 kw used?
    {
        # above 128K
        $addr = (($t & 0x3F) << 18) | (($t & 0xFC00) << 2) | ($addr & 0x0FFE);
        $s=prhex(24,$addr);
        emprlog("EA Write: Memory addressed above MAXADDRESS (physical address " . $s . ")\n");
        #$RUN=0;
        return MEMSIZE; # some value outside memory
    }
    elsif($t & 0x300)
    {
        # page fault
        $s=prhex(16,$addr);
        prlog("EA Write Page Fault: logical address " . $s . "\n");
        $RUN=0;
        return MEMSIZE; # some value outside memory
    }
    else
    {
        $addr = (($t & 0xFC00) << 2) | ($addr & 0x0FFE);
        return $addr;
    }
}

sub state_mmu
{
    my $i;
    prlog("\n\n\n");
    $i=0;
    while($i<16)
    {
        prlog("MMU register" . prhex(4,$i) . prhex(32,$MMU[$i]) . "\n");
        $i=$i+1
    }
}

sub reset_mmu
{
	# default mmu setting
	$MMU[0]  = 0x0000;
	$MMU[1]  = 0x0400;
	$MMU[2]  = 0x0800;
	$MMU[3]  = 0x0C00;
	$MMU[4]  = 0x1000;
	$MMU[5]  = 0x1400;
	$MMU[6]  = 0x1800;
	$MMU[7]  = 0x1C00;
	$MMU[8]  = 0x2000;
	$MMU[9]  = 0x2400;
	$MMU[10] = 0x2800;
	$MMU[11] = 0x2C00;
	$MMU[12] = 0x3000;
	$MMU[13] = 0x3400;
	$MMU[14] = 0x3800;
	$MMU[15] = 0x3C00;
}

# Calculate for mode 1, 2 and 3 instructions the logical memory
# address of the operand.
# The parameter can be zero, or nonzero.
# If zero: r2 must be nonzero (T2 instructions not allowed)
# If nonzero, T2 instruction are allowed.
#
sub la_operand {
	my $t = shift;
	if($md == 1)
	{
		# T3
		$a = $R[$r2];                  # effective logical address
        if($r2 == 0)
		{
			if($t) # T2 allowed ?
			{
				# T2
				$R[0] = $R[0] + 2;
			}
			else
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc, "r2 must be nonzero");
			}
		}
	}
	elsif($md == 2)
	{
		# T4/T5
		$a = $M[la2pa($R[0])];	        # memory operand address
		$R[0] = ($R[0] + 2);	           # increment A0 (PC)
		if($r2 != 0)			           # indexing ?
		{
			$a = ($a + $R[$r2]);         # yes
		}
		# $a is effective logical address 
	}
	elsif($md == 3)
	{
		# T6/T7
		$a = $M[la2pa($R[0])];	        # memory operand address
		$R[0] = ($R[0] + 2);	           # increment A0 (PC)
		if($r2 != 0)			           # indexing ?
		{
			$a = ($a + $R[$r2]);         # yes
		}
		$a =  $M[la2pa($a)];            # memory content = effective logical address
	}
}



#end mmu.md ===========================================================

# Internal Interrupts (traps)
# ===========================
# - Power Failure/Auto Restart
# - Link Monitor/Stack Overflow (A15 pointer < /100)
# - Real Time Clock
# - Control Panel
# - (Invalid Instruction = trap /7E which also works in INH mode)
# - Page Fault (for P800 with MMU)
# - Floating Point Unit interrupt (for P800 with FPU)

# Some internal interrupts are also part of the PSW (see above)
# Internal Interrupt register (last 4 bits are part of PSW: bits 10:13):

my $inint=0;      # internal interrupt register

# 4 spares: the RIT instruction is able to handle 8 bits
# traps are SET by the trap subroutine, which sets the bit in $inint
# and in $intreg0
# traps are RESET by the resettrap subroutine, which resets the bit in $inint
# and in $intreg0

# Interrupt system
# ================
# The interrupt system is a priority system with 64 levels. The 
# interrupt lines are connected according priority to memory locations
# /0000 .. /007E, where /0000 represents the highest priority.

my $intreg0=0;     # interrupt register 1st 32 bits
my $intreg1=0;     # interrupt register 2nd 32 bits

# The interrupt lines are linked with an interrupt flipflops collected in a
# interrupt register. The lines/flopflops are arranged in the register in 
# priority order. Highest priority is the most significant bit
#
# DOM CONFIGURATION (OF THE DOS5.IMG and p8d10) configured to boot from unit-0 (md1)
# common interrupt level assignment DOS5,MASR, MASRA:
use constant IPWR   => 0x80000000;     # Power failure, auto restart (0) internal interrupt
use constant ILKM   => 0x40000000;     # Link monitor, stackoverflow (1) internal interrupt
use constant IRTC   => 0x20000000;     # Real time clock             (2) internal interrupt
use constant IASR   => 0x02000000;     # Console typewriter (ty0)    (6)
use constant ITY1   => 0x00800000;     # 2nd tty                     (8)  intreg0
use constant ITY2   => 0x00100000;     # 3rd tty                     (/B) intreg0
use constant ILP    => 0x00000100;     # Line printer                (/17)
use constant IMD0   => 0x00008000;     # X1215/16 Moving head disk   (/10)
use constant IBD0   => 0x80000000;     # Bigdisk:                    (/20) intreg1 bit 0


# disconnected for MASR (symbols still defined for the drivers)
use constant IMT    => 0x00001000;     # Mag tape                    (/13)
use constant ITK    => 0x00000800;     # Cas tape                    (/14)
use constant ICR    => 0x00000400;     # Card reader                 (/15)

#
# The internal interrupts are linked to the priority interrupt system
# Mapping:
my @II2PI;
$II2PI[CP]  = ICP;  #intreg
$II2PI[PWR] = IPWR; #intreg
$II2PI[RTC] = IRTC; #intreg
$II2PI[LKM] = ILKM; #intreg
#
# Priority Interrupt Locations (not used by the simulator; for documentation only)
#
#                   Mem Address         Bit in IntReg
use constant AdPWR   => 0x00;           # 8000 0000 power failure interrupt location (highest priority = level 0)
use constant AdLKM   => 0x02;           # 4000 0000 LKM/Stack overflow (priority level 1) 
use constant AdRTC   => 0x04;           # 2000 0000 real time clock (priority level 2)
use constant ilres1  => 0x06;           # 1000 0000 reserved (priority level 3)
use constant AdPTR   => 0x08;           # 0800 0000 punched tape reader (priority level 4)
use constant AdPTP   => 0x0A;           # 0400 0000 tape punch (priority level 5)
use constant AdASR   => 0x0C;           # 0200 0000 operator's typewriter (priority level 6)
use constant AdCP    => 0x0E;           # 0100 0000 control panel (priority level 7)
use constant ilres2  => 0x10;           # 0080 0000 reserved (priority level 8)
use constant ilres3  => 0x12;           # 0040 0000 reserved (priority level 9)
use constant AdTY1   => 0x14;           # 0020 0000 2nd tty  (priority level A)
use constant Adty2   => 0x16;           # 0010 0000 3rd tty  (priority level B)
use constant ilres6  => 0x18;           # 0008 0000 reserved (priority level C)
use constant ilres7  => 0x1A;           # 0004 0000 reserved (priority level D)
use constant ilres8  => 0x1C;           # 0002 0000 reserved (priority level E)
use constant ilres9  => 0x1E;           # 0001 0000 reserved (priority level F)
use constant AdMD0   => 0x20;           # 0000 8000 X1215    (priority level 10)
use constant ilres11 => 0x22;           # 0000 4000 reserved (priority level 11)
use constant ilres12 => 0x24;           # 0000 2000 reserved (priority level 12)
use constant AdMT    => 0x26;           # 0000 1000 Mag.Tape (priority level 13)
use constant AdTK    => 0x28;           # 0000 0800 Cas.Tape (priority level 14)
use constant AdCR    => 0x2A;           # 0000 0400 Card Reader (priority level 15)
use constant ilres13 => 0x2C;           # 0000 0200 reserved (priority level 16)
use constant AdLP    => 0x2E;           # 0000 0100 Line Printer (priority level 17)
use constant ilres14 => 0x30;           # 0000 0080 reserved (priority level 18)
use constant ilres15 => 0x32;           # 0000 0040 reserved (priority level 19)
use constant ilres16 => 0x34;           # 0000 0020 reserved (priority level 1A)
use constant ilres17 => 0x36;           # 0000 0010 reserved (priority level 1B)
use constant ilres18 => 0x38;           # 0000 0008 reserved (priority level 1C)
use constant ilres19 => 0x3A;           # 0000 0004 reserved (priority level 1D)
use constant ilres20 => 0x3C;           # 0000 0002 reserved (priority level 1E)
use constant ilres21 => 0x3E;           # 0000 0001 reserved (priority level 1F)
use constant AdBD0   => 0x40;           # 0000 0000 8000 0000 CDC (priority level 20)
#
# Traps
# A trap is activated regardless of the current Priority Level or CPU mode, so regardless of
# in Inhibit or Enable mode or System/User mode
# Action:
# - P, PSW (logical page number) stored on the A15 stack
# - Priority Level is not changed
# - switch to inhibit mode (if in enabled mode)
# - User mode bit reset when in User Mode
# - Indirect branch via the address in the trap location
use constant AdPAG   => 0x7A;           # 0000 0000 0000 0004 Memory Access Fault (priority level 3D)
                                        # Trap: activated in case of:
                                        # - Access of a wrong or missing page (in User Mode)
                                        # - A attempt to write in a read only page
                                        # stores P, PSW and the logical page number (in bits 4-7)
use constant AdFDF   => 0x7C;           # 0000 0000 0000 0002 Not Implemented Instructions (priority level 3E)
                                        # Trap: activated in case of:
                                        # - any attempt to execute not implemented D or F format instructions
                                        # - Floating Point Errors (P854)
use constant AdILL   => 0x7E;           # 0000 0000 0000 0001 Invalid Instruction Trap (priority level 3F)
                                        # Trap: activated in case of:
                                        # - Non-exsisting instructions (e.g. the floating point instructions)
                                        # - Privileged instructions executed in User Mode
                                        # - System stack access (A15) in User Mode

# devices/control units
#
# The control unit STATE consists of two parts
# 1) ls 16 bits  = device status word, different for each device, but
#    bit 15 is 1 always means: device not operable
#
# 2) 4 bits before the ls 16 bits
#
#    bit 2:    0 = output request
#              1 = input request
#              1 = cio bigdisk
#              1 = command request (Bigdisk)
#    bit 3:4  00 = inactive state
#             01 = execute state
#             11 = exchange state
#             10 = wait state
#    bit 1     1 = stop io requested
#    the device is busy if not in inactive state
#
# control unit states (the 4 bits as part of STATE)
use constant INAC => 0;                  # inactive
use constant XCIO => 4;                  # process a CIO (CIO-ipl or CIO-str/stp: Bigdisk)
use constant EXE  => 1;                  # execute
use constant IEXE => (0b100 + 0b001);    # input  + execute (not used by Bigdisk)
use constant OEXE => (0b000 + 0b001);    # output + execute
use constant CEXE => (0b100 + 0b001);    # command + execute (Bigdisk)
use constant EXC  => 3;                  # exchange
use constant IEXC => (0b100 + 0b011);    # input  + exchange
use constant OEXC => (0b000 + 0b011);    # output + exchange
use constant WAIT => 2;                  # wait state
use constant WREQ => 0b1000;             # stop io (or wait state) requested

# device control block declaration
my @TY0;
my @TY1;
my @TY2;
my @PTR;
my @PTP;
my @CLK;
my @LPT;
my @CRD;
my @MD0;
my @MD1;
my @MD2;
my @MD3;
my @BD0;
my @BD1;

# device control block layout
use constant NEXT       => 0;
use constant NAME       => 1;
use constant TIMEOUT    => 2;
use constant SERVICE    => 3;
use constant STATE      => 4;
use constant BUFFER     => 5;
use constant TIME       => 6;
use constant CIO        => 7;
use constant INR        => 8;
use constant OTR        => 9;
use constant SST        => 10;
use constant TST        => 11;
use constant DSTAT      => 12;
use constant RESET      => 13;
use constant FILE       => 14;
use constant FC         => 15;
use constant RDY        => 16;

#########
# tty device control blocks (teletype keyboard/printer - programmed channel)
my $key;
# The 1st tty (ASR) is used as operator console. It is the primary tty, used for machine declaration 
# and handling monitor operator commands and messages (panel interupts, M:, linked to file code /EF).
# The 2nd/3rd tty are used for control commands (FCL, LIB, etc.) and ascii data input
# and linked to file codes /E0,/E1

# tty specific entries in device control block
use constant CSET => 14;     # 64 or 128 Ascii character set
use constant NLCR => 15;     # new line state

# OPCON(TY0), uses device address /10
$TY0[NEXT]      = 0;                    # next pointer field
$TY0[NAME]      = "ty0";                # device name
$TY0[TIMEOUT]   = 0;                    # event timeout value
$TY0[SERVICE]   = \&svc_ty0;            # event service routine
$TY0[STATE]     = 0;                    # control unit state
$TY0[BUFFER]    = 0;                    # TTY buffer
$TY0[TIME]      = 3000;                 # default device event time
$TY0[CIO]       = \&cio_ty0;            # cio processor
$TY0[INR]       = \&inr_ty0;            # inr processor
$TY0[OTR]       = \&otr_ty0;            # otr processor
$TY0[SST]       = \&sst_ty0;            # sst processor
$TY0[TST]       = \&tst_ty0;            # sst processor
$TY0[DSTAT]     = \&state_ty0;          # display state
$TY0[RESET]     = \&reset_ty0;          # reset device
$TY0[CSET]      = 64;                   # default is 64 character set 
$TY0[NLCR]      = 1;                    # starts on a newline

# CMDCON1(TY1), uses device address /08
$TY1[NEXT]      = 0;                    # next pointer field
$TY1[NAME]      = "ty1";                # device name
$TY1[TIMEOUT]   = 0;                    # event timeout value
$TY1[SERVICE]   = \&svc_ty1;            # event service routine
$TY1[STATE]     = 0;                    # control unit state
$TY1[BUFFER]    = 0;                    # TTY buffer
$TY1[TIME]      = 3000;                 # default device event time
$TY1[CIO]       = \&cio_ty1;            # cio processor
$TY1[INR]       = \&inr_ty1;            # inr processor
$TY1[OTR]       = \&otr_ty1;            # otr processor
$TY1[SST]       = \&sst_ty1;            # sst processor
$TY1[TST]       = \&tst_ty1;            # sst processor
$TY1[DSTAT]     = \&state_ty1;          # display state
$TY1[RESET]     = \&reset_ty1;          # reset device
$TY1[CSET]      = 64;                   # default is 64 character set 
$TY1[NLCR]      = 1;                    # starts on a newline

# CMDCON2(TY2-fast), uses device address /09
$TY2[NEXT]      = 0;                    # next pointer field
$TY2[NAME]      = "ty2";                # device name
$TY2[TIMEOUT]   = 0;                    # event timeout value
$TY2[SERVICE]   = \&svc_ty2;            # event service routine
$TY2[STATE]     = 0;                    # control unit state
$TY2[BUFFER]    = 0;                    # TTY buffer
$TY2[TIME]      = 30;                   # default device event time
$TY2[CIO]       = \&cio_ty2;            # cio processor
$TY2[INR]       = \&inr_ty2;            # inr processor
$TY2[OTR]       = \&otr_ty2;            # otr processor
$TY2[SST]       = \&sst_ty2;            # sst processor
$TY2[TST]       = \&tst_ty2;            # sst processor
$TY2[DSTAT]     = \&state_ty2;          # display state
$TY2[RESET]     = \&reset_ty2;          # reset device
$TY2[CSET]      = 64;                   # default is 64 character set
$TY2[NLCR]      = 1;                    # starts on a newline

# ptr device control block (paper tape reader - programmed channel )
$PTR[NEXT]      = 0;                    # next pointer field
$PTR[NAME]      = "ptr";                # device name
$PTR[TIMEOUT]   = 0;                    # event timeout value
$PTR[SERVICE]   = \&svc_ptr;            # event service routine
$PTR[STATE]     = 0;                    # control unit state
$PTR[BUFFER]    = 0;                    # PTR buffer
$PTR[TIME]      = 150;                  # default device event time
$PTR[CIO]       = \&cio_ptr;            # cio processor
$PTR[INR]       = \&inr_ptr;            # inr processor
$PTR[OTR]       = \&device_error;       # otr processor
$PTR[SST]       = \&sst_ptr;            # sst processor
$PTR[TST]       = \&tst_ptr;            # sst processor
$PTR[DSTAT]     = \&state_ptr;          # display state
$PTR[RESET]     = \&reset_ptr;          # reset device
$PTR[FILE]      = "";                   # attached file (name; 0 if not attached/inoperable)
$PTR[FC];                               # file handle of attached file
$PTR[RDY];                              # device in operational state (not used yet for ptr)

# ptp device control block (paper tape punch - programmed channel)
$PTP[NEXT]      = 0;                    # next pointer field
$PTP[NAME]      = "ptp";                # device name
$PTP[TIMEOUT]   = 0;                    # event timeout value
$PTP[SERVICE]   = \&svc_ptp;            # event service routine
$PTP[STATE]     = 0;                    # control unit state
$PTP[BUFFER]    = 0;                    # PTP buffer
$PTP[TIME]      = 750;                  # default device event time
$PTP[CIO]       = \&cio_ptp;            # cio processor
$PTP[INR]       = \&device_error;       # inr processor
$PTP[OTR]       = \&otr_ptp;            # otr processor
$PTP[SST]       = \&sst_ptp;            # sst processor
$PTP[TST]       = \&tst_ptp;            # sst processor
$PTP[DSTAT]     = \&state_ptp;          # display state
$PTP[RESET]     = \&reset_ptp;          # reset device
$PTP[FILE]      = "";                   # attached file (name; 0 if not attached/inoperable)
$PTP[FC];                               # file handle of attached file
$PTP[RDY];                              # device in operational state (not used yet for ptp)

# crd device control block and buffer (card reader - multiplex channel )
# card reader specific entries in device control block
use constant RTIME      => 17;          # card moving time
use constant RCLEN      => 18;          # read number of bytes

my $crdbuf;                             # card reader buffer

$CRD[NEXT]      = 0;                    # next pointer field
$CRD[NAME]      = "crd";                # device name
$CRD[TIMEOUT]   = 0;                    # event timeout value
$CRD[SERVICE]   = \&svc_crd;            # event service routine
$CRD[STATE]     = 0;                    # control unit state
$CRD[BUFFER]    = 0;                    # buffer
$CRD[TIME]      = 5;                    # mpx character transfer time
$CRD[CIO]       = \&cio_crd;            # cio processor
$CRD[INR]       = \&inr_crd;            # inr processor
$CRD[OTR]       = \&device_error;       # otr processor
$CRD[SST]       = \&sst_crd;            # sst processor
$CRD[TST]       = \&tst_crd;            # sst processor
$CRD[DSTAT]     = \&state_crd;          # display state
$CRD[RESET]     = \&reset_crd;          # reset device
$CRD[FILE]      = "";                   # attached file (name; 0 if not attached/inoperable)
$CRD[FC];                               # file handle of attached file
$CRD[RDY];                              # device in operational state (not used yet for crd)
$CRD[RTIME]     = 10000;                # time to move card to read station
$CRD[RCLEN]     = 0;                    # read length in bytes

# lpt device control block and buffer (line printer - multiplex channel)
# printer specific entries in printer device control block
use constant PTIME      => 17;          # buffer print time
use constant LMAX       => 18;          # lines per page printed
use constant NPAG       => 19;          # nbr of lines to skip between print pages
use constant LCUR       => 20;          # current line on page
# the following entry directs the page printing (skip page before or after printing the buffer).
use constant SKIP       => 21;
# this entry must be set to one of the following two constants.
use constant SKIP_BP    => 1;           # skip page before printing the buffer
use constant SKIP_AP    => 2;           # skip page after  printing the buffer
use constant SKIP_NO    => 3;           # no printer control at all, store chars forwarded to lpt in the printfile

my $lptbuf="";                          # lineprinter buffer

$LPT[NEXT]      = 0;                    # next pointer field
$LPT[NAME]      = "lpt";                # device name
$LPT[TIMEOUT]   = 0;                    # event timeout value
$LPT[SERVICE]   = \&svc_lpt;            # event service routine
$LPT[STATE]     = 0;                    # control unit state
$LPT[BUFFER]    = "";                   # buffer
$LPT[TIME]      = 5;                    # mpx character transfer time
$LPT[CIO]       = \&cio_lpt;            # cio processor
$LPT[INR]       = \&device_error;       # inr processor
$LPT[OTR]       = \&otr_lpt;            # otr processor
$LPT[SST]       = \&sst_lpt;            # sst processor
$LPT[TST]       = \&tst_lpt;            # sst processor
$LPT[DSTAT]     = \&state_lpt;          # display state
$LPT[RESET]     = \&reset_lpt;          # reset device
$LPT[FILE]      = "";                   # attached file (name; 0 if not attached/inoperable)
$LPT[FC];                               # file handle of attached file
$LPT[RDY];                              # device in operational state (not used yet for lpt)
$LPT[PTIME]     = 3000;                 # buffer print time
# page parameters: 66 lines per page, of which 64 being printed + 1 empty line at top and end
# (in case of no printer control chars and printer control is set by SKIP_AP or SKIP_BP)
$LPT[LMAX]      = 64;                   # 64 print lines per page
$LPT[NPAG]      = 2;                    # nbr of lines to skip between print pages
$LPT[LCUR]      = 0;                    # current line on page
#$LPT[SKIP]      = SKIP_NO;
$LPT[SKIP]      = SKIP_BP;              # skip page before printing the buffer
#$LPT[SKIP]      = SKIP_AP;              # skip page after  printing the buffer
#
########################
# X1215/16 moving head disk device control blocks (1 per drive) connected to IOP subchannel 2
#
# two units per control unit cq 4 drives max. 
# - unit 0 has 2 disks: md0 (address /02 = cartridge) and md1 (address /22 = fixed disk)
# - unit 1 has 2 disks: md2 (address /12 = cartridge) and md3 (address /32 = fixed disk)
# - unit 0 is operational/ready in case both disks md0 and md1 are attached to a file
# - unit 1 is operational/ready in case both disks md2 and md3 are attached to a file
# The control unit and the disk/drive 0 data are in the md0 control block. 
# The drive specific data of the units/disks are in md1, etc, where md2 contains the unit
# specific data for unit 0. 
# Only one disk can use the control unit and subchannel at a time; even seeks can not be overlapped.
#
# moving head disk specific constants
## equivalent constands MDdisk and BDdisk must have equivalent valus ##
use constant RWTIME => 17;              # latency to move to sector in cylinder
use constant TRTIME => 18;              # time to move 1 cylinder
use constant XLEN   => 19;              # transferred length in bytes
use constant DN     => 20;              # active disk/drive == drive with a pending operation
use constant CYL    => 21;              # current cylinder
use constant SEC    => 22;              # sector to read or write

# resulting state of a disk operation
#use constant DREADY   => 0x4000; # unit ready from not operable (was unready)
use constant DREADY   => 0x0000; # unit ready from not operable (was unready) <<< disk ready not supported at this moment
use constant DONCYL   => 0x0400; # on requested cylinder (seek complete)
use constant DSEEKERR => 0x0200; # seek error
use constant DDISKNBR => 0x0080; # disk/drive number: 0 for cartridge, 1 for the fixed disk
use constant DUNITNBR => 0x0040; # unit number: 0 or 1
use constant DPROGERR => 0x0010; # program error
use constant DLENGERR => 0x0008; # incorrect length
use constant DDATAERR => 0x0004; # data error
use constant DTHROERR => 0x0002; # throughput error
use constant DNOTOP   => 0x0001; # not operable

# disk parameters (X1215/16)
# the p800 premark (PREMDK) wants to have a disk with 204 cylinders (as the X1215 had),
# otherwise there is a seek error while executing the premark. For nomal operation also
# a disk with 203 cylinders can be used, because only 200 cylinders are used during normal
# operation. The last 4 cylinders on the x1215 pack are spare (the last 3 on an x1210 pack)
# the x1215 pack (with 204 cylinders) can be formatted like the x1210 pack with 203 cylinders.
# the X1216 has upto 1024 cylinders.
use constant NH       => 2;      # number of heads (per disk/drive)
use constant SPT      => 16;     # 16 sectors per track
use constant LSEC     => 205;    # sector length in 16 bit words

my $md0buf;                             # internal disk buffer

# unit0 drive0 + control unit
# cartridge of unit 0 ($dn=0 00) device address /2
$MD0[NEXT]      = 0;                    # next pointer field
$MD0[NAME]      = "md0";                # device name
$MD0[TIMEOUT]   = 0;                    # event timeout value
$MD0[SERVICE]   = \&svc_md0;            # event service routine
$MD0[STATE]     = 0;                    # control unit state
$MD0[BUFFER]    = "";                   # buffer
$MD0[TIME]      = 3;                    # mpx transfer time (30 musec)
$MD0[CIO]       = \&cio_md0;            # cio processor/drive selector
$MD0[INR]       = \&inr_md0;            # inr processor
$MD0[OTR]       = \&otr_md0;            # otr processor
$MD0[SST]       = \&sst_md0;            # sst processor
$MD0[TST]       = \&tst_md0;            # tst processor
$MD0[DSTAT]     = \&state_md0;          # display state
$MD0[RESET]     = \&reset_md0;          # reset device
$MD0[FILE]      = "";                   # attached file (name= "" if not attached/inoperable)
                                        # if attached, then also opened. filecode MD0
$MD0[FC];                               # not used
$MD0[RDY]       = 0;                    # 1 in case unit 0 is in operational state (READY)
$MD0[RWTIME]    = 100;                  # latency to move to sector in cylinder (12.5 msec)
$MD0[TRTIME]    = 50;                   # time to move 1 cylinder (0.5 msec)
$MD0[XLEN]      = 0;                    # transferred length in bytes
$MD0[DN]        = 0;                    # active drive == drive with a pending operation
$MD0[CYL]       = 0;                    # current cylinder unit 0 / drive 0
$MD0[SEC]       = 0;                    # physical sector to read or write

# unit0 drive1
# fixed disk on unit 0 ($dn=2 10)device address /22
$MD1[NAME]      = "md1";                # device name
$MD1[SERVICE]   = \&device_error;
$MD1[CIO]       = \&cio_md1;            # cio processor/drive selector
$MD1[INR]       = \&device_error;
$MD1[OTR]       = \&device_error;
$MD1[SST]       = \&sst_md0;
$MD1[TST]       = \&tst_md0;
$MD1[DSTAT]     = \&device_error;
$MD1[RESET]     = \&device_error;
$MD1[FILE]      = "";                   # attached file (name= "" if not attached/inoperable)
                                        # if attached, then also opened. filecode MD1
# unit1 drive0
# cardridge on unit 1 ($dn=1 01)device address /12
$MD2[NAME]      = "md2";                # device name
$MD2[SERVICE]   = \&device_error;
$MD2[CIO]       = \&cio_md2;            # cio processor/drive selector
$MD2[INR]       = \&device_error;
$MD2[OTR]       = \&device_error;
$MD2[SST]       = \&sst_md0;
$MD2[TST]       = \&tst_md0;
$MD2[DSTAT]     = \&device_error;
$MD2[RESET]     = \&device_error;
$MD2[FILE]      = "";                   # attached file (name= "" if not attached/inoperable)
                                        # if attached, then also opened. filecode MD2
$MD2[RDY]       = 0;                    # 1 in case unit 1 is in operational state (READY)										
$MD2[CYL]       = 0;                    # current cylinder unit 1 / drive 0

# unit1 drive1
# fixed disk on unit 1 ($dn=3 11)device address /32
$MD3[NAME]      = "md3";                # device name
$MD3[SERVICE]   = \&device_error;
$MD3[CIO]       = \&cio_md3;            # cio processor/drive selector
$MD3[INR]       = \&device_error;
$MD3[OTR]       = \&device_error;
$MD3[SST]       = \&sst_md0;
$MD3[TST]       = \&tst_md0;
$MD3[DSTAT]     = \&device_error;
$MD3[RESET]     = \&device_error;
$MD3[FILE]      = "";                   # attached file (name= "" if not attached/inoperable)
                                        # if attached, then also opened. filecode MD3

########################
# Bigdisk: CDC 80Mb Unit; Controller: P825-040
# 822 cylinders (0..821); 5 heads (0..4)
# Maximum, two units per control unit; connected by a DMA channel
#
# On the simulated disk:
# Tracklength: 0x5000 bytes (0x2800 words), of which 0x26CA words as userspace.
# Track administration (set for the current track after reading the track)
# word 0 cylinder number
# word 1 not used ?
# word 2 tracklength (number of words (/26CA): userspace)
# 64 table entries: 1 for each possible sectors in the track (max 64 sector)
#  $bd0sectoroffset[0] word offset sector 0
#  $bd0sectorlength[0] length in words for sector 0
#  etc.... for not existing sectors, content of offset and length is 0.

# Bigdisk specific constants
use constant TRACKLENGTH => 0x5000;
use constant UNDEF       => 0xFFFF;

## equivalent constands MDdisk and BDdisk must have equivalent valus ##
use constant STIME    => 17;            # latency to move to sector in cylinder
use constant TRTIME   => 18;            # time to move 1 cylinder
use constant XLEN     => 19;            # transferred length in bytes
use constant CYL      => 21;            # current cylinder
use constant SEC      => 22;            # sector to read or write
use constant SLEN     => 23;            # sector length
use constant HEAD     => 24;            # head/track number
use constant PSL      => 25;            # length physical sector (input)

# unit 0
my $bd0trackbufffer = "";               # buffer/cache current track (CYL/HEAD)
my @bd0sectoroffset;                    # 64 * sector start address (offset in words from beginning of track)
my @bd0sectorlength;                    # 64 * sector length (in words)
my $bd0trackindex;                      # (in bytes)
my $bd0trackdirty=0;                    # track cache dirty flag
my $bd0rw=1;                            # write enable flag (<<<<< 0=> write protect >>>>>)
# unit 1
my $bd1trackbufffer = "";               # buffer/cache current track (CYL/HEAD)
my @bd1sectoroffset;                    # 64 * sector start address (offset in words from beginning of track)
my @bd1sectorlength;                    # 64 * sector length (in words)
my $bd1trackindex;                      # (in bytes)
my $bd1trackdirty=0;                    # track cache dirty flag
my $bd1rw=1;                            # write enable flag (<<<<< 0=> write protect >>>>>)
# control unit
my $bdactiveunit;                       # active disk/drive == drive with a pending operation
my $bdactiveunitname;                   # name of the active drive
my $cmdaddr;                            # pointer to command word (DMA channel)
my $cmdword;                            # loaded commandword from memory
my $memaddr;                            # pointer to memory buffer where to read/write
my $cmd;                                # bits 0..3 of commandword
my $ic;                                 # commandchain bit (bit  5 of commandword)
my $dc;                                 # datachain bit (bit 1 of block length word (cw2))
my $nt;                                 # no transfer bit (bit 0 of the block length word (cw2)
my $cw1;                                # controlword 1
my $cw2;                                # controlword 2
my $cw3;                                # controlword 3
my $txlength;                           # total length transferred disk<=>cu

# unit0 ($dn=0) + control unit
$BD0[NEXT]      = 0;                    # next pointer field
$BD0[NAME]      = "bd0";                # device name
$BD0[TIMEOUT]   = 0;                    # event timeout value
$BD0[SERVICE]   = \&svc_bd0;            # event service routine
$BD0[STATE]     = 0;                    # control unit state
$BD0[BUFFER]    = "";                   # buffer current sector
$BD0[TIME]      = 3;                    # wordtransfer time
$BD0[CIO]       = \&cio_bd0;            # cio processor/drive selector
$BD0[INR]       = \&device_error;
$BD0[OTR]       = \&device_error;
$BD0[SST]       = \&sst_bd0;            # sst processor
$BD0[TST]       = \&tst_bd0;            # tst processor
$BD0[DSTAT]     = \&state_bd0;          # display state
$BD0[RESET]     = \&reset_bd0;          # reset device
$BD0[FILE]      = "";                   # attached file (name= "" if not attached/inoperable)
                                        # if attached, then also opened. filecode BD0
$BD0[STIME]     = 100;                  # latency to move to sector in cylinder; cio start time
$BD0[TRTIME]    = 50;                   # time to move 1 cylinder
$BD0[SLEN]      = 0;                    # length current block to transfer (command word) (words)
$BD0[PSL]       = 0;                    # length current sector to transfer (trackadmin) (words)
$BD0[XLEN]      = 0;                    # transferred length current block/sector (index) (words)

$BD0[RDY]       = 0;                    # 1 in case unit 0 is in operational state (READY)
$BD0[CYL]       = UNDEF;                # current cylinder unit 0 
$BD0[HEAD]      = UNDEF;                # current head/track unit 0
$BD0[SEC]       = UNDEF;                # current physical sector unit 0

# unit1 ($dn=1)
$BD1[NAME]      = "bd1";                # device name
$BD1[SERVICE]   = \&device_error;
$BD1[CIO]       = \&cio_bd1;            # cio processor/drive selector
$BD1[INR]       = \&device_error;
$BD1[OTR]       = \&device_error;
$BD1[TST]       = \&tst_bd0;            # tst processor
$BD1[SST]       = \&sst_bd0;            # sst processor
$BD1[DSTAT]     = \&device_error;
$BD1[RESET]     = \&device_error;
$BD1[FILE]      = "";                   # attached file (name= "" if not attached/inoperable)
                                        # if attached, then also opened. filecode BD1
$BD1[RDY]       = 0;                    # 1 in case unit 1 is in operational state (READY)
$BD1[CYL]       = UNDEF;                # current cylinder unit 1
$BD1[HEAD]      = UNDEF;                # current head/track unit 1
$BD1[SEC]       = UNDEF;                # current physical sector unit 1

sub device_error {
	if($RUN)
	{
		prlog( "Device error: Stop!\n");
		my $pcp=la2pa($R[A0]);              # current physical instruction address
		my $IR= $M[$pcp];                   # fetch instruction
		prlog( "PCl=".prhex(16,$pcl)." PCf=".prhex(20,$pcp)." M=".prhex(16,$IR)."\n");
	}
	$RUN = 0;
}
	
# clk device control block (50Hz clock)
my $rtc_on      = 0;        # clock activate request flag
# elapsed runtime measurement
my @t0;                     # start point elapsed time measurement during run command
my $secs;                   # run elapsed time in secs
my $cps;                    # cycles per second during run command
# real time clock synchronization
my @clk0;                   # start point of measurement period
my $laps;                   # actual measured period in seconds
my $pulses;                 # number of clock events in measured period

# clock specific entries in clock device control block
use constant FREQ       => 14;
use constant SYSEC      => 15;
use constant SYNC       => 16;
use constant CTIME      => 17;

$CLK[NEXT]      = 0;                    # next pointer field
$CLK[NAME]      = "rtc";                # device name
$CLK[TIMEOUT]   = 0;                    # event timeout value
$CLK[SERVICE]   = \&svc_clk;            # event service routine
$CLK[STATE]     = 0;                    # control unit state
$CLK[BUFFER]    = 0;                    # buffer
$CLK[TIME]      = 1000;                 # default device event time
$CLK[CIO]       = \&cio_clk;            # cio processor
$CLK[INR]       = \&inr_clk;            # inr processor
$CLK[OTR]       = \&otr_clk;            # otr processor
$CLK[SST]       = \&sst_clk;            # sst processor
$CLK[TST]       = \&tst_clk;            # sst processor
$CLK[DSTAT]     = \&state_clk;          # display state
$CLK[RESET]     = \&reset_clk;          # reset device
$CLK[FREQ]      = 50;                   # 50 HZ clock
$CLK[SYSEC]     = 5;                    # sync measurement period (secs) 
$CLK[SYNC]      = $CLK[SYSEC] * $CLK[FREQ]; # number sync pulses for measurement period
$CLK[CTIME]     = 0;                    # calculated synced device event time

# defined devices (device addresses)
# the single IOP has IOP address 0
my %DEV;

# MD connected to IOP subchannel 2
#$DEV{0x02} = \@MD0; # IOP, CU has device address 2, disk/drive 0 unit 0, $dn=0 (cartridge)
#$DEV{0x22} = \@MD1; # IOP, CU has device address 2, disk/drive 1 unit 0, $dn=2 (fixed)
#$DEV{0x12} = \@MD2; # IOP, CU has device address 2, disk/drive 0 unit 1, $dn=1 (cardridge)
#$DEV{0x32} = \@MD3; # IOP, CU has device address 2, disk/drive 1 unit 1, $dn=3 (fixed)

#$DEV{0x06} = \@CRD; # IOP (subchannel 6)

$DEV{0x07} = \@LPT; # IOP (subchannel 7)
$DEV{0x10} = \@TY0; # OPCON
$DEV{0x08} = \@TY1; # CMDCON1
$DEV{0x09} = \@TY2; # CMDCON2
$DEV{0x20} = \@PTR; # PTR
$DEV{0x30} = \@PTP; # PTP
$DEV{0x3F} = \@CLK; # RTC
if($P856==0) {
 $DEV{0x00} = 0;    # The floating point processor (address for SST instr.)
}
 # Bigdisk connected to a DMA channel
$DEV{0x16} = \@BD0; # CU has device address 16; unit 0
$DEV{0x36} = \@BD1; # CU has device address 16; unit 1

# speudo device for stepping function
my @STEP;
$STEP[NEXT]     = 0;                    # next pointer field
$STEP[NAME]     = "step";               # device name
$STEP[TIMEOUT]  = 0;                    # event timeout value
$STEP[SERVICE]  = \&svc_step;           # event service routine
# stepper service routine (scheduled after stepper event)
sub svc_step {
      $RUN = 0;     # stop cpu
}

# IOPs (I/O Processors) implement the Multiplex channels
# ======================================================
# Up to 8 IOPs can be connected, but most systems have only 1 or 2 of them installed.
# Each IOP supports 8 subchannels. IOP address + subchannel number provide the
# least significant bits of the device address:
#
# Device Address           X X X X X X (6 bits)
#     Subchannel                 S S S (3 bits)
#    IOP address           I I I       (up to 3 bits)
#
# The device control unit is connected to a subchannel. The control unit may
# support a single (e.g. a line printer) or multiple devices (e.g.multiple disk drives).
# In case of multiple devices, the most significant bits of the device address specify
# a particular device.
#
# The system being simulated assumes a single IO Processor, with address 0.
# This provides 8 subchannels, numbered 0..7 (0 has the highest priority)
# The cardreader, lineprinter and moving head disks are connected to a subchannnel.
#
#                                                            |IOP address
#                                                            V
# Card Reader uses subchannel 6                   => DA = 00 0 110
# Line Printer uses subchannel 7                  => DA = 00 0 111
# Moving head disk (X1215) uses subchannel 2      => DA = 00 0 010
#  This however is the address of the disk control unit !
#  The disk control unit is able to support multiple devices: Two disk units,
#  each with 2 spindels, a cartridge and an fixed drive, so 4 drives in total.
#  The addressing of a particular drive is as follows:
#                                                    DA = 00 0 010
#                                                         ^^
#                                                         ||Unit Number 0,1
#                                                         |Drive Number 0,1
#  Drive number 0 is the cartridge and drive number 1 is the fixed disk.
#  Because the 4 drives share a singe control unit, only 1 drive can be active
#  at a particular moment.
#
# Each subchannel uses 2 external registers to control the channel.
# Register 1 specifies the transfer (char or word, in or out, nbr of chars/words,..)
# Register 2 specifies the buffer address in memory.
# The external registers are to be loaded with WER instructions and addressed
# with the Control unit address (combination IOP address + subchannel).
#
# On some models (with a memory capability > 128kw) 3 WER instructions are used to
# initiate a subchannel. The 3rd WER is used then to provide the most significant
# address bits of the buffer (lowest bit provided by the 2nd WER)

# External registers used for the IOP subchannels:
my @EXTR;
# 8 sets of 2 external registers for IOP 0
$EXTR[0x0] = 0;
$EXTR[0x1] = 0;
$EXTR[0x2] = 0;
$EXTR[0x3] = 0;
$EXTR[0x4] = 0; # used by X1215/16 moving head disk CU (CU address = 2 => reg1 address = 2 * 2)
$EXTR[0x5] = 0; # used by X1215/16 moving head disk CU (CU address = 2 => reg2 address = 2 * 2 + 1)
$EXTR[0x6] = 0;
$EXTR[0x7] = 0;
$EXTR[0x8] = 0;
$EXTR[0x9] = 0;
$EXTR[0xA] = 0;
$EXTR[0xB] = 0;
$EXTR[0xC] = 0; # card reader (CU address = 6)
$EXTR[0xD] = 0 ;# card reader
$EXTR[0xE] = 0; # lineprinter (CU address = 7)
$EXTR[0xF] = 0; # lineprinter

# When an IOP/CU needs to transfer a byte or word, it sends a break. Channels breaks
# are processed in priority order: channel 0 has the  highest priority. When a transfer
# is completed, the IOP/CU sends an interrupt. The simulator collects the break 
# flipflops of the subchannels in a break register

# IOP subchannel break register
#                          bit15
# brkreg 0000 0000 1111 1111
#                  ^       ^
#                  |       channel 0 break request (highest priority)
#                  channel 7

my $brkreg;             # break register
my $iopstate;           # used to recieve the external register content
my $mpx1;               # multiplex word 1 external register
my $mpx2;               # multiplex word 2 external register
my $tx3;                # temporary for multiplex channel processing

# Channel break flipflops in breakregister
use constant BMD0  => 0x0004;   # MH disk CU    addr 0x2 => subchannel 2 => bit 13
use constant BLP   => 0x0080;   # Line printer: addr 0x7 => subchannel 7 => bit  8
use constant BCR   => 0x0040;   # Card reader:  addr 0x6 => subchannel 6 => bit  9 


###insert event.md (the simulator event handler)
### event.md
# The simulator event handler
#===============================================================================
my $interval;               # decreasing: number of instructions still to be executed till next event
my $currentinterval;	    # fixed: number of instructions to be executed till next event
my $event_queue;
my $queue_empty_time = 5000;
my $time;                   # accumulated number of executed instructions
my $ctime;                  # current time: always calculated from $time+executed part of current interval

sub activate_event {
	my $d = shift;		# device for which event is started
	my $t = shift;      # event time out value
	my $cur;
	my $prev = 0;
	my $acc = 0;        # acccumulated time of active events
	
   if($t < 0) { return -1 };                # error
	if(is_active($d)) { return 0 };          # already active
	
	$time = $time + ($currentinterval - $interval);
	# scan event queue (= linked activated devices)
	for($cur = $event_queue; $cur != 0; $cur = $$cur[NEXT])
	{
		if($t < ($acc + $$cur[TIMEOUT]))
		{
			last;
		}
		$acc = $acc + $$cur[TIMEOUT];
		$prev = $cur;
	}
	if($prev == 0)       # insert new event at head of the queue
	{
		$cur = $$d[NEXT] = $event_queue;   # = 0
		$event_queue = $d;                 # = head
	}
	else                 # insert at previous in the queue
	{
		$cur = $$d[NEXT] = $$prev[NEXT];   # = 0
        $$prev[NEXT] = $d;
	}
	$$d[TIMEOUT] = $t - $acc;
	if($cur != 0)
	{
		# make time of next element relative to new one
		$$cur[TIMEOUT] = $$cur[TIMEOUT] - $$d[TIMEOUT];	
	}
	$interval = $$event_queue[TIMEOUT];
	$currentinterval = $interval;
	return 0;
}

sub cancel_event {
   my $d = shift;                # event t o cancel
	my $cur;
	my $next = 0;
	
   if($event_queue == 0) { return 0 };	
	$time = $time + ($currentinterval - $interval);
	if($event_queue == $d)
	{
		$next = $event_queue = $$d[NEXT];
	}
	else
	{
		for($cur = $event_queue; $cur != 0; $cur = $$cur[NEXT])
		{
			if($$cur[NEXT] = $d)
			{
				$next = $$cur[NEXT] = $$d[NEXT];
				last;
			}
		}
	}
	if($next != 0)
	{
		$$next[TIMEOUT] = $$next[TIMEOUT] + $$d[TIMEOUT];
	}
	$$d[0] = 0;
	if($event_queue != 0)
	{
		$interval = $$event_queue[TIMEOUT];
	}
	else
	{
		$interval = $queue_empty_time;
	}
	$currentinterval = $interval;
	return 0;
}

sub is_active {
	my $d = shift;
	my $acc = 0;
	my $cur;
	for($cur = $event_queue; $cur != 0; $cur = $$cur[NEXT])
	{
		if($cur == $event_queue)
		{
			if($interval > 0)
			{
				$acc = $acc + $interval;
			}
		}
		else
		{
			$acc = $acc + $$cur[TIMEOUT];
		}
		if($cur == $d)
		{
			return $acc + 1;
		}
	}
	return 0;
}

sub process_events {
	my $d;
	my $err;
	
	$time = $time + $currentinterval;
	if($event_queue == 0)
	{
		$interval = $queue_empty_time;
		$currentinterval = $interval;
		$err = 0;
	}
	else
	{
		do
		{
			$d = $event_queue;          # remove 1st element from queue
			$event_queue = $$d[NEXT];   # set next
			$$d[NEXT] = 0;
			if($event_queue != 0)
			{
				$interval = $$event_queue[TIMEOUT]; # set new interval
			}
			else
			{
				$interval = $queue_empty_time;
			}
			$currentinterval = $interval;
			if($$d[SERVICE] != 0)
			{
				my $sub = $$d[SERVICE];
				$err = &$sub;           # execute event service routine
			}
			else
			{
				$err = 0;
			}
			# print "p";
		}
		while(($err == 0) && ($interval == 0));
	}
	return $err;
}

sub show_event_queue {
	my $cur;
	my $d;
	my $t;
	prlog("Time: $time Current interval: $currentinterval Actual interval: $interval\n");
	for($cur = $event_queue; $cur != 0; $cur = $$cur[NEXT])
	{
		$d = $$cur[NAME];
		$t = $$cur[TIMEOUT];
		prlog("Device $d Current event time $t\n");
	}
}
#end event.md ===============================================================

######################### Emulator controller ##############################

my $file;
my $log = 0;
my $do = "";
my $n;
my $m;
my $pm;
my $s;

# Init the system ##########################################################
###insert init.md default attached files initialisation
### init.md
# default attached files initialisation
# open default log file
if($logfile ne "")
{
	if(! open (LOG, ">$logfile"))
	{
		prlog("Cannot open the new logfile: $logfile\n");
		$logfile = "";
	}
	else
	{
		$log = 1;
		prlog("Set LOG on and log in $logfile\n");
	}
}

if(! $P856)
{
	prlog("P85x Emulator, version $version\n");
	if($MASRA)
	{
		prlog("Default: Boot MASRA from md1 (boot md1)\n");
	}
	else
	{
		prlog("Default: Boot MASR from bd0 (boot bd0)\n");
	}
}
else
{
	prlog("P85x Emulator, version $version running as a P856\n");
	prlog("Default: Boot DOS5 from md0 (boot md0)\n");
}

# attach a default file to the lineprinter
if($filelpt ne "")
{
	if(! open (LPT, ">$filelpt"))
	{
		prlog("Cannot open lineprinter file: $filelpt\n");
	}
	else
	{
		$LPT[FC] = \*LPT;
		prlog("File $filelpt attached to device LPT\n");
		$LPT[FILE] = $filelpt;		  # file attached and open
		$LPT[LCUR]  = 0;              # set on line 0 current page 	
	}
}


# attach a default diskpack to bd0
if($filebd0 ne "" && ($P856==0 && $MASRA==0))
{
	if(! open (BD0, "+<:raw", $filebd0)) # open for update
	{
		prlog("Cannot open disk file: $filebd0 for device BD0\n");
      prlog("BD0 is NOT READY\n");
	}
	else
	{
		prlog("File $filebd0 attached to device BD0\n");
		$BD0[FILE] = $filebd0;           # file attached and open
		if(Bd0Init())
		{
			$BD0[RDY]  = 1;
			$BD0[STATE] = INAC << 16;
			prlog("BigDisk unit-0 is READY\n");
		}
		else
		{
			$BD0[RDY]  = 0;
		}
	}
}
else
{
	prlog("No file attachted to BD0; BD0 is NOT READY\n");
}

# attach a default diskpack to bd1
if($filebd1 ne "" && ($P856==0 && $MASRA==0))
{
	if(! open (BD1, "+<:raw", $filebd1)) # open for update
	{
		prlog("Cannot open disk file: $filebd1 for device BD1\n");
		prlog("BD1 is NOT READY\n");
	}
	else
	{
		prlog("File $filebd1 attached to device BD1\n");
		$BD1[FILE] = $filebd1;           # file attached and open
		if(Bd1Init())
		{
			$BD1[RDY]  = 1;
			$BD0[STATE] = INAC << 16; # (control unit state!!)
			prlog("BigDisk unit-1 is READY\n");
		}
		else
		{
			$BD1[RDY]  = 0;
		}
	}
}
else
{
	prlog("No file attachted to BD1; BD1 is NOT READY\n");
}

# attach default diskpacks to md0/md1
if(($filemd0 ne "" && $filemd1 ne "") && ($MASRA || $P856))
{
	if(! open (MD0, "+<:raw", $filemd0)) # open for update
	{
		prlog("Cannot open disk file: $filemd0 for device MD0\n");
		prlog("X1215/16 unit-0 is NOT READY\n");
	}
	else
	{
		if(! open (MD1, "+<:raw", $filemd1)) # open for update
		{
			prlog("Cannot open disk file: $filemd1 for device MD1\n");
			prlog("X1215/16 unit-0 is NOT READY\n");
		}
		else
		{
			prlog("File $filemd0 attached to device MD0\n");
			prlog("File $filemd1 attached to device MD1\n");
			$MD0[FILE] = $filemd0;           # file attached and open
			$MD1[FILE] = $filemd1;           # file attached and open
			$MD0[CYL]  = 0;
			$MD0[RDY]  = 1;
			prlog("X1215/16 unit-0 is READY\n");
		}

	}
}
else
{
    prlog("X1215/16 unit-0 is NOT READY\n");
}

# attach default diskpacks to md2/md3
if(($filemd2 ne "" && $filemd3 ne "") && ($MASRA || $P856))
{
	if(! open (MD2, "+<:raw", $filemd2)) # open for update
	{
		prlog("Cannot open disk file: $filemd2 for device MD2\n");
		prlog("X1215/16 unit-1 is NOT READY\n");
	}
	else
	{
		if(! open (MD3, "+<:raw", $filemd3)) # open for update
		{
			prlog("Cannot open disk file: $filemd3 for device MD3\n");
			prlog("X1215/16 unit-1 is NOT READY\n");
		}
		else
		{
			prlog("File $filemd2 attached to device MD2\n");
			prlog("File $filemd3 attached to device MD3\n");
			$MD2[FILE] = $filemd2;           # file attached and open
			$MD3[FILE] = $filemd3;           # file attached and open
			$MD2[CYL]  = 0;
			$MD2[RDY]  = 1;
			prlog("X1215/16 unit-1 is READY\n");
		}

	}
}
else
{
    prlog("X1215/16 unit-1 is NOT READY\n");
}
#end init.md =======================================================


####################### emulator controller data ############################
my $EmTrace  = 0;           # trace on if 1, trace off 0
my $platrace = 0;           # regional trace: physical load address of program
my $pbatrace = 0;           # regional trace: physicalregion start (relative to pla)
my $peatrace = 0;           # regional trace: physicalregion end   (relative to pla)
my $EmBreak  = 0;           # 1 in case a breakpoint exist, else 0
my %BP;                     # breakpoint hash
my $program_started = 0;    # 1 if new program is started by RUN/GO/STEP
                            # reset, by reset-all command
# papertape format
my $null    = 0;
my $rub     = 0377;         # start of tape
my $xoff    = 0224;         # end of tape

############################# TTY devices ##################################
# Multiple TTY's are supperted. When MASR is started TY0 (TY10) is used as
# operater console (OPCON). TY1 (TY08), TY2 (TY09) can be used as terminals eg.
# for command processing (FCL, LIB, etc.) The keyboard is shared by the TTY's
# so only one tty input is active at a particular moment. 
# The keyboard is swapped by changing the tty window focus.

###insert ty0.md teletype
### ty0.md
###OPCON### the primary tty (TY0 => ty10)

sub cio_ty0 {
	my $f = shift;                  # function bit
	my $stat = $TY0[STATE] >> 16;   # get status/cu state
	if($f == 0) # CIO stop
	{
        if(($stat == IEXE) || ($stat == OEXE) || ($stat == IEXC) || ($stat == OEXC))
        {
            $TY0[STATE] = $TY0[STATE] | (WREQ << 16);     # state = wait state requested
        }
        if(DEBUG_TY)
        {
            prlog("TY-CIOstp at pc: " . prhex(16,$R[A0]) . " pcp: " . prhex(20,$pcp) . "\n");
        }
        $CR = 0;
	}
	elsif($stat == INAC)
	{
        if($R[$r3] & 1) # CIO start
        {
            # INPUT
            # tty event is already scheduled
            $TY0[STATE] = (IEXE << 16);        # state = reset + input + execute
            $TY0[BUFFER]  = 0;                 # reset tty buffer
            $ty0->SetCursor('end');
			$ty0->focus;
			$ty0->update;
            if(DEBUG_TY)
            {
                prlog("TY-CIOstri, at pc " . prhex(16,$R[A0]) . " pcp: " . prhex(20,$pcp) . " r3=$R[$r3]\n");
            }
        }
        else
        {
            # OUTPUT
            $TY0[STATE] = (OEXC << 16);        # state = reset + output + exchange
            $intreg0 = $intreg0 | IASR;        # set the ready flipflop
            if(DEBUG_TY)
            {
                prlog("TY-CIOstro at pc: " . prhex(16,$R[A0]) . " pcp: " . prhex(20,$pcp) . " r3=$R[$r3]\n");
            }
        }
		$CR = 0;
	}
	else
	{
		$CR = 1;                               # not accepted
	}
}
	
# tty service routine 
# processes the 'execute state' of the simulated tty cu+device, and:
# - simulated panel interrupt (key CntrlP)
# - stopping of the simulator by pressing the stop key CntrE

sub svc_ty0 
{
	my $stat = ($TY0[STATE] >> 16);
	my $k;
	if($ty0key != 0) # key defined?
	{
		$k=$ty0key;
		$ty0key = 0; # reset key
        if($CtrlP)	# CntrP
        {
            prlog("\nOPCON Panel interrupt " . prhex(20,$TY0[STATE]) . "\n");
            # waiting for tty input? if yes, close input and postpone 
			# the panel interrupt until the sst instruction.
            if($stat == IEXE)
            {
            	$TY0[BUFFER] = 0xD;                        # CR into buffer
                $intreg0 = $intreg0 | IASR;                # set the ready flipflop
                $TY0[STATE] = $TY0[STATE] & 0xFFFF;        # reset cu state bits
                $TY0[STATE] = $TY0[STATE] | (IEXC << 16);  # state = input + exchange
            }
            else
            {
            	$CtrlP=0;
            	trap(CP); # set the panel interrupt
            }
        }
        elsif($CtrlE)  # CntrE
        {
        	$CtrlE=0;
            prlog("\nOPCON Keyboard interrupt (Stop execution)\n");
            $RUN = 0;
        }
        else
        {
        	# ENTER provides 0A under Unix and 0D under Windows
        	# Always respond with a 0D (= p800 record end)
            if($k == 0x0A || $k == 0x0D)
            {
                $k = 0x0D;
                $TY0[NLCR] = 1;  # we are on a new line in the window
            }
            if($log)
            {
            	print LOG chr($k);
            }
            if( $stat == IEXE )                                # input + execute
            {
                if($TY0[BUFFER] == 0)                          # buffer reset?
                {
                    $TY0[BUFFER] = $k;                          # save character in buffer
                    $intreg0 = $intreg0 | IASR;                # set the ready flipflop
                    $TY0[STATE] = $TY0[STATE] & 0xFFFF;        # reset cu state bits
                    $TY0[STATE] = $TY0[STATE] | (IEXC << 16);  # state = input + exchange
                    # wait for INR
                }
                else
                {
                    prlog("Error: TY0-INR did not reset the buffer\n");				
                }
            }
            elsif( $stat == IEXC )                        # input + exchange
            {
                # throughput error (INR did not process)
                $intreg0 = $intreg0 | IASR;               # set the ready flipflop
                $TY0[STATE] = $TY0[STATE] & 0xFFFF;       # reset cu state bits
                $TY0[STATE] = $TY0[STATE] | (WAIT << 16); # cu state = wait
                $TY0[STATE] = $TY0[STATE] | 2;            # set throughput error bit in state	
                prlog("Error: TY0-throughput error\n");
            }
            else
            {
                prlog("TY0: ignore key\n"); # ignore key
            }
        }
    }
  
    if($stat == OEXE )                            # output + execute
    {
      $k = $TY0[BUFFER] & 0x7F;                   # print buffered character
		if(DEBUG_TY)
		{
			prlog("  TY0 out1 " . chr($k) . " " . prhex(16,$k) . "\n");
		}
        if($k == 0)
        {
        	;				                             # skip 0 (between /0D and /0A)
        }
        elsif($k == 0xD)
        {
            prlogty0("\r");
        }
        elsif($k == 0xA || $k == 0xC)
        {
            prlogty0("\r\n");
        }
        else
        {
            prlogty0(chr($k));
        }
        $intreg0 = $intreg0 | IASR;                   # set the ready flipflop
        $TY0[STATE] = $TY0[STATE] & 0xFFFF;           # reset cu state bits
        $TY0[STATE] = $TY0[STATE] | (OEXC << 16);     # state = output + exchange
        # wait for OTR or CIO stop
    }
    
    if( $stat & WREQ)
    {
        # stop io requested (CIO stop)
        if($stat == (OEXE + WREQ))
        {
            if(!($intreg0 & IASR))
            {
                # not ready, so still a buffered output character pending
                $k = $TY0[BUFFER] & 0x7F;             # print buffered character
				if(DEBUG_TY)
				{
					prlog("  TY0 out2 " . chr($k) . " " . prhex(16,$k) . "\n");
				}
                if($k == 0)
                {
                	;				# skip 0 (between /0D and /0A)
                }
                if($k == 0xD)
                {
                    prlogty0("\r");
                }
                elsif($k == 0xA || $k == 0xC)
                {
                    prlogty0("\r\n");
                }
                else
                {
                    prlogty0(chr($k));
                }				                       
            }
        }
        $intreg0 = $intreg0 | IASR;                     # set the ready flipflop
        $TY0[STATE] = $TY0[STATE] & 0xFFFF;           # reset cu state bits
        $TY0[STATE] = $TY0[STATE] | (WAIT << 16);     # cu state = wait
    }
	# schedule next tty event
	activate_event(\@TY0, $TY0[TIME]);
	$ty0->update;
}

sub inr_ty0 {
	my $k;
	if( ($TY0[STATE] >> 16) == IEXC )
	{
		# cu in exchange state
		$k = $TY0[BUFFER] & 0x7F;                     # buffered character
		if($k == 0xA)                                 # buffered character to r3
		{
			$R[$r3] = 0xD;
		}
		else
		{
			$R[$r3] = $k;
		}               
		$intreg0 = $intreg0 & (~ IASR);               # reset the ready flipflop
		$TY0[STATE] = $TY0[STATE] & 0xFFFF;           # reset cu state bits
		$TY0[STATE] = $TY0[STATE] | (IEXE << 16);     # state = input + execute
		$TY0[BUFFER] = 0;                             # reset the buffer
		$CR = 0;
      if(DEBUG_TY)
      {
          prlog(" TY-INR at pc: " . prhex(16,$R[A0]) . " pcp: " . prhex(20,$pcp) . " r3=" . prhex(16,$R[$r3]) . "\n");
      }
	}
	else
	{
		$CR = 1;
	}	
}

sub otr_ty0 {
	if(($TY0[STATE] >> 16) == OEXC )
	{
		# cu in exchange state
		$TY0[BUFFER] = $R[$r3] & 0x7F;                # buffer character
		$intreg0 = $intreg0 & (~ IASR);               # reset the ready flipflop
		$TY0[STATE] = $TY0[STATE] & 0xFFFF;           # reset cu state bits
		$TY0[STATE] = $TY0[STATE] | (OEXE << 16);     # state = output + execute
		$CR = 0;
		if(DEBUG_TY)
		{
			prlog(" TY-OTR at pc: " . prhex(16,$R[A0]) . " pcp: " . prhex(20,$pcp) . " r3=" . prhex(16,$R[$r3]) . "\n");
		}
	}
	else
	{
		$CR = 1;
	}
}

sub sst_ty0 {
    if(($TY0[STATE] >> 16) == WAIT)
    {
        # cu in wait state
        $TY0[STATE] = $TY0[STATE] & 0xFFFF;           # cu = inactive
        $R[$r3] = $TY0[STATE];                        # r3 = status
        $intreg0 = $intreg0 & (~ IASR);               # reset the ready flipflop
        $TY0[BUFFER] = 0;
        $CR = 0;
        if($CtrlP)
        {
        	$CtrlP=0;
        	trap(CP);
        }
        if(DEBUG_TY)
        {
            prlog("TY-SST at pc: " . prhex(16,$R[A0]) . " pcp: " . prhex(20,$pcp) . " r3=$R[$r3]\n");
        }
    }
    else
    {
        $R[$r3] = 0;                                  # interrupt handler MASR tests r3
        $CR = 1;	                                  # sst no accepted
    }
}

sub tst_ty0 {
	if( ($TY0[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # busy, not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}	
	$CR = 0;
	if(DEBUG_TY)
	{
		prlog("TY-TST at pc: " . prhex(16,$R[A0]) . " pcp: " . prhex(20,$pcp) . " r3=$R[$r3]\n");
   }
}


sub state_ty0 {
	prlog("CU" . prhex(20,$TY0[STATE]) . " CR" . prhex(4,$CR) . " BUFFER" . prhex(8,$TY0[BUFFER]) . " CSET $TY0[CSET]" . "\n");
}

sub reset_ty0 {
	$intreg0 = $intreg0 & (~ IASR);                   # reset the ready flipflop
	$TY0[STATE]  = INAC << 16;                        # state = inactive + 0
	$TY0[BUFFER] = 0;                                 # reset tty buffer
	$TY0[NLCR]   = 1;
}
#end ty0.md ===============================================================

###insert ty1.md teletype
### ty1.md
###CMDCON1############# the 2nd tty (TY1 => ty08)

sub cio_ty1 {
	my $f = shift;                  # function bit
	my $stat = $TY1[STATE] >> 16;   # get status/cu state
	if($f == 0) # CIO stop
	{
        if(($stat == IEXE) || ($stat == OEXE) || ($stat == IEXC) || ($stat == OEXC))
        {
            $TY1[STATE] = $TY1[STATE] | (WREQ << 16);     # state = wait state requested
        }
        $CR = 0;
	}
	elsif($stat == INAC)
	{
        if($R[$r3] & 1) # CIO start
        {
            # INPUT
            # tty event is already scheduled
            $TY1[STATE] = (IEXE << 16);        # state = reset + input + execute
            $TY1[BUFFER]  = 0;                 # reset tty buffer
			$ty1->SetCursor('end');
			$ty1->focus;
			$ty1->update;
        }
        else
        {
            # OUTPUT
            $TY1[STATE] = (OEXC << 16);        # state = reset + output + exchange
            $intreg0 = $intreg0 | ITY1;        # set the ready flipflop
        }
	     $CR = 0;
        activate_event(\@TY1, $TY1[TIME]);
	}
	else
	{
		$CR = 1;                               # not accepted
	}
}
	
# tty service routine 
# processes the 'execute state' of the simulated tty cu+device, and:
# - simulated panel interrupt (key CntrlP)
# - stopping of the simulator by pressing the stop key CntrE

sub svc_ty1 {
	my $stat = ($TY1[STATE] >> 16);
	my $k;
	if($ty1key != 0) # key defined?
	{
		$k=$ty1key;
		$ty1key = 0; # reset key
        if($CtrlP)	# CntrP
        {
            prlog("\nTY1 Panel interrupt " . prhex(20,$TY1[STATE]) . "\n");
            $CtrlP=0;
            trap(CP);
        }
        elsif($CtrlE)  # CntrE
        {
        	$CtrlE=0;
            prlog("\nTY1 Keyboard interrupt (Stop execution)\n");
            $RUN = 0;
        }
        else
        {
        	# ENTER provides 0A under Unix and 0D under Windows
        	# Always respond with a 0D (= p800 record end)
            if($k == 0x0A || $k == 0x0D)
            {
                $k = 0x0D;
                $TY1[NLCR] = 1;  # we are on a new line in the window
            }
            if($log)
            {
            	print LOG chr($k);
            }
            if( $stat == IEXE )                                # input + execute
            {
                if($TY1[BUFFER] == 0)                          # buffer reset?
                {
                    $TY1[BUFFER] = $k;                         # save character in buffer
                    $intreg0 = $intreg0 | ITY1;                # set the ready flipflop
                    $TY1[STATE] = $TY1[STATE] & 0xFFFF;        # reset cu state bits
                    $TY1[STATE] = $TY1[STATE] | (IEXC << 16);  # state = input + exchange
                    # wait for INR
                }
                else
                {
                    prlog("Error: TY1-INR did not reset the buffer\n");				
                }
            }
            elsif( $stat == IEXC )                        # input + exchange
            {
                # throughput error (INR did not process)
                $intreg0 = $intreg0 | ITY1;               # set the ready flipflop
                $TY1[STATE] = $TY1[STATE] & 0xFFFF;       # reset cu state bits
                $TY1[STATE] = $TY1[STATE] | (WAIT << 16); # cu state = wait
                $TY1[STATE] = $TY1[STATE] | 2;            # set throughput error bit in state	
                prlog("Error: TY1-throughput error\n");
            }
            else
            {
                prlog("TY1: ignore key\n"); # ignore key
            }
        }
    }

    if($stat == OEXE )                              # output + execute
    {
        $k = $TY1[BUFFER] & 0x7F;                   # print buffered character
		  if($k == 0)
        {
        	;				                        # skip 0 (between /0D and /0A)
        }
        elsif($k == 0xD)
        {
            prlogty1("\r");
        }
        elsif($k == 0xA)
        {
            prlogty1("\r\n");
        }
        else
        {
            prlogty1(chr($k));
        }
        $intreg0 = $intreg0 | ITY1;                   # set the ready flipflop
        $TY1[STATE] = $TY1[STATE] & 0xFFFF;           # reset cu state bits
        $TY1[STATE] = $TY1[STATE] | (OEXC << 16);     # state = output + exchange
        # wait for OTR or CIO stop
    }
    
    if( $stat & WREQ)
    {
        # stop io requested (CIO stop)
        if($stat == (OEXE + WREQ))
        {
            if(!($intreg0 & ITY1))
            {
                # not ready, so still a buffered output character pending
                $k = $TY1[BUFFER] & 0x7F;             # print buffered character
				if($k == 0)
				{
					;				                  # skip 0 (between /0D and /0A)
				}
                if($k == 0xD)
                {
                    prlogty1("\r");
                }
                elsif($k == 0xA)
                {
                    prlogty1("\r\n");
                }
                else
                {  
                    prlogty1(chr($k));
                }				                       
            }
        }
        $intreg0 = $intreg0 | ITY1;                   # set the ready flipflop
        $TY1[STATE] = $TY1[STATE] & 0xFFFF;           # reset cu state bits
        $TY1[STATE] = $TY1[STATE] | (WAIT << 16);     # cu state = wait
    }
	# schedule next tty event
	activate_event(\@TY1, $TY1[TIME]);
	$ty1->update;
}

sub inr_ty1 {
	my $k;
	if( ($TY1[STATE] >> 16) == IEXC )
	{
		# cu in exchange state
		$k = $TY1[BUFFER] & 0x7F;                     # buffered character
		if($k == 0xA)                                 # buffered character to r3
		{
			$R[$r3] = 0xD;
		}
		else
		{
			$R[$r3] = $k;
		}               
		$intreg0 = $intreg0 & (~ ITY1);               # reset the ready flipflop
		$TY1[STATE] = $TY1[STATE] & 0xFFFF;           # reset cu state bits
		$TY1[STATE] = $TY1[STATE] | (IEXE << 16);     # state = input + execute
		$TY1[BUFFER] = 0;                             # reset the buffer
		$CR = 0;
	}
	else
	{
		$CR = 1;
	}	
}

sub otr_ty1 {
	if(($TY1[STATE] >> 16) == OEXC )
	{
		# cu in exchange state
		$TY1[BUFFER] = $R[$r3] & 0x7F;                # buffer character
		$intreg0 = $intreg0 & (~ ITY1);               # reset the ready flipflop
		$TY1[STATE] = $TY1[STATE] & 0xFFFF;           # reset cu state bits
		$TY1[STATE] = $TY1[STATE] | (OEXE << 16);     # state = output + execute
		$CR = 0;
	}
	else
	{
		$CR = 1;
	}
}

sub sst_ty1 {
    if(($TY1[STATE] >> 16) == WAIT)
    {
        # cu in wait state
        $TY1[STATE] = $TY1[STATE] & 0xFFFF;           # cu = inactive
        $R[$r3] = $TY1[STATE];                        # r3 = status
        $intreg0 = $intreg0 & (~ ITY1);               # reset the ready flipflop
        $TY1[BUFFER] = 0;
        $CR = 0;
    }
    else
    {
        $R[$r3] = 0;                                  # interrupt handler MASR tests r3
        $CR = 1;	                                  # sst not accepted
    }
}

sub tst_ty1 {
	if( ($TY1[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # busy, not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}	
	$CR = 0;
}

sub state_ty1 {
	prlog("CU" . prhex(20,$TY1[STATE]) . " CR" . prhex(4,$CR) . " BUFFER" . prhex(8,$TY1[BUFFER]) . " CSET $TY1[CSET]" . "\n");
}

sub reset_ty1 {
	$intreg0 = $intreg0 & (~ ITY1);                   # reset the ready flipflop
	$TY1[STATE]  = INAC << 16;                        # state = inactive + 0
	$TY1[BUFFER] = 0;                                 # reset tty buffer
	$TY1[NLCR]   = 1;
}
#end ty1.md ===============================================================

# For ty2 as a basic tty insert the following module (remove ty2_2.md and ty2_esc_1.md)
###insert ty2.md teletype
### ty2.pm
###CMDCON2############# the 3rd tty (TY2 => ty09)

### configure the window for TY2 (TY09); the 1st additional typewriter

$ty2w=$mw->Toplevel();
$ty2w->title("P85x: TY2 (Teletype TY09)");
$ty2=$ty2w->Scrolled("Text", -scrollbars=>'osoe') -> pack(-expand=>1,-fill=>'both');
$ty2->configure(-wrap=>'none', -state=>'disabled');
$ty2-> bind('<KeyPress>' => \&ty2keypress );             ##########
$ty2-> bind('<KeyRelease>' => \&ty2keyrelease);          ##########
$ty2-> bind('<Button>' => \&ty2button);                  ##########

sub ty2keypress
{
	$key=($Tk::event->N) & 0xFF;    # code
	my $ch= $Tk::event->A;          # ASCII symbol
	my $kn= $Tk::event->K;          # keyname
	if(($key == 0xE3) || ($key == 0xE4))
	{
		# Control Key
		if($control)
		{
			# in in cotrol mode, ignore
			return;
		}
		$control = 1;	# set control mode
		return;
	}
	if(($key == 0x65 || $key == 0x70) && $control) # control mode
	{
		# CtrlE (Stop) or CtrlP (Panel Interrupt)
		if($key==0x65)
		{
			# CtrlE
			$ty2->insert('end',"\nStop(TY2)\n");
			$ty2->see('end');
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			$RUN=0;
		}
		else
		{
			# CtrlP
			$CtrlP = 1;
			$ty2->see('end');
			$ty2->SetCursor('end');
			$ty2->focus;
		}
		$ty2key = $key;
		$control=0;	# reset control mode
		return;
	}
	if( $kn eq 'BackSpace')
	{
		$ty2key = 0x5F;
		return;
	}
	if($key > 0x60 && $key < 0x7B) # lower case
	{
		# make upper case
		my $k=UP(chr($key));
		$ty2->delete('end - 2 chars');
		$ty2->insert('end',$k);
		$key=$key-0x20;
	}
	if(($key > 0x1F && $key < 0x60 && $ch ne "") || $key == 0xA || $key == 0xD)
	{
		# Valid character
		$ty2key = $key;
	}
}

sub ty2keyrelease
{
	$key=($Tk::event->N) & 0xFF; # code
	if(($key == 0xE3) || ($key == 0xE4))
	{
		$control=0;	# reset control mode
	}
	$key=0;
	return;
}

# mouse button press
sub ty2button
{
	$ty2->SetCursor('end');
	$ty2->focus;
}

# dummy ansi routines
sub ty2rb1click {};
sub ty2rb2click {};
sub ty2rb3click {}; # show echo status
sub ty2rb4click {}; # show insert status
sub ty2rb5click {}; # show CtrlA status


sub cio_ty2 {
	my $f = shift;                  # function bit
	my $stat = $TY2[STATE] >> 16;   # get status/cu state
	if($f == 0) # CIO stop
	{
        if(($stat == IEXE) || ($stat == OEXE) || ($stat == IEXC) || ($stat == OEXC))
        {
            $TY2[STATE] = $TY2[STATE] | (WREQ << 16);     # state = wait state requested
        }
        $CR = 0;
	}
	elsif($stat == INAC)
	{
        if($R[$r3] & 1) # CIO start
        {
            # INPUT
            # tty event is already scheduled
            $TY2[STATE] = (IEXE << 16);        # state = reset + input + execute
            $TY2[BUFFER]  = 0;                 # reset tty buffer
			$ty2->SetCursor('end');
			$ty2->focus;
			$ty2->update;
        }
        else
        {
            # OUTPUT
            $TY2[STATE] = (OEXC << 16);        # state = reset + output + exchange
            $intreg0 = $intreg0 | ITY2;        # set the ready flipflop
        }
        $CR = 0;
        activate_event(\@TY2, $TY2[TIME]);
	}
	else
	{
		$CR = 1;                               # not accepted
	}
}

# tty service routine 
# processes the 'execute state' of the simulated tty cu+device, and:
# - simulated panel interrupt (key CntrlP)
# - stopping of the simulator by pressing the stop key CntrE
sub svc_ty2 {
	my $stat = ($TY2[STATE] >> 16);
	my $k;
	if($ty2key != 0) # key defined?
	{
		$k=$ty2key;
		$ty2key = 0; # reset key
        if($CtrlP)	# CntrP
        {
            prlog("\nTY2 Panel interrupt " . prhex(20,$TY2[STATE]) . "\n");
            $CtrlP=0;
            trap(CP);
        }
        elsif($CtrlE)  # CntrE
        {
        	$CtrlE=0;
            prlog("\nTY2 Keyboard interrupt (Stop execution)\n");
            $RUN = 0;
        }
        else
        {
        	# ENTER provides 0A under Unix and 0D under Windows
        	# Always respond with a 0D (= p800 record end)
            if($k == 0x0A || $k == 0x0D)
            {
                $k = 0x0D;
                $TY2[NLCR] = 1;  # we are on a new line in the window
            }
            if($log)
            {
            	print LOG chr($k);
            }
            if( $stat == IEXE )                                # input + execute
            {
                if($TY2[BUFFER] == 0)                          # buffer reset?
                {
                    $TY2[BUFFER] = $k;                         # save character in buffer
                    $intreg0 = $intreg0 | ITY2;                # set the ready flipflop
                    $TY2[STATE] = $TY2[STATE] & 0xFFFF;        # reset cu state bits
                    $TY2[STATE] = $TY2[STATE] | (IEXC << 16);  # state = input + exchange
                    # wait for INR
                }
                else
                {
                    prlog("Error: TY2-INR did not reset the buffer\n");				
                }
            }
            elsif( $stat == IEXC )                        # input + exchange
            {
                # throughput error (INR did not process)
                $intreg0 = $intreg0 | ITY2;               # set the ready flipflop
                $TY2[STATE] = $TY2[STATE] & 0xFFFF;       # reset cu state bits
                $TY2[STATE] = $TY2[STATE] | (WAIT << 16); # cu state = wait
                $TY2[STATE] = $TY2[STATE] | 2;            # set throughput error bit in state	
                prlog("Error: TY2-throughput error\n");
            }
            else
            {
                prlog("TY2: ignore key\n"); # ignore key
            }
        }
    }

    if($stat == OEXE )                              # output + execute
    {
        $k = $TY2[BUFFER] & 0x7F;                   # print buffered character
        if($k == 0)
        {
        	;				                        # skip 0 (between /0D and /0A)
        }
        elsif($k == 0xD)
        {
            prlogty2("\r");
        }
        elsif($k == 0xA)
        {
            prlogty2("\r\n");
        }
        else
        {
            prlogty2(chr($k));
        }
        $intreg0 = $intreg0 | ITY2;                   # set the ready flipflop
        $TY2[STATE] = $TY2[STATE] & 0xFFFF;           # reset cu state bits
        $TY2[STATE] = $TY2[STATE] | (OEXC << 16);     # state = output + exchange
        # wait for OTR or CIO stop
    }
    
    if( $stat & WREQ)
    {
        # stop io requested (CIO stop)
        if($stat == (OEXE + WREQ))
        {
            if(!($intreg0 & ITY2))
            {
                # not ready, so still a buffered output character pending
                $k = $TY2[BUFFER] & 0x7F;             # print buffered character
				if($k == 0)
				{
					;				                  # skip 0 (between /0D and /0A)
				}
                if($k == 0xD)
                {
                    prlogty2("\r");
                }
                elsif($k == 0xA)
                {
                    prlogty2("\r\n");
                }
                else
                {  
                    prlogty2(chr($k));
                }				                       
            }
        }
        $intreg0 = $intreg0 | ITY2;                   # set the ready flipflop
        $TY2[STATE] = $TY2[STATE] & 0xFFFF;           # reset cu state bits
        $TY2[STATE] = $TY2[STATE] | (WAIT << 16);     # cu state = wait
    }
	# schedule next tty event
	activate_event(\@TY2, $TY1[TIME]);
	$ty2->update;
}


sub inr_ty2 {
	my $k;
	if( ($TY2[STATE] >> 16) == IEXC )
	{
		# cu in exchange state
		$k = $TY2[BUFFER] & 0x7F;                     # buffered character
		if($k == 0xA)                                 # buffered character to r3
		{
			$R[$r3] = 0xD;
		}
		else
		{
			$R[$r3] = $k;
		}               
		$intreg0 = $intreg0 & (~ ITY2);               # reset the ready flipflop
		$TY2[STATE] = $TY2[STATE] & 0xFFFF;           # reset cu state bits
		$TY2[STATE] = $TY2[STATE] | (IEXE << 16);     # state = input + execute
		$TY2[BUFFER] = 0;                             # reset the buffer
		$CR = 0;
	}
	else
	{
		$CR = 1;
	}	
}

sub otr_ty2 {
	if(($TY2[STATE] >> 16) == OEXC )
	{
		# cu in exchange state
		$TY2[BUFFER] = $R[$r3] & 0x7F;                # buffer character
		$intreg0 = $intreg0 & (~ ITY2);               # reset the ready flipflop
		$TY2[STATE] = $TY2[STATE] & 0xFFFF;           # reset cu state bits
		$TY2[STATE] = $TY2[STATE] | (OEXE << 16);     # state = output + execute
		$CR = 0;
	}
	else
	{
		$CR = 1;
	}
}

sub sst_ty2 {
    if(($TY2[STATE] >> 16) == WAIT)
    {
        # cu in wait state
        $TY2[STATE] = $TY2[STATE] & 0xFFFF;           # cu = inactive
        $R[$r3] = $TY2[STATE];                        # r3 = status
        $intreg0 = $intreg0 & (~ ITY2);               # reset the ready flipflop
        $TY2[BUFFER] = 0;
        $CR = 0;
    }
    else
    {
        $R[$r3] = 0;                                  # interrupt handler MASR tests r3
        $CR = 1;	                                  # sst not accepted
    }
}

sub tst_ty2 {
	if( ($TY2[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # busy, not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}	
	$CR = 0;
}

sub state_ty2 {
	prlog("CU" . prhex(20,$TY2[STATE]) . " CR" . prhex(4,$CR) . " BUFFER" . prhex(8,$TY2[BUFFER]) . " CSET $TY2[CSET]" . "\n");
}

sub reset_ty2 {
	$intreg0 = $intreg0 & (~ ITY2);                   # reset the ready flipflop	
	 $TY2[STATE]  = INAC << 16;                        # state = inactive + 0
     $TY2[BUFFER] = 0;                                 # reset tty buffer
     $TY2[NLCR]   = 1;
}



#end ty2.pm ===============================================================

# For ty2 as an ansi terminal insert the following two modules (remove ty2.md)
######insert ty2_2.md teletype/ansi terminal

######insert ty2_esc_1.md parse esc sequences

#############################################################################


# do script called at startup?
if($w[0] ne "")
{
    prlog("Processing of a startup script is not implemented yet\n");
}
initdecoder();
ty2rb3click(); # show echo status
ty2rb4click(); # show insert status
ty2rb5click(); # show CtrlA status
prlog ("> ");
MainLoop;

#end(main)
#===================================================================================

###insert command.md The command handler
### command.md
# The command handler
#===============================================================================
sub Command
{
	# read a command from a file (not implmented yet in p85x)
	if($do)
	{
		$cmdstr = <DO>;
		if($cmdstr eq "")
		{
			close DO || die "can't close $do: $!";			
			$do = ""; # reset after eof
		}
		else
		{
			
			prlog($cmdstr);
			chop $cmdstr;
			@W = split(/ /, $cmdstr);
			$cmdstr = LOW($cmdstr);
			@w = split(/ /, $cmdstr); #lowercase			
		}
	}
	
	# check and execute the command
	if($w[0] eq "run")
	{
		if($program_started)
		{
			prlog("Proceed with \"continue\", \"step\" or \"reset\"\n");
		}
		else
		{
			reset_all();
			if($w[1] ne "")
			{
				$n = cvhex(UP($w[1]));
				$n = $n & MAXADDR;
				$R[0] = $n;                    # set PC
			}
			
			$interval = 0;
			$currentinterval = 0;
			$time = 0;
			$event_queue = 0;
			if($rtc_on)
			{
				reset_clk();
				cio_clk(1);  # start rtc
			}
			# tty active to listen to CntrP (panel interrupt) or
			#                         CntrE (stop simulation)
			activate_event(\@TY0,$TY0[TIME]); 
			@t0 = gettimeofday ();             # fix t0 to measure elapsed time
			$ty0->configure(-state=>'normal');
			$ty0->see('end');
			$ty0->SetCursor('end');
			$ty0->focus;
			if(! $P856) {
				$ty1->configure(-state=>'normal');
				$ty1->see('end');
				$ty1->SetCursor('end');
					$ty2->configure(-state=>'normal');
					$ty2->see('end');
					$ty2->SetCursor('end');
			}
			$panel->configure(-state=>'disabled');
			$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
			$RUN = 1;
			$bt_stop->configure(-text=>'Stop',-background=>'green',-command=>\&ExeStop);
			while($RUN)
			{
				instr();
			}
			$ty0->configure(-state=>'disabled');
			if(! $P856) {
				$ty1->configure(-state=>'disabled');
					$ty2->configure(-state=>'disabled');
			}
			$panel-> bind('<KeyPress>' => \&cmdrecord);
			$panel->configure(-state=>'normal');
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			$secs = tv_interval (\@t0);        # elapsed run time in secs
			$ctime = $time + ($currentinterval - $interval);   # accumulated runned cycles
			if($secs > 0)
			{
				$cps = int($ctime / $secs);    # cycles per second
			}
			$s = prhex(20,$R[0]);
			$program_started = 1;              # program is still in a running state
			prlog("\nRun: emulation stopped at address $s\n");
			prlog("$ctime instructions in $secs seconds: $cps instructions per second\n");
		}
		BdCheck();
		mem_check(1);
		trace($R[0]);
	}
	elsif($w[0] eq "bd0rw1")
	{
		$bd0rw = 1;
		prlog("Bd0 write enabled\n");
	}
	elsif($w[0] eq "bd0rw0")
	{
		$bd0rw = 0;
		prlog("Bd0 write disabled\n");		
	}
	elsif($w[0] eq "bd1rw1")
	{
		$bd1rw = 1;
		prlog("Bd1 write enabled\n");
	}
	elsif($w[0] eq "bd1rw0")
	{
		$bd1rw = 0;
		prlog("Bd1 write disabled\n");		
	}
	elsif($w[0] eq "go")
	{
		if($program_started)
		{
			prlog("Proceed with \"continue\", \"step\" or \"reset\"\n");
		}
		else
		{
			if($w[1] ne "")
			{
				$n = cvhex(UP($w[1]));
				$n = $n & MAXADDR;				
				$R[0] = $n;                    # set PC
			}
			$interval = 0;
			$currentinterval = 0;
			$time = 0;
			$event_queue = 0;
			if($rtc_on)
			{
				reset_clk();
				cio_clk(1);  # start rtc
			}			
			# tty active to listen to CntrP (panel interrupt) or
			#                         CntrE (stop simulation)
			activate_event(\@TY0,$TY0[TIME]); 
			@t0 = gettimeofday ();             # fix t0 to measure elapsed time
			$ty0->configure(-state=>'normal');
			$ty0->see('end');
			$ty0->SetCursor('end');
			$ty0->focus;
			if(! $P856) {
				$ty1->configure(-state=>'normal');
				$ty1->see('end');
				$ty1->SetCursor('end');
					$ty2->configure(-state=>'normal');
					$ty2->see('end');
					$ty2->SetCursor('end');
			}
			$panel->configure(-state=>'disabled');
			$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
			$RUN = 1;
			$bt_stop->configure(-text=>'Stop',-background=>'green',-command=>\&ExeStop);
			while($RUN)
			{
				instr();
			}
			$ty0->configure(-state=>'disabled');
			if(! $P856) {
				$ty1->configure(-state=>'disabled');
					$ty2->configure(-state=>'disabled');
			}
			$panel-> bind('<KeyPress>' => \&cmdrecord);
			$panel->configure(-state=>'normal');
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			$secs = tv_interval (\@t0);        # elapsed run time in secs
			$ctime = $time + ($currentinterval - $interval);   # accumulated runned cycles
			if($secs>0)
			{
				$cps = int($ctime / $secs);    # cycles per second
			}
			$s = prhex(20,$R[0]);
			$program_started = 1;              # program is still in a running state
			prlog("\nRun/Go: emulation stopped at address $s\n");
			prlog("$ctime instructions in $secs seconds: $cps instructions per second\n");
		}
		BdCheck();
		mem_check(1);
		trace($R[0]);
	}	
	elsif($w[0] eq "continue" || $w[0] eq "c")
	{
		if(! $program_started)
		{
			prlog("Continue only after a run, go or step\n");
		}
		else
		{
			$panel->configure(-state=>'disabled');
			$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
			$ty0->configure(-state=>'normal');
			$ty0->see('end');
			$ty0->SetCursor('end');
			$ty0->focus;
			if(! $P856) {
				$ty1->configure(-state=>'normal');
				$ty1->see('end');
				$ty1->SetCursor('end');
					$ty2->configure(-state=>'normal');
					$ty2->see('end');
					$ty2->SetCursor('end');
			}
			$RUN = 1;
			$bt_stop->configure(-text=>'Stop',-background=>'green',-command=>\&ExeStop);
			while($RUN)
			{
				instr();
			}
			$ty0->configure(-state=>'disabled');
			if(! $P856) {
				$ty1->configure(-state=>'disabled');
					$ty2->configure(-state=>'disabled');
			}
			$panel-> bind('<KeyPress>' => \&cmdrecord);
			$panel->configure(-state=>'normal');
			$panel->see('end');
			$panel->SetCursor('end');
			$panel->focus;
			$ctime = $time + ($currentinterval - $interval);   # accumulated runned cycles
			$s = prhex(20,$R[0]);
			prlog("\nContinue: emulation stopped at address $s, $ctime instructions processed\n");
		}
		BdCheck();
		mem_check(1);
		trace($R[0]);
	}
	elsif($w[0] eq "step" || $w[0] eq "s")
	{
		prlog("step $w[1]\n");
		$n = 1;                              # default nbr of steps
		if($w[1] ne "")
		{
			if( ($n = cvdec(UP($w[1]))) <= 1)
			{
				$n=1;
			};
		}
		if(! $program_started)
		{
			$interval = 0;
			$currentinterval = 0;
			$time = 0;
			$event_queue = 0;
			reset_all();
			if($rtc_on)
			{
				reset_clk();
				cio_clk(1);  # start rtc
			}			
			# tty active to listen to CntrP (panel interrupt) or
			#                         CntrE (stop simulation)
			activate_event(\@TY0, $TY0[TIME]); 
			$program_started = 1;            # program is in a running state
		}
		activate_event(\@STEP, $n);          # set stepper event
		
		$ty0->configure(-state=>'normal');
		$ty0->see('end');
		$ty0->SetCursor('end');
		$ty0->focus;
		if(! $P856) {
			$ty1->configure(-state=>'normal');
			$ty1->see('end');
			$ty1->SetCursor('end');
				$ty2->configure(-state=>'normal');
				$ty2->see('end');
				$ty2->SetCursor('end');
		}
		$panel->configure(-state=>'disabled');
		$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
		$RUN = 1;
		while($RUN)
		{
			instr();
		}
		$ty0->configure(-state=>'disabled');
		if(! $P856) {
			$ty1->configure(-state=>'disabled');
				$ty2->configure(-state=>'disabled');
		}
		$panel-> bind('<KeyPress>' => \&cmdrecord);
		$panel->configure(-state=>'normal');
		$ctime = $time + ($currentinterval - $interval);   # accumulated runned cycles
		$s = prhex(20,$R[0]);
		prlog("Step: $ctime instruction(s) (remaining interval steps $interval), now at address $s\n");
		BdCheck();
		mem_check(1);
		if(! $EmTrace)
		{
			trace($R[0]);
		}
	}
	elsif($w[0] eq "do")
	{
		if($w[1] ne "")
		{
			$do = $w[1];
			if(! open (DO, $do))
			{
				prlog("Unable to open file: $do\n");
				$do = "";
			}
		}
		else
		{
			prlog("No do-script name specified\n");
			$do = "";
		}
	}
	elsif($w[0] eq "breakpoint" || $w[0] eq "bp")
	{
		if($w[1] eq "set" || $w[1] eq "s")
		{
			if(($n = cvhex(UP($w[2]))) >= 0)
			{
				$n = $n & MAXADDR;
				$BP{$n} = $n;
			}
			else
			{
				prlog("Wrong physical address, no breakpoint set\n");
			}
		}
		elsif($w[1] eq "clear" || $w[1] eq "c")
		{
			if($w[2] eq "all" || $w[2] eq "a")
			{
				%BP = ();
			}
			else
			{
				$n = cvhex(UP($w[2]));
				$n = $n & MAXADDR;
				delete $BP{$n};
			}
		}
		elsif($w[1] eq "print" || $w[1] eq "p")
		{
			prlog("Defined Breakpoints\n");
			foreach $n (sort keys( %BP))
			{
				prlog(prhex(20,$n) . "\n");
			}
		}
		else
		{
			prlog("????\n");
		}
		$n = scalar(keys(%BP));
		if($n)
		{
			$EmBreak = 1;
		}
		else
		{
			$EmBreak = 0;
		}
		prlog("$n Breakpoints defined (EmBreak=$EmBreak)\n");
	}
	elsif($w[0] eq "examine" || $w[0] eq "ex")
	{
		if(UP($w[1]) =~ /^LM/)
		{
			$s = UP($w[2]);                   # logical address
			if(($m=cvhex($s)) >= 0 && $m < 0x10000)
			{
				while($m < 0x10000)
				{
					$pm=la2pa($m);            # physical address
					prlog(prhex(16,$m) . prhex(20, $pm) . "  " . prhex(16,$M[$pm]) . " ");
					$s = waitforpanelch();
					$m = $m + 2;
					if($s =~ /S/)
					{
						last;
					}
				}
			}
			else
			{
				prlog("Wrong or no hex logical address\n");
			}
		}
		elsif(UP($w[1]) =~ /^M/)
		{
			$s = UP($w[2]);
			if(($m=cvhex($s)) >= 0 && $m <= MAXADDR)
			{
				$m=$m & MAXADDR;
				while($m < MAXADDR)
				{
					prlog(prhex(20, $m) . "  " . prhex(16,$M[$m]) . " ");
					$s = waitforpanelch();
					$m = $m + 2;
					if($s =~ /S/)
					{
						last;
					}
				}
			}
			else
			{
				prlog("Wrong or no hex physical address\n");
			}
		}
		elsif(($n=$R16{UP($w[1])}) ne undef)
		{
			if($n==0)
			{
				prlog("$w[1] = " . prhex(20,$R[$n]) . "\n");
			}
			else
			{
				prlog("$w[1] = " . prhex(16,$R[$n]) . "\n");
			}
		}
		else
		{
			prlog("Wrong memory or register reference $w[1]\n");
		}
	}
	elsif($w[0] eq "ldhex" || $w[0] eq "ldh")
	{
		my $s0;
		my $s1;
		if($w[1] ne undef)
		{
			if($w[1] eq "s")
			{
				# show content of file while loading
				if($w[2] =~ /.hex/)
				{
					if(! open (FHX, $W[2]))
					{
						prlog("Unable to open file: $W[2]\n");
					}
					else
					{
						while($s=<FHX>)
						{
							chop $s;
							($s0,$s1) = split(/\,/,$s);
							$s0=cvhex($s0) & MAXADDR; 
							$s1=cvhex($s1);
							prlog(prhex(20,$s0) . " " . prhex(16,$s1) . "  octal:" . proct($s0) . " " . proct($s1) . "\n");				
							$M[$s0] = $s1;
						}
						close FHX || die "can't close $W[2]: $!";
					}
				}
				else
				{
					prlog("No proper filename is specified: syntax is: ldhex|ldh [s] <fn>.hex\n");
				}					
			}
			else
			{
				if($w[1] =~ /.hex/)
				{
					if(! open (FHX, $W[1]))
					{
						prlog("Unable to open file: $W[1]\n");
					}
					else
					{
						while($s=<FHX>)
						{
							chop $s;
							($s0,$s1) = split(/\,/,$s);
							$s0=cvhex($s0) & MAXADDR; 
							$s1=cvhex($s1);		
							$M[$s0] = $s1;
						}
						close FHX || die "can't close $W[1]: $!";
					}
				}
				else
				{
					prlog("No proper filename is specified: syntax is: ldhex|ldh [s] <fn>.hex\n");
				}
			}
		}
		else
		{
			prlog("No parameters specified: syntax is: ldhex|ldh [s] <fn>.hex\n");
		}
	}
	elsif($w[0] eq "ldhbased")
	{
		my $s0;
		my $s1;
		my $s2;
		my $la; #1st physical address to load
		my $sa; #1st logical address to load  and logical start addres
		if($w[1] =~ /.hex/)
		{
			if(! open (FHX, $W[1]))
			{
				prlog("Unable to open file: $W[1]\n");
			}
			else
			{
				prlog("Enter physical loadaddress (hex: xxxxx<cr>) :");
				$la = waitforpanelrcd();
				if($la =~ /[\da-fA-F]/)
				{
					if(($la = cvhex(UP($la))) >= 0)
					{
						prlog("The requested load address is: " . prhex(20,$la) . "\n");
						prlog("Continue loading? Confirm with y<cr> : ");
						$s = waitforpanelrcd();
						if(substr($s,0,1) eq "y")
						{
							$s=<FHX>;
							chop $s;
							($s0,$s1) = split(/\,/,$s);
							$s0=cvhex($s0) & MAXADDR; 
							$s1=cvhex($s1);		
							$sa=$s0;
							$M[$la] = $s1;	# load 1st word
							# and the remaining part
							while($s=<FHX>)
							{
								chop $s;
								($s0,$s1) = split(/\,/,$s);
								$s0=cvhex($s0) & MAXADDR; 
								$s1=cvhex($s1);
								$s2=$la + ($s0 - $sa);
								$M[$s2] = $s1;
								prlog(prhex(16,$s0) . " " . prhex(20,$s2) . " " . prhex(16,$s1) . "\n");	
							}
						}
					}
				}
				close FHX || die "can't close $W[1]: $!";
			}
		}
		else
		{
			prlog("No proper filename is specified: syntax is: ldhbased <fn>.hex\n");
		}		
	 }
	 elsif($w[0] eq "decode" || $w[0] eq "dec")
	 {
        # decode logical memory content into symbolic instructions
		my $str;
		my $c;
		my $spcp = $pcp; # save current physical pc: $pcp
		my $spcl = $pcl; # save current logical pc:  $pcl
		$ea = undef;
		$s = UP($w[1]);
		if(($pcl=cvhex($s)) >= 0)
		{
		   $pcl=$pcl & 0xFFFE; # logical address
		   if($w[2] eq "")
		   {
		   	   while($pcl < 0x10000)
		   	   {
		   	   	   $pcp = la2pa($pcl); # physical address
		   	   	   prlog(decode() . "  ");
		   	   	   $s=waitforpanelch();
		   	   	   if(($s =~ /S/) || ($pcl > 0xFFFE)) # if s the stop
		   	   	   {
		   	   	   	   prlog("\n");
		   	   	   	   last;
		   	   	   }
		   	   }
		   }
		   else
		   {
		   	   $s = UP($w[2]);
		   	   $m = cvhex($s) & 0xFFFE;
		   	   while($m > $pcl)
		   	   {
		   	   	   $pcp = la2pa($pcl);
		   	   	   prlog(decode() . "\n");
		   	   }
		   }
		}
		$pcp = $spcp; $pcl = $spcl; #restore
	 }
	 elsif($w[0] eq "dump" || $w[0] eq "du")
	 {
		my $str;
		my $c;
		$s = UP($w[1]);		
		if(($m=cvhex($s)) >= 0)
		{
			$m=$m & MAXADDR & 0xFFFFFFE0;
			$s = UP($w[2]);	
			if(($n=cvhex($s)) >= 0)
			{
				if($w[3] eq "")
				{
					# dump on screen
					while($m < $n)
					{
						$str="";
						$s=0;
						prlog(prhex(20,$m) . " ");
						while($s<8)
						{	
							prlog(prhex(16,$M[$m]));
							$c=$ch{($M[$m] >> 8) & 0xFF};
							if($c ne undef)
							{	
								$str = $str . $c;
							}
							else
							{
								$str = $str . ".";
							}
							$c=$ch{$M[$m] & 0xFF};
							if($c ne undef)
							{
								$str = $str . $c;
							}
							else
							{
								$str = $str . ".";
							}						
							$m=$m+2;
							$s=$s+1;
						}
						prlog(" ");
						$s=0;
						while($s<8)
						{
							prlog(prhex(16,$M[$m]));
							$c=$ch{($M[$m] >> 8) & 0xFF};
							if($c ne undef)
							{
								$str = $str . $c;
							}
							else
							{
								$str = $str . ".";
							}
							$c=$ch{$M[$m] & 0xFF};
							if($c ne undef)
							{
								$str = $str . $c;
							}
							else
							{
								$str = $str . ".";
							}						
							$m=$m+2;
							$s=$s+1;
						}					
						prlog("  $str\n");
					}
				}
				else
				{
					# dump on an absolute papertape
					# print( "$w[3]\n";					
					if($w[3] =~ /\.abs/)
					{
						open (BIN,">:raw", $W[3]) || die "cannot open outputfile: $W[3]: $!";
						prlog("\nPunch in absolute 8+8 papertape load format: $W[3] \n\n");
						my $byte;
						my $w;
						my $chksum=0;
						my $low=$m;
						my $high=$n+2;
						my $i;
						
						punch($rub);                         # rubout
						$w = ($high >> 1) - ($low >> 1);     # word count (high = endaddr + 2)
						$byte = $w >> 8;
						punch($byte);
						$byte = $w & 0xFF;
						punch($byte);

						$w = $low-2;	                     # begin address - 2
						$byte = $w >> 8;
						punch($byte);
						$byte = $w & 0xFF;
						punch($byte);

						$i = $low;                           # begin address 

						while($i < $high)                    # content
						{
							$w = $M[$i];
							$chksum = $chksum ^ $w;
							$byte = $w >> 8;
							punch($byte);
							$byte = $w & 0xFF;
							punch($byte);
							$i = $i + 2;
						}

						$w=$chksum;                          # checksum
						$byte = $w >> 8;
						punch($byte);
						$byte = $w & 0xFF;
						punch($byte);
						punch($xoff);                        # xoff	
						prlog("Papertape ready\n");
						close BIN || die "can't close $W[3]: $!";
					}
					else
					{
						prlog("Wrong filename: no .abs extension\n");
					}
				}
			}
		}					
	}
	elsif($w[0] eq "deposit" || $w[0] eq "de")
	{
		if(UP($w[1]) =~ /^LM/)
		{
			$s = UP($w[2]);                   # logical address
			if(($s=cvhex($s)) >= 0 && $s < 0x10000)
			{
				$pm=la2pa($s);                # physical address
				$m = UP($w[3]);               # content
				if(($m=cvhex($m)) >= 0)
				{
					$M[$pm] = $m;
				}
				else
				{
					# read content from keyboard
					while($s < 0x10000)
					{
						$pm=la2pa($s);        # physical address
						prlog(prhex(16, $s) . prhex(20, $pm) . "  " . prhex(16,$M[$pm]) . " ");
						$m = waitforpanelrcd();
						if($m =~ /S/)
						{
							last;             # stop
						}
						elsif($m =~ /[\da-fA-F]/)
						{
							if(($m=cvhex(UP($m))) >= 0 && $m < 0x10000)
							{
								$M[$pm] = $m;
							}
							else
							{
								prlog("Wrong content\n");
								$s = $s - 2;           # redo current address
							}
						}
						$s = $s + 2;
					}
				}
			}
			else
			{
				prlog("Wrong or no hex logical address\n");
			}
		}
		if(UP($w[1]) =~ /^M/)
		{
			$s = UP($w[2]);                   # physical address
			if(($s=cvhex($s)) >= 0 && $s <= MAXADDR)
			{
				$s=$s & MAXADDR;
				$m = UP($w[3]);               # content
				if(($m=cvhex($m)) >= 0)
				{
					$M[$s] = $m;
				}
				else
				{
					# read content from keyboard
					while(1)
					{
						prlog(prhex(20, $s) . "  " . prhex(16,$M[$s]) . " ");
						$m = waitforpanelrcd();
						if($m =~ /S/)
						{
							last;                 # stop
						}
						elsif($m =~ /[\da-fA-F]/)
						{
							if(($m=cvhex(UP($m))) >= 0)
							{
								$M[$s] = $m;
							}
							else
							{
								prlog("Wrong content\n");
								$s = $s - 2;       # redo current address
							}
						}
						$s = $s + 2;
					}
				}
			}
			else
			{
				prlog("Wrong or no hex physical address\n");
			}
		}
		elsif(($n=$R16{UP($w[1])}) ne undef)
		{
			if($w[2] eq undef)
			{
				prlog("$w[1] = ");
				$s = waitforpanelrcd();	# input hex number
				if(($m=cvhex($s)) >= 0)
				{
					if($n==0 && $m <= MAXADDR)
					{
						$R[$n] = $m & MAXADDR;
					}
					elsif($m < 0x10000)
					{
						$R[$n] = $m;
					}
					else
					{
						prlog("Error input hex number\n");
					}
				}
				else
				{
					prlog("Error input hex number\n");
				}
			}
			else
			{
				$s = UP($w[2]);                   # content
				if(($m=cvhex($s)) >= 0)
				{
					if($n==0 && $m <= MAXADDR)
					{
						$R[$n] = $m & MAXADDR;
					}
					elsif($m < 0x10000)
					{
						$R[$n] = $m;
					}
					else
					{
						prlog("Error input hex number\n");
					}					
				}
				else
				{
					prlog("Error input hex number\n");
				}
			}
		}
		else
		{
			prlog("Wrong memory or register reference $w[1]\n");
		}
	}
	elsif($w[0] eq "reset")
	{
		if($w[1] eq "cpu")
		{
			prlog("CPU reset\n");
			reset_cpu();
		}
		elsif($w[1] eq "ty0")
		{
			prlog("TY0 reset\n");
			reset_ty0();
		}
		elsif($w[1] eq "ty1")
		{
			prlog("TY1 reset\n");
			reset_ty1();
		}
		elsif($w[1] eq "ty2")
		{
			prlog("TY2 reset\n");
			#reset_ty2();
		}        
		elsif($w[1] eq "rtc")
		{
			prlog("Realtime clock reset\n");
			reset_clk();
		}
		elsif($w[1] eq "ptr")
		{
			prlog("Papertape reader reset\n");
			reset_ptr();
		}	
		elsif($w[1] eq "ptp")
		{
			prlog("Papertape punch reset\n");
			reset_ptp();
		}
		elsif($w[1] eq "lpt")
		{
			prlog("Line printer reset\n");
			reset_lpt();
		}	
		elsif($w[1] eq "crd")
		{
			prlog("Card reader reset\n");
			reset_crd();
		}
		elsif($w[1] eq "md0" || $w[1] eq "md1"|| $w[1] eq "md2"|| $w[1] eq "md3")
		{
			prlog("Moving head disk reset\n");
			reset_md0();
		}
		elsif($w[1] eq "bd0")
		{
			prlog("BigDisk reset\n");
			reset_bd0();
		}
		elsif($w[1] eq "mem")
		{
			prlog("Memory reset\n");
			@M=();
		}
		elsif($w[1] eq "power")
		{
		    reset_all();
			@M=();
			$R[0]=0;
			prlog("Power reset\n"); 
		}
		else
		{
			prlog("Reset All, except A0/P and Memory\n"); 
			reset_all();
		}
	}
	elsif($w[0] eq "trace" || $w[0] eq "tr")
	{
		$platrace = 0; # reset rtrace
		$pbatrace = 0;
		$peatrace = 0;
		if($w[1] eq "on")
		{
			if($w[2] eq "")
			{
				$EmTrace = 1;
				# no tracefile specified
				prlog("Set trace $w[1]\n");
			}
			else
			{
				# tracefile specified
				if($tracefile ne "")
				{
					close TRACE || die "can't close $tracefile: $!";
					prlog("Previous tracefile $tracefile is closed\n");
				}
				$tracefile = $W[2];
				if(! open (TRACE, ">$tracefile"))
				{
					$EmTrace = 0;
					prlog("Cannot open the new tracefile: $tracefile\n");
				}
				else
				{
					$EmTrace = 1;
					prlog("Set trace $w[1], trace dumped in $tracefile\n");
				}					
			}
		}
		elsif($w[1] eq "off")
		{
			$EmTrace = 0;
			prlog("Set trace $w[1]\n");
		}
		else
		{
			$EmTrace = 1;
			prlog("Set trace on\n");
		}		
	}
	elsif($w[0] eq "rtrace" || $w[0] eq "rt")
	{
		$EmTrace = 0;
		$platrace = 0;
		$pbatrace = 0;
		$peatrace = 0;
		if($w[1] eq "on")
		{
			if($w[2] ne "")
			{
				$s = UP($w[2]);		
				if(($platrace=(cvhex($s) & MAXADDR)) >= 0)
				{
					if($w[3] ne "")
					{
						$s = UP($w[3]);
						$m=cvhex($s) & MAXADDR;
						if($w[4] ne "")
						{
							$s = UP($w[4]);	
							$n=cvhex($s) & MAXADDR;
							$pbatrace = ($m+$platrace) & MAXADDR;
							$peatrace = ($n+$platrace) & MAXADDR;
							if($pbatrace<=$peatrace)
							{
								$EmTrace = 1;
								prlog("Set rtrace on: pla=" . prhex(20,$platrace) . " pba=" . prhex(20,$pbatrace) . " pea=" . prhex(20,$peatrace) . "\n");
							}
						}
					}
				}
				else
				{
					prlog("Wrong <pla>/<pba>/<pea>, rtrace off\n");
					$platrace = 0;
					$pbatrace = 0;
					$peatrace = 0;
				}
			}
			else
			{
				# just trace the batch userarea (batch only running)
				if($MASR)
				{
					$platrace = 0x1B000; # batch userarea start
					$pbatrace = 0x1B008;
					$peatrace = MAXADDR;
				}
				elsif($MASRA)
				{
					$platrace = 0x15000; # batch userarea start
					$pbatrace = 0x15008;
					$peatrace = MAXADDR;
				}
				$EmTrace = 1;
				prlog("Set rtrace on: pla=" . prhex(20,$platrace) . " pba=" . prhex(20,$pbatrace) . " pea=" . prhex(20,$peatrace) . "\n");
			}
		}
		elsif($w[1] eq "off")
		{
			prlog("Set rtrace $w[1]\n");
		}
		else
		{
			prlog("Wrong rt command, rtrace off\n");
		}
	}
	elsif($w[0] eq "log")
	{
		if($w[1] ne "")
		{
			if($w[1] eq "on" || $w[1] eq "off")
			{
				if($w[1] eq "on")
				{
					if($logfile ne "")
					{
					    $log=1;
					    prlog("Set LOG on and log in existing $logfile\n");						
					}
					else
					{
						prlog("No logfile specified\n");
					}
				}
				if($w[1] eq "off")
				{
					$log=0;
				}
			}
			else
			{
				if($logfile ne "")
				{
					close LOG || die "can't close $logfile: $!";
					prlog("Previous logfile $logfile is closed\n");	
				}
				$logfile = $W[1];
				if(! open (LOG, ">$logfile"))
				{
					prlog("Cannot open the new logfile: $logfile\n");
					$logfile = "";					
				}
				else
				{
					$log = 1;
					prlog("Set LOG on and log in $logfile\n");
				}
			}																			
		}
		else
		{
			prlog("Invalid parameter; use: log [on|off] | <file>\n");
		}
	}	
	elsif($w[0] eq "rtc")
	{
		my $stat;
		if($w[1] eq "on")
		{
			$rtc_on=1;
			$stat = $CLK[STATE] >> 16;
			if($stat == INAC)
			{
				cio_clk(1);
			}
		}
		elsif($w[1] eq "off")
		{
			$rtc_on=0;
			cio_clk(0); # stop clock			
		}

		state_clk();
		$stat = $CLK[STATE] >> 16;
		if($stat == INAC)
		{
			prlog(" is stopped\n");
		}
		elsif($stat == (EXE | WREQ))
		{
			prlog(" is requested to be stopped\n");
		}
		else
		{
			prlog(" is active\n");				
		}		
	}
	elsif($w[0] eq "load")
	{
		my $leader = "false";
		my $c;
		my $w;
		my $err=0;
		my $ba=0;     # begin address of load area
		my $wc=0;     # word count
		my $l;
		my $mode = ""; 

		$file = $W[1];
		if ($file eq "" || (( $file !~ /\.abs/ ) && ( $file !~ /\.rel/ ) && ( $file !~ /\.LM/ ) && ( $file !~ /\.lm/ )))
		{
			prlog("No filename, or wrong extension (must be .abs or .rel/.LM/.lm)\n");
			$err=1;
		}	
				
		if($w[1] =~ /\.abs/)
		{
			$mode = 'a';
		}
		
		if($w[1] =~ /\.rel/ || $w[1] =~ /\.LM/ || $w[1] =~ /\.lm/)
		{
			if($w[2] ne "" && $w[2] =~ /^[0-9a-f]/)
			{
				# load a relocatable load module
				$ba = cvhex(UP($w[2]));
				$ba = $ba & MAXADDR;	
				$mode = 'r';
			}
			elsif($w[2] ne "" && $w[2] eq "mon")
			{
				# load a relocatable monitor load module at address 0
				$ba = -8;
				$mode = 'm';				
			}			
			else
			{
				prlog("Load address missing\n");
				$err = 1;
			}			
		}

		if($err == 0)
		{
			if(! open (IN, $file))
			{
				prlog("Unable to open requested load file: $file\n");
				$err = 1;
			}
		}
		
		if($err == 0 && $mode eq 'a')
		{
			binmode IN, ":raw";			
			prlog("Load $w[1]\n");
			# Read bootable 8+8 formatted paper tape
			# skip leader
			while( 1 )
			{
				$c = nextchar();
				# skip leader in case there
				if ($leader eq "false")
				{
					next if $c eq $null;
					$leader = "true";
					prlog("Leader skipped\n");
					last;
				}
			}
			$wc = nextword();                       # word count
			$ba = (nextword() + 2) & 0xFFFE;        # begin address of load area
			my $low = $ba;
			my $high = $ba + $wc*2;
			my $chksum = 0;
			prlog("Load " . prhex(16,$wc) . " words\; start loading at" . prhex(16,$ba) . "\n");
			$l = 0;
			while($l < $wc)
			{
				$w = nextword();
				$chksum = $chksum ^ $w;
				$M[$ba] = $w;
				$ba = $ba + 2;
				$l = $l + 1;
			}	
			my $chk = nextword();	
			if( ($chksum - $chk) != 0)
			{
				prlog("Checksum error\n");
			}
			$c =nextchar();
			if($c != $xoff)
			{
				prlog("No x-off marking end of tape\n");
			}
			close (IN) || die "can't close $file: $!";
			prlog("LOADING COMPLETE\; 1st free address is" . prhex(16,$high) . "\n");
			$R[0] = $low;		# default start address
			prlog("Default start address (P) is:" . prhex(16,$low) . "\n");
		}
		if($err == 0 && $mode eq 'r')
		{		
			# load relocatable load module
			binmode IN, ":raw";			
			prlog("Load $w[1]\n");
			nextword(); # header word 1
			nextword(); # header word 2
			my $sa = nextword();    # start address
			my $ns = nextword();    # number of sectors
			$wc    = nextword();    # length in words, counted in bytes
			$wc    = $wc >> 1;      # length in words
			nextword();             # sym table pointer for debugging: not used at this moment
			prlog("Load " . prhex(16,$wc) . " words\; start loading at" . prhex(16,$ba) . "\n");
			# $ba is the relocator
			$M[$ba]   = $sa;
			$M[$ba+2] = $ns;
			$M[$ba+4] = $wc << 1;
			$M[$ba+6] = 0;          # sym table pointer for debugging: not used at this moment
				
			my $k = 0;              # total number of words relocated
			$l=4;					# total number of words loaded
			
			my $i=4;				# number of code/data words retrieved from record
			while($l<$wc)
			{
				if($i == 0)
				{
					# skip header
			        nextword(); # header word 1
			        nextword(); # header word 2
				}					
				# load record
				while(($i<188) && ($l<$wc))
				{
					$w=nextword();
					$M[$ba+($l*2)] = $w;
					$i=$i+1;
					$l=$l+1;
				}
				# skip to relocation table, if not there yet
				while($i<188)
				{
					nextword();
					$i=$i+1;
				}
				# relocate this record
				$i=0;
				while($i<12)    # scan the relocation table
				{
					my $rw = nextword();
					my $j = 0;
					while(($j<16) && ($k<$l))
					{
						if($rw & 0x8000)
						{
							$M[$ba+($k*2)] = ($M[$ba+($k*2)] + $ba) & 0xFFFF ; # relocate
						}
						$rw = $rw << 1;
						$j=$j+1;
						$k=$k+1;
					}
					$i=$i+1;
				}
				# skip to end of record
				nextword(); # trailer word 1
				nextword(); # trailer word 1
				nextword(); # trailer word 1
				$i=0;
			}
			close (IN) || die "can't close $file: $!";
			$i=$ba+($l*2);      # first free address 
			prlog("LOADING COMPLETE\; 1st free address is" . prhex(16,$i) . "\n");
			$R[0] = $M[$ba];		# start address
			prlog("Start address (P) is: " . prhex(20,$R[0]) . "\n");			
		}
		if($err == 0 && $mode eq 'm')
		{		
			# load relocatable monitor load module at address 0
			binmode IN, ":raw";			
			prlog("Load monitor $w[1]\n");
			nextword(); # header word 1
			nextword(); # header word 2
			my $sa = nextword()-8;  # start address (relocated)
			my $ns = nextword();    # number of sectors
			$wc    = nextword();    # length in words, counted in bytes
			$wc    = $wc >> 1;      # length in words
			nextword();             # sym table pointer for debugging: not used at this moment
			prlog("Load " . prhex(16,$wc) . " -4 words\; start loading at" . prhex(16,0) . "\n");
			# $ba is the relocator (-8 !)
			my $sec0=1; # sector 0 indicator
			my $low=0;
			my $high=0;	
			my $k = 4;              # total number of words relocated
			$l=4;					      # total number of words loaded
			my $i=4;				      # number of code/data words retrieved from record
			while($l<$wc)
			{
				if($i == 0)
				{
					# skip header
			      nextword(); # header word 1
			      nextword(); # header word 2
				}					
				# load record
				while(($i<188) && ($l<$wc))
				{
					$w=nextword();
					$M[$ba+($l*2)] = $w;
					$i=$i+1;
					$l=$l+1;
				}
				# skip to relocation table, if not there yet
				while($i<188)
				{
					nextword();
					$i=$i+1;
				}
				# relocate this record
				$i=0;
				while($i<12)    # scan the relocation table
				{
					my $rw = nextword();
					my $j = 0;
					if($sec0)
					{
						# skip 1st 4 words of sector 0
						$rw = $rw << 4;
						$j  = 4;
						$sec0=0;
					}					
					while(($j<16) && ($k<$l))
					{
						if($rw & 0x8000)
						{
							$M[$ba+($k*2)] = ($M[$ba+($k*2)] + $ba) & 0xFFFF ; # relocate
						}
						$rw = $rw << 1;
						$j=$j+1;
						$k=$k+1;
					}
					$i=$i+1;
				}
				# skip to end of record
				nextword(); # trailer word 1
				nextword(); # trailer word 1
				nextword(); # trailer word 1
				$i=0;
			}
			close (IN) || die "can't close $file: $!";
			$i=$ba+($l*2);      # first free address 
			prlog("LOADING COMPLETE\; 1st free address is" . prhex(16,$i) . "\n");
			$high=$ba+($l*2)-2;
			$i = "Used memory area is: low=" . prhex(16,$low) . " high=" . prhex(16,$high);
			prlog("$i\n");					
			$R[0] = $sa;		# start address
			prlog("Start address (P) is:" . prhex(16,$R[0]) . "\n");			
		}		
	}
	elsif($w[0] eq "boot")
	{
		if($w[1] eq "ptr")
		{
			if($PTR[FILE] eq "")
			{
				prlog("No file attached to paper tape reader\n");
			}
			else
			{
				reset_all();
				# reset memory
				my $i=0;
				while($i < MEMSIZE)
				{
					$M[$i] = 0;
					$i = $i + 2;
				}
				# put papertape 8+8 bootstrap in memory
				#                 * CODE   EQU   *+/2E
				#                   PR     EQU   /20
				#                   S      EQU   1
				$M[0]  = 0x20BF;  #        INH
				$M[2]  = 0x41E0;  #        CIO   A1,S,PR
				$M[4]  = 0x4A20;  # SEARCH INR   A2,0,PR
				$M[6]  = 0x5C04;  #        RB(4) *-2
				$M[8]  = 0x227F;  #        ANK   A2,/7F
				$M[10] = 0x5808;  #        RB(0) SEARCH              skip leader
				$M[12] = 0x0704;  #        LDK   A7,4                read 4 bytes:
				$M[14] = 0x0540;  #        LDK   A5,/40              word count, and
				#                   INPUT  EQU   *
				$M[16] = 0x4A20;  #        INR   A2,0,PR             begin address - 2
				$M[18] = 0x5C04;  #        RB(4) *-2
				$M[20] = 0xE235;  #        SCR   A2,A5
				$M[22] = 0x1501;  #        ADK   A5,1
				$M[24] = 0x1F01;  #        SUK   A7,1
				$M[26] = 0x590C;  #        RB(1) INPUT               > 0
				$M[28] = 0x5210;  #        RF(2) CODE                < 0
				$M[30] = 0xBAC0;  #        ML    5,/3A               = 0
				$M[32] = 0x003A;  #
				$M[34] = 0x1502;  #        ADK   A5,2
				$M[36] = 0x9508;  #        ADR   A5,A2
				$M[38] = 0x3C41;  #        SLL   A4,1
				$M[40] = 0x8614;  #        LDR   A6,A5               A6 default start address
				$M[42] = 0x0100;  #        LDK   A1,0
				$M[44] = 0x5F1E;  #        RB    INPUT
				#                   CODE   EQU   *
				$M[46] = 0xE104;  #        ECR   A1,A1
				$M[48] = 0xB108;  #        XRR   A1,A2
				$M[50] = 0x1C01;  #        SUK   A4,1
				$M[52] = 0x5C26;  #        RB(4) INPUT               ne 0
				$M[54] = 0x8F18;  #        ABR   A6                  jump to start address (or HLT)           
				$M[56] = 0x0000;  #        DATA  0 UNUSED
				$M[58] = 0x0000;  # (3A)   DATA  0 UNUSED            A1
				$M[60] = 0x0000;  #        DATA  0 BASE ADDRESS      A2
				$M[62] = 0x0000;  #        DATA  0 UNUSED            A3
				########################################
				$M[64] = 0x0000;  # (40)   DATA  0 WORD COUNT        A4
				$M[66] = 0x0000;  #        DATA  0 BEGIN ADDRESS -2  A5
				#
				if($w[2] eq "h")
				{
					$M[54] = 0x207F;               # HALT, after loading complete
				}
				if($w[2] eq "r")
				{
					$M[54] = 0x8F18;               # ABR A6 => RUN starting at begin 1st address
				}
				$R[0] = 0;                         # PC = 0, start at address 0
				
				$interval = 0;
				$currentinterval = 0;
				$time = 0;
				$event_queue = 0;
				if($rtc_on)
				{
					reset_clk();
					cio_clk(1);  # start 
				}				
				activate_event(\@TY0,$TY0[TIME]); 
				@t0 = gettimeofday ();             # fix t0 to measure elapsed time
				$ty0->configure(-state=>'normal');
				$ty0->see('end');
				$ty0->SetCursor('end');
				$ty0->focus;
				if(! $P856) {
					$ty1->configure(-state=>'normal');
					$ty1->see('end');
					$ty1->SetCursor('end');
						$ty2->configure(-state=>'normal');
						$ty2->see('end');
						$ty2->SetCursor('end');
				}
				$panel->configure(-state=>'disabled');
				$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
				$RUN = 1;
				$bt_stop->configure(-text=>'Stop',-background=>'green',-command=>\&ExeStop);
				while($RUN)
				{
					instr();
				}
				$ty0->configure(-state=>'disabled');
				if(! $P856) {
					$ty1->configure(-state=>'disabled');
						$ty2->configure(-state=>'disabled');
				}
				$panel-> bind('<KeyPress>' => \&cmdrecord);
				$panel->configure(-state=>'normal');
				$panel->see('end');
				$panel->SetCursor('end');
				$panel->focus;
				if($secs > 0)
				{
					$secs = tv_interval (\@t0);        # elapsed run time in secs
				}
				$ctime = $time + ($currentinterval - $interval);   # accumulated runned cycles
				$cps = int($ctime / $secs);        # cycles per second
				$s = prhex(20,$R[0]);
				$program_started = 1;              # program is still in a running state
				prlog("\nRun/Boot: emulation stopped at address $s\n");
				prlog("$ctime instructions in $secs seconds: $cps instructions per second\n");
			}
			mem_check(1);
         trace($R[0]);
		}
		elsif($w[1] eq "md0" || $w[1] eq "md1" || $w[1] eq "md2" || $w[1] eq "md3")
		{
			if(($w[1] eq "md0" && $MD0[FILE] eq "") || ($w[1] eq "md1" && $MD1[FILE] eq "") ||
			   ($w[1] eq "md2" && $MD2[FILE] eq "") || ($w[1] eq "md3" && $MD3[FILE] eq ""))
			{
				prlog("No disk image file attached to disk drive\n");
			}
			else
			{
				reset_all();
				# reset memory
				my $i=0;
				while($i < MEMSIZE)
				{
					$M[$i] = 0;
					$i = $i + 2;
				}
            # X1215/X1216 BOOT LOADS ONE RECORD INTO LOCATION /80 ... THEN STARTS AT /84
				# THE RECORD IS THE LOGIAL SECTOR 1 ON DISK, OR 254 CHARACTERS FROM THE 
				# INPUT DEVICE (LEADING NULL CHARACTERS ARE IGNORED). SECTOR 0 IN CASE THE FLOPPY IS USED.
				# On the X1215 disk images, logical sector 1 is physical sector 3 (interlace=3)
				# On the X1216 disk images, logical sector 1 is physical sector 1 (interlace=1)
            #
				# At boot start, A15 must contain the boot parameters:
                # BIT 0    = 0 : CHARACTER EXCHANGE ON PROGRAMMED CHANNEL
                #            1 : WORD         "      "     "        =
                # 
                #     1    = 0 : IPL FROM A NON-DISK DEVICE
                #            1 : IPL FROM DISK
                #
                #     2    = 0 : FIXED HEADS DISK
                #            1 : MOVING HEADS DISK
                #
                #     3    = 0 : DEVICE ON I/O PROCESSOR (MX)
                #            1 : DEVICE ON PROGRAMMED CHANNEL (CP)
                #
                #     4 TO 7   =  BOU LINES, USED TO QUALIFY I/O INSTRUCTION (CIO START NON-DISK DEVICE)
                #
                #     8    = 0 : SINGLE DEVICE CONTROLLER
                #            1 : MULTI DEVICE CONTROLLER
                #
                #     9    = 0 : NON X1215 DISK IS USED
                #            1 : X1215 DISK IS USED
                #
                #     10 TO 15 = DEVICE ADDRESS
                #
                #        WARNING: NOTE THAT THE BITS 0 AND 3 ARE COMPLEMENTARY				
				#
				# X1215
				# A15 = /63C2 boots from the X1215 cartridge  (drive 0 unit 0)
				# A15 = /63E2 boots from the X1215 fixed disk (drive 1 unit 0)
				# A15 = /63D2 boots from the X1215 cartridge  (drive 0 unit 1)
				# A15 = /63F2 boots from the X1215 fixed disk (drive 1 unit 1)
				#
				# X1216
				# A15 = /61C2 boots from the X1216 cartridge  (drive 0 unit 0)
				# A15 = /61E2 boots from the X1216 fixed disk (drive 1 unit 0)
				# A15 = /61D2 boots from the X1216 cartridge  (drive 0 unit 1)
				# A15 = /61F2 boots from the X1216 fixed disk (drive 1 unit 1)
				#
				# Example A15 boot parameter setting: boot from X1215 cartridge
				#    0110 0011 1100 0010
				#     ||  ---- |||| |--- subchannel 2 
				#     ||     | |||| |IOP 0
				#     ||     | ||||disk unit 0
				#     ||     | |||drive 0
				#     ||     | ||boot from an X1215
				#     ||     | |a multi device controller is used
				#     ||     |load physical sector 3 (logical 1) which is the sector with IPL
				#     ||moving heads disk
				#     |ipl from disk
				#
				if($P856)
				{
					prlog("Boot from X1215, drive $w[1]\n");
					if(  $w[1] eq "md0")
					{
						$R[A15] = 0x63C2; # boot from unit 0 drive 0 (address 02)
					}
					elsif($w[1] eq "md1")
					{
						$R[A15] = 0x63E2; # boot from unit 0 drive 1 (address 22)
					}
					elsif($w[1] eq "md2")
					{
						$R[A15] = 0x63D2; # boot from unit 0 drive 1 (address 12)
					}				
					elsif($w[1] eq "md3")
					{
						$R[A15] = 0x63F2; # boot from unit 0 drive 1 (address 32)
					}
				}
				else
				{
					prlog("Boot from X1216, drive $w[1]\n");
					if(  $w[1] eq "md0")
					{
						$R[A15] = 0x61C2; # boot from unit 0 drive 0 (address 02)
					}
					elsif($w[1] eq "md1")
					{
						$R[A15] = 0x61E2; # boot from unit 0 drive 1 (address 22)
					}
					elsif($w[1] eq "md2")
					{
						$R[A15] = 0x61D2; # boot from unit 0 drive 1 (address 12)
					}				
					elsif($w[1] eq "md3")
					{
						$R[A15] = 0x61F2; # boot from unit 0 drive 1 (address 32)
					}										
				}
				#				
                                    # * BASE REGISTER INITIALIZATION
				$M[0x00] = 0x0254;  # BOOT   LDK         A2,INR               A2 = ADDRESS INR INSTRUCTION
				$M[0x02] = 0x0336;  #        LDK         A3,CIO               A3 = ADDRESS CIO INSTRUCTION
				$M[0x04] = 0x0472;  #        LDK         A4,SST               A4 = ADDRESS SST INSTRUCTION
                                    # * SET DEVICE ADDRESS TO INITIALIZE THE I/O COMMANDS
				$M[0x06] = 0x861E;  #        LDR         A6,A15               A6 = VALUE OF THE KEYS
				$M[0x08] = 0x263F;  #        ANK         A6,/3F               KEEP JUST THE DEVICE ADDRESS
				$M[0x0A] = 0xAE29;  #        ORRS        A6,A2                INIT INR WITH DEVICE ADDRESS
				$M[0x0C] = 0xAE2D;  #        ORRS        A6,A3                INIT CIO WITH DEVICE ADDRESS
				$M[0x0E] = 0xAE41;  #        ORS         A6,HIO               INIT THE HALT IO WITH DEVICE ADDRESS
				$M[0x10] = 0x0070;  
                                    # * SET CONTROLLER TYPE AND ADDRESS
				$M[0x12] = 0x871E;  #        LDR         A7,A15               MULTI OR SINGLE DEVICE CU?
				$M[0x14] = 0x3FC8;  #        SLC         A7,8
				$M[0x16] = 0x5602;  #        RF(6)       INIT20               JUMP IF SINGLE
				$M[0x18] = 0x260F;  #        ANK         A6,/F                MULTI: KEEP CONTROLLER ADDRESS (CA)
                                    # * INITIALIZE THE WER INSTRUCTIONS AND SST ONE
				$M[0x1A] = 0xAE31;  # INIT20 ORRS        A6,A4                INIT SST WITH DEVICE OR CONTROLLER ADDR
				$M[0x1C] = 0x3E41;  #        SLL         A6,1                 COMPUTE EXTERNAL REGISTER ADDRESS
				$M[0x1E] = 0xAE41;  #        ORS         A6,WER1              UPDATE WER INSTRUCTIONS
				$M[0x20] = 0x0042;  
				$M[0x22] = 0xAE41;  #        ORS         A6,WER2
				$M[0x24] = 0x0044;  
				$M[0x26] = 0x811C;  #        LDR         A1,A7                A1 = BOU LINES
				$M[0x28] = 0x0550;  #        LDK         A5,/50               BLOCK LENGTH TO BE LOADED
				$M[0x2A] = 0x0680;  #        LDK         A6,/80               IN LOCATION /80.....
                                    # * CHECK DEVICE TYPE
				$M[0x2C] = 0x3FE7;  #        SRC         A7,7                 IS THE DEVICE ADISK OR NOT ?
				$M[0x2E] = 0x5612;  #        RF(6)       WER1                 NO
				$M[0x30] = 0x3FC1;  #        SLC         A7,1                 IS IT A FIXED HEADS DISK ?
				$M[0x32] = 0x5604;  #        RF(6)       NOSEEK               YES => NO SEEK TO ZERO
				$M[0x34] = 0x0103;  #        LDK         A1,3                 EXECUTE A SEEK TO ZERO OPERATION
				$M[0x36] = 0x41C0;  # CIO    CIO         A1,1,0               ON THE MOVING HEADS DISK
                                    # * PREPARE THE NEXT LOGICAL IO FOR A DISK
				$M[0x38] = 0x811E;  # NOSEEK LDR         A1,A15               COMPUTE THE 
				$M[0x3A] = 0x3966;  #        SRL         A1,6                 SECTOR
				$M[0x3C] = 0x213C;  #        ANK         A1,/3C               NUMBER
				$M[0x3E] = 0x8520;  #        LDKL        A5,/80CD             1ST WORD FOR MX FOR A DISK
				$M[0x40] = 0x80CD; 
                                    # * EXECUTE THE LOGICAL IO OPERATION FOR ANY DEVICE, ON MX OR CP
				$M[0x42] = 0x7500;  # WER1   WER         A5,0                 FOR ANY DEVICE (DISK OR NOT) EXECUTE THE WER,
				$M[0x44] = 0x7601;  # WER2   WER         A6,1                 THE CHANNEL IS
				$M[0x46] = 0xF031;  #        EXR*        A4                   EXECUTE SST A7,..
				$M[0x48] = 0xF02D;  #        EXR*        A3                   EXECUTE CIO A1,..
				$M[0x4A] = 0x5C06;  #        RB(4)       *-4                  REFUSED !  TRY AGAIN
                                    # * CHECK WHETHER THE CHANNEL WANTED TO TAKE THE ACTION
				$M[0x4C] = 0x8194;  #        LDR         A9,A5                A9 = NBR OF CHARS TO READ
				$M[0x4E] = 0x871E;  # MX::CP LDR         A7,A15               IS THE DEVICE CONNECTED TO
				$M[0x50] = 0x3F43;  #        SLL         A7,3                 THE MULTIPLEX CHANNEL ?
				$M[0x52] = 0x561E;  #        RF(6)       SST                  YES, SEND AN SST
				                    # * NO, CONNECTED TO CP => INPUT ONE CHARACTE/WORD FROM THE DEVICE
				$M[0x54] = 0x4F00;  # INR    INR         A7,0,0               READ INTO A7
				$M[0x56] = 0x541A;  #        RF(4)       SST                  REFUSED !, SEND AN SST TO KNOW WHY
				$M[0x58] = 0xE994;  #        CWR         A9,A5                LEADING CHAR ?
				$M[0x5A] = 0x5404;  #        RF(4)       INR10                NO
				$M[0x5C] = 0x871C;  #        LDR         A7,A7                YES
				$M[0x5E] = 0x580C;  #        RB(0)       INR
				                    # * CHECK WHETHER WORD OR CHARACTER MODE
				$M[0x60] = 0x879E;  # INR10  LDR         A15,A15              CHARACTER MODE ?
				$M[0x62] = 0x5604;  #        RF(6)       STORE                YES
				$M[0x64] = 0x8739;  #        STR         A7,A6                STORE WORD JUST READ FROM CP
				$M[0x66] = 0x1601;  #        ADK         A6,1                 USE SAME ROUTINE FOR WORD AND CHAR MODE
                                    # * STORE CHAR JUST READ AND CHECK FOR END OF TRANSFER
				$M[0x68] = 0xE739;  # STORE  SCR         A7,A6                STORE ONE CHAR TO /80 + (A6)
				$M[0x6A] = 0x1601;  #        ADK         A6,1                 PREPARE FOR NEXT LOCATION TO STORE
				$M[0x6C] = 0x1D01;  #        SUK         A5,1                 OTHER CHAR TO READ ?
				$M[0x6E] = 0x5C1C;  #        RB(4)       INR                  YES, LOOP TO INPUT
                                    # * END OF TRANSFER, EXECUTE A CIO HALT
				$M[0x70] = 0x4180;  # HIO    CIO         A1,0,0               TO EXCHANGE
                                    # * EXECUTE AN SST AND ANALYZE THE STATUS 
				$M[0x72] = 0x4FC0;  # SST    SST         A7,0                 
				$M[0x74] = 0x5C28;  #        RB(4)       MX::CP               REFUSED ! => THIS HANDLES BOTH CASES: WAIT ON CP OR MX
				$M[0x76] = 0xA720;  #        ANKL        A7,/4007             
				$M[0x78] = 0x4007; 
                                # * TEST: BIT 1  = DEVICE BECAME READY
                                # *       BIT 13 = DATA FAULT
                                # *       BIT 14 = THROUGHPUT ERROR
                                # *       BIT 15 = NOT OPERABLE
				$M[0x7A] = 0x0C00;  #        AB(4)       /00                  ONE OF THESE CONDITIONS => RESTART THE BOOTSTRAP
				$M[0x7C] = 0x0F84;  #        AB          /84                  NORMAL END => JUMP TO IPL
                                #        END         BOOT
				if($w[2] eq "h")
				{
					$M[0x7C] = 0x207F;             # HALT, after loading complete
					prlog("Boot stops after loading IPL\n");
				}
				if($w[2] eq "r")
				{
					$M[0x7C] = 0x0F84;             # AB /84 => RUN starting at begin 1st address of IPL
					prlog("Boot starts IPL after loading IPL\n");			
				}
				$R[0] = 0;                         # start with PC = 0
				$interval = 0;
				$currentinterval = 0;
				$time = 0;
				$event_queue = 0;
				if($rtc_on)
				{
					reset_clk();
					cio_clk(1);  # start 
				}
				# tty active to listen to CntrP (panel interrupt) or
				#                         CntrE (stop simulation)
            activate_event(\@TY0,$TY0[TIME]); 
				@t0 = gettimeofday ();             # fix t0 to measure elapsed time
				$ty0->configure(-state=>'normal');
				$ty0->see('end');
				$ty0->SetCursor('end');
				$ty0->focus;
				if(! $P856)
            {
                    my $i;
                    # set breakpoint to load a patch
                    $BP{0x15356} = 0x15356; # set breakpoint in INIMON
                    $EmBreak = 1;
					     prlog("Breakpoint set to load patchfile\n");
                    # boot MASRA
						  # 2 additional terminal windows
						  $ty1->configure(-state=>'normal');
						  $ty1->see('end');
						  $ty1->SetCursor('end');
							$ty2->configure(-state=>'normal');
							$ty2->see('end');
							$ty2->SetCursor('end');
					     $RUN = 1;
					     $panel-> configure(-state=>'disabled');
					     $panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
					     $bt_stop->configure(-text=>'    ',-background=>'green');
                    while($RUN)
                    {
                        instr();
                    }
                    # after boot, load the patchfile
                    # stops after breakpoint in INIMON
                    # 
					     $panel-> configure(-state=>'normal'); # disabled during run/boot
                    
					     if(! open (FHX, $patchmasra))
					     {
						    prlog("Unable to open patchfile: $patchmasra\n");
					     }
					     else
					    {
							 prlog("Load MASRA patchfile: " . $patchmasra . "\n");
							 $M[0x1322E]=0x8154; # M:DFM error in MAS8.1
							 $M[0x13238]=0x8154; # M:DFM error in MAS8.1
							 my $s0;	my $s1;
							 while($s=<FHX>)
							 {
								 chop $s;
								 ($s0,$s1) = split(/\,/,$s);
								 $s0=cvhex($s0) & MAXADDR; 
								 $s1=cvhex($s1);		
								 $M[$s0] = $s1;
							 }
						    close FHX || die "can't close $patchmasra $!";
						    prlog("MASRA patchfile: " . $patchmasra . " loaded\n");                
						}
                  delete $BP{0x15356}; # delete breakpoint
                  $i = scalar(keys(%BP));
                  if($i)
                  {
                        $EmBreak = 1;
                  }
                  else
                  {
                       $EmBreak = 0;
                  }
						prlog("Breakpoint deleted\n");
           }
				$panel-> configure(-state=>'disabled');
				$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
				$bt_stop-> configure(-text=>'Stop',-background=>'green',-command=>\&ExeStop);
            $RUN = 1;
				while($RUN)
            {
                    instr();
            }
            $ty0-> configure(-state=>'disabled');
				if(! $P856) {
					$ty1-> configure(-state=>'disabled');
						$ty2-> configure(-state=>'disabled');
				}
            $panel-> bind('<KeyPress>' => \&cmdrecord);
            $panel-> configure(-state=>'normal');
				$panel-> see('end');
				$panel-> SetCursor('end');
				$panel-> focus;
				$secs = tv_interval (\@t0);        # elapsed run time in secs
				$ctime = $time + ($currentinterval - $interval);   # accumulated runned cycles
				if($secs > 0)
				{
					$cps = int($ctime / $secs);         # cycles per second
				}
				$s = prhex(20,$R[0]);
				$program_started = 1;              # program is in running state
				prlog("\n\nRun/Boot: emulation stopped at address $s\n");
				prlog("$ctime instructions in $secs seconds: $cps instructions per second\n");
			}
			mem_check(1);
         trace($R[0]);
		}
		elsif($w[1] eq "bd0" || $w[1] eq "bd1")
		{
			if(($w[1] eq "bd0" && $BD0[FILE] eq "") || ($w[1] eq "bd1" && $BD1[FILE] eq "")) 
			{
				prlog("No disk image file attached to disk drive\n");
			}
			else
			{
				reset_all();
				# reset memory
				my $i=0;
				while($i < MEMSIZE)
				{
					$M[$i] = 0;
					$i = $i + 2;
				}
                # At boot start, A15 must contain the boot parameters:
                # A15 = /0116 => boot from BD0
                # A15 = /0136 => boot from BD1
				if(  $w[1] eq "bd0")
				{
				    $R[A15]    = 0x0116; # boot from unit 0 (address /16)
                    $M[0x1000] = 0x0101; # LDK   A1,1
                    $M[0x1002] = 0x41D6; # CIO   A1,1,/16
                    $M[0x1004] = 0x5002; # RF(0) *+4
                    $M[0x1006] = 0x207F; # HLT
                    $M[0x1008] = 0x0100; # LDK A1,0
                    $M[0x100A] = 0x1101; # ADK A1,1
                    $M[0x100C] = 0x5C04; # RB(4) *-2
                    $M[0x100E] = 0x0F00; # AB    0
                    # loaded boot record from disk performs SST, ect.

				}
				elsif($w[1] eq "bd1")
				{
				    $R[A15]    = 0x0136; # boot from unit 1 (address /36)
                    $M[0x1000] = 0x0101; # LDK   A1,1
                    $M[0x1002] = 0x41F6; # CIO   A1,1,/36
                    $M[0x1004] = 0x5002; # RF(0) *+4
                    $M[0x1006] = 0x207F; # HLT
                    $M[0x1008] = 0x0100; # LDK A1,0
                    $M[0x100A] = 0x1101; # ADK A1,1
                    $M[0x100C] = 0x5C04; # RB(4) *-2
                    $M[0x100E] = 0x0F00; # AB    0
                    # loaded boot record from disk performs SST, ect.                  
				}
            #				
				if($w[2] eq "h")
				{
					$M[0x100E] = 0x207F;             # HALT, after loading complete
					prlog("Boot stops after loading IPL\n");
				}
				if($w[2] eq "r")
				{
					$M[0x100E] = 0x0F00;             # AB /0000 => RUN starting at 1st address of IPL
					prlog("Boot starts IPL after loading IPL\n");			
				}
				$R[0] = 0x1000;                      # start at address /1000
				$interval = 0;
				$currentinterval = 0;
				$time = 0;
				$event_queue = 0;
				if($rtc_on)
				{
					reset_clk();
					cio_clk(1);  # start
				}
            # set breakpoint to load the patchfile
            $BP{0x15040} = 0x15040; # set breakpoint: INIMON
            $EmBreak = 1;
				prlog("Breakpoint set to load patchfile\n");
				# tty active to listen to CntrP (panel interrupt) or
				#                         CntrE (stop simulation)
				activate_event(\@TY0,$TY0[TIME]);
				@t0 = gettimeofday ();             # fix t0 to measure elapsed time
				# boot MASR
				$ty0->configure(-state=>'normal');
				$ty0->see('end');
			   $ty0->SetCursor('end');
				$ty0->focus;
					$ty1->configure(-state=>'normal');
					$ty1->see('end');
					$ty1->SetCursor('end');
						$ty2->configure(-state=>'normal');
						$ty2->see('end');
						$ty2->SetCursor('end');
				$RUN = 1;
				$panel->configure(-state=>'disabled');
				$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
				$bt_stop->configure(-text=>'    ',-background=>'green');
				while($RUN)
				{
					instr();
				}
            # booted; stops after breakpoint in INIMON
				#
            # load the patchfile: patch.hex
				$panel->configure(-state=>'normal'); # disabled during run/boot
            if(! open (FHX, $patchmasr))
            {
                prlog("Unable to open patchfile: $patchmasr\n");
            }
            else
            {
				    prlog("Load MASR patchfile: " . $patchmasr . "\n");
                my $s0;	my $s1;
                while($s=<FHX>)
                {
                    chop $s;
                    ($s0,$s1) = split(/\,/,$s);
                    $s0=cvhex($s0) & MAXADDR; 
                    $s1=cvhex($s1);		
                    $M[$s0] = $s1;
                }
                close FHX || die "can't close $patchmasr $!";
                prlog("MASR patchfile: " . $patchmasr . " loaded\n");                
            }
            delete $BP{0x15040}; # delete breakpoint
				prlog("Breakpoint deleted\n");
            $i = scalar(keys(%BP));
            if($i)
            {
              	$EmBreak = 1;
            }
            else
            {
             	$EmBreak = 0;
            }
				# date: allow year < 82
				$M[0x15F82]=0x5700; # RF *+2

				$panel->configure(-state=>'disabled');
				$panel-> bind('<KeyPress>' => \&dummy);# ignore all keys
				$bt_stop->configure(-text=>'Stop',-background=>'green',-command=>\&ExeStop);
				$RUN = 1;
				while($RUN)
				{
					instr();
				}
				$ty0->configure(-state=>'disabled');
					$ty1->configure(-state=>'disabled');
						$ty2->configure(-state=>'disabled');
            $panel-> bind('<KeyPress>' => \&cmdrecord);
            $panel->configure(-state=>'normal');
				$panel->see('end');
				$panel->SetCursor('end');
				$panel->focus;
				$secs = tv_interval (\@t0);        # elapsed run time in secs
				$ctime = $time + ($currentinterval - $interval);   # accumulated runned cycles
				if($secs > 0)
				{
					$cps = int($ctime / $secs);        # cycles per second
				}
				$s = prhex(20,$R[0]);
				$program_started = 1;              # program is in running state
				prlog("\n\n\nBoot/Run: emulation stopped at address $s\n");
				prlog("$ctime instructions in $secs seconds: $cps instructions per second\n");
			}
         BdCheck();
         mem_check(1);
         trace($R[0]);
		}
		else
		{
			prlog("Unsupported boot device $w[1]\n");
		}
	}
	elsif($w[0] eq "attach" || $w[0] eq "att")
	{
		if($w[1] eq "ptr")
		{
			$file = $W[2];
			if($file eq "")
			{
				prlog("No proper filename\n");
			}
			else
			{
				if($PTR[FILE] ne "")
				{
					close ($PTR[FC]) || die "can't close $PTR[FILE]: $!";
					prlog("File $PTR[FILE] detached from device PTR and closed\n");
					$PTR[FILE] = "";         # file detached and closed; device inoperable	
				}
				if(! open (PTR, $file))
				{
					prlog("Cannot open papertape input file: $file\n");
				}
				else
				{
					$PTR[FC] = \*PTR;
					binmode $PTR[FC], ":raw";
					prlog("File $file attached to device PTR\n");
					$PTR[FILE] = $file;           # file attached and open
					$ptrcode = "  ";
				}
			}
		}
		elsif($w[1] eq "crd")
		{
			$file = $W[2];
			my($fi,$fy) = split(/\./, $file);
			if($file eq "" || $fy ne "crd")
			{
				prlog("No filename, or wrong extension (must be a .crd file)\n");
			}
			else
			{
				if($CRD[FILE] ne "")
				{
					close ($CRD[FC]) || die "can't close $CRD[FILE]: $!";
					prlog("File $CRD[FILE] detached from device CRD and closed\n");
					$CRD[FILE] = "";         # file detached and closed; device inoperable	
				}
				if(! open (CRD, $file))
				{
					prlog("Cannot open card reader input file: $file\n");
				}
				else
				{
					$CRD[FC] = \*CRD;
					binmode $CRD[FC], ":raw";
					prlog("File $file attached to device CRD\n");
					$CRD[FILE] = $file;           # file attached and open
				}
			}
		}		
		elsif($w[1] eq "ptp")
		{
			$file = $W[2];
			if($file eq "")
			{
				prlog("No proper filename\n");
			}
			else
			{
				if($PTP[FILE] ne "")
				{
					close ($PTP[FC]) || die "can't close ($PTP[FILE]: $!";
					prlog("File $PTP[FILE] detached from device PTP and closed\n");
					$PTP[FILE] = "";         # file detached and closed; device inoperable	
				}				
				if(! open (PTP, ">:raw", $file))
				{
					prlog("Cannot open papertape punch file: $file\n");
				}
				else
				{
					$PTP[FC] = \*PTP;
					prlog("File $file attached to device PTP\n");
					$PTP[FILE] = $file;		      # file attached and open
				}
			}				
		}
		elsif($w[1] eq "lpt")
		{
			$file = $W[2];
			if($file eq "")
			{
				prlog("No proper filename\n");
			}
			else
			{
				if($LPT[FILE] ne "")
				{
					close ($LPT[FC]) || die "can't close ($LPT[FILE]: $!";
					prlog("File $LPT[FILE] detached from device LPT and closed\n");
					$LPT[FILE] = "";         # file detached and closed; device inoperable	
				}				
				if(! open (LPT, ">$file"))
				{
					prlog("Cannot open lineprinter file: $file\n");
				}
				else
				{
					$LPT[FC] = \*LPT;
					prlog("File $file attached to device LPT\n");
					$LPT[FILE] = $file;		      # file attached and open
					$LPT[LCUR]  = 0;              # set on line 0 current page 	
				}
			}					
		}
      elsif($w[1] eq "bd0") # 1st bigdisk
		{
			$file = $W[2];
         my($fi,$fy) = split(/\./, $file);
			my $stat = $BD0[STATE] >> 16;   # get status: cu state
         $fi=UP($fi); $fy=UP($fy);
			if($file eq "" || $fy ne "DTA")
			{
				prlog("No filename, or wrong extension (must be a .dta file)\n");
			}
			else
			{
            if($BD0[FILE] ne "")
				{
					if($stat == INAC)
					{
                  close (BD0) || die "can't close $BD0[FILE]: $!";
						prlog("File $BD0[FILE] detached from device BD0 and closed\n");
						$BD0[FILE] = ""; # file detached and closed; device inoperable
                  $BD0[RDY]  = 0;
					}
					else
					{
							prlog("BD0 is active and its attached file can not be closed\n");
					}					
				}
            if($BD0[FILE] eq "")
				{					
					if(! open (BD0, "+<:raw", $file)) # open for update
					{
						prlog("Cannot open disk file: $file for device BD0\n");
					}
					else
					{
                  prlog("File $file attached to device BD0\n");
                  $BD0[FILE] = $file;  # file attached and open
                  if(Bd0Init())
                  {
							$BD0[RDY]  = 1;
                     $BD0[STATE] = INAC << 16;
                   	prlog("BigDisk unit-0 is READY\n");
                  }
                  else
                  {
                     $BD0[RDY]  = 0;
                     prlog("Cannot initialize BD0\n");
                  }
					}
				}
        }
      }
      elsif($w[1] eq "bd1") # 2nd bigdisk
		{
			$file = $W[2];
         my($fi,$fy) = split(/\./, $file);
			my $stat = $BD0[STATE] >> 16;   # get status: cu state
         $fi=UP($fi); $fy=UP($fy);
			if($file eq "" || $fy ne "DTA")
			{
				prlog("No filename, or wrong extension (must be a .dta file)\n");
			}
			else
			{
            if($BD1[FILE] ne "")
				{
					if($stat == INAC)
					{
                  close (BD1) || die "can't close $BD1[FILE]: $!";
						prlog("File $BD1[FILE] detached from device BD1 and closed\n");
						$BD1[FILE] = ""; # file detached and closed; device inoperable
                  $BD1[RDY]  = 0;
					}
					else
					{
							prlog("BD1 is active and its attached file can not be closed\n");
					}					
				}
            if($BD1[FILE] eq "")
				{					
					if(! open (BD1, "+<:raw", $file)) # open for update
					{
						prlog("Cannot open disk file: $file for device BD1\n");
					}
					else
					{
                  prlog("File $file attached to device BD1\n");
                  $BD1[FILE] = $file;  # file attached and open
                  if(Bd1Init())
                  {
							$BD1[RDY]  = 1;
                     $BD0[STATE] = INAC << 16;
                    	prlog("BigDisk unit-1 is READY\n");
                  }
                  else
                  {
                     $BD1[RDY]  = 0;
                     prlog("Cannot initialize BD1\n");
                  }
					}
				}
         }
      }        
		elsif($w[1] eq "md0")
		{
			$file = $W[2];
			my($fi,$fy) = split(/\./, $file);
			my $stat = $MD0[STATE] >> 16;   # get status: cu state
			if($file eq "" || $fy ne "img")
			{
				prlog("No filename, or wrong extension (must be a .img file)\n");
			}
			else
			{
				if($MD0[FILE] ne "")
				{
					if($stat != INAC)
					{
						if($MD0[DN] == 0)
						{
							prlog("MD0 is active and its attached file can not be closed\n");
						}
						else
						{
							close (MD0) || die "can't close $MD0[FILE]: $!";
							prlog("File $MD0[FILE] detached from device MD0 and closed\n");
							$MD0[FILE] = ""; # file detached and closed; device inoperable
						}
					}
					else
					{
						close (MD0) || die "can't close $MD0[FILE]: $!";
						prlog("File $MD0[FILE] detached from device MD0 and closed\n");
						$MD0[FILE] = ""; # file detached and closed; device inoperable
					}					
				}
				if($MD0[FILE] eq "")
				{					
					if(! open (MD0, "+<:raw", $file)) # open for update
					{
						prlog("Cannot open disk file: $file\n");
					}
					else
					{
						prlog("File $file attached to device MD0\n");
						$MD0[FILE] = $file;           # file attached and open
						$MD0[CYL]  = 0;
					}
					if($MD0[FILE] ne "" && $MD1[FILE] ne "")
					{
						$MD0[RDY] = 1;
						prlog("X1215 unit-0 is READY\n");
					}
					else
					{
						$MD0[RDY] = 0;
						prlog("X1215 unit-0 is NOT READY\n");
						prlog("To make unit-0 ready, both MD0 and MD1 must be attached to a diskimage file\n");
						#state_md0();
					}							
				}
			}
		}			
		elsif($w[1] eq "md1")
		{
			$file = $W[2];
			my($fi,$fy) = split(/\./, $file);
			my $stat = $MD0[STATE] >> 16;   # get status: cu state			
			if($file eq "" || $fy ne "img")
			{
				prlog("No filename, or wrong extension (must be a .img file)\n");
			}
			else
			{
				if($MD1[FILE] ne "")
				{
					if($stat != INAC)
					{
						if($MD0[DN] == 2)
						{
							prlog("MD1 is active and its attached file can not be closed\n");
						}
						else
						{
							close (MD1) || die "can't close $MD1[FILE]: $!";
							prlog("File $MD1[FILE] detached from device MD1 and closed\n");
							$MD1[FILE] = ""; # file detached and closed; device inoperable
						}
					}
					else
					{
						close (MD1) || die "can't close $MD1[FILE]: $!";
						prlog("File $MD1[FILE] detached from device MD1 and closed\n");
						$MD1[FILE] = ""; # file detached and closed; device inoperable
					}					
				}
				if($MD1[FILE] eq "")
				{				
					if(! open (MD1,"+<:raw", $file)) # open for update
					{
						prlog("Cannot open disk file: $file\n");
					}
					else
					{
						prlog("File $file attached to device MD1\n");
						$MD1[FILE] = $file;           # file attached and open
						$MD0[CYL]  = 0;
					}
					if($MD0[FILE] ne "" && $MD1[FILE] ne "")
					{
						$MD0[RDY] = 1;
						prlog("X1215 unit-0 is READY\n");
					}
					else
					{
						$MD0[RDY] = 0;
						prlog("X1215 unit-0 is NOT READY\n");
						prlog("To make unit-0 ready, both MD0 and MD1 must be attached to a diskimage file\n");
						#state_md0();
					}							
				}
			}
		}
		elsif($w[1] eq "md2")
		{
			$file = $W[2];
			my($fi,$fy) = split(/\./, $file);
			my $stat = $MD0[STATE] >> 16;   # get status: cu state			
			if($file eq "" || $fy ne "img")
			{
				prlog("No filename, or wrong extension (must be a .img file)\n");
			}
			else
			{
				if($MD2[FILE] ne "")
				{
					if($stat != INAC)
					{
						if($MD0[DN] == 1)
						{
							prlog("MD2 is active and its attached file can not be closed\n");
						}
						else
						{						
							close (MD2) || die "can't close $MD2[FILE]: $!";
							prlog("File $MD2[FILE] detached from device MD2 and closed\n");
							$MD2[FILE] = ""; # file detached and closed; device inoperable
						}
					}
					else
					{						
						close (MD2) || die "can't close $MD2[FILE]: $!";
						prlog("File $MD2[FILE] detached from device MD2 and closed\n");
						$MD2[FILE] = ""; # file detached and closed; device inoperable
					}					
				}
				if($MD2[FILE] eq "")
				{				
					if(! open (MD2,"+<:raw", $file)) # open for update
					{
						prlog("Cannot open disk file: $file\n");
					}
					else
					{
						prlog("File $file attached to device MD2\n");
						$MD2[FILE] = $file;           # file attached and open
						$MD2[CYL]  = 0;
					}
					if($MD2[FILE] ne "" && $MD3[FILE] ne "")
					{
						$MD2[RDY] = 1;
						prlog("X1215 unit-1 is READY\n");
					}
					else
					{
						$MD2[RDY] = 0;
						prlog("X1215 unit-1 is NOT READY\n");
						prlog("To make unit-1 ready, both MD2 and MD3 must be attached to a diskimage file\n");
						#state_md0();
					}							
				}
			}
		}		
		elsif($w[1] eq "md3")
		{
			$file = $W[2];
			my($fi,$fy) = split(/\./, $file);
			my $stat = $MD0[STATE] >> 16;   # get status: cu state				
			if($file eq "" || $fy ne "img")
			{
				prlog("No filename, or wrong extension (must be a .img file)\n");
			}
			else
			{
				if($MD3[FILE] ne "")
				{
					if($stat != INAC)
					{
						if($MD0[DN] == 3)
						{
							prlog("MD3 is active and its attached file can not be closed\n");
						}
						else
						{						
							close (MD3) || die "can't close $MD3[FILE]: $!";
							prlog("File $MD3[FILE] detached from device MD3 and closed\n");
							$MD3[FILE] = "";  # file detached and closed; device inoperable	
						}
					}
					else
					{						
						close (MD3) || die "can't close $MD3[FILE]: $!";
						prlog("File $MD3[FILE] detached from device MD3 and closed\n");
						$MD3[FILE] = "";  # file detached and closed; device inoperable	
					}					
				}
				if($MD3[FILE] eq "")
				{				
					if(! open (MD3,"+<:raw", $file)) # open for update
					{
						prlog("Cannot open disk file: $file\n");
					}
					else
					{
						prlog("File $file attached to device MD3\n");
						$MD3[FILE] = $file;           # file attached and open
						$MD2[CYL]  = 0;
					}
					if($MD2[FILE] ne "" && $MD3[FILE] ne "")
					{
						$MD2[RDY] = 1;
						prlog("X1215 unit-1 is READY\n");
					}
					else
					{
						$MD2[RDY] = 0;
						prlog("X1215 unit-1 is NOT READY\n");
						prlog("To make unit-1 ready, both MD2 and MD3 must be attached to a diskimage file\n");
						#state_md0();
					}						
				}
			}
		}		
		else
		{
			prlog("Unsupported device $w[1] requested for file attachement\n");
		}
	}
	elsif($w[0] eq "detach" || $w[0] eq "det")
	{
		if($w[1] eq "ptr")
		{
			$file = $PTR[FILE];
			if($file eq "")
			{
				prlog("Device PTR not attached\n");
			}
			else
			{
				close ($PTR[FC]) || die "can't close $file: $!";
				prlog("File $file detached from device PTR and closed\n");
				$PTR[FILE] = "";         # file detached and closed; device inoperable	
			}
		}
		elsif($w[1] eq "cdr")
		{
			$file = $CRD[FILE];
			if($file eq "")
			{
				prlog("Device CRD not attached\n");
			}
			else
			{
				close ($CRD[FC]) || die "can't close $file: $!";
				prlog("File $file detached from device CRD and closed\n");
				$CRD[FILE] = "";         # file detached and closed; device inoperable	
			}
		}		
		elsif($w[1] eq "ptp")
		{
			$file = $PTP[FILE];
			if($file eq "")
			{
				prlog("Device PTP not attached\n");
			}
			else
			{
				close ($PTP[FC]) || die "can't close $file: $!";
				prlog("File $file detached from device PTP and closed\n");			
				$PTP[FILE] = "";			# file detached and closed; device inoperable		
			}				
		}
		elsif($w[1] eq "lpt")
		{
			$file = $LPT[FILE];
			if($file eq "")
			{
				prlog("Device LPT not attached\n");
			}
			else
			{
				close ($LPT[FC]) || die "can't close $file: $!";
				prlog("File $file detached from device LPT and closed\n");			
				$LPT[FILE] = "";			# file detached and closed; device inoperable		
			}				
		}
		elsif($w[1] eq "bd0")
		{
			$file = $BD0[FILE];
			my $stat = $BD0[STATE] >> 16;   # get status: cu state					
			if($file eq "")
			{
				prlog("Device BD0 not attached\n");
			}
			else
			{
				if($stat == INAC)
				{
					close (BD0) || die "can't close $file: $!";
					prlog("File $file detached from device BD0 and closed\n");			
					$BD0[FILE] = ""; # file detached and closed; device inoperable
					$BD0[RDY] = 0;
					prlog("BigDisk unit-0 is NOT READY\n");	
				}
				else
				{
					prlog("BD0 is active and its attached file can not be closed\n");
				}
			}
		}
		elsif($w[1] eq "bd1")
		{
			$file = $BD1[FILE];
			my $stat = $BD1[STATE] >> 16;   # get status: cu state					
			if($file eq "")
			{
				prlog("Device BD1 not attached\n");
			}
			else
			{
				if($stat == INAC)
				{
					close (BD1) || die "can't close $file: $!";
					prlog("File $file detached from device BD1 and closed\n");			
					$BD1[FILE] = ""; # file detached and closed; device inoperable
					$BD1[RDY] = 0;
					prlog("BigDisk unit-1 is NOT READY\n");	
				}
				else
				{
					prlog("BD1 is active and its attached file can not be closed\n");
				}
			}
		}        
		elsif($w[1] eq "md0")
		{
			$file = $MD0[FILE];
			my $stat = $MD0[STATE] >> 16;   # get status: cu state					
			if($file eq "")
			{
				prlog("Device MD0 not attached\n");
			}
			else
			{
				if($stat != INAC)
				{
					if($MD0[DN] == 0)
					{
						prlog("MD0 is active and its attached file can not be closed\n");
					}
            }
				else
				{					
					close (MD0) || die "can't close $file: $!";
					prlog("File $file detached from device MD0 and closed\n");			
					$MD0[FILE] = ""; # file detached and closed; device inoperable
					$MD0[RDY] = 0;
					prlog("MD0 unit-0 is NOT READY\n");						
				}
			}
		}
		elsif($w[1] eq "md1")
		{
			$file = $MD1[FILE];
			my $stat = $MD0[STATE] >> 16;   # get status: cu state					
			if($file eq "")
			{
				prlog("Device MD1 not attached\n");
			}
			else
			{
				if($stat != INAC)
				{
					if($MD0[DN] == 2)
					{
						prlog("MD1 is active and its attached file can not be closed\n");
					}
            }
				else
				{					
					close (MD1) || die "can't close $file: $!";
					prlog("File $file detached from device MD1 and closed\n");			
					$MD1[FILE] = ""; # file detached and closed; device inoperable	
					$MD0[RDY] = 0;						
					prlog("MD0 unit-0 is NOT READY\n");						
				}						
			}				
		}
		elsif($w[1] eq "md2")
		{
			$file = $MD2[FILE];
			my $stat = $MD0[STATE] >> 16;   # get status: cu state					
			if($file eq "")
			{
				prlog("Device MD2 not attached\n");
			}
			else
			{
				if($stat != INAC)
				{
					if($MD0[DN] == 1)
					{
						prlog("MD2 is active and its attached file can not be closed\n");
					}
            }
				else
				{						
					close (MD2) || die "can't close $file: $!";
					prlog("File $file detached from device MD2 and closed\n");			
					$MD2[FILE] = ""; # file detached and closed; device inoperable	
					$MD2[RDY] = 0;						
					prlog("MD2 unit-1 is NOT READY\n");
				}
			}				
		}
		elsif($w[1] eq "md3")
		{
			$file = $MD3[FILE];
			my $stat = $MD0[STATE] >> 16;   # get status: cu state					
			if($file eq "")
			{
				prlog("Device MD3 not attached\n");
			}
			else
			{
				if($stat != INAC)
				{
					if($MD0[DN] == 3)
					{
						prlog("MD3 is active and its attached file can not be closed\n");
					}
            }
				else
				{						
					close (MD3) || die "can't close $file: $!";
					prlog("File $file detached from device MD3 and closed\n");			
					$MD3[FILE] = ""; # file detached and closed; device inoperable
					$MD2[RDY] = 0;						
					prlog("MD2 unit-1 is NOT READY\n");
				}						
			}	
		}
		else
		{
			prlog("Unsupported device $w[1]\n");
		}
	}	
	elsif($w[0] eq "state")
	{
		if($w[1] eq "cpu")
		{
			prlog("CPU state\n");
			trace($R[0]);
		}
		elsif($w[1] eq "ty0")
		{
			prlog("TY0 state: ");
			state_ty0();
		}
		elsif($w[1] eq "ty1")
		{
			prlog("TY1 state: ");
			state_ty1();
		}
        elsif($w[1] eq "ty2")
		{
			prlog("TY2 state: ");
			state_ty2();
		}
		elsif($w[1] eq "rtc")
		{
			prlog("RTC state: ");
			state_clk();
		}	
		elsif($w[1] eq "ptr")
		{
			prlog("PTR state: ");
			state_ptr();
		}
		elsif($w[1] eq "ptp")
		{
			prlog("PTP state: ");
			state_ptp();
		}
		elsif($w[1] eq "lpt")
		{
			prlog("LPT state: ");
			state_lpt();
		}	
		elsif($w[1] eq "crd")
		{
			prlog("CRD state: ");
			state_crd();
		}
		elsif($w[1] eq "md0" || $w[1] eq "md1" || $w[1] eq "md2" || $w[1] eq "md3")
		{
			prlog("MD* state: ");
			state_md0();
		}
        elsif($w[1] eq "bd0")
        {
            prlog("BD* state: ");
			state_bd0();
		}
        elsif($w[1] eq "mmu")
        {
            prlog("MMU state: ");
            state_mmu();
        }
        elsif($w[1] eq "pcs")
        {
            prlog("PC stack:\n");
            state_pcstk();
        }        
		else
		{
			prlog("CPU state\n");
			trace($R[0]);
			prlog("TY0 state: ");
			state_ty0();
			prlog("TY1 state: ");
			state_ty1();
         prlog("TY2 state: ");
			state_ty2();
			prlog("RTC state: ");
			state_clk();
			prlog("PTR state: ");
			state_ptr();
			prlog("PTP state: ");
			state_ptp();
   		prlog("LPT state: ");
			state_lpt();
   		prlog("CRD state: ");
			state_crd();
			prlog("MD* state: ");
			state_md0();
         prlog("BD* state: ");
			state_bd0();            
		}
	}
	elsif($w[0] eq "queue" || $w[0] eq "q")
	{
		show_event_queue();
	}
	elsif($w[0] eq "echo")
	{	
		prlog(eval($w[1]));
	}
	elsif($w[0] eq "console")
	{
		if($w[1] eq "64")
		{
			$TY0[CSET] = 64;
		}
		elsif($w[1] eq "128")	
		{
			$TY0[CSET] = 128;	
		}	
		else
		{
			prlog("Wrong console character set selected, set to 64\n");
			$TY0[CSET] = 64;
		}
	}
	elsif($w[0] eq "exit")
	{
		EmExit();
	}
	else
	{
		prlog("Unknown command\n");
	}
	$cmdstr=""; # reset
	if($RUN == 0)
	{
		if($program_started)
		{
			$bt_stop->configure(-text=>'Cont',-background=>'red',-command=>\&ExeCont);
		}
		else
		{
			$bt_stop->configure(-text=>'     ',-background=>'red',-command=>\&dummy);
		}
	}
}

sub EmExit {
	# close still open/attached files and cleanup
    BdCheck();
	if($PTR[FILE] ne "")
	{
		close ($PTR[FC]) || die "can't close $PTR[FILE]: $!";
		prlog("File $PTR[FILE] detached from device PTR and closed\n");
	}
	if($PTP[FILE] ne "")
	{
		close ($PTP[FC]) || die "can't close $PTP[FILE]: $!";
		prlog("File $PTP[FILE] detached from device PTP and closed\n");
	}
	if($LPT[FILE] ne "")
	{
		close ($LPT[FC]) || die "can't close $LPT[FILE]: $!";
		prlog("File $LPT[FILE] detached from device LPT and closed\n");
	}
	if($CRD[FILE] ne "")
	{
		close ($CRD[FC]) || die "can't close $CRD[FILE]: $!";
		prlog("File $CRD[FILE] detached from device CRD and closed\n");
	}
	if($MD0[FILE] ne "")
	{
		close (MD0) || die "can't close $MD0[FILE]: $!";
		prlog("File $MD0[FILE] detached from device MD0 and closed\n");
	}
	if($MD1[FILE] ne "")
	{
		close (MD1) || die "can't close $MD1[FILE]: $!";
		prlog("File $MD1[FILE] detached from device MD1 and closed\n");
	}
	if($MD2[FILE] ne "")
	{
		close (MD2) || die "can't close $MD2[FILE]: $!";
		prlog("File $MD2[FILE] detached from device MD2 and closed\n");
	}
	if($MD3[FILE] ne "")
	{
		close (MD3) || die "can't close $MD3[FILE]: $!";
		prlog("File $MD3[FILE] detached from device MD3 and closed\n");
	}
	if($BD0[FILE] ne "")
	{
		close (BD0) || die "can't close $BD0[FILE]: $!";
		prlog("File $BD0[FILE] detached from device BD0 and closed\n");
	}
	if($BD1[FILE] ne "")
	{
		close (BD1) || die "can't close $BD1[FILE]: $!";
		prlog("File $BD1[FILE] detached from device BD1 and closed\n");
	}        
	if($do ne "")
	{
		close DO || die "can't close $do: $!";
		prlog("Dofile $do closed\n");
	}
	if($tracefile ne "")
	{
		close TRACE || die "can't close $tracefile: $!";
		prlog("Tracefile $tracefile closed\n");
	}
	prlog ("EXIT!\n");
	if($logfile ne "")
	{
        prlog("Logfile $logfile is closed\n");
		close LOG || die "can't close $logfile: $!";
	}
	exit;
}

#end command.md ==============================================================

###insert logging.md
### logging.md
# -performs logging of commands and terminal output in a logfile.
# -displays terminal output in the terminal window.

# System messages are displayed on the Control Panel.
sub prlog {
	my $s=shift;
	my $l=length($s);
	my $i=0;	
	my $c=substr($s,$i,1);
	if(Exists($panel))
	{
		if($RUN)
		{
			# while running, first enable the panel for output
			$panel->configure(-state=>'normal');
			print $s;
			$panel->configure(-state=>'disabled');
		}
		else
		{
			print $s;
		}
		$panel->see('end');
		$panel->update;
	}
	if($log)
	{
		print LOG $s;
	}
}

# log console commands
sub cmdlog {
	my $s=shift;
	if($log)
	{
		print LOG $s . "\n";
	}
}

# output TY0 characters in window
sub prlogty0 {
	# state:
	# 0 => at begin of the current line
	# 1 => at begin of a new lime
	# 2 => mid in the current line
	# The tk window does not like \r
	my $s=shift;
	my $l=length($s);
	my $i=0;	
	my $c;

		while($i<$l)
		{
			$c=substr($s,$i,1);
			if($c eq "\r")
			{
				if($TY0[NLCR] == 2)
				{
					$TY0[NLCR] = 0;
				}
			}
			elsif($c eq "\n")
			{
				if($TY0[NLCR] != 1)
				{
					$TY0[NLCR] = 1;
				}
				else
				{
					$c="\r"; # suppress multiple newlines
				}
			}
			else # alpha
			{
				if($TY0[NLCR] == 0) # on a new line?
				{
					# no
					$ty0->insert('end',"\n");
				}
				$TY0[NLCR] = 2;
			}
			if($c ne "\r") # ignore \r
			{
				$ty0->insert('end',"$c");
			}
			$i=$i+1;
		}
		$ty0->update;
		$ty0->see('end');
		if($log)
		{
			print LOG $s;
		}
}

# output TY1 character in window
sub prlogty1
{
	# state:
	# 0 => at begin of the current line
	# 1 => at begin of a new lime
	# 2 => mid in the current line
	# The tk window does not like \r
   my $s=shift;
	my $l=length($s);
	my $c;
	my $i=0;
	while($i<$l)
	{
		$c=substr($s,$i,1);
		if($c eq "\r")
		{
			if($TY1[NLCR] == 2)
			{
				$TY1[NLCR] = 0;
			}
		}
		elsif($c eq "\n")
		{
			if($TY1[NLCR] != 1)
				{
					$TY1[NLCR] = 1;
				}
				else
				{
					$c="\r"; # suppress multiple newlines
				}
		}
		else # alpfa
		{
			if($TY1[NLCR] == 0) # on a new line?
			{
				# no
				$ty1->insert('end',"\n");
			}
			$TY1[NLCR] = 2;
		}
		if($c ne "\r") # ignore \r
		{
			$ty1->insert('end',"$c");
		}
		$i=$i+1;
	}
	$ty1->update;
	$ty1->see('end');
	if($log)
	{
		print LOG $s;
	}
}    

# output TY2 character in window
sub prlogty2
{
	# state:
	# 0 => at begin of the current line
	# 1 => at begin of a new lime
	# 2 => mid in the current line
	# The tk window does not like \r
   my $s=shift;
	my $l=length($s);
	my $c;
	my $i=0;
	while($i<$l)
	{
		$c=substr($s,$i,1);
		if($c eq "\r")
		{
			if($TY2[NLCR] == 2)
			{
				$TY2[NLCR] = 0;
			}
		}
		elsif($c eq "\n")
		{
			if($TY2[NLCR] != 1)
			{
				$TY2[NLCR] = 1;
				if($ty2tty==0)
				{
					$ty2->insert(cvpos2s($ty2tkl,$ty2tkc),"\n");
					prlog("ty2out nlcr $ty2tkl $ty2tkc \n");
					$ty2tkl=$ty2tkl+1; $ty2tkc=0;   # next line
					if($ty2tkl>24)
					{
						$ty2tkl=24;
					}
				}
				else
				{
					$ty2->insert('end',"\n");
					$ty2->see('end');
					$ty2tkl=$ty2tkl+1; $ty2tkc=0;   # next line
				}
			}
			else
			{
				# suppress multiple newlines
				$ty2tkc=0;         # column 0
			}
		}
		else # alpfa
		{
			if($ty2tty)
			{
				# tty
				if($TY2[NLCR] == 0) # on a new line?
				{
					# no
					$ty2->insert('end',"\n");
					$ty2->see('end');
					$ty2tkl=$ty2tkl+1; $ty2tkc=0;   # next line
				}
				$TY2[NLCR] = 2;
			}
			else
			{
				# ansi
				if($TY2[NLCR] == 0) # on a new line?
				{
					# no
					$ty2->insert(cvpos2s($ty2tkl,$ty2tkc),"\n");
					prlog("ty2out nlcr $ty2tkl $ty2tkc \n");
					$ty2tkl=$ty2tkl+1; $ty2tkc=0;   # next line
					if($ty2tkl>24)
					{
						$ty2tkl=24;
					}
				}
				$TY2[NLCR] = 2;
			}
			if($ty2tty)
			{
				# tty
				$ty2->insert('end',"$c");
				$ty2->see('end');
				$ty2tkc=$ty2tkc+1;   # next character
			}
			else
			{
				# ansi
				$ty2->insert(cvpos2s($ty2tkl,$ty2tkc),$c);
				prlog("ty2out " . $c . " $ty2tkl $ty2tkc \n");
				$ty2tkc=$ty2tkc+1;   # next character
				if($ty2tkc>79)
				{
					$ty2tkc=79;
				}
			}
		}
		$i=$i+1;
	}
	$ty2->update;
	$ty2->see('end');
	if($log)
	{
		print LOG $s;
	}
}

# CDC disk control unit (debug support)
sub bdprlog {
    my $s=shift;
    if(DEBUG_BD)
    {
        prlog($s);
    }
}

# Extended system mode 
sub emprlog {
    my $s=shift;
    if(DEBUG_EM)
    {
        prlog($s);
    }
}
#end logging.md ==============================================================

###insert emulator.md The instruction emulator
### emulator.md
# The instruction emulator
############################## Emulator #################################
# execute a single instruction at address $R[0]
# $R[0]/PC contains the logical address of the current instruction
#

sub instr {

   $interval = $interval - 1;
	if($interval <= 0)
	{
		process_events();
	}
	if($brkreg)
	{
		# Break (operates currently only for a single IOP with address 0 !)
		$t1 = $brkreg;
		$t2 = 0;
		while(! ($t1 & 1))
		{
			$t1 = $t1 >> 1;
			$t2 = $t2 + 1;
		}
		# $t2 = subchannel number requesting a break
		# the control unit must be in EXCHANGE state
		$t1   = 1 << $t2;
		$brkreg = $brkreg & (~ $t1);      # reset break request
		$t1   = $DEV{$t2};                # cu on IOP 0 requesting the break
		$t3   = $$t1[STATE] >> 16;        # cu state
		$a    = $t2 << 1;                 # index of external register used by subchannel		
		$mpx1 = $EXTR[$a];	             # w1:
		                                  # bit0 0=chr 1=wrd
		                                  # bit1 0=in  1=out
		                                  # bit4-15 length in characters or words
		$mpx2 = $EXTR[$a+1];              # w2: buffer start cq pointer to byte/word to be read/written
		$tx3  = $mpx1 & 0xFFF;            # length to tranfer (still)

		if($mpx1 & 0x4000)	# check IO-bit in register 1
		{	
			# IO-bit is 1 => OUTPUT (from memory to control unit)
			if($t3 == OEXC)
			{
				# indeed the CU is in outputmode
				if($tx3 == 0)
				{
					# end of range; transfer ready
					# switch control unit to the execute state
					$$t1[STATE] = $$t1[STATE] & 0xFFFF;           # reset cu state bits
					$$t1[STATE] = $$t1[STATE] | (OEXE << 16);     # state = output + execute										
				}				
				else
				{
					$t3 = $$t1[OTR];            # set output service routine					
					if($mpx1 & 0x8000)          # check C/W-bit in register 1
					{
						# C/W-bit is 1 => word transfer			
						$$t1[BUFFER] = $M[$mpx2 & MAXADDR];	
						$mpx1 = $mpx1 - 1;	    # update length to transfer (length counted in words)
						$mpx2 = $mpx2 + 2;      # update position
						&$t3(1);                # transfer a word							
					}
					else
					{
						# C/W-bit is 0 => character transfer
						if($mpx2 & 1)
						{
							$$t1[BUFFER] = $M[$mpx2 & MAXADDR] & 0xFF;         # righthand byte
						}
						else
						{
							$$t1[BUFFER] = ($M[$mpx2 & MAXADDR] >> 8) & 0xFF;  # lefthand byte
						}
						$mpx1 = $mpx1 - 1;	    # update length to transfer (length counted in bytes)
						$mpx2 = $mpx2 + 1;      # update position
						&$t3(0);                # transfer a byte	
					}
					$EXTR[$a]     = $mpx1 & 0xFFFF;                # length
					$EXTR[$a+1]   = $mpx2;                         # position
				}
			}
			else
			{
				# control unit state error		
				prlog("Error Output Multiplex channel, DEV:" . prhex(8,$t2) . " STATE:" . prhex(20,$t3) . "\n");
				mpxerror();
			}
		}
		else
		{
			# IO-bit is 0 => INPUT (from control unit to memory)
			if($t3 == IEXC)
			{
				# indeed the CU is in inputmode
				if($tx3 == 0)
				{
					# end of range; transfer ready
					# switch control unit to the wait request state
					$$t1[STATE] = $$t1[STATE] & 0xFFFF;           # reset cu state bits
					$$t1[STATE] = $$t1[STATE] | (WREQ << 16);    									
				}
				else
				{
					$t3 = $$t1[INR];            # call input service routine
					if($mpx1 & 0x8000)          # check C/W-bit in register 1
					{
						# C/W-bit is 1 => word transfer
						&$t3(1);	# ask for a word
						$M[$mpx2 & MAXADDR] = $$t1[BUFFER] & 0xFFFF;
						$mpx1 = $mpx1 - 1;	# update length (length counted in words)
						$mpx2 = $mpx2 + 2;  # update position							
					}
					else
					{
						&$t3(0);	# ask for a byte
						$t1=$M[$mpx2 & MAXADDR];
						if($mpx2 & 1)
						{
							# righthand byte
							$M[$mpx2 & MAXADDR] = ($t1 & 0xFF00) | ($$t1[BUFFER] & 0xFF);
						}
						else
						{
							# lefthand byte
							$M[$mpx2 & MAXADDR] = ($t1 & 0xFF)   | (($$t1[BUFFER] & 0xFF) << 8);
						}
						$mpx1 = $mpx1 - 1;	 # update length to transfer (length counted in bytes)
						$mpx2 = $mpx2 + 1;   # update position					
					}
					$$t1[BUFFER] = 0;                 # reset buffer
					$EXTR[$a]     = $mpx1 & 0xFFFF;   # update register 1
					$EXTR[$a+1]   = $mpx2;            # update register 2					
				}
			}
			else
			{
				# control unit state error	
				prlog("Error Input Multiplex channel, DEV:" . prhex(8,$t2) . " STATE:" . prhex(20,$t3) . "\n");
				mpxerror();				
			}
		}
	}
	if($ENB)
	{
		# interrupt?
		if($intreg0)
		{
			$t2 = 0;		# t2 is interrupt level
			$t1 = $intreg0;
			while(! ($t1 & 0x80000000))
			{
				$t1 = $t1 << 1;
				$t2 = $t2 + 1;
			}
			if($t2 < $PL)   # if interrupt level < current level => interrupt
			{
			    # P, PSW on stack
			    $M[$R[A15]] = $R[A0] & 0xFFFE; # save P
			    $R[A15] = $R[A15] - 2;         # decrease stack pointer
			    if($R[A15] < 0x100)
			    {
				    trap(LKM);	                 # A15 stack overflow
			    }
			    $M[$R[A15]] = Fpsw();          # save PSW
			    $R[A15] = $R[A15] - 2;         # decrease stack pointer
			    if($R[A15] < 0x100)
			    {
				    trap(LKM);		              # A15 stack overflow
			    }
			    $ENB = 0;                      # inhibit
			    $UM  = 0;                      # system mode
			    $EM  = 0;                      # no extended mode
			    $PL = $t2;		               # set new level
			    $R[A0] = $M[$t2+$t2];	       # fetch address of interrupt routine
			}
		}
		elsif($intreg1)
		{
			$t2 = 0x20;
			$t1 = $intreg1;
			while(! ($t1 & 0x80000000))
			{
				$t1 = $t1 << 1;
				$t2 = $t2 + 1;
			}            
			if($t2 < $PL)   # if interrupt level < current level => interrupt
			{
			    # P, PSW on stack
			    $M[$R[A15]] = $R[A0] & 0xFFFE; # save P
			    $R[A15] = $R[A15] - 2;         # decrease stack pointer
			    if($R[A15] < 0x100)
			    {
					trap(LKM);	                 # A15 stack overflow
			    }
			    $M[$R[A15]] = Fpsw();          # save PSW
			    $R[A15] = $R[A15] - 2;         # decrease stack pointer
			    if($R[A15] < 0x100)
			    {
				   trap(LKM);		              # A15 stack overflow
			    }
			    $ENB = 0;                      # inhibit
			    $UM  = 0;                      # system mode
			    $EM  = 0;                      # no extended mode 
			    $PL = $t2;		                 # set new level
			    $R[A0] = $M[$t2+$t2];	        # fetch address of interrupt routine
			}
		}
	}
	$pcp   = la2pa($R[A0]);              # current physical instruction address
	$IR    = $M[$pcp];                   # fetch instruction
	# for debugging
	pushpc($pcp);                        # backtrack stack
	$pcl   = $R[A0];                     # current logical instruction address for tracing
	$ea    = undef;                      # physical effective address for tracing ea
	#
	$R[A0] = $R[A0] + 2;                 # incr (logical) location counter    
	if(! ($IR & mskf10))
	{
		# format 0
		# - short constant instructions
		# - shift instructions
		# - i/o instructions
		# - miscellanious instructions
		# execute a format 0 instruction		
		format0();
	}	
	elsif(!($IR & 1))
	{
		# format 1, ls bit 0
		format10();
	}
	else
	{
		# format 1, ls bit 1
		format11();
	}
	
	if($EmBreak)
	{
		# breakpoint?
		if($BP{$pcp} ne undef)
		{
			$RUN = 0;
			$s = prhex(16,$pcl) . prhex(20,$pcp);
			prlog("\nBreakpoint, last instruction executed at: $s\n");
		}
	}

	if($EmTrace)
	{
		if($peatrace==0)
		{
			# display the result of the executed instruction
			trace($R[A0]); # logical address of next instruction
		}
		else
		{
			rtrace($R[A0]); # trace instructions a region
		}
	}

}

#end emulator.md ==============================================================

###insert format10.md
### format10.md
# emulate the format 1 instructions with the ls bit == 0
sub format10 {

$opc = ($IR >> 11) & 0xF;                   # opcode
$r1  = ($IR >> 7)  & 0xF;                   # r1 or condition shifted 1 left	
$r2  = ($IR >> 1)  & 0xF;                   # r2
$md  = ($IR >> 5)  & 0x3;                   # addressing mode

if($opc == 0)
{
	# load
	if($md == 0)				    # register operand
	{
		# T1 LDR r1,r2
		$R[$r1] = $R[$r2];
	}
	elsif($md == 1)				        
	# indirect register operand
	{
		# T3A/B LDR* r1,r2, T2 LDKL r1,lk
		if($r2 == 0xF)                      # A15 ?
		{
			# A15, the stack pointer is addressed
			$R[0xF] = ($R[0xF] + 2) & 0xFFFE;
		}
      $ea = la2pa($R[$r2]);
		$R[$r1] = $M[$ea];
		if($r2 == 0)
		{
			# T2 indirect via A0: LDKL r1,lk
			$R[0] = $R[0] + 2;          # increment A0 (PC)
		}
	}
	elsif($md == 2)				        # memory/indexed memory operand
	{
		# T4/T5 LD r1,m or LD r1,m,r2
		$a = $M[la2pa($R[0])];		    # memory operand address
		$R[0] = ($R[0] + 2);        	 # increment A0 (PC)
		if($r2 != 0)			          # indexing ?
		{
			$a = ($a + $R[$r2]);        # yes
		}
		$ea = la2pa($a);                # physical effective address
		$R[$r1] = $M[$ea];              # load content of effective address
	}
	elsif($md == 3)				        # indirect memory/indexed memory operand
	{
		# T6/T7 LD* r1,m or LD* r1,m,r2
		$a = $M[la2pa($R[0])];	        # memory operand address
		$R[0] = $R[0] + 2;         	  # increment A0 (PC)
		if($r2 != 0)			           # indexing ?
		{
			$a = ($a + $R[$r2]);         # yes
		}
		$a = $M[la2pa($a)];             # memory content = logical effective address
      $ea = la2pa($a);                # physical effective address
		$R[$r1] = $M[$ea];              # load content of effective address
	}
	setCR1($r1);
}
elsif($opc == 1)
{
	$r1=$r1>>1;								    # position condition
	# absolute branche
   if($md == 0)				                # register operand
	{
		# T1 ABR(cnd) r2
		# $r1 is the condition code in the operation
		if(evalcond($r1))
		{
			$R[0] = $R[$r2];
		}
	}
	elsif($md == 1)				               # indirect register operand
	{
		# T3 ABR(cnd)* r2
		# $r1 is the condition code in the operation
		if(evalcond($r1))
		{
         $ea   = la2pa($R[$r2]);
			$R[0] = $M[$ea];       # jump
		}
		elsif($r2 == 0)                        # no jump, skip address in case of an ABL
		{
			# T2 indirect via A0: ABL(cnd) lk
			$R[0] = $R[0] + 2;                  # increment A0 (PC)
		}
	}
	elsif($md == 2)				               # memory/indexed memory operand
	{	
		# T4/T5 ABI(cnd) m or ABI(cnd) m,r2
		# $r3 is the condition code in the operation
		$a = $M[la2pa($R[0])];		           # memory operand address
		$R[0] = ($R[0] + 2);         	        # increment A0 (PC)
		if($r2 != 0)			                 # indexing ?
		{
			$a = ($a + $R[$r2]);               # yes
		}
		# $a is effective address
		if(evalcond($r1))
		{
         $ea   = la2pa($a);
			$R[0] = $M[$ea];                   # load P with content of effective address
		}
	}
	elsif($md == 3)				              # indirect memory/indexed memory operand
	{
		# T6/T7 ABI(cnd)* m or ABI(cnd)* m,r2
		$a = $M[la2pa($R[0])];		           # memory operand address
		$R[0] = ($R[0] + 2);         	        # increment A0 (PC)
		if($r2 != 0)			                 # indexing ?
		{
			$a = ($a + $R[$r2]);               # yes
		}
		$a = $M[la2pa($a)];                   # memory content = logical effective address
		if(evalcond($r1))
		{
         $ea   = la2pa($a);                 # physical effective address
			$R[0] = $M[$ea];                   # load P with content of effective address
		}
	}		
}
elsif($opc == 2)
{
	# add, increment memory
	$overflow = 0;
	if($md == 0)				                 # register operand
	{
		# T1 ADR r1,r2
		$t1 = $R[$r1]; $t2 = $R[$r2]; $t3 = $t1 + $t2;
	}
	elsif($md == 1)				               # indirect register operand
	{
		# T3 ADR* r1,r2, T2 ADKL r1,lk
      $ea = la2pa($R[$r2]);
		$t1 = $R[$r1]; $t2 = $M[$ea]; $t3 = $t1 + $t2;
		if($r2 == 0)
		{
			# T2 indirect via A0: ADKL r1,lk
			$R[0] = ($R[0] + 2);        	      # increment A0 (PC)
		}
	}
	elsif($md == 2)				                # memory/indexed memory operand
	{
		# T4/T5 AD r1,m or AD r1,m,r2
		$a = $M[la2pa($R[0])];  	             # memory operand address
		$R[0] = ($R[0] + 2);        	          # increment A0 (PC)
		if($r2 != 0)			                   # indexing ?
		{
			$a = ($a + $R[$r2]);                 # yes
		}
		# $a is logical effective address
      $ea = la2pa($a);                        # physical effective address
		$t1 = $R[$r1]; $t2 = $M[$ea]; 
		$t3 = $t1 + $t2;                        # add content of effective address
	}
	elsif($md == 3)				                # indirect memory/indexed memory operand
	{
		# T6/T7 AD* r1,m or AD* r1,m,r2
		$a = $M[la2pa($R[0])];  	             # memory operand address
		$R[0] = ($R[0] + 2);        	          # increment A0 (PC)
		if($r2 != 0)			                   # indexing ?
		{
			$a = ($a + $R[$r2]);                 # yes
		}
		$a  = $M[la2pa($a)];                    # memory content = logical effective address
      $ea = la2pa($a);                        # physical effective address
		$t1 = $R[$r1]; $t2 = $M[$ea];
		$t3 = $t1 + $t2;                        # add content of effective address
	}
	# overflow? (+)
	if((((~$t1) ^ $t2) & ($t1 ^ $t3)) & SIGN)
	{
		$overflow = 1;
	}
	$R[$r1] = setCRvalue($t3);
}
elsif($opc == 3)
{
	# subtract, two complement
	$overflow = 0;
	if($md == 0)				                # register operand
	{
		# T1 SUR r1,r2
		$t1 = $R[$r1]; $t2 = $R[$r2]; $t3 = $t1 - $t2;
	}
	elsif($md == 1)				                # indirect register operand
	{
		# T3 SUR* r1,r2, T2 SUKL r1,lk
      $ea = la2pa($R[$r2]);       
		$t1 = $R[$r1]; $t2 = $M[$ea]; $t3 = $t1 - $t2;
		if($r2 == 0)
		{
			# T2 indirect via A0: ADKL r1,lk
			$R[0] = ($R[0] + 2);        	       # increment A0 (PC)
		}
	}
	elsif($md == 2)				                # memory/indexed memory operand
	{
		# T4/T5 SU r1,m or SU r1,m,r2
		$a = $M[la2pa($R[0])];   	             # memory operand address
		$R[0] = ($R[0] + 2);	                   # increment A0 (PC)
		if($r2 != 0)			                   # indexing ?
		{
			$a = ($a + $R[$r2]);                 # yes
		}
		# $a is logical effective address
      $ea = la2pa($a);                        # physical effective address       
		$t1 = $R[$r1]; $t2 = $M[$ea]; 
		$t3 = $t1 - $t2;                        # subtract content of effective address
	}
	elsif($md == 3)				                # indirect memory/indexed memory operand
	{
		# T6/T7 SU* r1,m or SU* r1,m,r2
		$a = $M[la2pa($R[0])];			          # memory operand address
		$R[0] = ($R[0] + 2);         	          # increment A0 (PC)
		if($r2 != 0)			                   # indexing ?
		{
			$a = ($a + $R[$r2]);                 # yes
		}
		$a = $M[la2pa($a)];                     # memory content = logical effective address
      $ea = la2pa($a);                        # physical effective address
		$t1 = $R[$r1]; $t2 = $M[la2pa($a)];
		$t3 = $t1 - $t2;                        # subtract content of effective address
	}
	# underflow? (-)
	if((($t1 ^ $t2) & ((~$t2) ^ $t3)) & SIGN)
	{
		$overflow = 1;
	}	
	$R[$r1] = setCRvalue($t3);
}
elsif($opc == 4)
{
	# AND
	if($r1 != 0)
	{
		if($md == 0)				                # register operand
		{
			# T1 ANR r1,r2
			$t3 = $R[$r1] & $R[$r2];
		}
		elsif($md == 1)				             # indirect register operand
		{
			# T3 ANR* r1,r2, T2 ANKL r1,lk
         $ea = la2pa($R[$r2]);
			$t3 = $R[$r1] & $M[$ea];
			if($r2 == 0)
			{
				# T2 indirect via A0: ANKL r1,lk
				$R[0] = ($R[0] + 2);	             # increment A0 (PC)
			}
		}
		elsif($md == 2)				             # memory/indexed memory operand
		{
			# T4/T5 AN r1,m or AN r1,m,r2
			$a = $M[la2pa($R[0])];		          # memory operand address
			$R[0] = ($R[0] + 2);         	       # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$ea = la2pa($a);                     # physical effective address
			$t3 = $R[$r1] & $M[$ea];             # and content of effective address         
		}
		elsif($md == 3)				             # indirect memory/indexed memory operand
		{
			# T6/T7 AN* r1,m or AN* r1,m,r2
			$a = $M[la2pa($R[0])];		          # memory operand address
			$R[0] = ($R[0] + 2);        	       # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$a = $M[la2pa($a)];                  # memory content = effective address
         $ea = la2pa($a);                     # physical effective address
			$t3 = $R[$r1] & $M[$ea];             # and content of effective address               
		}
		$R[$r1] = setCRvalue($t3);
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "AND10");
	}			
}
elsif($opc == 5)
{
	# OR
	if($r1 != 0)
	{
		if($md == 0)				                # register operand
		{
			# T1 ORR r1,r2
			$t3 = $R[$r1] | $R[$r2];
		}
		elsif($md == 1)				             # indirect register operand
		{
			# T3 ORR* r1,r2, T2 ORKL r1,lk
            $ea = la2pa($R[$r2]);
			$t3 = $R[$r1] | $M[$ea];
			if($r2 == 0)
			{
				# T2 indirect via A0: ORKL r1,lk
				$R[0] = ($R[0] + 2);	             # increment A0 (PC)
			}
		}
		elsif($md == 2)				             # memory/indexed memory operand
		{
			# T4/T5 OR r1,m or OR r1,m,r2
			$a = $M[la2pa($R[0])];			       # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$ea = la2pa($a);                     # physical effective address
			$t3 = $R[$r1] | $M[$ea];             # or content of effective address         
		}
		elsif($md == 3)				             # indirect memory/indexed memory operand
		{
			# T6/T7 OR* r1,m or OR* r1,m,r2
			$a = $M[la2pa($R[0])];			       # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$a = $M[la2pa($a)];                  # memory content = effective address
         $ea = la2pa($a);                     # physical effective address
			$t3 = $R[$r1] | $M[$ea];             # or content of effective address               
		}
		$R[$r1] = setCRvalue($t3);
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "OR10");
	}	
}
elsif($opc == 6)
{
	# XOR
	if($r1 != 0)
	{
		if($md == 0)				                # register operand
		{
			# T1 XRR r1,r2
			$t3 = $R[$r1] ^ $R[$r2];
		}
		elsif($md == 1)				             # indirect register operand
		{
			# T3 XRR* r1,r2, T2 XRKL r1,lk
         $ea = la2pa($R[$r2]);                # physical effective address
			$t3 = $R[$r1] ^ $M[$ea];
			if($r2 == 0)
			{
				# T2 indirect via A0: XRKL r1,lk
				$R[0] = ($R[0] + 2);	             # increment A0 (PC)
			}
		}
		elsif($md == 2)				             # memory/indexed memory operand
		{
			# T4/T5 XR r1,m or XR r1,m,r2
			$a = $M[la2pa($R[0])];		          # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$ea = la2pa($a);                     # physical effective address
			$t3 = $R[$r1] ^ $M[$ea];             # xr content of effective address
		}
		elsif($md == 3)				             # indirect memory/indexed memory operand
		{
			# T6/T7 XR* r1,m or XR* r1,m,r2
			$a = $M[la2pa($R[0])];   	          # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$a = $M[la2pa($a)];                  # memory content = effective address
         $ea = la2pa($a);                     # physical effective address
			$t3 = $R[$r1] ^ $M[$ea];             # xr content of effective address
		}
		$R[$r1] = setCRvalue($t3);
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "XOR10");
	}
}
elsif($opc == 7)
{
    if($r1 != 0)
    {
        # multiple load
        if($md == 1)				                   # indirect register operand
        {
            # T3A/B MLR n,r2, T2 MLK n
            # $r1 is n
            $t1 = 1;
            if($r2 == 0xF)
            {
                # A15, the stack pointer is addressed
                $a = $R[0xF] = ($R[0xF] + $r1*2) & 0xFFFE;
                $sea=la2pa($a);
                while($t1 <= $r1)
                {
                    $ea = la2pa($a);             # physical effective address
                    $R[$A[$t1]] = $M[$ea];       # load content of physical effective address
                    $a = $a - 2;
                    $t1 = $t1 + 1;
                }
            }
            else
            {
                $a = $R[$r2];                    # logical effective address
                $sea=la2pa($a);
                while($t1 <= $r1)
                {
                    $ea = la2pa($a);             # physical effective address
                    $R[$A[$t1]] = $M[$ea];       # load content of physical effective address
                    $a = $a + 2;
                    $t1 = $t1 + 1;
                }
            }
            if($r2 == 0)
            {
                # T2 indirect via A0: MLK n ($r1 = n)
                $R[0] = ($R[0] + $r1*2);	       # increment A0 (PC)
            }
        }
        elsif($md == 2)				                # memory/indexed memory operand
        {           
            # T4/T5 ML n,m or ML n,m,r2
            $a = $M[la2pa($R[0])];		          # memory operand address
            $R[0] = ($R[0] + 2);	                # increment A0 (PC)
            if($r2 != 0)			                # indexing ?
            {
                $a = ($a + $R[$r2]);             # yes
            }
            # $a is logical effective address
            # $r1 is n
            $t1 = 1;
            $sea=la2pa($a);
            while($t1 <= $r1)
            {
                $ea = la2pa($a);                 # physical effective address
                $R[$A[$t1]] = $M[$ea];           # load content of physical effective address
                $a = $a + 2;
                $t1 = $t1 + 1;
            }
        }
        elsif($md == 3)				                # indirect memory/indexed memory operand
        {
            # T6/T7 ML* n,m or ML* n,m,r2
            $a = $M[la2pa($R[0])];		          # memory operand address
            $R[0] = ($R[0] + 2);	                # increment A0 (PC)
            if($r2 != 0)			                # indexing ?
            {
                $a = ($a + $R[$r2]);             # yes
            }
            $a = $M[la2pa($a)];                  # memory content = logical effective address
            # $r1 is n
            $t1 = 1;
            $sea=la2pa($a);
            while($t1 <= $r1)
            {
                $ea = la2pa($a);                 # physical effective address
                $R[$A[$t1]] = $M[$ea];           # load content of physical effective address
                $a = $a + 2;
                $t1 = $t1 + 1;
            }
        }
        else
        {
            # $md == 0
            # illegal instruction
            ilcerror($R[0]-2, $IR, $opc, "ML10");
        }
        $R[2] = setCRvalue($R[2]); # condition register set by A1
        $ea=$sea;
	}
   else
   {
        # Segment table load (TLR/TL)
        if($UM == 0)
        {
            $t1 = 0;
            if($md == 1)				            # indirect register operand
            {
                # T3 TLR r2
                $a = $R[$r2];                       # logical effective address
                $sea=la2pa($a);
                while($t1 < 16)
                {
                    $ea = la2pa($a);                # physical effective address
                    $MMU[$t1] = $M[$ea];
                    $a = $a + 2;
                    $t1 = $t1 + 1;
                }
            }
            elsif($md == 2)				            # memory/indexed memory operand
            {
                # T4/T5 TL m or TL m,r2
                $a = $M[la2pa($R[0])];             # memory operand address
                $R[0] = ($R[0] + 2);	            # increment A0 (PC)
                if($r2 != 0)			               # indexing ?
                {
                    $a = ($a + $R[$r2]);            # yes
                }
                # $a is logical effective address
                $sea=la2pa($a);
                while($t1 < 16)
                {
                    $ea = la2pa($a);                # physical effective address
                    $MMU[$t1] = $M[$ea];            # load content of effective address
                    $a = $a + 2;
                    $t1 = $t1 + 1;
                }
            }
            elsif($md == 3)				            # indirect memory/indexed memory operand
            {
                # T6/T7 TL* m or TL* m,r2
                $a = $M[la2pa($R[0])];              # memory operand address
                $R[0] = ($R[0] + 2);	             # increment A0 (PC)
                if($r2 != 0)			                # indexing ?
                {
                    $a = ($a + $R[$r2]);            # yes
                }
                $a = $M[la2pa($a)];                 # memory content = logical effective address
                $sea=la2pa($a);
                while($t1 <= 16)
                {
                    $ea = la2pa($a);                # physical effective address
                    $MMU[$t1] = $M[$ea];            # load content of effective address
                    $a = $a + 2;
                    $t1 = $t1 + 1;
                }
            }
            else
            {
                # $md == 0
                # illegal instruction
                ilcerror($R[0]-2, $IR, $opc, "TL10");
            }
            $ea=$sea;
        }
        else
        {
            prlog("Segment Table Load only allowed in System Mode\n");
            $RUN = 0;
        }
    }
}
elsif($opc == 8)
{
	# Multiply
	$overflow = 0;
	if($r1 == 0)
	{
		my $s = 0;		                            # collect sign result
		$t2 = $R[4];                               # A2				
		if($md == 0)
		{
			# T1 MUR r2
			$t1 = $R[$r2];                          # operand
		}
		elsif($md == 1)
		{
			if($r2 != 0)
			{
				# T3 MUR* r2
                $ea = la2pa($R[$r2]);
				$t1 = $M[$ea];                       # operand
			}
			else
			{
				# T2 MUK lk
                $ea = la2pa($R[0]);
				$t1 = $M[$ea];                       # lk, operand
				$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			}
		}
		elsif($md == 2)
		{
			# T4/T5 MU m or MU m,r2
			$a = $M[la2pa($R[0])];	                # memory operand address
			$R[0] = ($R[0] + 2);        	          # increment A0 (PC)
			if($r2 != 0)			                   # indexing ?
			{
				$a = ($a + $R[$r2]);                 # yes
			}
			# $a is logical effective address
            $ea = la2pa($a);
			$t1 = $M[$ea];                          # operand
		}
		elsif($md == 3)
		{
			# T6/T7 MU* m or MU* m,r2
			$a = $M[la2pa($R[0])];	                # memory operand address
			$R[0] = ($R[0] + 2);        	          # increment A0 (PC)
			if($r2 != 0)			                   # indexing ?
			{
				$a = ($a + $R[$r2]);                 # yes
			}
			$a = $M[la2pa($a)];                     # memory content = logical effective address
			$ea = la2pa($a);
         $t1 = $M[$ea];                          # operand	
		}
		
		$t1 = $t1 & DMASK; 
		$t2 = $t2 & DMASK; 
		if($t1 & SIGN)
		{
			$t1 = ((~ $t1) + 1) & DMASK;            # sign - => 2-compl
			$s = $s ^ 1;
		}
		if($t2 & SIGN)
		{
			$t2 = ((~ $t2) + 1) & DMASK;            # sign - => 2-compl
			$s = $s ^ 1;
		}
		$t3 = ($t1 * $t2) & DPDMASK;               # A2 * operand 
		if($t3 != 0)
		{
			if($s)
			{
				$t3 = ((~ $t3) & DPDMASK) + 1;       # sign - => 2-compl
				if( ! ($t3 & DPSIGN))
				{
					$overflow = 1;
				}
			}
			else
			{
				if($t3 & DPSIGN)
				{
					$overflow = 1;
				}
			}
		}
		setCR2s($t3);
		putdbls($t3);
	}
	elsif($r1 == 2)
	{
		# Floating Point Load
		$fppstatus=0;
		if($md == 0)
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc,"FLD");
		}
		else
		{
			la_operand(0);          # a = logical address of operand
			$ea = la2pa($a);        # physical effective address
			$FPA1=$M[$ea];
			$ea = la2pa($a+2);
			$FPA2=$M[$ea];
			$ea = la2pa($a+4);
			$FPA3=$M[$ea];
			# set CR
			if($FPP)
			{
				$t1=$FPA1 & 0x8000; # bit 0
				$t2=$FPA1 & 0x4000; # bit 1
				if($FPA1==0 && $FPA2==0)
				{
					$CR=0;
				}
				else
				{
					if($t1 && ($t2==0))
					{
						# negative and normalized
						$CR=2;
					}
					elsif($t2 && ($t1==0))
					{
						# positive and normalized
						$CR=1;
					}
					else
					{
						# unnormalized operand
						error_fpp(0x0210);
					}
				}
			}
			else
			{
				error_fpp(0xFFFF);  # FPP not configured
			}
		}
	}
	else
	{	
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc,"F10-8");
	}
}
elsif($opc == 9)
{
	$overflow = 0;
	if($r1 == 0)
	{
		# Divide
		my $s  = 0;		                            # collect sign result (quotient)
		my $sr = 0;                                # sign remainder (gets sign of dividend)
		$t1 = getdbls();                           # A1,A2 dividend				
		if($md == 0)
		{
			# T1 DVR r2
			$t2 = $R[$r2];                          # operand, divisor
		}
		elsif($md == 1)
		{
			if($r2 != 0)
			{
				# T3 DVR* r2
            $ea = la2pa($R[$r2]);
				$t2 = $M[$ea];                       # operand, divisor
			}
			else
			{
				# T2 DVK lk
            $ea = la2pa($R[0]);
				$t2 = $M[$ea];                       # lk, operand, divisor
				$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			}
		}
		elsif($md == 2)
		{
			# T4/T5 DV m or DV m,r2
			$a = $M[la2pa($R[0])];	                # memory operand address
			$R[0] = ($R[0] + 2);        	          # increment A0 (PC)
			if($r2 != 0)			                   # indexing ?
			{
				$a = ($a + $R[$r2]);                 # yes
			}
			# a2 is logical effective address
         $ea = la2pa($a);
			$t2 = $M[$ea];                          # operand, divisor
		}
		elsif($md == 3)
		{
			# T6/T7 DV* m or DV* m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);        	      # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			$a = $M[la2pa($a)];                 # memory content = logical effective address
			$ea = la2pa($a);
         $t2 = $M[$ea];                      # operand, divisor
		}
		if($t1 & DPSIGN)
		{
			$t1 = (((~ $t1) & DPDMASK) + 1) & DPDMASK; # make positive (2-compl)
			$s = $sr = $s ^ 1;                         # and save sign / sign remainder
		}
		if($t2 & SIGN)
		{
			$t2 = (((~ $t2) & DMASK) + 1) & DMASK;
			$s = $s ^ 1;
		}

      # 1st test divisor then dividend
		if($t2 == 0)
		{
			$overflow = 1;                      # divisor = 0
			$t3 = 0x7FFF;
			$t1 = 0;
		}
		elsif($t1 == 0)
		{
			$t3 = 0;	                           # dividend = 0 => result = 0
		}
		else
		{
			   $t3 = int($t1 / $t2);            # quotient
            if($s==0)                        # positive quotient requested
            {
            	if($t3 > 0x7FFF)
            	{
            		$overflow = 1;             # + quotient bigger than 15 bit
            	}
            }
            if($s==1)                        # negative quotient requested
            {
            	if($t3 > 0x8000)
            	{
            		$overflow = 1;             # for negative quotients, the lnn is allowed 
            	}
            	else
            	{
            		# no overflow
            		$t3 = (((~ $t3) & DMASK) + 1) & DMASK; # 2-comp
            	}
            }            
			   $t1 = $t1 % $t2;	               # remainder
			
			   if($sr)                          # remainder negative ?
			   {
				   $t1 = (((~ $t1) & DMASK) + 1) & DMASK;
			   }
		}
		$R[4] = setCRvalue($t3);                # A2 = quotient
		$R[2] = $t1;                            # A1 = remainder
	}
	elsif($r1==2)
	{
		# FFL: Convert an integer (in A1,A2) to floating point value
		# A1,A2 => float(FPA1,FPA2,FPA3)
		if($FPP)
		{
			if($R[A1] == 0 && $R[A2] == 0)
			{
				$FPA1=0, $FPA2=0, $FPA3=0;
				$CR  = 0;
			}
			else
			{
				my $lng; my $i;
				$lng=getdbls();                # get A1,A2 as long
				# left normalize
				$t3=($lng & DPSIGN) >>1;       # save sign shifted
				$i=0;                          # count
				while($i<31)
				{
					$t1=$lng & 0x20000000;
					if($t1==$t3)
					{
						$lng=$lng<<1;
						$i=$i+1;
					}
					else
					{
						last;
					}
				}
				$FPA3 = ( ~ ($i-31)) & 0xFFFF;
				$FPA1 = ($lng >> 16) & 0xFFFF;
				$FPA2 = $lng & 0x7FFF;
				$CR   = 1;
				if($FPA1 & 0x8000)
				{ 
					$CR = 2;
				}
			}
		}
		else
		{
			error_fpp(0xFFFF); # FPP not configured
		}
	}
	elsif($r1==8)
	{
		# Floating Point Add: result in FPA
		$fppstatus=0;
		if($md == 0 || (! $FPP) )
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc,"FAD");
		}
		else
		{
			load_2nd_operand();
			fladd(); 					# FPB=FPA+FPM and sets CR
			store_result_fpp();         # FPA=FPB
		}
	}
	elsif($r1==10)
	{
		# Floating Point Sub: result in FPA
		$fppstatus=0;
		if($md == 0 || (! $FPP) )
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc,"FSU");
		}
		else
		{
			load_2nd_operand();
			flsub(); 					# FPB=FPA-FPM and sets CR
			store_result_fpp();         # FPA=FPA
		}
	}
	elsif($r1==12)
	{
		# Floating Point Mul: result in FPA
		$fppstatus=0;
		if($md == 0 || (! $FPP) )
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc,"FMU");
		}
		else
		{
			load_2nd_operand();
			flmul(); 					# FPB=FPA*FPM and sets CR
			store_result_fpp();         # FPA=FPB
		}
	}
	elsif($r1==14)
	{
		# Floating Point Div: result in FPA
		$fppstatus=0;
		if($md == 0 || (! $FPP) )
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc,"FDV");
		}
		else
		{
			load_2nd_operand();
			fldiv(); 					# FPB=FPA+FPM and sets CR
			store_result_fpp();         # FPA=FPB
		}
	}
	else
	{	
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc,"F10-9");
	}
}
elsif($opc == 10)
{
	# double add
	$overflow = 0;
	if($r1 == 0)
	{
		$t1 = getdbls();						# A1,A2 double accumulator
		if($md == 0)
		{
			# T1 DAR r2
			$t2 = $R[$r2] << 15;
			if($r2 == 0xE)
			{
				$r2 = 1;
			}
			else
			{
				$r2 = $r2 + 2;
			}
			if($r2 > 0xF)
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc,"DADD10a");
			}
			$t2 = $t2 | ($R[$r2] & MMASK);		# operand
		}
		elsif($md == 1)
		{
			if($r2 != 0)
			{
				# T3 DAR* r2
            $ea = la2pa($R[$r2]);
				$t2 = $M[$ea] << 15;
            $ea = la2pa($R[$r2]+2);
				$t2 = $t2 | ($M[$ea] & MMASK);
			}
			else
			{
				# T2 DAK lk1,lk2
            $ea = la2pa($R[0]);
				$t2 = $M[$ea];
				$R[0] = ($R[0] + 2);	        # increment A0 (PC)
            $ea = la2pa($R[0]);
				$t3 = $M[$ea];
				$R[0] = ($R[0] + 2);	        # increment A0 (PC)
				$t2 = ($t2 << 15) | ($t3 & MMASK); # operand
			}
		}
		elsif($md == 2)
		{
			# T4/T5 DA m or DA m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);        	      # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			# $a is logical effective address
         $ea = la2pa($a);
			$t2 = $M[$ea] << 15;
         $ea = la2pa($a + 2);
			$t2 = $t2 | ($M[$ea] & MMASK);      # operand
		}
		elsif($md == 3)
		{
			# T6/T7 DA* m or DA* m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);        	      # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			$a  = $M[la2pa($a)];                # memory content = logical effective address
			$ea = la2pa($a);
         $t2 = $M[$ea] << 15;
         $ea = la2pa($a + 2);
			$t2 = $t2 | ($M[$ea] & MMASK);      # operand		
		}
		$t3 = $t1 + $t2;
		# overflow ?
		if((((~$t1) ^ $t2) & ($t1 ^ $t3)) & DPSIGN)
		{
			$overflow = 1;
		}
		setCR2s($t3);
		putdbls($t3);
	}
	else
    {
        # Extended Load
        # ELx is sometimes used in extended mode and operates then as a normal Load
        if($UM == 0)
        {
            if($md == 1)
            {
                # T3 ELR r1,r2
                $ea = extendedaddr($R[$r2]);
                if($ea < MEMSIZE)
                {
                    $R[$r1] = $M[$ea];
                    setCR1($r1);
                }
                else
                {
                    emprlog("Error: Extended load above memory size\n");
                }
            }
            elsif($md == 2)
            {
                # T4/T5 EL r1,m of EL r1,m,r2
                $a = $M[la2pa($R[0])];              # memory operand address
                $R[0] = ($R[0] + 2);        	       # increment A0 (PC)
                if($r2 != 0)			                # indexing ?
                {
                    $a = ($a + $R[$r2]);            # yes
                }
                # $a is effective logical address
                $ea = extendedaddr($a);             # $ea is effective physical address
                if($ea < MEMSIZE)
                {
                    $R[$r1] = $M[$ea];
                    setCR1($r1);
                }
                else
                {
                    emprlog("Error: Extended load above memory size\n");
                }
            }
            elsif($md == 3)
            {
                $a = $M[la2pa($R[0])];              # memory operand address
                $R[0] = ($R[0] + 2);         	    # increment A0 (PC)
                if($r2 != 0)			                # indexing ?
                {
                    $a = ($a + $R[$r2]);            # yes
                }
                $a = $M[la2pa($a)];                  # memory operand address = effective logical address
                $ea = extendedaddr($a);              # $ea is effective physical address
                if($ea < MEMSIZE)
                {
                    $R[$r1] = $M[$ea];
                    setCR1($r1);
                }
                else
                {
                    emprlog("Error: Extended load above memory size\n");
                }
            }
            else
            {
                # illegal instruction
                ilcerror($R[0]-2, $IR, $opc,"EL10");
            }
        }
        else
        {
            prlog("Extended Load in User Mode not allowed\n");
            $RUN = 0;
        }
	}
}
elsif($opc == 11)
{
	# double sub
	$overflow = 0;
	if($r1 == 0)
	{
		$t1 = getdbls();						   # A1,A2 double accumulator
		if($md == 0)
		{
			# T1 DSR r2
			$t2 = $R[$r2] << 15;
			if($r2 == 0xE)
			{
				$r2 = 1;
			}
			else
			{
				$r2 = $r2 + 2;
			}
			if($r2 > 0xF)
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc,"DSUB10a");
			}
			$t2 = $t2 | ($R[$r2] & MMASK);			# operand
		}
		elsif($md == 1)
		{
			if($r2 != 0)
			{
				# T3 DSR* r2
            $ea = la2pa($R[$r2]);
				$t2 = $M[$ea] << 15;
            $ea = la2pa($R[$r2]+2);
				$t2 = $t2 | ($M[$ea] & MMASK);
			}
			else
			{
				# T2 DSK lk1,lk2
            $ea   = la2pa($R[0]);
				$t2   = $M[$ea];
				$R[0] = ($R[0] + 2);                # increment A0 (PC)
            $ea   = la2pa($R[0]);
				$t3   = $M[$ea];
				$R[0] = ($R[0] + 2);	               # increment A0 (PC)	
				$t2 = ($t2 << 15) | ($t3 & MMASK);	# operand
			}
		}
		elsif($md == 2)
		{
			# T4/T5 DS m or DS m,r2
			$a = $M[la2pa($R[0])];		           # memory operand address
			$R[0] = ($R[0] + 2);        	        # increment A0 (PC)
			if($r2 != 0)			                 # indexing ?
			{
				$a = ($a + $R[$r2]);               # yes
			}
			# $a is logical effective address
         $ea = la2pa($a);
			$t2 = $M[$ea] << 15;
         $ea = la2pa($a + 2);
			$t2 = $t2 | ($M[$ea] & MMASK);         # operand
		}
		elsif($md == 3)
		{
			# T6/T7 DS* m or DS* m,r2
			$a = $M[la2pa($R[0])];	               # memory operand address
			$R[0] = ($R[0] + 2);        	         # increment A0 (PC)
			if($r2 != 0)			                  # indexing ?
			{
				$a = ($a + $R[$r2]);                # yes
			}
			$a  = $M[la2pa($a)];
         $ea = la2pa($a);
			$t2 = $M[$ea] << 15;
         $ea = la2pa($a + 2);
			$t2 = $t2 | ($M[$ea] & MMASK);         # operand
		}
		$t3 = $t1 - $t2;
		# underflow ? (-)
		if((($t1 ^ $t2) & ((~$t2) ^ $t3)) & DPSIGN)
		{
			$overflow = 1;
		}	
		setCR2s($t3);
		putdbls($t3);
	}
	else
	{	
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc,"DSUB10");
	}
}
elsif($opc == 12)
{
	# character transfer
	if($r1 != 0)
	{
		if($md == 0)				               # register operand
		{
			# T1 ECR r1,r2
			$t1 = ($R[$r2] >> 8) & 0xFF;
			$R[$r1] = (($R[$r2] << 8) | $t1) & 0xFFFF;
		}
		elsif($md == 1)				            # indirect register operand
		{
			# T3 LCR r1,r2, T2 LCK r1,lk
			$a  = $R[$r2];                      # $a is logical byte address !
         $ea = la2pa($a);                    # $ea is word address
			$t1 = $M[$ea];
			if($a & 1)
			{
				$t1 = $t1 & 0xFF;                # 1 = right hand byte
			}
			else
			{
				$t1 = ($t1 >> 8) & 0xFF;         # 0 = left hand byte
			}
			if($r2 == 0)
			{
				# T2 indirect via A0: LCK r1,lk
				$R[0] = ($R[0] + 2);	            # increment A0 (PC)
			}
		}
		elsif($md == 2)				            # memory/indexed memory operand
		{
			# T4/T5 LC r1,m or LC r1,m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);	               # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			# $a is logical byte address !
         $ea = la2pa($a);                    # $ea is word address
			$t1 = $M[$ea];                      # get word with addressed byte
			if($a & 1)
			{
				$t1 = $t1 & 0xFF;                # 1 = right hand byte
			}
			else
			{
				$t1 = ($t1 >> 8) & 0xFF;         # 0 = left hand byte
			}
		}
		elsif($md == 3)				            # indirect memory/indexed memory operand
		{
			# T6/T7 LC* r1,m or LC* r1,m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);	               # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			$a  = $M[la2pa($a)];
			# $a is logical byte address !
         $ea = la2pa($a);                    # $ea is word address
			$t1 = $M[$ea];                      # get word with addressed byte
			if($a & 1)
			{
				$t1 = $t1 & 0xFF;                # 1 = right hand byte
			}
			else
			{
				$t1 = ($t1 >> 8) & 0xFF;         # 0 = left hand byte
			}		
		}
		$R[$r1] = ($R[$r1] & 0xFF00) | $t1;	
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "LC10");	
	}		
}
elsif($opc == 13)
{
	# compare word
	if($md == 0)				                   # register operand
	{
		# T1 CWR r1,r2
		$t1 = $R[$r1]; $t2 = $R[$r2];
	}
	elsif($md == 1)				                # indirect register operand
	{
		# T3 CWR* r1,r2, T2 CWK r1,lk
      $ea = la2pa($R[$r2]);
		$t2 = $M[$ea];
		if($r2 == 0)
		{
			# T2 indirect via A0: CWK r1,lk
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
		}
		$t1 = $R[$r1];
	}
	elsif($md == 2)				                # memory/indexed memory operand
	{
		# T4/T5 CW r1,m or CW r1,m,r2
		$a = $M[la2pa($R[0])];		             # memory operand address
		$R[0] = ($R[0] + 2);	                   # increment A0 (PC)
		if($r2 != 0)			                   # indexing ?
		{
			$a = ($a + $R[$r2]);                 # yes
		}
		# $a is logical effective address
      $ea = la2pa($a);
		$t1 = $R[$r1]; $t2 = $M[$ea]; 
	}
	elsif($md == 3)				                # indirect memory/indexed memory operand
	{
		# T6/T7 CW* r1,m or CW* r1,m,r2
		$a = $M[la2pa($R[0])];	                # memory operand address
		$R[0] = ($R[0] + 2);	                   # increment A0 (PC)
		if($r2 != 0)			                   # indexing ?
		{
			$a = ($a + $R[$r2]);                 # yes
		}
		$a = $M[la2pa($a)];                     # memory content = logical effective address
      $ea = la2pa($a);
		$t1 = $R[$r1]; $t2 = $M[$ea];
	}
	# direct subtraction of t1 and t2 is not possible; prevent over/underflow
	# over/undeflow with subtraction is only possible with t1 and t2 having 
	# different signs (and when comparing 0x8000)
	if(($t1 ^ $t2) & SIGN)
	{
		# sign t1 and t2 are different, so underflow is possible
		if($t1 & SIGN)
		{
			# sign t1 is - (and so sign t2 is +)
			$t3 = -1;		                     # t1 < t2
		}
		else
		{
			# sign t1 is + (and so sign t2 is -)
			$t3 = 1;                            # t1 > t2
		}
	}
	elsif($t1 == $t2)                         # t1 == t2
	{
		# t1 and t2 can be 0x8000, the smallest neg integer. subtraction
		# (making 2complement) gives overflow
		$t3 = 0;
	}
	else
	{
		$t3 = $t1 - $t2;                       
	}
	setCRvalue($t3);                            # set condition register
}
elsif($opc == 14)
{
	# RTN or LDA
	if($r1 == 0 && $r2 != 0 && $md == 1)
	{
		# return from function, RTN r2
		$R[$r2] = ($R[$r2] + 2);                 # incr. stackpointer
      $ea = la2pa($R[$r2]);
		$t1 = $M[$ea];                           # PSW
		$CR = ($t1 >> 8) & 0x3;                  # restore saved CR
		$R[$r2] = ($R[$r2] + 2);            	  # incr. stackpointer
      $ea = la2pa($R[$r2]);
		$R[0] = $M[$ea];                         # restore saved P
		if($r2 == 0xF)                           # A15 ?
		{
			$PL =  ($t1 >> 10) & 0x3F;            # restore saved PL
			$ENB = ($t1 >> 6) & 1;			        # restore saved interrupt mode (P856,P857)
			if(! $P856)
			{
				$EM  = ($t1 >> 2) & 1;             # restore extended system mode
			}
			else
			{
				$EM=0;
			}
			$UM  = $t1 & 1;                       # restore saved user/system mode
		}
    }
    elsif($r1 != 0 && $md == 0)
    {
        # Load address: LDA r1,D,r2
        $ea = la2pa($R[0]);
        $t1 = $M[$ea];	                       # memory operand address D
	     $R[0] = ($R[0] + 2);	                 # increment A0 (PC)
        $R[$r1] = ($R[$r2] + $t1) & 0xFFFF;
    }
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "OPCE-10");			
	}
}
elsif($opc == 15)
{
	# 1-complement
	if($r1 != 0)
	{
		if($md == 0)				                 # register operand
		{
			# T1 C1R r1,r2
			$t3 = ~ $R[$r2];
		}
		elsif($md == 1)				              # indirect register operand
		{
			# T3 C1R* r1,r2
         $ea = la2pa($R[$r2]);
			$t3 = ~ $M[$ea];
		}
		elsif($md == 2)				              # memory/indexed memory operand
		{
			# T4/T5 C1 r1,m or C1 r1,m,r2
			$a = $M[la2pa($R[0])];	              # memory operand address
			$R[0] = ($R[0] + 2);	                 # increment A0 (PC)
			if($r2 != 0)			                 # indexing ?
			{
				$a = ($a + $R[$r2]);               # yes
			}
			# $a is logical effective address
         $ea = la2pa($a);
			$t3 = ~ $M[$ea];                      # complement content of effective address         
		}
		elsif($md == 3)				              # indirect memory/indexed memory operand
		{
			# T6/T7 C1* r1,m or C1* r1,m,r2
			$a = $M[la2pa($R[0])];	              # memory operand address
			$R[0] = ($R[0] + 2);	                 # increment A0 (PC)
			if($r2 != 0)			                 # indexing ?
			{
				$a = ($a + $R[$r2]);               # yes
			}
			$a  = $M[la2pa($a)];                  # memory content = logical effective address
			$ea = la2pa($a);
         $t3 = ~ $M[$ea];                      # complement content of effective address               
		}
		$R[$r1] = setCRvalue($t3);
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "C110");
	}	
}
else
{
	# illegal instruction
	ilcerror($R[0]-2, $IR, $opc,"OPC10");
}
} 
#end format10.md ==============================================================

###insert format11.md
### format11.md
# emulate the format 1 instructions	with the ls bit == 1:
sub format11 {

$opc = ($IR >> 11) & 0xF;   # opcode
$r1  = ($IR >> 7)  & 0xF;   # r1 or cnd shifted 1 left	
$r2  = ($IR >> 1)  & 0xF;   # r2
$md  = ($IR >> 5)  & 0x3;   # adressing mode

if($opc == 0)
{
	# store
	if($md == 1)				            # indirect register operand
	{
		# T3A/B STR r1,r2
		$a=$R[$r2];                      # $a is logical effective address
		if($r2 == 0xF)
		{
			# A15, the stack pointer is addressed
			$R[0xF] = ($R[0xF] - 2) & 0xFFFE;
			if($R[0xF] < 0x100) 
			{
				trap(LKM);		            # A15 stack overflow
			}
		}
	}
	elsif($md == 2)				         # memory/indexed memory operand
	{
		# T4/T5 ST r1,m or ST r1,m,r2
		$a = $M[la2pa($R[0])];	         # memory operand address
		$R[0] = ($R[0] + 2);	            # increment A0 (PC)
		if($r2 != 0)			            # indexing ?
		{
			$a = ($a + $R[$r2]);          # yes
		}
		# $a is logical effective address
	}
	elsif($md == 3)				         # indirect memory/indexed memory operand
	{
		# T6/T7 ST* r1,m or ST* r1,m,r2
		$a = $M[la2pa($R[0])];	         # memory operand address
		$R[0] = ($R[0] + 2);	            # increment A0 (PC)
		if($r2 != 0)			            # indexing ?
		{
			$a = ($a + $R[$r2]);          # yes
		}
		$a = $M[la2pa($a)];              # memory content = logical effective address
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "ST11");
	}
   $ea     = la2pa_store($a);          # physical effective address
	$M[$ea] = $R[$r1] & DMASK;          # store content r1 in effective address	
}
elsif($opc == 2)
{
	# add, increment memory
	$overflow = 0;
	if($r1 != 0)
	{
		if($md == 1)		               # indirect register operand
		{
			# T3 ADRS r1,r2
			$a  = $R[$r2];
		}
		elsif($md == 2)			         # memory/indexed memory operand
		{
			# T4/T5 ADS r1,m or ADS r1,m,r2
			$a = $M[la2pa($R[0])];        # logical memory operand address
			$R[0] = ($R[0] + 2);	         # increment A0 (PC)
			if($r2 != 0)		            # indexing ?
			{
				$a = ($a + $R[$r2]);       # yes
			}
		}
		elsif($md == 3)			         # indirect memory/indexed memory operand
		{
			# T6/T7 ADS* r1,m or ADS* r1,m,r2
			$a = $M[la2pa($R[0])];        # memory operand address
			$R[0] = ($R[0] + 2);	         # increment A0 (PC)
			if($r2 != 0)		            # indexing ?
			{
				$a = ($a + $R[$r2]);       # yes
			}
		    $a = $M[la2pa($a)];          # memory content = logical effective address
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc, "ADD11");
		}
		# $a is logical effective address
      $ea = la2pa_store($a);
		$t1 = $R[$r1]; $t2 = $M[$ea];
		$t3 = $t1 + $t2;                 # add content of effective address		
		# overflow? (+)
		if((((~$t1) ^ $t2) & ($t1 ^ $t3)) & SIGN)
		{
			$overflow = 1;
		}		
		$M[$ea] = setCRvalue($t3);       # store result in effective address
	}
	else
	{
		if($md == 1)			            # indirect register operand
		{
			# T3 IMR r2
			$a = $R[$r2];
		}
		elsif($md == 2)		            # memory/indexed memory operand
		{
			# T4/T5 IM m or IM m,r2
			$a = $M[la2pa($R[0])];        # memory operand address
			$R[0] = ($R[0] + 2);	         # increment A0 (PC)
			if($r2 != 0)		            # indexing ?
			{
				$a = ($a + $R[$r2]);       # yes
			}
		}
		elsif($md == 3)			         # indirect memory/indexed memory operand
		{
			# T6/T7 IM* m or IM* m,r2
			$a = $M[la2pa($R[0])];	      # memory operand address
			$R[0] = ($R[0] + 2);	         # increment A0 (PC)
			if($r2 != 0)		            # indexing ?
			{
				$a = ($a + $R[$r2]);       # yes
			}
			$a = $M[la2pa($a)];           # memory content = effective address
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc, "IM11");
		}
		$ea = la2pa_store($a);            # physical effective address
		$t1 = 1; $t2 = $M[$ea];
		$t3 = $t1 + $t2;                  # add 1 to content of effective addres		
		# overflow? (+)
		if((((~$t1) ^ $t2) & ($t1 ^ $t3)) & SIGN)
		{
			$overflow = 1;
		}		
		$M[$ea] = setCRvalue($t3);        # store result in effective address		
	}
} 
elsif($opc == 3)
{
	# subtract, two complement
	$overflow = 0;
	if($r1 != 0)
	{
		if($md == 0) # not on P855/P860
		{
			# T1 NGR r1,r2
			$t1 = 0; $t2 = $R[$r2];
			$t3 = $t1 - $t2;               # subtract content
			# underflow? (-)
			if((($t1 ^ $t2) & ((~$t2) ^ $t3)) & SIGN)
			{
				$overflow = 1;
			}	
			$R[$r1] = setCRvalue($t3);		
		}
      else
      {
         if($md == 1)			                # indirect register operand
         {
            # T3 SURS r1,r2
            $a  = $R[$r2];                    # effective address
         }
         elsif($md == 2)			             # memory/indexed memory operand
         {
            # T4/T5 SUS r1,m or SUS r1,m,r2
            $a = $M[la2pa($R[0])];            # memory operand address
            $R[0] = ($R[0] + 2);	             # increment A0 (PC)
            if($r2 != 0)			             # indexing ?
            {
                $a = ($a + $R[$r2]);          # yes
            }
         }
         elsif($md == 3)			             # indirect memory/indexed memory operand
         {
            # T6/T7 SUS* r1,m or SUS* r1,m,r2
            $a = $M[la2pa($R[0])];            # memory operand address
            $R[0] = ($R[0] + 2);	             # increment A0 (PC)
            if($r2 != 0)		                # indexing ?
            {
                $a = ($a + $R[$r2]);          # yes
            }
            $a =  $M[la2pa($a)];              # memory content = logical effective address
         }
         $ea = la2pa_store($a);               # physical effective address
         $t1 = $R[$r1]; $t2 = $M[$ea];
         $t3 = $t1 - $t2;                     # subtract content of effective address
         # underflow? (-)
         if((($t1 ^ $t2) & ((~$t2) ^ $t3)) & SIGN)
         {
            $overflow = 1;
         }		
         $M[$ea] = setCRvalue($t3);           # store result in effective address
      }
	}
	else
	{
		if($md == 1)			                   # indirect register operand
		{
			# T3 C2R r2
			$a  = $R[$r2];                       # effective address
		}
		elsif($md == 2)			                # memory/indexed memory operand
		{
			# T4/T5 C2 m or C2 m,r2
			$a = $M[la2pa($R[0])];               # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)		                   # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}	
		}
		elsif($md == 3)			                # indirect memory/indexed memory operand
		{
			# T6/T7 C2* m or C2* m,r2
			$a = $M[la2pa($R[0])];               # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)		                   # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$a = $M[la2pa($a)];                  # memory content = effective address			
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc,"C211");
		}
		$ea = la2pa_store($a);                  # effective physical address
		$t1 = 0; $t2 = $M[$ea];
		$t3 = $t1 - $t2;                        # subtract content of effective address			
		# underflow? (-)
		if((($t1 ^ $t2) & ((~$t2) ^ $t3)) & SIGN)
		{
			$overflow = 1;
		}			
		$M[$ea] = setCRvalue($t3);              # store result in effective address
	}
}
elsif($opc == 4)
{
	# AND/TM
	if($r1 != 0)
	{
		if($md == 0)			                   # register operand
		{
			# T1 TM r1,r2
			setCRvalue($R[$r1] & $R[$r2]);                         
		}
		else
		{
			if($md == 1)		                   # indirect register operand
			{
				# T3 ANRS r1,r2
				$a  = $R[$r2];                    # effective logical address
			}
			elsif($md == 2)				          # memory/indexed memory operand
			{
				# T4/T5 ANS r1,m or ANS r1,m,r2
				$a = $M[la2pa($R[0])];	          # memory operand address
				$R[0] = ($R[0] + 2);	             # increment A0 (PC)
				if($r2 != 0)			             # indexing ?
				{
					$a = ($a + $R[$r2]);           # yes
				}
				# $a is effective logical address                		
			}
			elsif($md == 3)				          # indirect memory/indexed memory operand
			{
				# T6/T7 ANS* r1,m or ANS* r1,m,r2
				$a = $M[la2pa($R[0])];	          # memory operand address
				$R[0] = ($R[0] + 2);	             # increment A0 (PC)
				if($r2 != 0)			             # indexing ?
				{
					$a = ($a + $R[$r2]);           # yes
				}
				$a =  $M[la2pa($a)];              # memory content = effective logical address           			
			}
         $ea     = la2pa_store($a);           # effective physical address
			$M[$ea] = setCRvalue($R[$r1] & $M[$ea]);  # store result in effective address
		}
	}
	else
	{
		#CM clear memory
		if($md == 1)
		{
			# T3 CMR r2
			$a  = $R[$r2];                       # effective logical address
		}
		elsif($md == 2)
		{
			# T4/T5 CM m or CM m,r2
			$a = $M[la2pa($R[0])];	             # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			# $a is effective logical address
		}
		elsif($md == 3)
		{
			# T6/T7 CM* m or CM* m,r2
			$a = $M[la2pa($R[0])];	             # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$a = $M[la2pa($a)];                  # memory content = effective logical address
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc, "CM11");
		}
        $ea = la2pa_store($a);
        $M[$ea] = 0;                          # clear memory cell at physical effective address
	}	
}
elsif($opc == 5)
{
	# OR
	if($r1 != 0)
	{
		if($md == 1)				               # indirect register operand
		{
			# T3 ORRS r1,r2
			$a  = $R[$r2];                      # effective logical address
        }
		elsif($md == 2)				            # memory/indexed memory operand
		{
			# T4/T5 ORS r1,m or ORS r1,m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);	               # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			# $a is effective logical address                		
		}
		elsif($md == 3)				            # indirect memory/indexed memory operand
		{
			# T6/T7 ORS* r1,m or ORS* r1,m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);	               # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			$a =  $M[la2pa($a)];                # memory content = effective logical address           			
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc, "OR11b");
		}
      $ea = la2pa_store($a);                    # effective physical address
		$M[$ea] = setCRvalue($R[$r1] | $M[$ea]);  # store result in effective address
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "OR11a");
	}	
}	
elsif($opc == 6)
{
	# XOR/TNM
	if($r1 != 0)
	{
		if($md == 0)				                # register operand
		{
			# T1 TNM r1,r2
			setCRvalue($R[$r1] ^ $R[$r2]);
		}
		else
		{
			if($md == 1)				             # indirect register operand
			{
				# T3 XRRS r1,r2
				$a  = $R[$r2];                    # effective logical address
			}
			elsif($md == 2)				          # memory/indexed memory operand
			{
				# T4/T5 XRS r1,m or XRS r1,m,r2
				$a = $M[la2pa($R[0])];	          # memory operand address
				$R[0] = ($R[0] + 2);	             # increment A0 (PC)
				if($r2 != 0)			             # indexing ?
				{
					$a = ($a + $R[$r2]);           # yes
				}
				# $a is effective logical address                		
			}
			elsif($md == 3)				          # indirect memory/indexed memory operand
			{
				# T6/T7 XRS* r1,m or XRS* r1,m,r2
				$a = $M[la2pa($R[0])];	          # memory operand address
				$R[0] = ($R[0] + 2);	             # increment A0 (PC)
				if($r2 != 0)			             # indexing ?
				{
					$a = ($a + $R[$r2]);           # yes
				}
				$a =  $M[la2pa($a)];              # memory content = effective logical address
			}
         $ea = la2pa_store($a);               # effective physical address
			$M[$ea] = setCRvalue($R[$r1] ^ $M[$ea]);  # store result in effective address
		}
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "XOR11");
	}	
}
elsif($opc == 7)
{
    if($r1 != 0)
    {
        # multiple store
        $t1 = 1;
        if($md == 1)				                 # indirect register operand
        {
            # T3A/B MSR n,r2
            # $r1 is n
            $sea=la2pa($a);
            if($r2 == 0xF)
            {
                # A15, the stack pointer is addressed
                $a = $R[0xF]; # logical effective address (use $a because a15 can be put in the stack)
                while($t1 <= $r1)
                {
                    $ea     = la2pa_store($a);
                    $M[$ea] = $R[$A[$t1]];
                    $a      = $a - 2;
                    if($a < 0x100)
                    {
                        $R[0xF]=$a;
                        trap(LKM);		        # A15 stack overflow
                    }					
                    $t1 = $t1 + 1;
                }
                $R[0xF]=$a;
            }
            else
            {
                $a = $R[$r2];                   # effective logical address			
                while($t1 <= $r1)
                {
                    $ea     = la2pa_store($a);
                    $M[$ea] = $R[$A[$t1]];
                    $a      = $a + 2;
                    $t1     = $t1 + 1;
                }
            }
        }
        elsif($md == 2)				               # memory/indexed memory operand
        {
            # T4/T5 MS n,m or MS n,m,r2
            $a = $M[la2pa($R[0])];	            # memory operand address
            $R[0] = ($R[0] + 2);	               # increment A0 (PC)
            if($r2 != 0)			               # indexing ?
            {
                $a = ($a + $R[$r2]);            # yes
            }
            # $a is effective logical address
		      $sea=la2pa($a);
            while($t1 <= $r1)
            {
                $ea = la2pa_store($a);          # physical effective address
                $M[$ea] = $R[$A[$t1]];          # store content in effective address
                $a = $a + 2;
                $t1 = $t1 + 1;
            }			
        }
        elsif($md == 3)				               # indirect memory/indexed memory operand
        {
            # T6/T7 MS* n,m or MS* n,m,r2
            $a = $M[la2pa($R[0])];	            # memory operand address
            $R[0] = ($R[0] + 2);	               # increment A0 (PC)
            if($r2 != 0)			               # indexing ?
            {
                $a = ($a + $R[$r2]);            # yes
            }
            $a = $M[la2pa($a)];                 # memory content = effective logical address
            $sea=la2pa($a);
            while($t1 <= $r1)
            {
                $ea = la2pa_store($a);          # physical effective address
                $M[$ea] = $R[$A[$t1]];          # store content in effective address
                $a = $a + 2;
                $t1 = $t1 + 1;
            }				
        }
        else
        {
            # md == 0
            # illegal instruction
            ilcerror($R[0]-2, $IR, $opc, "MS11");
        }
    }
    else
    {
        # Segment table store (TSR/TS)
        if($UM == 0)
        {
            $t1 = 0;
            if($md == 1)				            # indirect register operand
            {
                # T3 TSR r2
                $a = $R[$r2];                   # effective logical address	
                $sea=la2pa($a);
                while($t1 < 16)
                {
                    $ea = la2pa_store($a);
                    $M[$ea] = $MMU[$t1];
                    $a = $a + 2;
                    $t1 = $t1 + 1;
                }
            }
            elsif($md == 2)				         # memory/indexed memory operand
            {
                # T4/T5 TS m or TS m,r2
                $a = $M[la2pa($R[0])];          # memory operand address
                $R[0] = ($R[0] + 2);	         # increment A0 (PC)
                if($r2 != 0)			            # indexing ?
                {
                    $a = ($a + $R[$r2]);        # yes
                }
                # $a is logical effective address
                $sea=la2pa($a);
                while($t1 < 16)
                {
                    $ea = la2pa_store($a);
                    $M[$ea] = $MMU[$t1];        # store content in physical effective address
                    $a = $a + 2;
                    $t1 = $t1 + 1;
                }			
            }
            elsif($md == 3)				         # indirect memory/indexed memory operand
            {
                # T6/T7 TS* m or TS* m,r2
                $a = $M[la2pa($R[0])];          # memory operand address
                $R[0] = ($R[0] + 2);	         # increment A0 (PC)
                if($r2 != 0)			            # indexing ?
                {
                    $a = ($a + $R[$r2]);        # yes
                }
                $a =  $M[la2pa($a)];            # memory content = logical effective address
                $sea=la2pa($a);
                while($t1 < 16)
                {
                    $ea = la2pa_store($a);
                    $M[$ea] = $MMU[$t1];        # store content in physical effective address
                    $a = $a + 2;
                    $t1 = $t1 + 1;
                }				
            }
            else
            {
                # md == 0
                # illegal instruction
                ilcerror($R[0]-2, $IR, $opc, "TS11");
            }
        }
        else
        {
            prlog("Segment Table Store only allowed in System Mode\n");
            $RUN = 0;
        }
    }
    $ea=$sea;
}
elsif($opc == 8)
{
	if($r1 == 2)
	{
		# Floating Point Store
		$fppstatus=0;
		if($md == 0)
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc,"FST");
		}
		else
		{
			la_operand(0);					           # a = logical address of operand
         $sea=la2pa($a);
			if($FPP)
			{
				$ea = la2pa_store($a);		        # physical effective address
				$M[$ea] = $FPA1;
				$ea = la2pa_store($a+2);
				$M[$ea] = $FPA2;
				$ea = la2pa_store($a+4);
				$M[$ea] = $FPA3;
				$ea = $sea;
			}
			else
			{
				error_fpp(0xFFFF);                 # FPP is not configured
			}
		}
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc,"F11OPC8");
	}
}
elsif($opc == 9)
{
	if($FPP)
	{
		if($r1 == 2)
		{
			# FXX: Convert a floating point value to integer (truncated)
			$t1 = $FPA1 & 0xC000;
			if(($t1 == 0x8000) || ($t1 == 0x4000))
			{
				# normalized
				if($FPA3 & 0x8000)
				{
					# exponent < 0 => result is 0
					$R[A1] = 0; $R[A2] = 0; $CR = 0;
				}
				else
				{
					$FPA3 = $FPA3 - 30;
					if($FPA3 > 0)
					{
						# overflow
						error_fpp(0x0604);
					}
					else
					{
						$FPA3 = - $FPA3;
						$t1 = ($FPA1 << 15) | ($FPA2 & MMASK);
						$t2 = $t1 & DPSIGN; # save sign
						while($FPA3)
						{
							$t1 = ($t1 >> 1) | $t2;
							$FPA3=$FPA3-1;
						}
						putdbls($t1);       # set A1,A2
						setCR2s($t1);
					}
				}
			}
			else
			{
				if($FPA1 == 0 && $FPA2 == 0)
				{
					$R[A1] = 0; $R[A2] = 0; $CR = 0;
				}
				else
				{
					# unnormalized
					error_fpp(0x610);
				}
			}
		}
		elsif($r2 == 8)
		{
			# Floating Point Add: result in memory
			$fppstatus=0;
			if($md == 0)
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc,"FAD-S");
			}
			else
			{
				load_2nd_operand();
				fladd(); 					        # FPB=FPA+FPM and sets CR
            store_result_fpp();             # M=FPB
			}
		}
		elsif($r2 == 10)
		{
			# Floating Point Sub: result in memory
			$fppstatus=0;
			if($md == 0)
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc,"FSU-S");
			}
			else
			{
				load_2nd_operand();
				flsub(); 					        # FPB=FPA-FPM and sets CR
            store_result_fpp();             # M=FPB
			}
		}
		elsif($r2 == 12)
		{
			# Floating Point Mul: result in memory
			$fppstatus=0;
			if($md == 0)
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc,"FMU-S");
			}
			else
			{
				load_2nd_operand();
				flmul(); 					        # FPB=FPA*FPM and sets CR
            store_result_fpp();             # M=FPB
			}
		}
		elsif($r2 == 14)
		{
			# Floating Point Div: result in memory
			$fppstatus=0;
			if($md == 0)
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc,"FDV-S");
			}
			else
			{
				load_2nd_operand();
				fldiv(); 					        # FPB=FPA+FPM and sets CR
            store_result_fpp();             # M=FPB
			}
		}
	}
	else
	{
		error_fpp(0xFFFF); # FPP not in the configuration
	}
}
elsif($opc == 10)
{
    # Extended Store
    # ESx can be used in extended mode and operates then as a normal Store
    if($UM == 0)
    {
        if($md == 1)				              # indirect register operand
        {
            # T3 ESR r1,r2
            $ea = extendedaddr_store($R[$r2]);
            if($ea < MEMSIZE)
            {
                $M[$ea] = $R[$r1] & DMASK;
            }
            else
            {
                emprlog("Error: Extended Store above memory size\n");
            }
        }
        elsif($md == 2)				            # memory/indexed memory operand
        {
            # T4/T5 ES r1,m or ES r1,m,r2
            $a = $M[la2pa($R[0])];           # memory operand address
            $R[0] = ($R[0] + 2);	            # increment A0 (PC)
            if($r2 != 0)			            # indexing ?
            {
                $a = ($a + $R[$r2]);         # yes
            }
            # $a = logical effective address
            $ea = extendedaddr_store($a);    # physical effective address
            if($ea < MEMSIZE)
            {
                $M[$ea] = $R[$r1] & DMASK;
            }
            else
            {
                emprlog("Error: Extended Store above memory size\n");
            }            
        }
        elsif($md == 3)				            # indirect memory/indexed memory operand
        {
            # T6/T7 ES* r1,m or ES* r1,m,r2
            $a = $M[la2pa($R[0])];           # memory operand address
            $R[0] = ($R[0] + 2);	            # increment A0 (PC)
            if($r2 != 0)			            # indexing ?
            {
                $a = ($a + $R[$r2]);         # yes
            }
            $a = $M[la2pa($a)];              # memory operand address = effective logical address
            $ea = extendedaddr_store($a);    # physical effective address
            if($ea < MEMSIZE)
            {
                $M[$ea] = $R[$r1] & DMASK;
            }
            else
            {
                emprlog("Error: Extended Store above memory size\n");
            }            
        }
        else
        {
            # illegal instruction
            ilcerror($R[0]-2, $IR, $opc, "ES11");
        }
    }
    else
    {
        prlog("Extended Store in User Mode not allowed\n");
        $RUN = 0;
    }
}
elsif($opc == 12)
{
	# character transfer
	if($r1 !=0)
	{
		# store
		if($md == 1)				               # indirect register operand
		{
			# T3 SCR r1,r2
			$a  = $R[$r2];                      # $a is logical byte address
            $ea = la2pa_store($a);
			$t1 = $M[($ea)];                    # get word with addressed byte
			if($a & 1)
			{
				$t1 = ($t1 & 0xFF00) | ($R[$r1] & 0xFF); # right hand byte
			}
			else
			{
				$t1 = ($t1 & 0x00FF) | ($R[$r1] << 8);   # left hand byte
			}
		}
		elsif($md == 2)				            # memory/indexed memory operand
		{
			# T4/T5 SC r1,m or SC r1,m,r2
			$a = $M[la2pa($R[0])];	            # memory operand address
			$R[0] = ($R[0] + 2);	               # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			# $a is effective logical byte address
         $ea = la2pa_store($a);
			$t1 = $M[$ea];                      # get word with addressed byte
			if($a & 1)
			{
				$t1 = ($t1 & 0xFF00) | ($R[$r1] & 0xFF); # right hand byte
			}
			else
			{
				$t1 = ($t1 & 0x00FF) | ($R[$r1] << 8);   # left hand byte
			}
		}
		elsif($md == 3)				            # indirect memory/indexed memory operand
		{
			# T6/T7 SC* r1,m or SC* r1,m,r2
			$a = $M[la2pa($R[0])];              # memory operand address
			$R[0] = ($R[0] + 2);	               # increment A0 (PC)
			if($r2 != 0)			               # indexing ?
			{
				$a = ($a + $R[$r2]);             # yes
			}
			$a =  $M[la2pa($a)];                # memory content = effective logical byte address
         $ea = la2pa_store($a);
			$t1 = $M[$ea];                      # get word with addressed byte
			if($a & 1)
			{
				$t1 = ($t1 & 0xFF00) | ($R[$r1] & 0xFF); # right hand byte
			}
			else
			{
				$t1 = ($t1 & 0x00FF) | ($R[$r1] << 8);   # left hand byte
			}
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc, "SC11b");
		}
		$M[$ea] = $t1 & 0xFFFF;                 # replace word
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "SC11a");	
	}
}
elsif($opc == 13)
{
	# compare characters
	if($r1 !=0)
	{	
		if($md == 1)				                # indirect register operand
		{
			# T3 CCR r1,r2, T2 CCK r1,lk
			$a  = $R[$r2];
         $ea = la2pa($a);
			$t1 = $R[$r1] & 0xFF; $t2 = $M[$ea];
			if($a & 1)
			{
				$t2 = $t2 & 0xFF;                 # 1 = right hand byte
			}
			else
			{
				$t2 = ($t2 >> 8) & 0xFF;          # 0 = left hand byte
			}		
			if($r2 == 0)
			{
				# T2 indirect via A0: CCK r1,lk
				$R[0] = ($R[0] + 2);	# increment A0 (PC)
			}
		}
		elsif($md == 2)				             # memory/indexed memory operand
		{
			# T4/T5 CC r1,m or CC r1,m,r2
			$a = $M[la2pa($R[0])];	             # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
         $ea = la2pa($a);
			$t1 = $R[$r1] & 0xFF; $t2 = $M[$ea]; 
			if($a & 1)
			{
				$t2 = $t2 & 0xFF;                 # 1 = right hand byte
			}
			else
			{
				$t2 = ($t2 >> 8) & 0xFF;          # 0 = left hand byte
			}				
		}
		elsif($md == 3)				             # indirect memory/indexed memory operand
		{
			# T6/T7 CC* r1,m or CC* r1,m,r2
			$a = $M[la2pa($R[0])];	             # memory operand address
			$R[0] = ($R[0] + 2);	                # increment A0 (PC)
			if($r2 != 0)			                # indexing ?
			{
				$a = ($a + $R[$r2]);              # yes
			}
			$a = $M[la2pa($a)];                  # memory content = effective logical address
         $ea = la2pa($a);
			$t1 = $R[$r1] & 0xFF; $t2 = $M[$ea];
			if($a & 1)
			{
				$t2 = $t2 & 0xFF;                 # 1 = right hand byte
			}
			else
			{
				$t2 = ($t2 >> 8) & 0xFF;          # 0 = left hand byte
			}				
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc, "CC11b");			
		}		
		# t1 and t2 contain the characters to compare
		$t3 = $t1 - $t2; 
		setCRvalue($t3);                        # set condition register
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "CC11a");			
	}		
}
elsif($opc == 14)
{
	if($r1 != 0)
	{
		# call function
		if($md == 0)				                      # register operand
		{
			# T1 CFR r1,r2
         $ea = $R[$r2];
			if($r1 != 0xF)                             # not A15
			{
				$M[la2pa_store($R[$r1])] = $R[0];       # save P
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$M[la2pa_store($R[$r1])] = Fpsw();      # save PSW
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$R[0] = $ea;                            # effective logical address
			}
			else                                       # via A15
			{
				$M[la2pa_store($R[0xF])] = $R[0];       # save P
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}				
				$M[la2pa_store($R[0xF])] = Fpsw();      # save PSW
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}
				$R[0] = $ea;                            # effective logical address
			}
		}
		elsif($md == 1)				                   # indirect register operand
		{
			# T2/T3 CF r1,lk   CFR* r1,r2
			$ea =  $M[la2pa($R[$r2])];                 # save new P value
			if($r2 == 0)
			{
				# T2 CF r1,lk
				$R[0] = ($R[0] + 2);                    # increment A0 (PC)
			}
			if($r1 != 0xF)    			
			{
				$M[la2pa_store($R[$r1])] = $R[0];       # save P on stack
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$M[la2pa_store($R[$r1])] = Fpsw();      # save PSW on stack
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$R[0] = $ea;                            # effective logical address
			}				
			else                                       # via A15
			{
				$M[la2pa_store($R[0xF])] = $R[0];       # save P on stack
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}
				$M[la2pa_store($R[0xF])] = Fpsw();      # save PSW on stack
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}
				$R[0] = $ea;                            # effective logical address
			}
		}
		elsif($md == 2)				                   # memory/indexed memory operand
	    {	
			# T4/T5 CFI r1,m or CFI r1,m,r2
			$a = $M[la2pa($R[0])];                     # memory operand address
			$R[0] = ($R[0] + 2);                       # increment A0 (PC)
			if($r2 != 0)			                      # indexing ?
			{
				$a = ($a + $R[$r2]);                    # yes
			}
			$ea = la2pa($a);
			if($r1 != 0xF)
			{
				$M[la2pa_store($R[$r1])] = $R[0];       # save P
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$M[la2pa_store($R[$r1])] = Fpsw();      # save PSW
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$R[0] = $M[$ea];                        # effective logical address
			}
			else                                       # via A15
			{
				$M[la2pa_store($R[0xF])] = $R[0];       # save P
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}
				$M[la2pa_store($R[0xF])] = Fpsw();      # save PSW
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}
				$R[0] = $M[$ea];                        # effective logical address
			}
		}
		elsif($md == 3)				                   # indirect memory/indexed memory operand
		{
			# T6/T7 CFI* r1,m or CFI* r1,m,r2
			$a = $M[la2pa($R[0])];	                   # memory operand address
			$R[0] = ($R[0] + 2);	                      # increment A0 (PC)
			if($r2 != 0)			                      # indexing ?
			{
				$a = ($a + $R[$r2]);                    # yes
			}
			$a = $M[la2pa($a)];                        # memory content = effective logical address
         $ea = la2pa($a);
			if($r1 != 0xF)
			{
				$M[la2pa_store($R[$r1])] = $R[0];       # save P
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$M[la2pa_store($R[$r1])] = Fpsw();      # save PSW
				$R[$r1] = $R[$r1] - 2;                  # decrease link stack
				$R[0] = $M[$ea];
			}
			else                                       # via A15
			{
				$M[la2pa_store($R[0xF])] = $R[0];       # save P
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}
				$M[la2pa_store($R[0xF])] = Fpsw();      # save PSW
				$R[0xF] = $R[0xF] - 2;                  # decrease link stack
				if($R[0xF] < 0x100)
				{
					trap(LKM);		                      # A15 stack overflow
				}
				
			}
         $R[0] = $M[$ea];                           # effective logical address
		}
	}
	else
	{
		# execute instructions
		my $t1;
		my $exerr=0;
		my $il=2;                           # default instruction length
		# execute
		if($md == 0)
		{
			$t1=$R[$r2];					   	# instruction to execute
		}  
		elsif($md == 1)
		{
			# T3 EXR* r2, T2 EXK lk
         $ea = la2pa($R[$r2]);
			$t1 = $M[$ea];          	    	# instruction to execute
			if($r2 == 0)
			{
				# T2 indirect via A0: EXK lk
				$R[0] = ($R[0] + 2);         	# increment A0 (PC)	
				$il=4;
			}
		}
		elsif($md == 2)		
		{
			# T4/T5 EX m or EX m,r2
			$a = $M[la2pa($R[0])];	         # memory operand address
			$R[0] = ($R[0] + 2);	            # increment A0 (PC)
			$il=4;
			if($r2 != 0)			            # indexing ?
			{
				$a = ($a + $R[$r2]);          # yes
			}
			$ea = la2pa($a);                 # effective physical address
			$t1 = $M[$ea]; 						# instruction to execute
		}
		elsif($md == 3)
		{
			# T6/T7 EX* m or EX* m,r2
			$a = $M[la2pa($R[0])];	         # memory operand address
			$R[0] = ($R[0] + 2);	            # increment A0 (PC)
			$il=4;
			if($r2 != 0)			            # indexing ?
			{
				$a = ($a + $R[$r2]);          # yes
			}
		   $a  = $M[la2pa($a)];             # memory content = effective address
			$ea = la2pa($a);                 # effective physical address
			$t1 = $M[$ea]; 						# instruction to execute				
		}
		
		# execute t1 if:
		# - it is a single word instruction
		# - it is not a CF.., RTN, EX..
		#
		# check instruction to execute (format0 needs no checking)
		if($t1 & 0x8000)
		{
			# format 1, check whether it is an allowed single word instruction 
			my $opc = ($t1 >> 11) & 0xF;            # opcode
			my $r1  = ($t1 >> 7)  & 0xF;            # r1 or condition shifted 1 left	
			my $r2  = ($t1 >> 1)  & 0xF;            # r2
			my $md  = ($t1 >> 5)  & 0x3;            # addressing mode
			if($opc == 0xE || $md == 2 || $md == 3 || $r2 == 0)
			{
				# illegal instruction
				ilcerror($R[0]-$il, $t1, $opc, "EX11");
				$exerr=1;
				# in case the illegal instruction is not trapped it
				# operates as a no operation to ease debugging
			}
		}
		# execute $t1
		if($exerr == 0)
		{
			$IR=$t1;
			if(! ($t1 & mskf10))
			{
				#print "format 0\n";
				format0();
			}
			elsif(!($t1 & 1))
			{
				#print "format 10\n";				
				format10();
			}
			else
			{
				#print "format 11\n";				
				format11();
			}
		}
	}
}
elsif($opc == 15)
{
	# 1-complement
	if($r1 == 0)
	{
		if($md == 1)				            # indirect register operand
		{
			# T3 C1RS r2
			$a  = $R[$r2];                   # effective logical address
        }
		elsif($md == 2)				         # memory/indexed memory operand
		{
			# T4/T5 C1S m or C1S m,r2
			$a = $M[la2pa($R[0])];	         # memory operand address
			$R[0] = ($R[0] + 2);         	   # increment A0 (PC)
			if($r2 != 0)			            # indexing ?
			{
				$a = ($a + $R[$r2]);          # yes
			}               		
		}
		elsif($md == 3)				         # indirect memory/indexed memory operand
		{
			# T6/T7 C1S* m or C1S* m,r2
			$a = $M[la2pa($R[0])];	         # memory operand address
			$R[0] = ($R[0] + 2);	            # increment A0 (PC)
			if($r2 != 0)			            # indexing ?
			{
				$a = ($a + $R[$r2]);          # yes
			}
			$a =  $M[la2pa($a)];             # memory content = effective address           			
		}
		else
		{
			# illegal instruction
			ilcerror($R[0]-2, $IR, $opc, "C111b");
		}
		$ea = la2pa_store($a);              # effective physical address 
		$M[$ea] = setCRvalue(~ $M[$ea]);    # store result in effective address
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "C111a");
	}	
}	
else
{
	# illegal instruction
	ilcerror($R[0]-2, $IR, $opc,"OPC11");
}

}
#end format11.md ==============================================================

###insert format0.md
### format0.md
# emulate the format 0 instructions.
sub format0 {
#
# emulate the format 0 instructions:
# 	- short constant instructions
# 	- shift instructions
# 	- i/o instructions
# 	- miscellanious instructions
$opc = ($IR >> 11) & 0xF;	 # opcode
$r3  = ($IR >> 7)  & 0xE;   # r3 or cnd (shifted 1 left)
$k   = $IR & 0xFF;          # short constant
				
if($opc == 0)
{
	# load constant LDK
	$R[$r3] = $k;			    # CR unchanged !!!!
}
elsif($opc == 1)
{
	# absolute branche AB
	# $r3 is the condition code in operation
	$r3 = $r3 >> 1; # position the condition code	
	if(evalcond($r3))
	{
		$R[0] = $k;
	}
}
elsif($opc == 2)
{
	# add constant ADK
	$overflow = 0;
	$t1 = $R[$r3];
	$t2 = $t1 + $k;
	# overflow? (+)
	if((((~$t1) ^ $k) & ($t1 ^ $t2)) & SIGN)
	{
		$overflow = 1;
	}
	$R[$r3] = setCRvalue($t2);
}
elsif($opc == 3)
{
	# subtract constant SUK
	$overflow = 0;
	$t1 = $R[$r3];
	$t2 = $t1 - $k;
	# underflow? (-)
	if((($t1 ^ $k) & ((~$k) ^ $t2)) & SIGN)
	{
		$overflow = 1;
	}
	$R[$r3] = setCRvalue($t2);
}
elsif($opc == 4)
{
	# logical and constant ANK - MIS: HLT, INH, RIT
	if($r3 != 0)
	{
		# ANK
		$R[$r3] = $R[$r3] & $k;
		setCR1($r3);
	}
	else
	{
		if($k == 0x7F) #change into if(($k == 0x7F) && ($UM==0) ??
		{
			# HLT
			$RUN = 0;
			prlog("\nExecution stopped with a HLT\n");
		}
		elsif($k == 0xBF) #change into if(($k == 0xBF) && ($UM==0) ??
		{
			# INH
			$ENB = 0;
			# on the real machine, INH is only allowed in system mode, so $UM == 0;
			# because we don't check on mode, INH can be given in usermode.
			# usermode however is an implicit ENB so INH will not inhibit the
			# interrupts when given in usermode. to get inhibit state we also
			# set to system mode
		}
		else
		{
			my $t1 = $k & 0xC1;
			if($t1 == 0xC1) # is it an RIT  #change into if(($k == 0xC1) && ($UM==0) ??
			{
				# RIT
				# resetting more internal interrupts in a single instruction is allowed
				$t1 = ($k & 0x3F) >> 1; # 5 bits
				$t1 = ~ $t1;
				if($t1 & 4) # 0x1B
				{
					resettrap(RTC);     # reset clock interrupt
				}
				if($t1 & 2) # 0x1D
				{
					resettrap(LKM);     # reset LKM interrupt
				}
				if($t1 & 16) # 0x0F
				{
					resettrap(CP);      # reset control panel interrupt
				}
				if($t1 & 8) # 0x17
				{
					resettrap(PWR);     # reset power failure interrupt
				}
				# ignore other bits
			}
			else
			{
				# illegal instruction
				ilcerror($R[0]-2, $IR, $opc, "F04");
			}
		}
	}
}
elsif($opc == 5)
{
	# logical or constant ORK - MIS: LKM ENB SMD
	if($r3 != 0)
	{
		# ORK
		$R[$r3] = $R[$r3] | $k;
		setCR1($r3);
	}
	else
	{
		if($k & 0x04)
		{
			# LKM
            if($ENB)
            {
                trap(LKM);
            }
            else
            {
                $R[0] = ($R[0] + 2); # skip DATA to execute next instruction
            }
		}
		if($k & 0x40)
		{
			# ENB
			$ENB = 1;
		}
		if($k & 0x01)
		{
			# SMD
			$UM  = 1;
		}
        # ignore setting of other bits
	}
}
elsif($opc == 6)
{
	# excl or constant XRK
	if($r3 != 0)
	{
		# XRK
		$R[$r3] = $R[$r3] ^ $k;
		setCR1($r3);
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "F06");
	}
}
elsif($opc == 7)
{
	# shift: single/double word shift, normalize
	my $tlng;
	my $i;
	$sc   = $k & 0x1F;                    # shift count (5 bit)
	$sfun = ($k & 0xE0) >> 5;             # shift function (3 bit)
	$t1   = $sc;
	$overflow = 0;
	if($r3 != 0)
	{
		# single register shifts
				
		if($sfun == 0)
		{
			# SLA: single left arithmetic shift
			if($t1 > 16) { $t1 = 16 };      # limit to 16 
			$t2 = $R[$r3] & SIGN;           # save sign
			$i = 0;
			while($i < $t1)
			{
				$R[$r3] = $R[$r3] << 1;
				if(($R[$r3] & SIGN) != $t2)
				{
					$overflow = 1;
				}
				$i = $i + 1;
			}
			setCR1($r3);
		}
		elsif($sfun == 1)
		{
			# SRA: single right arithmetic shift
			if($t1 > 16) { $t1 = 16 };      # limit to 16 
			$t2 = $R[$r3] & SIGN;           # save sign
			$i=0;
			while($i < $t1)
			{
				$R[$r3] = $R[$r3] >> 1;
				$R[$r3] = $R[$r3] | $t2;
				$i = $i + 1;
			}
			setCR1($r3);
		}
		elsif($sfun == 2)
		{
			# SLL: single left logical shift
		   if($t1 > 16) 
			{
				$R[$r3] = 0;               # > 16 ? all 0 
			}
			else
			{
				$R[$r3] = ($R[$r3] << $t1) & DMASK;
			}
			setCR1($r3);
		}
		elsif($sfun == 3)
		{
			# SRL: single right logical shift
			if($t1 > 16) 
			{ 
				$R[$r3] = 0;               # > 16 ? all 0 
			}
			else
			{
				$R[$r3] = ($R[$r3] >> $t1) & DMASK;
			}
			setCR1($r3);
		}
		elsif($sfun == 6)
		{
			# SLC: single left circular shift
			$t2 = $t1 % 16;               # mod 16, t2 is remainder
			$R[$r3] = (($R[$r3] << $t2) | ($R[$r3] >> (16 -$t2)) & DMASK);
			setCR1($r3);
		}
		elsif($sfun == 7)
		{
			# SRC: single right circular shift
			$t2 = $t1 % 16;               # mod 16, t2 is remainder
			$R[$r3] = (($R[$r3] >> $t2) | ($R[$r3] << (16 -$t2)) & DMASK);
			setCR1($r3);
		}
		elsif($sfun == 4)
		{
			# SLN: single left normalize shift
			$r2 = ($k & 0x1E) >> 1;
			$t2 = $R[$r3] & SIGN;          # save sign (bit 0)
			$t3 = $t2 >> 1;                # sign shifted 1 right for comparison
			$i = 0;
			while($i < 16)
			{
				$t1 = $R[$r3] & 0x4000;     # extract bit 1
				if($t3 == $t1)              # bit 0 equal to bit 1?
				{
					$R[$r3] = $R[$r3] << 1;  # yes => shift left
					$i = $i + 1;
				}
				else
				{
					last;
				}
			}
			$R[$r3] = ($R[$r3] & MMASK) | $t2;
			$R[$r2] = $i;
		}
		elsif($sfun == 5)
		{
			# SRN: single right normalize shift
			$r2 = ($k & 0x1E) >> 1;
			$t2 = $R[$r3] & SIGN;          # save sign
			$i = 0;
			while($i < 16)
			{
				$t1 = $R[$r3] & 1;
				if($t1 == 0)
				{
					$R[$r3] = ($R[$r3] >> 1) | $t2;
					$i = $i + 1;
				}
				else
				{
					last;
				}
			}
			$R[$r3] = ($R[$r3] & MMASK) | $t2;
			$R[$r2] = $i;
		}
	}
	else
	{
		# double register shifts (A1-A2)
				
		if($sfun == 0)
		{
			# DLA: double left arithmetic shift
			$tlng = getdbls();				  # get A1, A2 as long
			$t2 = $tlng & DPSIGN;           # save sign
			$i = 0;
			while($i < $t1)
			{
				$tlng = $tlng << 1;
				if(($tlng & DPSIGN) != $t2)
				{
					$overflow = 1;
				}
				$i = $i + 1;
			}
			setCR2s($tlng);	               # set condition code
			putdbls($tlng);                  # restore A1, A2
		}
		elsif($sfun == 1)
		{
			# DRA: double right arithmetic shift
			$tlng = getdbls();			   	# get A1, A2 as long
			$t2 = $tlng & DPSIGN;            # save sign
			$i=0;
#			if($t1 != 0) # special case for 0 shifts: keep A1/A2 as is (from testprogram CPB8K)
#           the P852 in case of 0 shifts did not change bit-0 of A2 (if it is 1, it remains 1)
#           the P854 (and later models) makes bit-0 of A2 always 0 also in case of zero shifts.
#           This implementation follows approach (at this moment): bit-0 A2 is always made 0
#			{
				while($i < $t1)
				{
					$tlng = $tlng >> 1;
					$tlng = $tlng | $t2;
					$i = $i + 1;
				}		
				putdbls($tlng);               # restore A1, A2
#			}
			setCR2s($tlng);
		}
		elsif($sfun == 2)
		{
			# DLL: double left logical shift
			$tlng = getdblu();			   	# get A1, A2 as long
			$tlng = $tlng << $t1;
			setCR2u($tlng);
			putdblu($tlng);                  # restore A1, A2
		}
		elsif($sfun == 3)
		{
			# DRL: double right logical shift
			$tlng = getdblu();				   # get A1, A2 as long
			$tlng = $tlng >> $t1;
			setCR2u($tlng);
			putdblu($tlng);                  # restore A1, A2
		}
		elsif($sfun == 6)
		{
			# DLC: double left circular shift
			$tlng = getdblu();				   # get A1, A2 as long
			$tlng = ($tlng << $t1) | ($tlng >> (32 - $t1));
			setCR2u($tlng);
			putdblu($tlng);                  # restore A1, A2
		}
		elsif($sfun == 7)
		{
			# DRC: double right circular shift
			$tlng = getdblu();			   	# get A1, A2 as long
			$tlng = ($tlng >> $t1) | ($tlng << (32 - $t1));
			setCR2u($tlng);
			putdblu($tlng);                  # restore A1, A2
		}
		elsif($sfun == 4)
		{
			# DLN: double left normalize shift
			$r2 = ($k & 0x1E) >> 1;
			$tlng = getdbls();				   # get A1, A2 as long
			$t2 = $tlng & DPSIGN;            # save sign
			$t3 = $t2 >> 1;                  # sign shifted 1 right for comparison
			$i = 0;
			while($i < 31)
			{
				$t1 = $tlng & 0x20000000;
				if($t3 == $t1)
				{
					$tlng = $tlng << 1;
					$i = $i + 1;
				}
				else
				{
					last;
				}
			}
			$tlng = ($tlng & DPMMASK) | $t2;
			putdbls($tlng);                  # restore A1, A2
			$R[$r2] = $i;
		}
		elsif($sfun == 5)
		{
			# DRN: double right normalize shift
			$r2 = ($k & 0x1E) >> 1;
			$tlng = getdbls();				   # get A1, A2 as long
			$t2 = $tlng & DPSIGN;            # save sign
			$i = 0;
			while($i < 31)
			{
				$t1 = $tlng & 1;
				if($t1 == 0)
				{
					$tlng = ($tlng >> 1) | $t2;
					$i = $i + 1;
				}
				else
				{
					last;
				}
			}
			$tlng = ($tlng & DPMMASK) | $t2;
			putdbls($tlng);                  # restore A1, A2
			$R[$r2] = $i;
		}
	}		
}
elsif($opc == 8)
{
	# IO: CIO OTR
	# 
	if($r3 !=0)
	{
		my $bit8 = $k & 0x80;
		my $bit9 = $k & 0x40;               # function bit
		my $devaddr = $k & 0x3F;
		my $d = $DEV{$devaddr};             # pointer to device block
		if($d eq undef)
		{
			# unknown device address
			if($StopOnIllDev)
			{
				ilderror($R[0]-2, $IR, $opc, "IO3");
			}
			$CR = 3;
		}
		elsif($bit8)
		{
			# CIO
			$n = $$d[CIO];                    # CIO routine of device
			&$n($bit9);                       # call
		}
		else
		{
			# OTR
			$n = $$d[OTR];                    # OTR routine of device
			&$n($bit9);                       # call
		}
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "IO1");
	}
}
elsif($opc == 9)
{
	# IO: INR SST TST 
	if($r3 !=0)
	{
		my $bit8 = $k & 0x80;
		my $bit9 = $k & 0x40;
		my $devaddr = $k & 0x3F;
		my $d = $DEV{$devaddr};              # pointer to device block
		if($d eq undef)
		{
			# unknown device address
			if($StopOnIllDev)
			{
				if($bit9)
				{
					# TST with an undef device address is allowed
					ilderror($R[0]-2, $IR, $opc, "IO4");
				}
			}
			$CR = 3;
		}
		elsif($bit8 == 0)
		{
			# INR
			$n = $$d[INR];                    # INR routine of device
			&$n($bit9);                       # call			
		}
		elsif($bit9 == 0)
		{
			# TST
			$n = $$d[TST];                    # TST routine of device
			&$n();                            # call			
		}
		else
		{
			# SST
			if($devaddr == 0)
			{
				# provide the floating point processor status
				# (only for a P857/9 type FPP!)
				if($FPP==0)
				{
					$CR = 3; # the (P857/9) FPP does not exist
					prlog("SST 0: the (P857/9) FPP is not configured\n");
				}
				else
				{
					$R[$r3] = $fppstatus & 0xFFFF;
					$CR = 0; # accepted
				}
				
			}
			else
			{
				$n = $$d[SST];                 # SST routine of device
				&$n();                         # call
			}
		}
	}
	else
	{
		# illegal instruction
		ilcerror($R[0]-2, $IR, $opc, "IO2");
	}
}
elsif($opc == 0xA)
{
	# RF
	# $r3 (4 bit) is the condition code in operation >> 1
	$r3 = $r3 >> 1;
	if(evalcond($r3))
	{
		$R[0] = ($R[0] + $k);
	}
}
elsif($opc == 0xB)
{   # RB 
    # $r3 (4 bit) is the condition code in operation >> 1
        $r3 = $r3 >> 1;
        if(evalcond($r3))
        {
            $R[0] = ($R[0] - $k);
        }
}
elsif($opc == 0xD && $r3 == 0)
{   
    #format D string instructions
    my $b1; #byte to move/compare
    my $b2;
    
    if($k == 0)
    {
        # MVS (A3 sending buffer, A4 receiving buffer)
        # if A2==0, or if A3 == A4, nothing has to be moved.
        if($R[A2] > 0)
        {
            if($R[A3] > $R[A4])
            {
                # load right or left hand byte for moving
                if($R[A3] & 1)
                {
                    $b1 = $M[la2pa($R[A3])] & 0xFF;   # move righthand byte
                }
                else
                {
                    $b1 = ($M[la2pa($R[A3])] & 0xFF00) >> 8; # move lefthand byte
                }
                # store into right or left hand byte
                if($R[A4] & 1)
                {
                    $M[la2pa_store($R[A4])] = ($M[la2pa($R[A4])] & 0xFF00) | $b1; # righthand
                }
                else
                {
                    $M[la2pa_store($R[A4])] = ($M[la2pa($R[A4])] & 0xFF) | ($b1 << 8); # lefthand
                }
                $R[A3] = $R[A3] + 1;
                $R[A4] = $R[A4] + 1;
                $R[A2] = $R[A2] - 1;
                if($R[A2] > 0)
                {
                    $R[A0] = ($R[A0] - 2); # continue current instruction
                    # but 1st scan for breaks and interrupts
                }
            }
            elsif($R[A4] > $R[A3])
            {
                $t1= $R[A3] + $R[A2] - 1; #sending address
                $t2= $R[A4] + $R[A2] - 1; #receiving address
                if($t1 & 1)
                {
                    $b1 = $M[la2pa($t1)] & 0xFF;          # move righthand byte
                }
                else
                {
                    $b1 = ($M[la2pa($t1)] & 0xFF00) >> 8; # move righthand byte
                }
                # store into right or left hand byte
                if($t2 & 1)
                {
                    $M[la2pa_store($t2)] = ($M[la2pa($t2)] & 0xFF00) | $b1; # righthand
                }
                else
                {
                    $M[la2pa_store($t2)] = ($M[la2pa($t2)] & 0xFF) | ($b1 << 8); # lefthand
                }
                $R[A2] = $R[A2] - 1;
                if($R[A2] > 0)
                {
                    $R[A0] = ($R[A0] - 2);                # continue current instruction
                    # but 1st scan for breaks and interrupts
                }                
            }
        }
    }
    elsif($k == 0x40)
    {
        # MVA (A1 byte to store, A4 receiving buffer)
        # if A2==0, nothing has to be moved.
        if($R[A2] > 0)
        {
            if($R[A4] & 1)
            {
                # move A1 into righthand byte
                $M[la2pa_store($R[A4])] = ($M[la2pa($R[A4])] & 0xFF00) | ($R[A1] & 0x00FF);
            }
            else
            {
                # move A1 into lefthand byte
                $M[la2pa_store($R[A4])] = ($M[la2pa($R[A4])] & 0x00FF) | (($R[A1] << 8)  & 0xFF00);
            }
            $R[A4] = $R[A4] + 1;
            $R[A2] = $R[A2] - 1;
            if($R[A2] > 0)
            {
                $R[A0] = ($R[A0] - 2); # continue current instruction
                # but 1st scan for breaks and interrupts
            }            
        }
    }
    elsif($k == 0x80)
    {
        # CS: Compare strings
        # A3 points to 1st string; A4 points to 2nd string; A2 is length string 2
        $CR = 0;
        if($R[A2] > 0)
        {
            $R[A2] = $R[A2] - 1;                         # remaining length
            # isolate the bytes to compare
            if($R[A3] & 1)
            {
                $b1 = $M[la2pa($R[A3])] & 0xFF;          # righthand byte
            }
            else
            {
                $b1 = ($M[la2pa($R[A3])] & 0xFF00) >> 8; # lefthand byte
            }
            if($R[A4] & 1)
            {
                $b2 = $M[la2pa($R[A4])] & 0xFF;          # righthand byte
            }
            else
            {
                $b2 = ($M[la2pa($R[A4])] & 0xFF00) >> 8; # lefthand byte
            }
            if($b1 == $b2)
            {
                $R[A3] = $R[A3] + 1;
                $R[A4] = $R[A4] + 1;
                if($R[A2] > 0)
                {
                    $R[A0] = ($R[A0] - 2);               # continue current instruction
                    # but 1st scan for breaks and interrupts
                }            
            }
            elsif($b1 > $b2)
            {
                $CR = 1;
            }
            else
            {
                $CR = 2;
            }
        }
    }
    elsif($k == 0xA0)
    {
        # CA; compare character in string
        # A3 points to the string; A1(r) is character; A2 is length string
        $CR = 0;
        $b2=$R[A1] & 0xFF;
        if($R[A2] > 0)
        {
            # isolate the byte from string to compare
            if($R[A3] & 1)
            {
                $b1 = $M[la2pa($R[A3])] & 0xFF;         # righthand byte
            }
            else
            {
                $b1 = $M[la2pa($R[A3])] & 0xFF00 >> 8;  # lefthand byte
            }
            if($b1 == $b2)
            {
                $R[A2] = $R[A2] - 1;
                $R[A3] = $R[A3] + 1;
                $R[A4] = $R[A4] + 1;
                if($R[A2] > 0)
                {
                    $R[A0] = ($R[A0] - 2);               # continue current instruction
                    # but 1st scan for breaks and interrupts
                }            
            }
            elsif($b1 > $b2)
            {
                $CR = 2;
            }
            else
            {
                $CR = 1;
            }
        }        
    }
    else
    {
        # illegal instruction
        ilcerror($R[0]-2, $IR, $opc, "F0D");
    }
}
elsif($opc == 0xE)
{
	# WER
	if($r3 != 0)
	{
		if($k & 1)
		{
			# 2nd or 3rd WER
			if($iopstate == 1)
			{
				# the 2nd WER
				$EXTR[$k] = $R[$r3]; # set the 2nd control word
				# check whether the 1st control word has buffer address bits
				$tx3 = $EXTR[$k-1] & 0x3000;
				if($tx3)
				{
					# yes; move these bits to the 2nd control word
					$EXTR[$k] = $EXTR[$k] | ($tx3 << 4);
					# and reset these bits in the 1st control word
					$EXTR[$k-1] = $EXTR[$k-1] & 0xCFFF;
				}
				$iopstate   = 2;  # expect the 3rd WER
			}
			elsif($iopstate == 2)
			{
				# an optional 3rd WER
				$EXTR[$k] = ($EXTR[$k] & 0xFFFF) | (($R[$r3] & 0xFF) << 16);
				$iopstate   = 0;
			}
		}
		else
		{
			# 1st WER to init a channel
			$EXTR[$k]   = $R[$r3]; # set the 1st control word
			$EXTR[$k+1] = 0;       # reset the 2nd register
			$iopstate   = 1;       # expect the 2nd WER
		}
	 }
    else
    {
        $r2  = ($IR >> 1) & 0xF;   # r2
        if($r2 != 0)
        {
            $R[$r2] = ($R[$r2]-2) & 0xFFFE;
            if($R[$r2] >= 0)
            {
                if($k & 0x80)
                {
                    # MVSU
                    if($UM)
                    {
                        #user mode
                        $M[la2pa_store($R[A2] + $R[$r2])] = $M[la2pa($R[A1] + $R[$r2])];
                    }
                    else
                    {
                        # system mode
                        $ea = extendedaddr_store($R[A2] + $R[$r2]);
                        if($ea < MEMSIZE)
                        {
                            $M[$ea] = $M[la2pa($R[A1] + $R[$r2])];
                        }
                        else
                        {
                            $RUN=0; # stop
                            emprlog("Error: MVSU: destination above memory size\n");
                        }
                    }
                }
                else
                {
                    #MVF
                    $M[la2pa_store($R[A2] + $R[$r2])] = $M[la2pa($R[A1] + $R[$r2])];

                }
                if($R[$r2])
                {
                    $R[A0] = ($R[A0] - 2); # continue current instruction
                    # but 1st scan for breaks and interrupts
                }               
            }
        }
        else
        {
            # illegal instruction
            ilcerror($R[0]-2, $IR, $opc, "F0E");
        }
	}	           
}
elsif($opc == 0xF)
{
	# RER
	if($r3 != 0)
	{
		$R[$r3]=$EXTR[$k];
		$CR = $R[$r3] >> 8;
	}
	else
    {
        $r2  = ($IR >> 1)  & 0xF;   # r2
        if($r2 != 0)
        {
            if($R[$r2] > 1)
            {            
                if($k & 0x80)
                {
                    # MVUS
                    if($UM)
                    {
                        #user mode
                        $M[la2pa_store($R[A2])] = $M[la2pa($R[A1])];
                    }
                    else
                    {
                        #system mode
                        $ea = extendedaddr($R[A1]);
                        if($ea < MEMSIZE)
                        {
                            $M[la2pa_store($R[A2])] = $M[$ea];
                        }
                        else
                        {
                            $RUN=0; #stop
                            emprlog("Error: MVUS: source above memory size\n");
                        }
                    }
                }
                else
                {
                    #MVB
                    $M[la2pa_store($R[A2])] = $M[la2pa($R[A1])];
                }
                $R[A1] = $R[A1] + 2;
                $R[A2] = $R[A2] + 2;
                $R[$r2] = $R[$r2] - 2;
                if($R[$r2] > 1)
                {
                    $R[A0] = ($R[A0] - 2); # continue current instruction
                    # but 1st scan for breaks and interrupts
                }                                  
            }
        }
        else
        {
            # illegal instruction
            ilcerror($R[0]-2, $IR, $opc, "F0F");
        }
    }
}
else
{
	# illegal instruction
	ilcerror($R[0]-2, $IR, $opc, "OPC00");	
}
} 
#end format0.md ==============================================================

###insert subs.md Various subroutines
### subs.md
# Various subroutines
########################### Emulator subroutines #########################
# Evaluate the Condition code in an operation against the current CR value
# If true, the function returns a 1, else 0.
sub evalcond {
	my $cd = shift;  	# condition code (3 bit) from operation
	my $not;
	if($cd == 7)
	{
		return 1;	# unconditional
	}
	$not  = $cd & 4;
	$cd   = $cd & 3;
	if($not)        # not bit
	{
		if($cd == $CR)
		{
			return 0;
		}
		else
		{
			return 1;
		}
	}
	else
	{
		if($cd == $CR)
		{
			return 1;
		}
		else
		{
			return 0;
		}
	}
}

# set Condition Register according value of r1 or r3 (or temporary register in @R)
sub setCR1 {
	my $r = shift;
	my $t = $R[$r] & 0xFFFF;
	if($overflow)
	{
		$CR = 3;                 # overflow
	}
	elsif($t & 0x8000)
	{
		$CR = 2;                 # result LT 0
	}
	elsif($t & 0x7FFF)
	{
		$CR = 1;                 # result GT 0
	}
	else
	{
		$CR = 0;                 # result = 0
	}
	$R[$r] = $t;
	$overflow = 0;
}

# set Condition Register according  a given value
# the masked 16-bit value is reurned
sub setCRvalue {
	my $t = shift;
	$t = $t & 0xFFFF;
	if($overflow)
	{
		$CR = 3;                 # overflow
	}
	elsif($t & 0x8000)
	{
		$CR = 2;                 # result LT 0
	}
	elsif($t & 0x7FFF)
	{
		$CR = 1;                 # result GT 0
	}
	else
	{
		$CR = 0;                 # result = 0
	}
	$overflow = 0;
    return $t;
}

# set Condition Register according value of A1, A2 as 31 bit signed long integer
# bit 1 (A1 bit 0) is sign bit (bit 0 A2 excluded)
# to be used in combination of getdbls/putdbls
sub setCR2s {
	my $l = shift;
	if($overflow)               # DLA + arith ops like double add, etc.
	{
		$CR = 3;                 # overflow
	}	
	elsif($l & 0x40000000)
	{
		$CR = 2;                 # result LT 0
	}
	elsif($l & 0x3FFFFFFF)
	{
		$CR = 1;                 # result GT 0
	}
	else
	{
		$CR = 0;                 # result = 0
	}
	$overflow = 0;
}

# set Condition Register according value of A1, A2 as 32 bit signed long integer
# bit 0 (A1 bit 0) is sign bit
# to be used in combination of getdblu/putdblu
sub setCR2u {
	my $l = shift;
	if($l & 0x80000000)
	{
		$CR = 2;                 # result LT 0
	}
	elsif($l & 0x7FFFFFFF)
	{
		$CR = 1;                 # result GT 0
	}
	else
	{
		$CR = 0;                 # result = 0
	}
}

# In the following 4 routines A1 an A2 are accessed as long accumulator.
# !!!!!! A1 = $R[2] A2=$R[4] !!!!!!!!
# get double signed
# returns A1, A2 as signed 31 value
sub getdbls {
	return (($R[2] << 15) | ($R[4] & MMASK));
}

# get double unsigned
# returns A1, A2 as unsigned 32 value
sub getdblu {
	return (($R[2] << 16) | $R[4] );
}

# put double signed
# stores signed 31 bit value in A1, A2
sub putdbls {
	my $x = shift;
	$x = $x & 0x7FFFFFFF;
	$R[2] = ($x >> 15) & DMASK;
	$R[4] = ($x & MMASK);
}

# put double unsigned
# stores unsigned 32 bit value in A1, A2
sub putdblu {
	my $x = shift;
	$R[2] = ($x >> 16) & DMASK;
	$R[4] = $x & DMASK;
}

# set internal interrupt (which must also be reset later by the program with an RIT , like LKM)
sub trap {
	my $int = shift;
	my $pc = $R[0] - 2;
	$inint = $inint | $int; 			    # set internal interrupt
	$intreg0 = $intreg0 | $II2PI[$int];		# set priority interrupt
	if($DEBUG)
	{
		prlog("\nTrap" . prhex(8,$int) . " at" . prhex(16,$pc) . "\n");
		prlog("Opcode =" . prhex(4,$opc) . " Instruction =" . prhex(16,$IR) . "\n");
		trace($pc);
	}
}

# reset internal interrupt (which is not automatically reset)
sub resettrap {
	my $int = shift;
	$inint  = $inint & (~ $int);            # reset internal interrupt
	$intreg0 = $intreg0 & (~ $II2PI[$int]); # reset priority interrupt
}

# Invalid instruction trap
# this trap should also be generated in case of:
#  - a privileged instruction is executed in User Mode (not implemented)
#  - A15 stack is used in User Mode (not implemented)
#
# execution of the instruction is stopped; PSW and the address of the invalid 
# instruction are stored in the stack.
# the internal interrupt is automatically reset and an indirect jump is made
# to address /7E
#
sub trap7E {
	my $pc=shift; # address of trapped instruction

	if($DEBUG)
	{
		prlog("\nTrap-7E at" . prhex(16,$pc) . "\n");
		trace($pc);
	}
	# instruction address and PSW on stack
	$M[$R[A15]] = $pc;                      # save address
	$R[A15] = $R[A15] - 2;                  # decrease link stack
	if($R[A15] < 0x100)
	{
		trap(LKM);		                    # A15 stack overflow
	}				
	$M[$R[A15]] = Fpsw()         ;          # save PSW
	$R[A15] = $R[A15] - 2;                  # decrease link stack
	if($R[A15] < 0x100)
	{
		trap(LKM);		                    # A15 stack overflow
	}											
	$ENB = 0;                               # inhibit
	$UM  = 0;                               # system mode
    # $PL=0x3F;                             # level is NOT changed
	$R[A0] = $M[0x7E];                      # continue with the trap routine
}

# Illegal instruction 
sub ilcerror {
	my $lc    = shift;
	my $instr = shift;
	my $opc   = shift;
	my $ident = shift;
	if($DEBUG)
	{
		prlog("\nERROR: Illegal Instruction at" . prhex(16,$lc) . " IR:" . prhex(16,$instr) . " OPCODE:" . prhex(4,$opc) . " $ident\n");
    }
	if($StopOnIllInstr)
	{
		prlog( "\nERROR: Illegal Instruction at" . prhex(16,$lc) . " IR:" . prhex(16,$instr) . " OPCODE:" . prhex(4,$opc) . " $ident\n");
		$RUN = 0;
	}
	else
	{
		trap7E($lc);      # trap illegal instruction
	}
}

# Illegal/Unknown device
sub ilderror {
	my $lc    = shift;
	my $instr = shift;
	my $opc   = shift;
	my $ident = shift;
	if($DEBUG)
	{
		prlog("\nERROR: Illegal/Unknown Device at" . prhex(16,$lc) . " IR:" . prhex(16,$instr) . " OPCODE:" . prhex(4,$opc) . " $ident\n");
   }
	if($StopOnIllDev)
	{
		prlog( "\nERROR: Illegal/Unknown Device at" . prhex(16,$lc) . " IR:" . prhex(16,$instr) . " OPCODE:" . prhex(4,$opc) . " $ident\n");
		$RUN = 0;
	}
	else
	{
		trap7E($lc);      # trap illegal instruction
	}
}


# Illegal IOP channel condition
sub mpxerror {
	if($StopOnMpxError)
	{
		trace($R[A0]);
		$RUN=0;
	}
}
         
# format PSW
sub Fpsw {

# P856/P857
#	my $PL;             # priority level 			   psw bit 0:5
#	my $CR;             # condition register		   psw bit 6:7
#	my $overflow=0;     # (aid to set CR, must be 0)
#	my $RUN;            # run bit                   psw bit 8
#	my $ENB;            # interrupt enable bit		psw bit 9
#	my $CP;             # control panel interrupt	psw bit 10      X
#	my $PWR;            # power fail interrupt      psw bit 11      X
#	my $RTC;            # real time clock interrupt psw bit 12      X
#	my $LKM;            # link monitor interrupt    psw bit 13      X
#						     # + stack overflow
#	                    # not used                  psw bit 14
#	my $UM;             # user mode indicator       psw bit 15
#                      ########### X bits are part of $inint and $intreg0

# P853/P854/P858/P859
#	my $PL;             # priority level            psw bit 0:5
#	my $CR;             # condition register        psw bit 6:7
#	my $overflow=0;     # (aid to set CR, must be 0)
#	my $RUN;            # run bit                   psw bit 8
#	my $ENB;            # interrupt enable bit		psw bit 9
#	my $CP;             # control panel interrupt	psw bit 10      X
#                      # not used                  psw bit 11
#	my $PWR;            # power fail interrupt      psw bit 12      X
#	my $RTC;            # real time clock interrupt                 X (not in PSW)
#	my $EM;             # extended system mode      psw bit 13
#  my $LKM             # link monitor interrupt    psw bit 14      X
#						     # + stack overflow
#	my $UM;             # user mode indicator       psw bit 15
#                      ########### X bits are part of $inint and $intreg0
    # Power fail not implemented
    if(! $P856)
    {
    	my $CP  = $inint & CP;
    	my $LKM = $inint & LKM;
    	$PSW = ((((((((((((($PL << 2) | $CR) << 1) | $RUN) << 1) | $ENB) << 1) | $CP) << 3) | $EM) << 1) | $LKM) << 1) | $UM;
    }
    else
    {
    	my $i = $inint & 0x1F;      # isolate the 5 internal interrupts represented in the P856 PSW
    	$PSW = ((((((((($PL << 2) | $CR) << 1) | $RUN) << 1) | $ENB) << 5) | $i) << 1) | $UM;
    }
    return $PSW;
}

sub reset_cpu {
	$PL  = 0x3F;   #??? or is the reset value 0 ??? NO, on P856 /3F is OK
	$CR  = 0;
	$overflow = 0;
	$RUN = 0;
#####################################################################################
	$ENB = 0;      # 0 is OK IPL disables the interrupts                             #
                  # in case ENB == 1 after reset, system does not boot dos5 from md1#
#####################################################################################
   $EM  = 0;      # no extended system mode
	$UM  = 0;      # system mode
	$PSW = 0;
	$intreg0  = 0; # priority interrupts
   $intreg1  = 0; # priority interrupts
	$inint    = 0; # internal interrupts
	$brkreg   = 0; # channel breaks
	$iopstate = 0; # reset iop
	# all registers, except A0 to 0
	$R[1]  = 0;
	$R[2]  = 0;	
	$R[3]  = 0;	
	$R[4]  = 0;
	$R[5]  = 0;	
	$R[6]  = 0;		
	$R[7]  = 0;
	$R[8]  = 0;	
	$R[9]  = 0;	
	$R[10] = 0;
	$R[11] = 0;	
	$R[12] = 0;	
	$R[13] = 0;
	$R[14] = 0;	
	$R[15] = 0;	
#########################################################
# as a debugging aid, A15 is set to a predefined value: #
	$R[15] = 0x1FE;                                      #
# for the same reason ENB is set to 0 and PL to /3F     #
#########################################################
	reset_mmu();
}

# the memory array M should only be used for even addresses
# in case an oneven address contains a value, there is an error
# in the simulators memory access
# on even addresses, also 1-bits outside the lower 16 part of each
# word should not be there
sub mem_check {
	my $fl = shift;
	my $b = 0;
	my $i = 0;
	while($i < MEMSIZE)
	{
		if($i & 1)
		{
			# uneven address
			if($M[$i] ne undef)
			{
				prlog("ERROR! value" . prhex(16,$M[$i]) . " is found at the uneven address" . prhex(16,$i) . "\n");
				$b=1;
			}
		}
		else
		{
			# even address
			if($M[$i] & 0xFFFF0000)
			{
				prlog("ERROR! wrong bits" . prhex(32,$M[$i]) . " found at the even address" . prhex(16,$i) . "\n");
				$b=1;
			}
		}
		$i = $i + 1;
	}
	$i=0;
	while($i < 0x10)
	{
		if($R[$i] & 0xFFFF0000)
		{
			prlog("ERROR! wrong bits" . prhex(32,$R[$i]) . " found in Register $Reg[$i] \n");
			$b=1;
		}
		$i = $i + 1;
	}
	if($fl)
	{
		prlog("Memory and Registers Checked\n");
	}
	return $b;
}

my @pcstk;
sub pushpc {
    my $pc = shift;
    $pcstk[30] = $pcstk[29];
    $pcstk[29] = $pcstk[28];
    $pcstk[28] = $pcstk[27];
    $pcstk[27] = $pcstk[26];
    $pcstk[26] = $pcstk[25];
    $pcstk[25] = $pcstk[24];
    $pcstk[24] = $pcstk[23];
    $pcstk[23] = $pcstk[22];
    $pcstk[22] = $pcstk[21];
    $pcstk[21] = $pcstk[20];
    $pcstk[20] = $pcstk[19];
    $pcstk[19] = $pcstk[18];
    $pcstk[18] = $pcstk[17];
    $pcstk[17] = $pcstk[16];
    $pcstk[16] = $pcstk[15];
    $pcstk[15] = $pcstk[14];
    $pcstk[14] = $pcstk[13];
    $pcstk[13] = $pcstk[12];
    $pcstk[12] = $pcstk[11];
    $pcstk[11] = $pcstk[10];
    $pcstk[10] = $pcstk[9];
    $pcstk[9]  = $pcstk[8];
    $pcstk[8]  = $pcstk[7];
    $pcstk[7]  = $pcstk[6];
    $pcstk[6]  = $pcstk[5];
    $pcstk[5]  = $pcstk[4];
    $pcstk[4]  = $pcstk[3];
    $pcstk[3]  = $pcstk[2];
    $pcstk[2]  = $pcstk[1];
    $pcstk[1]  = $pcstk[0];
    $pcstk[0]  = $pc;
}

sub state_pcstk {
    prlog("0 " . prhex(20,$pcstk[0]) . "\n");
    prlog("1 " . prhex(20,$pcstk[1]) . "\n");
    prlog("2 " . prhex(20,$pcstk[2]) . "\n");
    prlog("3 " . prhex(20,$pcstk[3]) . "\n");
    prlog("4 " . prhex(20,$pcstk[4]) . "\n");
    prlog("5 " . prhex(20,$pcstk[5]) . "\n");
    prlog("6 " . prhex(20,$pcstk[6]) . "\n");
    prlog("7 " . prhex(20,$pcstk[7]) . "\n");
    prlog("8 " . prhex(20,$pcstk[8]) . "\n");
    prlog("9 " . prhex(20,$pcstk[9]) . "\n");
    
    prlog("10" . prhex(20,$pcstk[10]) . "\n");
    prlog("11" . prhex(20,$pcstk[11]) . "\n");
    prlog("12" . prhex(20,$pcstk[12]) . "\n");
    prlog("13" . prhex(20,$pcstk[13]) . "\n");
    prlog("14" . prhex(20,$pcstk[14]) . "\n");
    prlog("15" . prhex(20,$pcstk[15]) . "\n");
    prlog("16" . prhex(20,$pcstk[16]) . "\n");
    prlog("17" . prhex(20,$pcstk[17]) . "\n");
    prlog("18" . prhex(20,$pcstk[18]) . "\n");
    prlog("19" . prhex(20,$pcstk[19]) . "\n");
    
    prlog("20" . prhex(20,$pcstk[20]) . "\n");
    prlog("21" . prhex(20,$pcstk[21]) . "\n");
    prlog("22" . prhex(20,$pcstk[22]) . "\n");
    prlog("23" . prhex(20,$pcstk[23]) . "\n");
    prlog("24" . prhex(20,$pcstk[24]) . "\n");
    prlog("25" . prhex(20,$pcstk[25]) . "\n");
    prlog("26" . prhex(20,$pcstk[26]) . "\n");
    prlog("27" . prhex(20,$pcstk[27]) . "\n");
    prlog("28" . prhex(20,$pcstk[28]) . "\n");
    prlog("29" . prhex(20,$pcstk[29]) . "\n");
    prlog("30" . prhex(20,$pcstk[30]) . "\n");
}
    
###################### Controller subroutines #################################

sub reset_all {
	$program_started = 0;
	reset_cpu();
	reset_mmu();
	reset_clk();
	reset_ty0();
	reset_ty1();
	reset_ty2();
	reset_ptr();
	reset_ptp();
	reset_lpt();
	reset_crd();
	reset_md0();
	reset_bd0();
	reset_fpp();
}

# trace can be used in two ways:
# 1) with pc=A0/P it displays the state of the cpu
# 2  with pc=location of an executed instruction it provides the state of
#    the cpu after the execution of that instruction
my $pctrace = 0;
my $trrep   = 0;
sub trace {
	my $pc  = shift; # logical address
	my $psw = Fpsw();

	if($tracefile) # dump trace in file ?
	{
		if($pc != $pctrace)
		{
			$pctrace=$pc;
			$trrep=0;			
			print TRACE "  P" . prhex(16,$pc) . prhex(20,$pcp) . "   M" . prhex(16,$M[$pcp]) . "  PSW" . prhex(16,$psw);
			print TRACE " CR" . prhex(4,$CR); 
			print TRACE " IR" . prhex(32,$intreg0) . prhex(32,$intreg1) . "  IN" . prhex(16,$inint) . "   BR" . prhex(16,$brkreg);
			print TRACE " A1";
			print TRACE prhex(16,$R[2]);
			print TRACE prhex(16,$R[4]);
			print TRACE prhex(16,$R[6]);
			print TRACE prhex(16,$R[8]);
			print TRACE prhex(16,$R[10]);
			print TRACE prhex(16,$R[12]);
			print TRACE prhex(16,$R[14]);
	
			print TRACE prhex(16,$R[1]);
			print TRACE prhex(16,$R[3]);
			print TRACE prhex(16,$R[5]);
			print TRACE prhex(16,$R[7]);
			print TRACE prhex(16,$R[9]);
			print TRACE prhex(16,$R[11]);
			print TRACE prhex(16,$R[13]);
			print TRACE prhex(16,$R[15]);
			print TRACE "\n";
		}
		else
		{
			if($trrep < 5)
			{
				print TRACE "=\n";
			}
			$trrep=$trrep+1;
		}
	}
	prlog(decode() . "\n");
	prlog("  P" . prhex(16,$pc) . prhex(20,$pcp) . "   M" . prhex(16,$M[$pcp]) . "  PSW" . prhex(16,$psw));
	prlog(" CR" . prhex(4,$CR));
	prlog(" IR" . prhex(32,$intreg0) . prhex(32,$intreg1) . "  IN" . prhex(16,$inint) . "   BR" . prhex(16,$brkreg) . "\n");
	prlog(" A1");
	prlog(prhex(16,$R[2]));
	prlog(prhex(16,$R[4]));
	prlog(prhex(16,$R[6]));
	prlog(prhex(16,$R[8]));
	prlog(prhex(16,$R[10]));
	prlog(prhex(16,$R[12]));
	prlog(prhex(16,$R[14]));

	prlog(prhex(16,$R[1]));
	prlog(prhex(16,$R[3]));
	prlog(prhex(16,$R[5]));
	prlog(prhex(16,$R[7]));
	prlog(prhex(16,$R[9]));
	prlog(prhex(16,$R[11]));
	prlog(prhex(16,$R[13]));
	prlog(prhex(16,$R[15]));
	prlog("\n");
}

# trace instructions in a region
sub rtrace {
	my $pc = shift;
	if($pcp >= $pbatrace && $pcp <= $peatrace)
	{
		trace($pc);
	}
}

#end subs.md ===============================================================

###insert clock.md real time clock device
### clock.md
# The real time clock device
######################### CLK device #######################
# Real time clocks were delivered with several frequencies (1 ms, 10 ms, etc.),
# depending on the applied cristal. 
# The default was a line frequency clock(20 ms or 16.6 ms). 
# The clock is started/stopped with a key on the panel (RTC ON/OFF)

sub cio_clk {
	my $f = shift;                  # function bit
	my $stat = $CLK[STATE] >> 16;   # get status/cu state
	if($f == 0)
	{
		# CIO STOP, always accepted
		if($stat == EXE)
		{
			$CLK[STATE] = $CLK[STATE] | (WREQ << 16);     # state = wait state requested
		}
		else
		{
			 $CLK[STATE] = INAC;
		}
		$CR = 0;
	}
	elsif($stat == INAC)
	{
		# CIO START, accepted if state == inactive
		# F=1 => CIO start clock
		$CLK[STATE] = (EXE << 16);                    # state = execute	
		$CLK[BUFFER] = 0;                             # reset sync period
		$CLK[CTIME] =  $CLK[TIME];                    # start with default interval
		activate_event(\@CLK,$CLK[CTIME]);            # schedule event
		$CR = 0;		
	}
	else
	{
		$CR = 1;                    # not accepted                    
	}	
}

# Clock service routine 
# processes the 'execute state' of the simulated clock device.

sub svc_clk {
	my $stat = ($CLK[STATE] >> 16);	
	if($stat == EXE)
	{
		trap(RTC);                                     # set the ready flipflop
		###### clock sync code
      if($CLK[BUFFER] == 0)                          # new sync period ?
		{
			@clk0 = gettimeofday ();                    # fix start point
		}
		elsif($CLK[BUFFER] == $CLK[SYNC])
		{
		#	# sync period ended
			$laps = tv_interval (\@clk0);               # elapsed sync time in secs
			$pulses = $CLK[CTIME] * $CLK[SYNC];
		#	# new interval time
			$CLK[CTIME] = int(($pulses / $laps) / $CLK[FREQ]);
		#	# start a new sync period
			@clk0 = gettimeofday ();                    # fix new start point
			$CLK[BUFFER] = 0;
	    }
		$CLK[BUFFER] = $CLK[BUFFER] + 1;               # sync  period
		activate_event(\@CLK,$CLK[CTIME]);             # schedule a new event
		
	}
	else
	{
		prlog("Clock switched off\n");
		# switch directly to inactive state 
		$CLK[STATE] = INAC;                  # cu = inactive
	}
}

sub inr_clk {
	return 0; # nop
}

sub otr_clk {
	return 0; # nop
}

sub sst_clk {
	return 0; # nop
}

sub tst_clk {
	if( ($CLK[STATE] >> 16) )
	{
		$R[$r3] = 1;                                   # busy, not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}	
	$CR = 0;
}

sub state_clk {
	prlog("CU" . prhex(20,$CLK[STATE]) . " INTERVAL $CLK[CTIME]\n");
}

sub reset_clk {
	resettrap(RTC);                                    # reset the ready flipflop
	$CLK[STATE]  = INAC << 16;                         # state = inactive + 0
	$CLK[BUFFER] = 0;                                  # reset buffer
	$CLK[CTIME]  = 0;
	if($rtc_on)
	{
		cio_clk(1); # restart the clock
	}
}
#end clock.md ===============================================================

###insert ptr.md papertape reader
### ptr.md
######################### PTR device routines

sub cio_ptr {
	my $f = shift;                  # function bit
	my $stat = $PTR[STATE] >> 16;   # get status/cu state
	if($f == 0)
	{
		# CIO STOP, always accepted
		if(($stat == IEXE) || ($stat == IEXC))
		{
			$PTR[STATE] = $PTR[STATE] | (WREQ << 16);  # state = wait state requested
		}
		$CR = 0;
	}
	elsif($stat == INAC)
	{
		# CIO START INPUT, accepted if state == inactive
	   $PTR[STATE] = (IEXE << 16);                   # state = reset + input + execute
		$PTR[BUFFER]  = 0;                            # reset buffer
		$CR = 0;
		# schedule a PTR event
		activate_event(\@PTR, $PTR[TIME]);
	}
	else
	{
		$CR = 1;                                      # not accepted 
	}
}
	
# ptr service routine 
# processes the 'execute state' of the simulated ptr cu+device.
#
sub svc_ptr {
	my $stat = ($PTR[STATE] >> 16);  
	my $c;
	$PTR[STATE] = $PTR[STATE] & 0xFFFF;                    # reset cu state bits

	if( $stat & WREQ)
	{
		# stop io requested (CIO stop)
		$PTR[STATE] = $PTR[STATE] | (WAIT << 16);           # cu state = wait
	}	
	elsif( $stat == IEXE )                                 # input + execute
	{
		if($PTR[FILE] eq "")
		{
			# not attached, so not operable
	      $PTR[STATE] = $PTR[STATE] | (WAIT << 16);        # cu state = wait
			$PTR[STATE] = $PTR[STATE] | 1;                   # set not operable error bit in state
		}
		elsif($PTR[BUFFER] == 0)                            # buffer reset?
		{
			$c = read_ptr();
			if($c)            
			{
				$PTR[BUFFER] = $c;                            # save character in buffer
				$PTR[STATE]  = ($PTR[STATE] | (IEXC << 16));  # state = input + exchange
				# wait for INR
				# schedule next PTR event
				activate_event(\@PTR, $PTR[TIME]);
			}
			else
			{
				# end of tape
				$PTR[STATE] = $PTR[STATE] | (WAIT << 16);     # cu state = wait
				$PTR[STATE] = $PTR[STATE] | 0x20;             # set eot bit in state	
			}
		}
		else
		{
			prlog("Error: PTR-INR did not reset the buffer\n");		
		}
	}
	elsif( $stat == IEXC )                                 # input + exchange
	{
		# throughput error (INR did not process)
	   $PTR[STATE] = $PTR[STATE] | (WAIT << 16);           # cu state = wait
		$PTR[STATE] = $PTR[STATE] | 2;                      # set throughput error bit in state
	}
	else
	{
		prlog("Error: PTR service request with CU in wrong state: $stat\n");	
	}
	$intreg0 = $intreg0 | IPTR;                            # set the ready flipflop
}

sub inr_ptr {
	
	if( ($PTR[STATE] >> 16) == IEXC )
	{
		# cu in exchange state
		$R[$r3] = $PTR[BUFFER] & 0xFF;                # buffered character
		$intreg0 = $intreg0 & (~ IPTR);               # reset the ready flipflop
		$PTR[STATE] = $PTR[STATE] & 0xFFFF;           # reset cu state bits
		$PTR[STATE] = $PTR[STATE] | (IEXE << 16);     # state = input + execute
		$PTR[BUFFER] = 0;                             # reset the buffer
		$CR = 0;
	}
	else
	{
		$CR = 1;
	}	
}

sub sst_ptr {
    # state in r3 as result of an accepted sst:
    # 0x0000 => ok
    # 0x0001 => not operable (no file attached)
    # 0x0002 => througput error
    # 0x0020 => end of tape
	if( ($PTR[STATE] >> 16) == WAIT)
	{
		# cu in wait state
		$PTR[STATE] = $PTR[STATE] & 0xFFFF;           # cu = inactive
		$R[$r3] = $PTR[STATE];                        # r3 = status
		$intreg0 = $intreg0 & (~ IPTR);               # reset the ready flipflop
		$CR = 0;
	}
	else
	{
		$CR = 1;	                                     # sst not accepted
	}
}

sub tst_ptr {
	if( ($PTR[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # busy, if not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}	
	$CR = 0;
}

sub state_ptr {
	prlog("CU" . prhex(20,$PTR[STATE]) . " CR" . prhex(4,$CR) . " BUFFER" . prhex(8,$PTR[BUFFER]) . "\n");
    if($PTR[FILE] ne "")
	{
		prlog("Device PTR is attached to file: $PTR[FILE]\n");
	}
	else
	{
		prlog("Device PTR is not attached to a file\n");
	}
}

sub reset_ptr {
	$intreg0 = $intreg0 & (~ IPTR);                   # reset the ready flipflop
	$PTR[STATE]  = INAC << 16;                        # state = inactive + 0
	$PTR[BUFFER] = 0;                                 # reset buffer
	$ptrcode     = "XX";
	# if attached, reattach (set file at load point)
	if($PTR[FILE] ne "")
	{
		$file = $PTR[FILE];
		close ($PTR[FC]) || die "can't close $file: $!";
		open (PTR, $file) || die "Cannot open papertape inputfile $file: $!";
		$PTR[FC] = \*PTR;
		binmode $PTR[FC], ":raw";	
		$ptrcode = "  ";
		prlog("File $file reattached to device PTR\n");
	}
}

# read octad from papertape, attached to filecode PTR
sub read_ptr {
	my $c;
	my $s;
	if(	read($PTR[FC],$c,1) )
	{
		$c = unpack("C", $c); 	         # get next char
		$c = ($c & 0xFF) | 0x8000;
		$ptrcode = prhex(8,($c & 0xFF)); # show 8bit code
		return $c;                       # nonzero if not eot
	}
	else
	{
		# end of file
		$ptrcode = "XX";
		return 0;
	}
}

# read octad from papertape, attached to filecode IN (used by SCP load commands)
sub nextchar {
	my $c;
	read(IN,$c,1);
	$c = unpack("C", $c); 	#get new current char
	return ($c & 0xFF);
}

# read word (2 octads) from papertape
sub nextword {
	my $w = nextchar();
	$w = $w << 8;
	$w = $w + nextchar();;
	return $w;
}

#end ptr.md ===============================================================

###insert ptp.md papertape puncher
### ptp.md
######################### PTP device routines

sub cio_ptp {
	my $f = shift;                                       # function bit
	my $stat = $PTP[STATE] >> 16;                        # get status/cu state
	if($f == 0)
	{
		# CIO STOP, always accepted
		if(($stat == OEXE) || ($stat == OEXC))
		{
			$PTP[STATE] = $PTP[STATE] | (WREQ << 16);      # state = wait state requested
		}
		$CR = 0;
	}
	elsif($stat == INAC)
	{
		# CIO START OUTPUT, accepted if state == inactive
	   $PTP[STATE] = (OEXC << 16);                       # state = reset + output + exchange
		$intreg0 = $intreg0 | IPTP;                       # set the ready flipflop
		activate_event(\@PTP,$PTP[TIME]);                 # schedule a new event
		$CR = 0;
	}
	else
	{
		$CR = 1;                                          # not accepted                    
	}
}

# ptp service routine 
# processes the 'execute state' of the simulated ptp cu+device.
#
sub svc_ptp {
	my $stat = ($PTP[STATE] >> 16);  

	if( $stat == OEXE )                                  # output + execute
	{
		if($PTP[FILE] eq "")
		{
			# not attached, so not operable
		   $PTP[STATE] = $PTP[STATE] & 0xFFFF;            # reset cu state bits			
	      $PTP[STATE] = $PTP[STATE] | (WAIT << 16);      # cu state = wait
			$PTP[STATE] = $PTP[STATE] | 1;                 # set not operable error bit in state
			$intreg0 = $intreg0 | IPTP;                    # set the ready flipflop
		}
		else
		{
			punch_ptp($PTP[BUFFER]);
			$PTP[STATE] = $PTP[STATE] & 0xFFFF;            # reset cu state bits	
			$PTP[STATE]  = ($PTP[STATE] | (OEXC << 16));   # state = output + exchange
			$intreg0 = $intreg0 | IPTP;                    # set the ready flipflop
			# wait for next OTR or CIO HALT
			# schedule next PTP event
			activate_event(\@PTP, $PTP[TIME]);
		}
	}
	elsif( $stat & WREQ)
	{
		# stop io requested (CIO stop)
		if($stat == (OEXE + WREQ))
		{
			if(!($intreg0 & IPTP))
			{
				# not ready, so still a buffered output character pending
				punch_ptp($PTP[BUFFER]);
			}
		}
		$PTP[STATE] = $PTP[STATE] & 0xFFFF;               # reset cu state bits
		$PTP[STATE] = $PTP[STATE] | (WAIT << 16);         # cu state = wait
		$intreg0 = $intreg0 | IPTP;                       # set the ready flipflop
	}		
	else
	{
		# do nothing: wait for OTR or CIO HALT
		activate_event(\@PTP, $PTP[TIME]);
	}
}

sub otr_ptp {
	
	if( ($PTP[STATE] >> 16) == OEXC )
	{
		# cu in exchange state
		$PTP[BUFFER] = $R[$r3];                       # buffered character
		$intreg0 = $intreg0 & (~ IPTP);               # reset the ready flipflop
		$PTP[STATE] = $PTP[STATE] & 0xFFFF;           # reset cu state bits
		$PTP[STATE] = $PTP[STATE] | (OEXE << 16);     # state = output + execute
		$CR = 0;
	}
	else
	{
		$CR = 1;
	}	
}

sub sst_ptp {
	if( ($PTP[STATE] >> 16) == WAIT)
	{
		# cu in wait state
		$PTP[STATE] = $PTP[STATE] & 0xFFFF;           # cu = inactive
		$R[$r3] = $PTP[STATE];                        # r3 = status
		$intreg0 = $intreg0 & (~ IPTP);               # reset the ready flipflop
		$CR = 0;
	}
	else
	{
		$CR = 1;	                                     # sst not accepted
	}	
}

sub tst_ptp {
	if( ($PTP[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # busy, if not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}	
	$CR = 0;
}

sub state_ptp {
	prlog("CU" . prhex(20,$PTP[STATE]) . " CR" . prhex(4,$CR) . " BUFFER" . prhex(8,$PTP[BUFFER]) . "\n");
    if($PTP[FILE] ne "")
	{
		prlog("Device PTP is attached to file: $PTP[FILE]\n");
	}
	else
	{
		prlog("Device PTP is not attached to a file\n");
	}
}

sub reset_ptp {
	$intreg0 = $intreg0 & (~ IPTP);                   # reset the ready flipflop
	$PTP[STATE]  = INAC << 16;                        # state = inactive + 0
	$PTP[BUFFER] = 0;                                 # reset buffer
	# if attached, reattach
	if($PTP[FILE] ne "")
	{
		$file = $PTP[FILE];
		close ($PTP[FC]) || die "can't close $file: $!";
		open (PTP, ">:raw", $file) || die "Cannot open paper punch file $file: $!";	
		$PTP[FC] = \*PTP;
		prlog("File $file reattached to device PTP\n");
	}
}

# punch a byte on papertape connected to filecode PTP
sub punch_ptp {
    my($a) = @_;
    my $byte;
	 my $fc = $PTP[FC];
    $byte = pack("C", ($a & 0xFF) );
    print $fc $byte;
}

sub punch {
    my($a) = @_;
    my $byte;
    $byte = pack("C", ($a & 0xFF) );
    print BIN $byte;
}

#end ptp.md ===============================================================

###insert cdc80mbdisk.md 2 * 80mb moving head disk controller/disk
### cdc80mbdisk.md
# 2 * 80mb moving head disk controller/disk
#
########################## CDC 80 Mb Bigdisk routines ##############################
# The control unit (supporting 2 disk units) is wired to an internal DMA channel 
# The DMA channel is part of the disk control unit. Interrupt after the in or output
# is ready. Device addresses: Unit 0: /16; Unit 1: /36.
# The addressing of a particular drive is as follows:
#                                        DA = 01 0 110
#                                             ^
#                                             |Unit Number 0 or 1
#
# Command and Control words in the 1st 32kwords of memory
#
# CIO processor for the 2 Bigdisk Units
# CIO start and CIO start IPL (no CIO stop)
# r3 is the addres of the 1st command word
# if the address is odd (bit 15 == 1) => CIO start IPL
# no command overlap with seeks implemented
#
# returned status:
#  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 
#    ^ ^   ^   ^     ^     ^ ^ ^ ^
#    | |   |   |     |     | | | |not operable
#    | |   |   |     |     | | |throughput
#    | |   |   |     |     | |parity
#    | |   |   |     |     |length
#    | |   |   |     |disk
#    | |   |   |seek error
#    | |   |record not found
#    | |bad track flag
#    |disk ready after unready
#
#
# The 80M Disk Pack Image File (xxx.dta)
# Disk pack file structure (of the file simulating the 80M disk pack)
# There are 822 cylinders (0..821); 5 heads (0..4), so 822 * 5 tracks.
# Tracklength: 0x5000 bytes (0x2800 words), of which 0x26CA words = 9930 words
# as userspace.
# The userspace of the tracks (0x26CA words = 9930 words) and can have 64 
# sectors maximum. 
# Each track starts with a table: the track administration:
# -word0  = cylinder number (5 tracks / cylinder)
# -word1  = /0000
# -word2  = useable tracklength in words (/26CA)
# There are 2 words for each record in the track administration (so 64 entries):
# -word   = record start (offset in words from beginning of track)
# -word   = record length (in words)
# For entries not used, the 2 words contain /0000
# So this table is 64*2 + 3 = 131 words long (/83)
# Record 0 in the track starts at offset /83.
# 
# An unused (not within a DAD), but formatted track, contains the following info:
# -word0 = cylinder number
# -word1 = /0000
# -word2 = /26CA
# -word3 = /83   (start record 0)     <<<< track admin record 0
# -word4 = /26CA (length record 0)    <<<< track admin record 0
# - the remaining words (63*2) of the track admin are /0000
# - the userspace (9930 words) also contain /0000
# 
# This is the result of a "write home address" command which writes just one sector:
# "cylinder number" "head number" "last sector = 0" "sector length = 9930"
#
# If a "write home address" command is given with other values for "last sector" and
# "sector length", then more track admin entries are filled (last sector + 1 entries).
# The user space is always filled with zero's by the "write home address" command.


# Cyl0/Track0 (the start and part of DAD0) contains global volume information to 
# make it possible to access the DAD's on the diskpack:
# - physical record 0   => BOOT record (= logical sector 0; on CDC called logical sector 1)
# - physical record /A  => VOLUME LABEL record (= interlace DAD0) 
#                          (= logical sector 1; on CDC called logical sector 0)
#                          contains the BITAB of DAD0 and global volume parameters:
#                           - physical sector number of bad track list (at byte address /4A)
#                           - number of sectors/track in DAD0 (at byte address /4C)
#                           - interlace factor of DAD0 (at byte address /4E)
#                           - sector size in bytes of DAD0 (at byte address /50)
#                           - physical sector number of the VTOC (at byte addess /52)
#
# With this info the following can be accesses:
# - logical sector 6        => the bad track list (volume is checked: no bad tracks, so ignored)
# - logical sector 7        => VTOC (providing the list of DAD's + their access info on the volume)
# - logical sectors 2,3,4,5 => CATALOGUE of DAD0.

# unit 0
sub cio_bd0 {
        my $stat = $BD0[STATE] >> 16;                         # get status: cu state
        if($stat == INAC)
        {
            # CIO START, accepted if state == inactive
            $BD0[STATE] = XCIO << 16;                         # set cio state
            $cmdaddr = $R[$r3];                               # pointer to command word
            $bdactiveunit = 0x0000;                           # set active unit
            $bdactiveunitname = $BD0[NAME];
            $CR = 0;
            BdSon();
            activate_event(\@BD0,$BD0[STIME]);                # schedule start event
        }
        else
        {
            $CR = 1;                                          # CIO not accepted 
        }
        bdprlog("\nBD0 CIO at: " . prhex(20,$pcp) . " Cmd at: " . prhex(16,$cmdaddr) . " CR=$CR\n");
}

# unit 1
sub cio_bd1 {
        my $stat = $BD0[STATE] >> 16;   # get status: cu state
        if($stat == INAC)
        {
            # CIO START, accepted if state == inactive
            $BD0[STATE] = XCIO << 16;                         # set cio state
            $cmdaddr = $R[$r3];                               # pointer to command word
            $bdactiveunit = 0x0040;                           # set active unit
            $bdactiveunitname = $BD1[NAME];
            $CR = 0;
            BdSon();
            activate_event(\@BD0,$BD0[STIME]);                # schedule start event
        }
        else
        {
            $CR = 1;                                          # CIO not accepted 
        }
        bdprlog("\nBD1 CIO at: " . prhex(20,$pcp) . " Cmd at: " . prhex(16,$cmdaddr) . " CR=$CR\n");
}

sub svc_bd0 {
    # $bdactiveunit contains the active disk unit
    my $stat = $BD0[STATE] >> 16; 
    my $w;
    my $cyl;
    my $boot = 0;
    if($stat == XCIO)
    {
        # CIO start being executed
        if($cmdaddr & 1)
        {
            # CIO IPL; Read  Cyl 0 Track/Head 0 Sector 0 from the active disk
            if($bdactiveunit)
            {
                if($BD1[RDY])
                {
                    prlog("Boot from BD1\n");
                    $boot = 1;
                }
            }
            else
            {
                if($BD0[RDY])
                {
                    prlog("Boot from BD0\n");
                    $boot = 1;
                }
            }
            if($boot)
            {
                # rdtrack and rdpsec know the active unit
                if(rdtrack(0,0))    #<<<<<<<<<<<<< error handling still to add !!!!!!!!
                {
                    if(rdpsec(0))   #<<<<<<<<<<<<< error handling still to add !!!!!!!!
                    {
                        $BD0[SLEN] = 0xCD;
                        $BD0[XLEN] = 0;
                        $nt        = 0;                 # transfer
                        $dc        = 0;                 # no data chaining
                        $cw1       = 0xCD;              # total length to transfer
                        $ic        = 1;                 # stop after transfer
                        $txlength  = 0;
                        $memaddr   = 0;                 # address to store psec
                        $BD0[STATE] = IEXC << 16;       # psec => memory
                        activate_event(\@BD0,$BD0[STIME]);
                    }
                    else
                    {
                        prlog("Boot: Sector read error ($bdactiveunitname)\n");
                    }
                }
                else
                {
                    prlog("Boot: Track read error ($bdactiveunitname)\n");
                }
            }
            else
            {
                prlog("Boot disk is not ready\n");
                if($bdactiveunit)
                {
                    $BD0[STATE] = 0x0041 | (WREQ << 16)     # unit 1 not operable
                }
                else
                {
                    $BD0[STATE] = 0x0001 | (WREQ << 16)     # unit 0 not operable
                }
            }
        }
        else
        {
            # CIO Start
            if($bdactiveunit)
            {
                if($BD1[RDY])
                {
                    $BD0[STATE] = (CEXE << 16);             # execute command
                }
                else
                {
                    $BD0[STATE] = 0x0041 | (WREQ << 16)     # unit 1 not operable
                }
            }
            else
            {
                if($BD0[RDY])
                {
                    $BD0[STATE] = (CEXE << 16);             # execute command
                }
                else
                {
                    $BD0[STATE] = 0x0001 | (WREQ << 16)     # unit 0 not operable
                }
            }
        }
        activate_event(\@BD0,$BD0[STIME]);
    }
    elsif($stat == CEXE)
    {
        # load command word
        $cmdaddr = $cmdaddr & 0xFFFE;
        $cmdword = $M[$cmdaddr];
        bdprlog(">>>New BDCmd Unit:$bdactiveunit " . prhex(16,$cmdaddr) . prhex(16, $cmdword) . "\n");
        $cmdaddr = $cmdaddr + 2;
        $cmd     = ($cmdword >> 12) & 0xF;      # requested operation
        $ic      = $cmdword & 0x0800;           # interrupt/chain bit 
        # execute command word
        if($cmd == 0xE || $cmd == 0xA)          # seek
        {
            if($cmd == 0xE)
            {
                # seek zero
                if($bdactiveunit==0x0040)
                {
                     # unit 1
                     $w = $BD1[CYL];            # current cylinder
                     $cyl = 0;                  # new cylinder
                }
                if($bdactiveunit==0x0000)
                {
                     # unit 0
                     $w = $BD0[CYL];            # current cylinder
                     $cyl = 0;                  # new cylinder
                }
            }
            if($cmd == 0xA)
            {
                # seek
                if($bdactiveunit==0x0040)
                {
                     # unit 1
                     $w = $BD1[CYL];             # current cylinder
                     $cyl = $cmdword & 0x3FF;    # new cylinder
                     $w = abs($w - $cyl);
                }
                if($bdactiveunit==0x0000)
                {
                     # unit 0
                     $w = $BD0[CYL];             # current cylinder
                     $cyl = $cmdword & 0x3FF;    # new cylinder
                     $w = abs($w - $cyl);
                }
            }
            bdprlog("BDCmd Unit:$bdactiveunit Seek, new CYL " . prhex(16, $cyl) . " <<<<<<\n");
            # read track 0 of the new cylinder to make the seek effective
            if(rdtrack($cyl,0)) #rdtrack sets $BD0[CYL]/$BD0[HEAD] or $BD1[CYL]/$BD1[HEAD]
            {
                # ok: set state
                $BD0[STATE] = $BD0[STATE] & 0xFFFF;      # reset cu state bits
                if($ic)
                {
                     # set interrupt
                     $BD0[STATE] = $BD0[STATE] | $bdactiveunit | (WREQ << 16)
                }
                else
                {
                     # command chain
                     if($bdactiveunit)
                     {
                         bdprlog("BD1 Command Chain\n");
                     }
                     else
                     {
                         bdprlog("BD0 Command Chain\n");
                     }
                     $BD0[STATE] = $BD0[STATE] | (CEXE << 16);
                }
             }
             else
             {
                # error: set seek error state
                if($bdactiveunit)
                {
                	 bdprlog("BD1 Seek Error\n");
                }
                else
                {
                	 bdprlog("BD0 Seek Error\n");
                }
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0200 | $bdactiveunit; 
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
             }
             activate_event(\@BD0,$w * $BD0[TRTIME]);
        }
        elsif($cmd == 0x1)
        {
            # write (always into the current cylinder)
            bdprlog("BDCmd Write\n");
            $cw1 = $M[$cmdaddr] & 0x3FFF;        # Requested Total length (words)
            bdprlog("BD Rcw1: " . prhex(16,$cmdaddr) . prhex(16,$cw1) . " (total length (14bit) $cw1)\n");
            $cmdaddr = $cmdaddr + 2;
            $cw2 = $M[$cmdaddr];                 # Block length (words) ++
            $nt = 0;                             # No transfer bit (not used with write)
            $dc = $cw2 & 0x4000;                 # Data chain bit
            $BD0[SLEN] = $cw2 & 0xFFF;           # Block length (of the 1st block)
            bdprlog("BD Rcw2: " . prhex(16,$cmdaddr) . prhex(16,$cw2) . " (length this block (12bit) $BD0[SLEN] )\n");
            $cmdaddr = $cmdaddr + 2;
            $cw3 = $M[$cmdaddr];                 # Block start address in memory
            bdprlog("BD Rcw3: " . prhex(16,$cmdaddr) . prhex(16,$cw3) . "\n");
            $cmdaddr = $cmdaddr + 2;
            $memaddr = ((($cw2 & 0x3000) << 4) | $cw3) & 0x3FFFE; # 18 bit address
            bdprlog("BD block address (Rcw3+): " . prhex(20,$memaddr) . "\n");
            $BD0[XLEN]   = 0;                    # transferred length of this block
            $txlength    = 0;                    # total transferred length
            # get the track in which the record must be inserted
            if(rdtrack(UNDEF, $cmdword & 0x1F))
            {
                # and start the exchange
                # get the formatted psec parameters
                if($bdactiveunit)
                {
                    bdprlog("BD1 track loaded + psec parameters\n");
                    $BD1[SEC] = (($cmdword >> 5) & 0x3F);             # psec number
                    $BD0[PSL] = $bd1sectorlength[$BD1[SEC]];          # from the track admin (words!)
                    $bd1trackindex = $bd1sectoroffset[$BD1[SEC]] * 2; # from the track admin (words!)
                    bdprlog("BD1 Write     C:$BD1[CYL] H:$BD1[HEAD] S:$BD1[SEC]\n");
                }
                else
                {
                    bdprlog("BD0 track loaded + psec parameters\n");
                    $BD0[SEC] = (($cmdword >> 5) & 0x3F);             # psec number
                    $BD0[PSL] = $bd0sectorlength[$BD0[SEC]];          # from the track admin (words!)
                    $bd0trackindex = $bd0sectoroffset[$BD0[SEC]] * 2; # from the track admin (words!)
                    bdprlog("BD0 Write     C:$BD0[CYL] H:$BD0[HEAD] S:$BD0[SEC]\n"); 
                }
                $BD0[STATE] = (OEXC << 16);                           # memory => psec
            }
            else
            {
            	 if($bdactiveunit)
            	 {
            	 	 prlog("BD1 track read error\n");
            	 }
            	 else
            	 {
            	 	 prlog("BD0 track read error\n");
            	 }
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0800 | $bdactiveunit; 
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            }
            activate_event(\@BD0,$BD0[STIME]);
        }
        elsif(($cmd & 3) == 0x0)
        {
            # read (always from the current cylinder)
            bdprlog("BDCmd Read\n");
            $cw1 = $M[$cmdaddr] & 0x3FFF;        # Requested Total length (words)
            bdprlog("BD Rcw1: " . prhex(16,$cmdaddr) . prhex(16,$cw1) . " (total length (14bit) $cw1)\n");
            $cmdaddr = $cmdaddr + 2;
            $cw2 = $M[$cmdaddr];                 # Block length (words) ++
            $nt = $cw2 & 0x8000;                 # No transfer bit
            $dc = $cw2 & 0x4000;                 # Data chain bit
            $BD0[SLEN] = $cw2 & 0xFFF;           # Block length (of the 1st block)
            bdprlog("BD Rcw2: " . prhex(16,$cmdaddr) . prhex(16,$cw2) . " (length this block (12bit) $BD0[SLEN] )\n");
            $cmdaddr = $cmdaddr + 2;
            $cw3 = $M[$cmdaddr];                 # Block start address in memory
            bdprlog("BD Rcw3: " . prhex(16,$cmdaddr) . prhex(16,$cw3) . "\n");
            $cmdaddr = $cmdaddr + 2;
            $memaddr = ((($cw2 & 0x3000) << 4) | $cw3) & 0x3FFFE; # 18 bit address
            bdprlog("BD block address (Rcw3+): " . prhex(20,$memaddr) . "\n");
            $BD0[XLEN] = 0;                      # transferred length of this block
            $txlength  = 0;                      # total transferred length
            if(rdtrack(UNDEF, $cmdword & 0x1F))
            {
                if(rdpsec(($cmdword >> 5) & 0x3F)) # always from the current track
                {
                	if($bdactiveunit)
                	{
                	 	 bdprlog("BD1 Read      C:$BD1[CYL] H:$BD1[HEAD] S:$BD1[SEC]\n");
                	}
                	else
                	{
                	 	 bdprlog("BD0 Read      C:$BD0[CYL] H:$BD0[HEAD] S:$BD0[SEC]\n");
                	}
                    $BD0[STATE] = IEXC << 16;    # psec => memory
                }
                else
                {
                	 if($bdactiveunit)
                	 {
                	 	 prlog("BD1 sector read error\n");
                	 }
                	 else
                	 {
                	 	 prlog("BD0 sector read error\n");
                	 }                	 
                    $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0800 | $bdactiveunit; 
                    $BD0[STATE] = $BD0[STATE] | (WREQ << 16);                    
                }
            }
            else
            {
            	  if($bdactiveunit)
            	  {
            	  	  prlog("BD1 track read error\n");
            	  }
            	  else
            	  {
            	  	  prlog("BD0 track read error\n");
            	  }            	  
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0800 | $bdactiveunit; 
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            }
            activate_event(\@BD0,$BD0[STIME]);
        }
        elsif(($cmd & 3) == 0x3)
        {
            # read verify
            prlog("Bigdisk read verify not implemented\n");
        }
        elsif(($cmd & 3) == 0x2)
        {
            # write home address
            my $i=0;
            my $offset=0x83; # 1st record in track starts at word /83
            my $head = $cmdword & 0x001F;
            my $lastsector = ($cmdword >> 5) & 0x003F;
            my $error = 0;
            $cw1 = $M[$cmdaddr] & 0x3FFF;        # sector length (words)
            $cmdaddr = $cmdaddr + 2;
            bdprlog("BD Rcw1: " . prhex(16,$cmdaddr) . prhex(16,$cw1) . " (sector length (14bit) $cw1)\n");
            if($bdactiveunit)
            {
                $cyl = $BD1[CYL];
            }
            else
            {
                $cyl = $BD0[CYL];
            }
            # read the track to format from the active unit
            # the trackindex is reset by the read action
            # the tracklength is 0x2800 words
            if(rdtrack(UNDEF, $head))
            {
                # refill the trackbuffer
                # reset the track index
                if($bdactiveunit)
                {
                   	$bd1trackindex = 0;
                   	bdprlog("BD1 Write HA  C:$BD1[CYL] H:$BD1[HEAD]\n");
                }
                else
                {
                   	$bd0trackindex = 0;
                   	bdprlog("BD0 Write HA  C:$BD0[CYL] H:$BD0[HEAD]\n");
                }
                # header
                wrwtrk($cyl);   # word0 = cylinder number
                wrwtrk(0);      # word1 = /0000
                wrwtrk(0x26CA); # word2 = length of the userspace in the track, in words
                # track admin (64 * 2 words)
                while(($i <= $lastsector) && ($i < 64))
                {
                    if(($offset + $cw1) <= (0x83 + 0x26CA))
                    {
                        wrwtrk($offset); # sector offset
                        wrwtrk($cw1);    # sector length (words)
                        $offset = $offset + $cw1;
                        $i = $i + 1;
                    }
                    else
                    {
                        # track overflow
                        $error = 1;
                        last;
                    }
                }
                # remaining track admin words must be reset to 0
                while($i < 64)
                {
                    wrwtrk(0); # sector offset
                    wrwtrk(0); # sector length (words)
                    $i = $i + 1;
                }
                # userspace: fill with 0 words
                $i = 0;
                while($i < 0x26CA)
                {
                    wrwtrk(0);
                    $i=$i+1;
                }
                # trackbuffer complete
                if($error)
                {
                    # incorrect length
                    $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0008 | $bdactiveunit;   
                    $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
                }
                else
                {
                    # track completed
                    # reload the track admin
                    if($bdactiveunit)
                    {
                        $bd1trackindex = 6;
                        $i=0;
                        # reload sector info
                        while($i<64)
                        {
                            $bd1sectoroffset[$i] = rdwtrk();
                            $bd1sectorlength[$i] = rdwtrk();
                            $i=$i+1;
                        }
                    }
                    else
                    {
                        $bd0trackindex = 6;
                        $i=0;
                        # reload sector info
                        while($i<64)
                        {
                            $bd0sectoroffset[$i] = rdwtrk();
                            $bd0sectorlength[$i] = rdwtrk();
                            $i=$i+1;
                        }
                    }
                    $BD0[STATE] = OEXE << 16;   # trackbuffer => disk
                }
            }
            else
            {
            	if($bdactiveunit)
            	{
            	  prlog("BD1 track i/o error\n");
            	}
            	else
            	{
            	  prlog("BD0 track i/o error\n");
            	}
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0800 | $bdactiveunit; 
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            }
            activate_event(\@BD0,$BD0[STIME]);
        }
        else
        {
            prlog("Bigdisk CmdError, Unit: $bdactiveunit Cmd/Adr:" . prhex(16,$cmdword) . prehex(16,$cmdaddr) . "\n");
            $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0800 | $bdactiveunit; 
            $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            activate_event(\@BD0,$BD0[STIME]);
        }
    }
    elsif($stat == OEXC)
    {
        # memory => psec buffer : the dma channel (output)
        # Writes a single psec to disk; the psec may consist of multiple
        # memory blocks (data chaining)
        # Only one unit is active during a CIO-start ... SST sequence
        #bdprlog("BD OEXC XLEN:$BD0[XLEN] SLEN:$BD0[SLEN] txl:$txlength PSL:$BD0[PSL]\n");
        if($BD0[XLEN] < $BD0[SLEN] && $txlength < $BD0[PSL])
        {
            $w = $M[$memaddr];
            $memaddr = $memaddr + 2;
            $BD0[XLEN] = $BD0[XLEN] + 1;      # length transferred of this block
            $txlength = $txlength   + 1;      # total length transferrred sofar
            wrwtrk($w);                       # put word in trackbuffer
        }
        elsif($txlength == $BD0[PSL])
        {
            # physical sector transferred to trackbuffer
            if($txlength == $cw1)
            {
                # ok!
                # Write track to disk
                $BD0[STATE] = OEXE << 16;       # psec => disk
                bdprlog("BD Write; transfer to trackbuffer ready: => state OEXE\n");
            }
            else
            {
                # incorrect length
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0008 | $bdactiveunit;   
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            }
        }
        elsif($BD0[XLEN] == $BD0[SLEN])
        {
            if($txlength == $cw1)
            {
                # ok: total requested length transferred to trackbuffer
                # Write track to disk
                $BD0[STATE] = OEXE << 16;       # psec => disk
                bdprlog("BD Write; transfer to trackbuffer ready: => state OEXE\n");
            }
            elsif($dc)  # block transferred to trackbuffer; data chaining ?
            {
                # yes, data chaining; get next control words
                bdprlog("BD Write Datachain\n");
                $cw2 = $M[$cmdaddr];        # Block length (words) ++
                $nt = 0;
                $dc = $cw2 & 0x4000;        # Data chain bit
                $BD0[SLEN] = $cw2 & 0xFFF;  # Block length (of the this block)
                bdprlog("BD DCRcw2: " . prhex(16,$cmdaddr) . prhex(16,$cw2) . "(length this block (12bit) $BD0[SLEN])\n");
                $cmdaddr = $cmdaddr + 2;
                $cw3 = $M[$cmdaddr];        # Block start address in memory
                bdprlog("BD DCRcw3: " . prhex(16,$cmdaddr) . prhex(16,$cw3) . "\n");
                $cmdaddr = $cmdaddr + 2;
                $memaddr = ((($cw2 & 0x3000) << 4) | $cw3) & 0x3FFFE; # 18 bit address
                bdprlog("BD block address (DRcw3+): " . prhex(20,$memaddr) . "\n");
                $BD0[XLEN] = 0;             # transferred length of this block
                $BD0[STATE] = $BD0[STATE] & 0xFFFF;       # reset cu state bits
                $BD0[STATE] = $BD0[STATE] | (OEXC << 16); # proceed
            }
            else
            {
                # incorrect length
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0008 | $bdactiveunit;
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            }
        }
        activate_event(\@BD0,$BD0[TIME]);
    }
    elsif($stat == IEXC)
    {
        # psec buffer => memory : the dma channel (input)
        # $BD0[BUFFER] is shared for sectors of BD0 and BD1
        # Only one unit is active during a CIO-start ... SST sequence
        $w=(unpack("C", substr($BD0[BUFFER],($txlength*2),1))) << 8;
        $w=$w | (unpack("C", substr($BD0[BUFFER],($txlength*2)+1,1)));
        if(! $nt)
        {
            # nt bit not set
            $M[$memaddr] = $w;            # transfer to memory
        }
        $memaddr = $memaddr + 2;
        $BD0[XLEN] = $BD0[XLEN] + 1;      # length transferred of this block
        $txlength = $txlength   + 1;      # total length transferrred sofar

        if($txlength == $BD0[PSL])
        {
            # physical sector transferred to memory
            if($txlength == $cw1)
            {
                # ok!
                # command chaining ?
                $BD0[STATE] = $BD0[STATE] & 0xFFFF;      # reset cu state bits
                if($ic)
                {
                    # no => set interrupt
                    $BD0[STATE] = $BD0[STATE] | $bdactiveunit | (WREQ << 16)
                }
                else
                {
                    # yes, command chain
                    bdprlog("BD Command Chain\n");
                    $BD0[STATE] = $BD0[STATE] | (CEXE << 16);
                }
            }
            else
            {
                # incorrect length
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0008 | $bdactiveunit;
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            }
        }
        elsif($BD0[XLEN] == $BD0[SLEN])
        {
            if($txlength == $cw1)
            {
                # ok: total requested length transferred to memory
                # command chaining ?
                $BD0[STATE] = $BD0[STATE] & 0xFFFF;      # reset cu state bits
                if($ic)
                {
                    # no => set interrupt
                    $BD0[STATE] = $BD0[STATE] | $bdactiveunit | (WREQ << 16)
                }
                else
                {
                    # command chain
                    bdprlog("BD Command Chain\n");
                    $BD0[STATE] = $BD0[STATE] | (CEXE << 16);
                }
            }
            elsif($dc)  # block transferred to memory; data chaining ?
            {
                # yes, data chaining; get next control words
                bdprlog("BD Read Datachain\n");
                $cw2 = $M[$cmdaddr];        # Block length (words) ++
                $nt = $cw2 & 0x8000;        # No transfer bit
                $dc = $cw2 & 0x4000;        # Data chain bit
                $BD0[SLEN] = $cw2 & 0xFFF;  # Block length (of the this block)
                bdprlog("BD DCRcw2: " . prhex(16,$cmdaddr) . prhex(16,$cw2) . "(length this block (12bit) $BD0[SLEN])\n");
                $cmdaddr = $cmdaddr + 2;
                $cw3 = $M[$cmdaddr];        # Block start address in memory
                bdprlog("BD DCRcw3: " . prhex(16,$cmdaddr) . prhex(16,$cw3) . "\n");
                $cmdaddr = $cmdaddr + 2;
                $memaddr = ((($cw2 & 0x3000) << 4) | $cw3) & 0x3FFFE; # 18 bit address
                bdprlog("BD block address (DRcw3+): " . prhex(20,$memaddr) . "\n");
                $BD0[XLEN] = 0;             # transferred length of this block
                $BD0[STATE] = $BD0[STATE] & 0xFFFF;       # reset cu state bits
                $BD0[STATE] = $BD0[STATE] | (IEXC << 16); # proceed
            }
            else
            {
                # incorrect length
                $BD0[STATE] = ($BD0[STATE] & 0xFFFF) | 0x0008 | $bdactiveunit;
                $BD0[STATE] = $BD0[STATE] | (WREQ << 16);
            }
        }
        activate_event(\@BD0,$BD0[TIME]);
    }
    elsif($stat == OEXE)
    {
        # transfer the trackbuffer of the active unit to disk
        bdprlog("BD OEXE: $bdactiveunit\n");
        if($bdactiveunit)
        {
            $bd1trackdirty = 1;
            bdprlog("BD1 write: set track dirty\n");
            bdprlog("BD1 write: written sector $BD1[SEC] in trackbuffer\n");

            if(DEBUG_BD && ($cmd != 0x2))
            {
            	# in case of a write command
            	$BD0[BUFFER]= substr($bd1trackbufffer,$bd1sectoroffset[$BD1[SEC]]*2 ,$bd1sectorlength[$BD1[SEC]]*2);
            	prpsec();
            }
        }
        else
        {
            $bd0trackdirty = 1;
            bdprlog("BD0 write: set track dirty\n");
            bdprlog("BD0 write: written sector $BD0[SEC] in trackbuffer\n");

            if(DEBUG_BD && ($cmd != 0x2))
            {
            	# in case of a write command
            	$BD0[BUFFER]= substr($bd0trackbufffer,$bd0sectoroffset[$BD0[SEC]]*2 ,$bd0sectorlength[$BD0[SEC]]*2);
            	prpsec();
            }
        }

        # command chaining ?
        $BD0[STATE] = $BD0[STATE] & 0xFFFF;      # reset cu state bits
        if($ic)
        {
           # no => set interrupt
           bdprlog("BD write: Wait Request\n");
           $BD0[STATE] = $BD0[STATE] | $bdactiveunit | (WREQ << 16)
        }
        else
        {
           # command chain
           bdprlog("BD write: Command Chain\n");
           $BD0[STATE] = $BD0[STATE] | (CEXE << 16);
        }
        activate_event(\@BD0,$BD0[STIME]);
    }
    elsif($stat == WREQ)
    {
        # stop io requested
        $BD0[STATE] = $BD0[STATE] & 0xFFFF;               # reset cu state bits
        $BD0[STATE] = $BD0[STATE] | (WAIT << 16);         # cu state = wait
        $intreg1 = $intreg1 | IBD0;                       # set the ready flipflop
    }
    else
    {
        prlog("Bigdisk program error\n");
    }

}

sub sst_bd0 {
	if( ($BD0[STATE] >> 16) == WAIT)
	{
		# cu in wait state
		$BD0[STATE] = $BD0[STATE] & 0xFFFF;           # cu = inactive
		$R[$r3] = $BD0[STATE];                        # r3 = status
		$intreg1 = $intreg1 & (~ IBD0);               # reset the ready flipflop
		$CR = 0;
		BdSoff();
      bdprlog("BD Command end: accepted sst, status:" . prhex(16,$R[$r3]) . "\n");
	}
	else
	{
		$CR = 1;                                  # sst no accepted
	}
}

sub tst_bd0 {
	if( ($BD0[STATE] >> 16) )
	{
		$R[$r3] = 1;                              # CU busy, if not in inactive state
	}
	else
	{
		$R[$r3] = ($txlength & 0x3FFF) << 1;
	}
	$CR=0;
}


# Read track from the current (if $cyl == UNDEF), or requested cylinder and 
# load the track administration.
# In case the trackbufer to which the track must be read is dirty, then first the
# trackbuffer is written to disk.
# Assumes active drive and current cylinder set in the device control block.
# returns 1 if OK, 0 in case of error
sub rdtrack
{
    my $cyl  = shift;
    my $head = shift;
    my $pos;
    my $i;
    if($bdactiveunit == 0x0040)
    {
        # unit 1
        bdprlog("BD1 Readtrack: C $cyl, H $head: $bdactiveunitname (current: C:$BD1[CYL] H:$BD1[HEAD])\n");
        # check whether track is already loaded in trackbuffer
        if($cyl == UNDEF)
        {
            #the current cylinder is assumed
            $cyl = $BD1[CYL];
        }
        if($head != UNDEF)
        {
            if($cyl == $BD1[CYL] && $head == $BD1[HEAD])
            {
                # yes, the track is in the buffer
                bdprlog("Readtrack bd1: track already loaded\n");
                return 1; # ok
            }
            else
            {
                # if the current trackbuffer is dirty, 1st write to disk
                if($bd1trackdirty)
                {
                	bdprlog("Readtrack bd1: 1st write the dirty track C:$BD1[CYL] H:$BD1[HEAD] <<<<<<<<<<<<<<<<\n");
					   bdprlog("***Write track BD1: C:$BD1[CYL] H:$BD1[HEAD]\n");
                	if($bd1rw)
                	{
                		# write trackbuffer to disk
                		$pos = (($BD1[CYL] * 5) + $BD1[HEAD]) * TRACKLENGTH;
                		if(sysseek(BD1, $pos, 0) ne undef)
                		{
                			if(syswrite(BD1, $bd1trackbufffer, TRACKLENGTH) ==  TRACKLENGTH)
                			{
                				$bd1trackdirty = 0;
                			}
                			else
                			{
                				prlog("Track write error bd1, cylinder $BD1[CYL], head $BD1[HEAD]\n");
                				return 0; # error
                			}
                		}
                		else
                		{
                			prlog("Seek error bd1, cylinder $BD1[CYL], head $BD1[HEAD]\n");
                			return 0; # error
                		}
                	}
                	else
                	{
                		prlog ("Readtrack bd1: write track not enabled for bd1\n");
                		return 0;
                	}
                }
            }
            # read requested track
            bdprlog ("Readtrack bd1: read requested track\n");
            $pos = (($cyl * 5) + $head) * TRACKLENGTH;
            $bd1trackbufffer = "";
            $bd1trackindex = 0;
            if(sysseek(BD1, $pos, 0) ne undef)
            {
                if(sysread(BD1, $bd1trackbufffer, TRACKLENGTH) ==  TRACKLENGTH)
                {
                    # Read/Load the track administration
                    if(rdwtrk() == $cyl)
                    {
                        rdwtrk(); # word1
                        rdwtrk(); # track length
                        $i=0;
                        # sector info
                        while($i<64)
                        {
                            $bd1sectoroffset[$i] = rdwtrk();
                            $bd1sectorlength[$i] = rdwtrk();
                            $i=$i+1;
                        }
                        $BD1[CYL]  = $cyl;
                        $BD1[HEAD] = $head;
                        $bd1trackdirty = 0;
                        bdprlog("Track bd1 cyl $cyl head $head is loaded now\n");
                        return 1; # ok
                    }
                    else
                    {
                        prlog("Track format error bd1, cylinder $cyl, head $head\n");
                    }
                }
                else
                {
                    prlog("Track read error bd1, cylinder $cyl, head $head\n");
                }
            }
            else
            {
                prlog("Seek error bd1, cylinder $cyl, head $head\n");
            }
        }
        $BD1[CYL]  = UNDEF;
        $BD1[HEAD] = UNDEF;
        return 0; # error
    }
    elsif($bdactiveunit == 0x0000)
    {
        # unit 0
        bdprlog("BD0 Readtrack: C $cyl, H $head: $bdactiveunitname (current: C bd0 $BD0[CYL] ** H bd0 $BD0[HEAD])\n");
        # check whether track is already loaded in trackbuffer
        if($cyl == UNDEF)
        {
            #the current cylinder is assumed
            $cyl = $BD0[CYL];
        }
        if($head != UNDEF)
        {
            if($cyl == $BD0[CYL] && $head == $BD0[HEAD])
            {
                # yes, the track is in the buffer
                bdprlog("Readtrack bd0: track already loaded\n");
                return 1; # ok
            }
            else
            {
                # if the current trackbuffer is dirty, write to disk
                if($bd0trackdirty)
                {
                	bdprlog ("Readtrack bd0: 1st write the dirty track C:$BD0[CYL] H:$BD0[HEAD] <<<<<<<<<<<<<<<<\n");
					   bdprlog("***Write track BD0: C:$BD0[CYL] H:$BD0[HEAD]\n");
                	if($bd0rw)
                	{
                		# write trackbuffer to disk
                		$pos = (($BD0[CYL] * 5) + $BD0[HEAD]) * TRACKLENGTH;
                		if(sysseek(BD0, $pos, 0) ne undef)
                		{
                			if(syswrite(BD0, $bd0trackbufffer, TRACKLENGTH) ==  TRACKLENGTH)
                			{
                				$bd0trackdirty = 0;
                			}
                			else
                			{
                				prlog("Track write error bd0, cylinder $BD0[CYL], head $BD0[HEAD]\n");
                				return 0; # error
                			}
                		}
                		else
                		{
                			prlog("Seek error bd0, cylinder $BD0[CYL], head $BD0[HEAD]\n");
                			return 0; # error
                		}                	
                	}
                	else
                	{
                		prlog ("Readtrack bd0: write track not enabled for bd0\n");
                		return 0;
                	}
                }
            }
            # read requested track
            bdprlog ("Readtrack bd0: read requested track\n");
            $pos = (($cyl * 5) + $head) * TRACKLENGTH;
            $bd0trackbufffer = "";
            $bd0trackindex = 0;
            if(sysseek(BD0, $pos, 0) ne undef)
            {
                if(sysread(BD0, $bd0trackbufffer, TRACKLENGTH) ==  TRACKLENGTH)
                {
                    # Read/Load the track administration
                    if(rdwtrk() == $cyl)
                    {
                        rdwtrk(); # word1
                        rdwtrk(); # track length
                        $i=0;
                        # sector info
                        while($i<64)
                        {
                            $bd0sectoroffset[$i] = rdwtrk();
                            $bd0sectorlength[$i] = rdwtrk();
                            $i=$i+1;
                        }
                        $BD0[CYL]  = $cyl;
                        $BD0[HEAD] = $head;
                        $bd0trackdirty = 0;  
                        bdprlog("Track bd0 cyl $cyl head $head is loaded now\n");
                        return 1; # ok
                    }
                    else
                    {
                        prlog("Track error bd0, cylinder $cyl, head $head\n");
                    }
                }
                else
                {
                    prlog("Read track error bd0, cylinder $cyl, head $head\n");
                }
            }
            else
            {
                prlog("Seek error bd0, cylinder $cyl, head $head\n");
            }
        }
        $BD0[CYL]  = UNDEF;
        $BD0[HEAD] = UNDEF;
        return 0; # error
    }
    else
    {
        prlog("ReadTrack Error: wrong disk unit $bdactiveunit selected\n");
        $BD0[CYL]  = UNDEF;
        $BD0[HEAD] = UNDEF;
        $BD1[CYL]  = UNDEF;
        $BD1[HEAD] = UNDEF;
        return 0; # error
    }
}

# get word from trackbuffer of the active unit
sub rdwtrk
{
    my $w;
    if($bdactiveunit == 0)
    {
        $w=(unpack("C", substr($bd0trackbufffer,$bd0trackindex,1))) << 8;
        $w=$w | (unpack("C", substr($bd0trackbufffer,$bd0trackindex+1,1)));
        $bd0trackindex = $bd0trackindex + 2;
    }
    else
    {
        $w=(unpack("C", substr($bd1trackbufffer,$bd1trackindex,1))) << 8;
        $w=$w | (unpack("C", substr($bd1trackbufffer,$bd1trackindex+1,1)));
        $bd1trackindex = $bd1trackindex + 2;
    }
    return $w;
}

# put word in the trackbuffer of the active unit
sub wrwtrk
{
    my $w=shift;
    my $c="";
    $c = pack("C", (($w >> 8) & 0xFF));
    $c = $c . pack("C", ($w & 0xFF));   # word
    if($bdactiveunit == 0)
    {
        substr($bd0trackbufffer,$bd0trackindex,2,$c);
        $bd0trackindex=$bd0trackindex + 2;
    }
    else
    {
        substr($bd1trackbufffer,$bd1trackindex,2,$c);
        $bd1trackindex=$bd1trackindex + 2;
    }
}

# read a (physical) sector from a track of BD0 or BD1 in the sector buffer
# the sector is extracted from the current track buffer of BD0 or BD1.
# returns 1 if OK, 0 in case of error
sub rdpsec
{
    my $psn;
    $psn = shift; # physical sector number in track
    bdprlog("Read Psec $psn from current track (unit $bdactiveunit)\n");
    # record offset end length in the record admin are in words!
    if($bdactiveunit == 0)
    {
        bdprlog("BD0 Psec $psn : offset $bd0sectoroffset[$psn] length $bd0sectorlength[$psn]\n");
        if(($bd0sectoroffset[$psn] !=0 && $bd0sectorlength[$psn] !=0) && $psn < 64)
        {
            $BD0[BUFFER] = substr($bd0trackbufffer,($bd0sectoroffset[$psn]*2),($bd0sectorlength[$psn]*2));
            $BD0[PSL]    = $bd0sectorlength[$psn]; # sector length (words)
            $BD0[SEC]    = $psn;
            return 1;
        }
    }
    if($bdactiveunit == 0x0040)
    {
        bdprlog("BD1 Psec $psn : offset $bd0sectoroffset[$psn] length $bd0sectorlength[$psn]\n");
        if(($bd1sectoroffset[$psn] !=0 && $bd1sectorlength[$psn] !=0) && $psn < 64)
        {
            $BD0[BUFFER] = substr($bd1trackbufffer,($bd1sectoroffset[$psn]*2),($bd1sectorlength[$psn]*2));
            $BD0[PSL]    = $bd1sectorlength[$psn]; # sector length (words)
            $BD1[SEC]    = $psn;  
            return 1;
        }
    }
    $BD0[BUFFER] = "";
    $BD0[PSL] = 0;
    return 0; # error return
}


#============================================================================
my $secindex; # character index in sector buffer
# added for debugging
# print the physical sector as loaded in the sector buffer ($BD0[BUFFER])
sub prpsec
{
    my $lw = $BD0[PSL];       # sector length in words
    my $lb = $lw*2;           # sector length in bytes
    $secindex = 0;
    my $i = 0;
    my $str="";
    my $w;
    my $c;
    prlog("Physical sector length: $lb bytes ($lw words)\n");
    while($secindex<$lb)
    {
        $i=0;
        $str="";
        prlog(prdec(4,$secindex) . "  ");
        while($i<8 && $secindex<$lb)
        {
         	$w=rrw1();
         	prlog(prhex(16,$w));
         	$c=$ch{($w >> 8) & 0xFF};
		      if($c ne undef)
		      {
			      $str = $str . $c;
		      }
		      else
		      {
			      $str = $str . ".";
		      }
		      $c=$ch{$w & 0xFF};
		      if($c ne undef)
		      {
			      $str = $str . $c;
		      }
		      else
		      {
			      $str = $str . ".";
		      }
		      $i=$i+1;
        }
        prlog("  " . $str . "\n");
    }
    $secindex=0;
}

# get byte from sectorbuffer 
sub rrb1
{
    $secindex=$secindex+1;
    return (unpack("C", substr($BD0[BUFFER],$secindex-1,1)));
}

# get word from sectorbuffer
sub rrw1
{
	my $w;
	$w=rrb1() << 8;
	$w=$w | rrb1();
	return $w;
}

#=======================================================================
sub BdCheck{
    my $pos;
    # writes track if track has its dirty flag on
    if($bd0trackdirty)
    {
    	if($bd0rw) # write enabled?
    	{
    		$pos = (($BD0[CYL] * 5) + $BD0[HEAD]) * TRACKLENGTH;
    		if(sysseek(BD0, $pos, 0) ne undef)
    		{
    			if(syswrite(BD0, $bd0trackbufffer, TRACKLENGTH) ==  TRACKLENGTH)
    			{
    				$bd0trackdirty = 0;
    				bdprlog("BdCheck, BD0 dirty track C:$BD0[CYL] H:$BD0[HEAD] written to disk\n");
    			}
    			else
    			{
    				prlog("BdCheck, Track write error bd0, cylinder $BD0[CYL], head $BD0[HEAD]\n");
    				return 0; # error
    			}
    		}
    		else
    		{
    			prlog("BdCheck, Seek error bd0, cylinder $BD0[CYL], head $BD0[HEAD]\n");
    			return 0; # error
    		}    		
    	}
    	else
    	{
    		prlog ("BdCheck: write track not enabled for bd0\n");
    		return 0; # error
    	}
    }
    if($bd1trackdirty)
    {
    	if($bd1rw) # write enabled?
    	{
    		$pos = (($BD1[CYL] * 5) + $BD1[HEAD]) * TRACKLENGTH;
    		if(sysseek(BD1, $pos, 0) ne undef)
    		{
    			if(syswrite(BD1, $bd1trackbufffer, TRACKLENGTH) ==  TRACKLENGTH)
    			{
    				$bd1trackdirty = 0;
    				bdprlog("BdCheck, BD1 dirty track C:$BD1[CYL] H:$BD1[HEAD] written to disk\n");
    			}
    			else
    			{
    				prlog("BdCheck, Track write error bd1, cylinder $BD1[CYL], head $BD1[HEAD]\n");
    				return 0; # error
    			}
    		}
    		else
    		{
    			prlog("BdCheck, Seek error bd1, cylinder $BD1[CYL], head $BD1[HEAD]\n");
    			return 0; # error
    		}
    	}
    	else
    	{
    		prlog ("BdCheck: write track not enabled for bd1\n");
    		return 0; # error
    	}    	
    }
}

sub Bd0Init{
    $bdactiveunit = 0x0000;
    if(rdtrack(0,0))
    {
        prlog("BD0 is initialized\n");
        return 1;
    }
    prlog("BD0 Error: disc could not be initialized\n");
    return 0;
}

sub Bd1Init{
    $bdactiveunit = 0x0040;
    if(rdtrack(0,0))
    {
        prlog("BD1 is initialized\n");
        return 1;
    }
    prlog("BD1 Error: disc could not be initialized\n");
    return 0;    
}



sub state_bd0 {
    my $str;
    prlog("CU" . prhex(20,$BD0[STATE]) . " CR" . prhex(4,$CR) . " SECTOR-LENGTH" . prhex(16,$BD0[SLEN]) . " TRL" . prhex(16,$BD0[XLEN]) . "\n");
    prlog("(Last) selected drive(dn): $bdactiveunit\n");
    prlog("           Unit-0  Unit-1 \n");
    if($BD0[CYL] == UNDEF)  { $str = "   -   " } else {$str = prdec(4,$BD0[CYL])};
    if($BD1[CYL] == UNDEF)  { $str = $str . "    -   " } else {$str = $str . prdec(4,$BD1[CYL])};
    prlog(" Cylinder " . $str . "\n");
    if($BD0[HEAD] == UNDEF) { $str = "   -   " } else {$str = prdec(4,$BD0[HEAD])};
    if($BD1[HEAD] == UNDEF) { $str = $str . "    -   " } else {$str = $str . prdec(4,$BD1[HEAD])};
    prlog(" Head     " . $str . "\n");
    if($BD0[SEC] == UNDEF)  { $str = "   -   " } else {$str = prdec(4,$BD0[SEC])};
    if($BD1[SEC] == UNDEF)  { $str = $str . "     -   " } else {$str = $str . prdec(4,$BD1[SEC])};    
    prlog(" Psec     " . $str . "\n\n");
    if($BD0[FILE] ne "")
	{
		prlog("Device BD0 (a=0x16 u=0) is attached to file: $BD0[FILE]\n");
	}
	else
	{
		prlog("Device BD0 (a=0x16 u=0) is not attached to a file\n");
	}
    if($BD1[FILE] ne "")
	{
		prlog("Device BD1 (a=0x36 u=1) is attached to file: $BD1[FILE]\n");
	}
	else
	{
		prlog("Device BD1 (a=0x36 u=1) is not attached to a file\n");
	}
    if($BD0[RDY])
	{
		prlog("Bigdisk unit-0 is ready (dirty=$bd0trackdirty rwenb=$bd0rw)\n");
	}
	else
	{
		prlog("Bigdisk unit-0 is NOT ready (dirty=$bd0trackdirty rwenb=$bd0rw)\n");
	}
    if($BD1[RDY])
	{
		prlog("Bigdisk unit-1 is ready (dirty=$bd1trackdirty rwenb=$bd1rw)\n");
	}
	else
	{
		prlog("Bigdisk unit-1 is NOT ready (dirty=$bd1trackdirty rwenb=$bd1rw)\n");
	}	
}

sub reset_bd0 {
    BdCheck();
    $intreg1 = $intreg1 & (~ IBD0);                   # reset the ready flipflop
    $BD0[STATE]  = INAC << 16;                        # state = inactive + 0
    $BD0[BUFFER] = "";                                # reset sector buffer
    $BD0[SLEN]   = UNDEF;                             # reset sector length
    $BD0[XLEN]   = UNDEF;                             # reset transferred sector length
    $BD0[SEC]    = UNDEF;                             # reset physical sector number
    $BD1[SEC]    = UNDEF;                             # reset physical sector number
    $BD0[CYL]    = UNDEF;                             # reset cylinder
    $BD1[CYL]    = UNDEF;                             # reset cylinder
    $BD0[HEAD]   = UNDEF;
    $BD1[HEAD]   = UNDEF;
    $bdactiveunit    = UNDEF;
    $bd0trackbufffer = "";
    $bd0trackindex   = 0;
    $bd0trackdirty   = 0;
    $bd1trackbufffer = "";
    $bd1trackindex   = 0;
    $bd1trackdirty   = 0;
    # if attached, reattach (set file at load point)
    BdSoff();
	 if($BD0[FILE] ne "")
	 {
	    $file = $BD0[FILE];
	    close (BD0) || die "can't close $file: $!";
	    open (BD0, "+<:raw", $file) || die "Cannot open  disk file $file: $!";
	    prlog("File $file reattached to device BD0\n");
	 }
	 $BD0[RDY]=0;
	 if($BD1[FILE] ne "")
	 {
	    $file = $BD1[FILE];
	    close (BD1) || die "can't close $file: $!";
	    open (BD1, "+<:raw", $file) || die "Cannot open  disk file $file: $!";
	    prlog("File $file reattached to device BD1\n");
	 }
	 $BD1[RDY]=0;
	 if($BD0[FILE] ne "")
	 {
        if(Bd0Init())
        {
            $BD0[RDY]=1;
            $BD0[STATE] = INAC << 16;
            prlog("Bigdisk disk unit-0 is ready\n");
        }
	 }
	 if($BD1[FILE] ne "")
	 {
        if(Bd1Init())
        {
            $BD1[RDY]=1;
            $BD0[STATE] = INAC << 16;
            prlog("Bigdisk disk unit-1 is ready\n");
        }
	 }
	 if($BD0[RDY]==0)
	 {
	    prlog("Bigdisk unit-0 is NOT ready\n");
	 }
	 if($BD1[RDY]==0)
	 {
	    prlog("Bigdisk unit-1 is NOT ready\n");
	 }
}
#end cdc80mbdisk.md ===============================================================

###insert x12disk.md 4 * 2.5mb/5mb moving head disk support
### x12disk.md
####################### X1215/16 Moving Head Disk routines ############################
# The control unit is wired to an IOP subchannel; so only an interrupt when the
# cu switches to wait state. Data is transferred to/from memory from/to the internal 
# disk control unit buffer by the IOP/controlunit by means of breaks
# The controlunit supports 2 disk units, each unit with 2 disks so 4 disks/drives in total.
# The control unit is connected to IOP subchannel 2.
# 
# The addressing of a particular disk/drive is as follows:
#                                                    DA = 00 0 010
#                                                         ^^
#                                                         ||Unit Number 0,1
#                                                         |Drive Number 0,1
# Drive number 0 is the cartridge and drive number 1 is the fixed disk.
# Because the 4 drives share a singe control unit, only 1 drive can be active
# at a particular moment.
# The implementation supports two unit2: 
# unit 0; 2 drives. Drive 0 has address /02 and drive 1 has address /22.
# unit 1; 2 drives. Drive 0 has address /12 and drive 1 has address /32.

# unit 0
sub cio_md0 {
	my $f  = shift;
	my $dn = 0;     # drive/unit number (address /2)
	cio_md($f,$dn);
}

sub cio_md1 {
	my $f  = shift;
	my $dn = 2;     # drive/unit number	(address /22)
	cio_md($f,$dn);
}

# unit 1
sub cio_md2 {
	my $f  = shift;
	my $dn = 1;     # drive/unit number (address /12)
	cio_md($f,$dn);
}

sub cio_md3 {
	my $f  = shift;
	my $dn = 3;     # drive/unit number	(address /32)
	cio_md($f,$dn);
}

# common CIO processor
sub cio_md {
	my $f  = shift;
	my $dn = shift;
	my $stat = $MD0[STATE] >> 16;   # get status: cu state
	my $r;
	my $d;
	my $c;
	my $p;
	
	if($f == 0)
	{	
	  	# CIO STOP, always accepted
		if(($stat == IEXE) || ($stat == IEXC) || ($stat == OEXC)|| ($stat == OEXC))
		{
			$MD0[STATE] = $MD0[STATE] | (WREQ << 16);     # state = wait state requested
		}
	}
	elsif($stat == INAC)
	{
		# CIO START, accepted if state == inactive
		XdSon();
		$MD0[STATE] = 0;                                 # reset state
		$md0buf     = "";                                # reset buffer
		$MD0[XLEN]  = 0;                                 # mpx transferred length in bytes
		$r = $R[$r3] & 0x3;                              # requested operation
		if($r == 0)
		{
			# read a physical sector, CIO START INPUT
			$MD0[SEC]  = ($R[$r3] >> 2) & 0x1F;           # physical sector to read: 0..31
			$MD0[STATE] = $dn << 6;                       # set disc/unit number
			$MD0[STATE] = $MD0[STATE] | (IEXE << 16);     # state = input + execute
			activate_event(\@MD0,$MD0[RWTIME]);           # schedule event to start mpx transfer
		}
		elsif($r == 1)
		{
			#  write a physical sector, CIO START OUTPUT
			$MD0[SEC]  = ($R[$r3] >> 2) & 0x1F;           # physical sector to write: 0..31
			$MD0[STATE] = $dn << 6;                       # set disc/unit number
			$MD0[STATE] = $MD0[STATE] | (OEXC << 16);     # state = output + exchange
		  	activate_event(\@MD0,$MD0[RWTIME]);           # schedule event to start mpx transfer
		}
		elsif($r == 2)
		{
			# move heads of a unit to another cylinder (SEEK)
			
			# On the P856 the seek is slightly different from the P855/P860 seek
			# On the P855/P860 the delta number of cylinders to move with a direction is
			# specified. On the P856 just the cylinder to move to is specified in $R[$r3].
			#
			$MD0[STATE] = ($dn & 1) << 6;                 # set unit number in the status
			$MD0[STATE] = $MD0[STATE] | (WREQ << 16);     # cu state = wait request
			$c=$R[$r3] >> 3;                              # cylinder to move to
			$p = $c * SPT * NH * LSEC * 2;                # new position in chars
			if( ($dn == 0 || $dn == 2) && $MD0[RDY])
			{
				# unit 0 ($MD0[CYL] has the current unit cylinder)
				if(sysseek(MD0, $p, 0) ne undef)      # position heads to requested cylinder
				{
					$d=abs($c-$MD0[CYL]); # number of cylinders to move
					$MD0[CYL] = $c;
					$MD0[STATE] = $MD0[STATE] | DONCYL;
					# schedule event for moving $d cylinders
					activate_event(\@MD0,($d * $MD0[TRTIME] + $MD0[RWTIME])); # time > 0 ! 
				}
				else
				{
					# seek error
					$MD0[STATE] = $MD0[STATE] | DSEEKERR | DONCYL;
					activate_event(\@MD0,$MD0[RWTIME]);     # schedule event
				}
			}
			elsif(($dn == 1 || $dn == 3) && $MD2[RDY])
			{
				# unit 1 drive 0 ($MD2[CYL] has the current unit cylinder)
				if(sysseek(MD2, $p, 0) ne undef)           # position heads to requested cylinder
				{
					$d=abs($c-$MD2[CYL]);                   # number of cylinders to move
					$MD2[CYL] = $c;
					$MD0[STATE] = $MD0[STATE] | DONCYL;
					# schedule event for moving $d cylinders
					activate_event(\@MD0,($d * $MD0[TRTIME] + $MD0[RWTIME])); # time > 0 ! 
				}
				else
				{
					# seek error
					$MD0[STATE] = $MD0[STATE] | DSEEKERR | DONCYL;
					activate_event(\@MD0,$MD0[RWTIME]);     # schedule event
				}
			}
			else
			{
				# not attached, so not operable
				$MD0[STATE] = $MD0[STATE] | DSEEKERR| DONCYL | DNOTOP;  # set not operable error bit in state
			  	activate_event(\@MD0,$MD0[RWTIME]);        # schedule event
			}
		}
		else
		{
			# seek unit to cylinder 0
			$MD0[STATE] = ($dn & 1) << 6;                 # set unit number
			$MD0[STATE] = $MD0[STATE] | (WREQ << 16);     # cu state = wait request
				
			if( ($dn == 0 || $dn == 2) && $MD0[RDY])
			{
				# unit 0 ($MD0[CYL] haS the current unit cylinder)
				if(sysseek(MD0, 0, 0) ne undef)            # position heads to cylinder 0
				{
					$d = $MD0[CYL];
					$MD0[CYL] = 0;
					$MD0[STATE] = $MD0[STATE] | DONCYL;
					# schedule event for moving to cylinder 0
					activate_event(\@MD0,($d * $MD0[TRTIME] + $MD0[RWTIME]));  # time > 0 ! 
				}
				else
				{
					# seek error
					$MD0[STATE] = $MD0[STATE] | DSEEKERR | DONCYL;
					activate_event(\@MD0,$MD0[RWTIME]);     # schedule event
				}
			}
			elsif( ($dn == 1 || $dn == 3) && $MD2[RDY])
			{
				# unit 1 ($MD2[CYL] has the current unit cylinder)
				if(sysseek(MD2, 0, 0) ne undef)            # position heads to cylinder 0
				{
					$d = $MD2[CYL];
					$MD2[CYL] = 0;
					$MD0[STATE] = $MD0[STATE] | DONCYL;
					# schedule event for moving to cylinder 0
					activate_event(\@MD0,($d * $MD0[TRTIME] + $MD0[RWTIME]));  # time > 0 ! 
				}
				else
				{
					# seek error
					$MD0[STATE] = $MD0[STATE] | DSEEKERR | DONCYL;
					activate_event(\@MD0,$MD0[RWTIME]);     # schedule event
				}
			}
			else
			{
				# not attached, so not operable
				$MD0[STATE] = $MD0[STATE] | DSEEKERR| DONCYL | DNOTOP;  # set not operable error bit in state
			  	activate_event(\@MD0,$MD0[RWTIME]);        # schedule event
			}
		}
		$MD0[DN] = $dn; # save active drive/unit number
		$CR = 0;
	}
	else
	{
		$CR = 1;                                         # CIO not accepted 
	}
}

sub svc_md0 {
	my $stat = $MD0[STATE] >> 16;
	my $dn   = $MD0[DN];                                # number of active device
	my $pos;                                            # sector position in cylinder
	my $cyl;                                            # current cylider
	if(($dn == 0) || $dn == 2)
	{
		$cyl=$MD0[CYL];                                  # set current cylinder (unit 0)
	}
	else
	{
		$cyl=$MD2[CYL];                                  # set current cylinder (unit 1)
	}

	if($stat & WREQ)
	{
		# stop io requested (CIO STOP or end of SEEK)
		$MD0[STATE] = $MD0[STATE] & 0xFFFF;              # reset cu state bits
		$MD0[STATE] = $MD0[STATE] | (WAIT << 16);        # cu state = wait
		$intreg0 = $intreg0 | IMD0;                      # set the ready flipflop
	}
	elsif( $stat == IEXE )                              # input + execute
	{
		$MD0[STATE]  = $MD0[STATE] & 0xFFFF;             # reset cu state bits
		if(($dn == 0 && $MD0[RDY]) || ($dn == 2 && $MD0[RDY]) || 
		   ($dn == 1 && $MD2[RDY]) || ($dn == 3 && $MD2[RDY]))
		{
			# read requested physical sector into the device buffer
			$pos = (($cyl * SPT * NH) + $MD0[SEC]) * LSEC * 2;  # sector position in cylinder
			if($dn==0)
			{
				sysseek(MD0,$pos,0);                       # position and
				$stat = sysread(MD0, $md0buf, LSEC*2);     # read sector
			}
			elsif($dn==2)
			{
				sysseek(MD1,$pos,0);                       # position
				$stat = sysread(MD1, $md0buf, LSEC*2);     # read sector
			}
			elsif($dn==1)
			{
				sysseek(MD2,$pos,0);                       # position and
				$stat = sysread(MD2, $md0buf, LSEC*2);     # read sector
			}
			elsif($dn==3)
			{
				sysseek(MD3,$pos,0);                       # position
				$stat = sysread(MD3, $md0buf, LSEC*2);     # read sector
			}
			
			# check sector identifier as an integrity check. The real 
			# disk has the cylinder number as identifier in the 1st word of the sector.
			# cylinder: on the X1210/1215 cyl number fits in 8 bit.
			# on the X1216 in 10 bit
			my $c = unpack("C",substr($md0buf,0,1)) << 8;  
			my $c = $c | unpack("C",substr($md0buf,1,1));
			
			if(($stat == LSEC*2) && ($c == $cyl))            # check length an cylinder
			{
				# internal buffer ok and ready for mpx transfer
				$MD0[BUFFER] = 0;                             # reset word buffer
				$MD0[STATE]  = ($MD0[STATE] | (IEXC << 16));  # state = input + exchange
				# wait for INR
				activate_event(\@MD0, $MD0[TIME]);            # schedule event for mpx transfer
			}
			else
			{
				#error
				$MD0[STATE] = $MD0[STATE] | (WAIT << 16);     # cu state = wait
				if($stat != LSEC*2)
				{
					# incorrect length
					$MD0[STATE] = $MD0[STATE] | DLENGERR;      # set error bit in state
				}
				else
				{
					# sector identifier error
					$MD0[STATE] = $MD0[STATE] | DDATAERR;      # set error bit in state
				}
				$intreg0 = $intreg0 | IMD0;                   # set the ready flipflop
			}
		}
		else
		{
			# active disk not operable
			$MD0[STATE] = $MD0[STATE] | DNOTOP;              # set not operable error bit in state
			$MD0[STATE] = $MD0[STATE] | (WAIT << 16);        # cu state = wait
		   $intreg0 = $intreg0 | IMD0;                      # set the ready flipflop
		}
	}
	elsif( $stat == IEXC )                                 # input + exchange
	{
		# move internal device buffer via mpx into memory buffer
		if($MD0[BUFFER] == 0)
		{
			$brkreg = $brkreg | BMD0;                        # set an mpx break request
			activate_event(\@MD0,$MD0[TIME]);                # schedule next mpx event
		}
		else
		{
			# throughput error (INR/break did not process)
			$MD0[STATE] = $MD0[STATE] & 0xFFFF;              # reset cu state bits
			$MD0[STATE] = $MD0[STATE] | (WAIT << 16);        # cu state = wait
			$MD0[STATE] = $MD0[STATE] | DTHROERR;            # set throughput error bit in state
			$intreg0 = $intreg0 | IMD0;                      # set the ready flipflop
		}
	}
	elsif( $stat == OEXC )                                 # output + exchange
	{
		# move memory buffer into internal device buffer via mpx
		$brkreg = $brkreg | BMD0;                           # set an mpx break request
		activate_event(\@MD0,$MD0[TIME]);                   # schedule next mpx event
	}	
	elsif( $stat == OEXE )
	{
		# write device buffer into the requested sector
		$MD0[STATE] = $MD0[STATE] & 0xFFFF;                 # reset cu state bits
		if(($dn == 0 && $MD0[RDY]) || ($dn == 2 && $MD0[RDY]) ||
			($dn == 1 && $MD2[RDY]) || ($dn == 3 && $MD2[RDY]))
		{
			# check sector identifier as an integrity check. The real 
			# disk has the cylinder number as identifier in the 1st word of the sector.
			# cylinder: on the X1210/1215 cyl number fits in 8 bit; on the X1216 in 10 bit
			my $c = unpack("C",substr($md0buf,0,1)) << 8;  
			my $c = $c | unpack("C",substr($md0buf,1,1));
			my $l = length($md0buf);                         # length of the requested buffer to write
			if($l == 2*LSEC && $c == $cyl)
			{
				# sector format ok, write the sector
				$pos = (($cyl * SPT * NH) + $MD0[SEC]) * LSEC * 2;  # sector position in cylinder
				if($dn==0)
				{
					sysseek(MD0,$pos,0);                       # position and
					$stat = syswrite(MD0, $md0buf, LSEC*2);    # write sector
				}
				elsif($dn==2)
				{
					sysseek(MD1,$pos,0);                       # position and
					$stat = syswrite(MD1, $md0buf, LSEC*2);    # write sector
				}
				elsif($dn==1)
				{
					sysseek(MD2,$pos,0);                       # position and
					$stat = syswrite(MD2, $md0buf, LSEC*2);    # write sector
				}
				elsif($dn==3)
				{
					sysseek(MD3,$pos,0);                       # position and
					$stat = syswrite(MD3, $md0buf, LSEC*2);    # write sector
				}
				
				# and check the result
				if($stat == LSEC*2)
				{
					# internal buffer transferred to disk
					$MD0[STATE]  = ($MD0[STATE] | (WREQ << 16));  # state = wait request
					activate_event(\@MD0, $MD0[RWTIME]);          # schedule event write event
				}
				else
				{
					# incorrect length
					$MD0[STATE] = $MD0[STATE] | (WAIT << 16);  # cu state = wait
					$MD0[STATE] = $MD0[STATE] | DLENGERR;      # set error bit in state
					$intreg0 = $intreg0 | IMD0;                # set the ready flipflop
				}
			}
			else
			{
				# error in the format of the sector buffer to write; not written to disk
				$MD0[STATE] = $MD0[STATE] | (WAIT << 16);     # cu state = wait	
				if($l != 2*LSEC)
				{
					# incorrect length
					$MD0[STATE] = $MD0[STATE] | DLENGERR;      # set error bit in state
				}
				if($c != $cyl)                                # check sector identifier
				{
					# sector identifier in buffer is corrupted => program error
					$MD0[STATE] = $MD0[STATE] | DPROGERR;      # set error bit in state
				}
				$intreg0 = $intreg0 | IMD0;                   # set the ready flipflop
			}
		}
		else
		{
			# active disk not operable
			$MD0[STATE] = $MD0[STATE] | DNOTOP;              # set not operable error bit in state
			$MD0[STATE] = $MD0[STATE] | (WAIT << 16);        # cu state = wait
			$intreg0 = $intreg0 | IMD0;                      # set the ready flipflop
		}
	}
	else
	{
		prlog("Error: MD0 service request with CU in wrong state: $stat\n");
	}
}

sub inr_md0 {
	# byte or word transfer (internal buffer => memory)
	my $t = shift;    # transfer mode: 0=byte, 1=word 
	my $c;
	my $pos = $MD0[XLEN];
	if( $pos < LSEC*2)
	{
		if($t)
		{
			# word transfer
			$c = substr($md0buf,$pos,1);
			$MD0[BUFFER] = unpack("C", $c) << 8;
			$c = substr($md0buf,($pos+1),1);
			$c = unpack("C", $c);
			$MD0[BUFFER] = $MD0[BUFFER] | $c;
			$MD0[XLEN]   = $MD0[XLEN] + 2;
		}
		else
		{
			# byte transfer
			$c = substr($md0buf,$pos,1);
			$MD0[BUFFER] = unpack("C", $c);
			$MD0[XLEN]   = $MD0[XLEN] + 1;
		}
	}
	else
	{
		$MD0[BUFFER] = 0;
	}
}

sub otr_md0 {
	# byte or word transfer (memory => internal buffer)
	my $t = shift;    # transfer mode: 0=byte, 1=word
	my $c;
	if($t)
	{
		# word transfer
		$c = pack("C", (($MD0[BUFFER] >> 8) & 0xFF));
		$md0buf=$md0buf . $c;
		$c = pack("C", ($MD0[BUFFER] & 0xFF));
		$md0buf=$md0buf . $c;
		$MD0[XLEN] = $MD0[XLEN] + 2;
	}
	else
	{

		# byte transfer
		$c = pack("C", ($MD0[BUFFER] & 0xFF));
		$md0buf=$md0buf . $c;
		$MD0[XLEN] = $MD0[XLEN] + 1;
	}
}

sub sst_md0 {
	if( ($MD0[STATE] >> 16) == WAIT)
	{
		# cu in wait state
		$MD0[STATE] = $MD0[STATE] & 0xFFFF;           # cu = inactive
		$R[$r3] = $MD0[STATE];                        # r3 = status
		$intreg0 = $intreg0 & (~ IMD0);               # reset the ready flipflop
		XdSoff();
		$CR = 0;
	}
	else
	{
		$CR = 1;                                      # sst no accepted
	}
}

sub tst_md0 {
	if( ($MD0[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # CU busy, if not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}
	$CR=0;
}

sub state_md0 {
    $t1 = length($md0buf);
	prlog("CU" . prhex(20,$MD0[STATE]) . " CR" . prhex(4,$CR) . " BUFFER-LENGTH" . prhex(8,$t1) . " TRL" . prhex(16,$MD0[XLEN]) . "\n");
	prlog("(Last) selected drive(dn):$MD0[DN] PSector:$MD0[SEC] Cylinder: Unit-0 $MD0[CYL] Unit-1 $MD2[CYL]\n");
	if($MD0[FILE] ne "")
	{
		prlog("Device MD0 (a=0x02 d=0 u=0 dn=0) is attached to file: $MD0[FILE]\n");
	}
	else
	{
		prlog("Device MD0 (a=0x02 d=0 u=0 dn=0) is not attached to a file\n");
	}
	if($MD1[FILE] ne "")
	{
		prlog("Device MD1 (a=0x22 d=1 u=0 dn=2) is attached to file: $MD1[FILE]\n");
	}
	else
	{
		prlog( "Device MD1 (a=0x22 d=1 u=0 dn=2) is not attached to a file\n");
	}
	if($MD2[FILE] ne "")
	{
		prlog("Device MD2 (a=0x12 d=0 u=1 dn=1) is attached to file: $MD2[FILE]\n");
	}
	else
	{
		prlog("Device MD2 (a=0x12 d=0 u=1 dn=1) is not attached to a file\n");
	}
	if($MD3[FILE] ne "")
	{
		prlog("Device MD3 (a=0x32 d=1 u=1 dn=3) is attached to file: $MD3[FILE]\n");
	}
	else
	{
		prlog("Device MD3 (a=0x32 d=1 u=1 dn=3) is not attached to a file\n");
	}
	if($MD0[RDY])
	{
		prlog("X1215/16 disk unit-0 is ready\n");
	}
	else
	{
		prlog("X1215/16 disk unit-0 is NOT ready\n");
	}
	if($MD2[RDY])
	{
		prlog("X1215/16 disk unit-1 is ready\n");
	}
	else
	{
		prlog("X1215/16 disk unit-1 is NOT ready\n");
	}
}

sub reset_md0 {
	$intreg0 = $intreg0 & (~ IMD0);                   # reset the ready flipflop
	$brkreg = $brkreg & (~ BMD0);                     # reset break flipflop
	$MD0[STATE]  = INAC << 16;                        # state = inactive + 0
	$MD0[BUFFER] = 0;                                 # reset buffer
	$MD0[XLEN]   = 0;                                 # reset transferred length
	$MD0[DN]     = 0;                                 # reset to primary device
	$MD0[SEC]    = 0;                                 # reset physical sector
	$MD0[CYL]    = 0;                                 # unit 0 at load point
	$MD2[CYL]    = 0;                                 # unit 1 at load point
	$md0buf      = "";
	XdSoff();
	# if attached, reattach (set file at load point)
	if($MD0[FILE] ne "")
	{
		$file = $MD0[FILE];
		close (MD0) || die "can't close $file: $!";
		open (MD0, "+<:raw", $file) || die "Cannot open  disk file $file: $!";
		prlog("File $file reattached to device MD0\n");
	}
	if($MD1[FILE] ne "")
	{
		$file = $MD1[FILE];
		close (MD1) || die "can't close $file: $!";
		open (MD1, "+<:raw", $file) || die "Cannot open  disk file $file: $!";
		prlog("File $file reattached to device MD1\n");
	}
	if($MD2[FILE] ne "")
	{
		$file = $MD2[FILE];
		close (MD2) || die "can't close $file: $!";
		open (MD2, "+<:raw", $file) || die "Cannot open  disk file $file: $!";
		prlog("File $file reattached to device MD2\n");
	}
	if($MD3[FILE] ne "")
	{
		$file = $MD3[FILE];
		close (MD3) || die "can't close $file: $!";
		open (MD3, "+<:raw", $file) || die "Cannot open  disk file $file: $!";
		prlog("File $file reattached to device MD3\n");
	}
	if($MD0[FILE] ne "" && $MD1[FILE] ne "")
	{
		$MD0[RDY]=1;
		prlog("X1215/16 disk unit-0 is ready\n");
	}
	else
	{
		$MD0[RDY]=0;
		prlog("X1215/16 disk unit-0 is NOT ready\n");
	}
	if($MD2[FILE] ne "" && $MD3[FILE] ne "")
	{
		$MD2[RDY]=1;
		prlog("X1215/16 disk unit-1 is ready\n");
	}
	else
	{
		$MD2[RDY]=0;
		prlog("X1215/16 disk unit-1 is NOT ready\n");
	}	
	
}
#end x12disk.md ===============================================================

###insert crd.md punched card reader
### crd.md
######################### CRD device routines
# The control unit is wired to a multiplex channel; so only an interrupt when the
# cu switches to wait state. Data is transferred to memory from the internal 
# cardreader buffer by the multiplexer/control unit by means of breaks
#
sub cio_crd {
	my $f = shift;                                      # function bit
	my $stat = $CRD[STATE] >> 16;                       # get status/cu state
	if($f == 0)
	{
		# CIO STOP, always accepted
		if(($stat == IEXE) || ($stat == IEXC))
		{
			$CRD[STATE] = $CRD[STATE] | (WREQ << 16);     # state = wait state requested
		}
		$CR = 0;
	}
	elsif($stat == INAC)
	{
		# CIO START INPUT, accepted if state == inactive
	   $CRD[STATE] = (IEXE << 16);                      # state = reset + input + execute
      $crdbuf = "";                                    # reset buffer
		activate_event(\@CRD,$CRD[RTIME]);               # schedule a event, move next card
		$CR = 0;
	}
	else
	{
		$CR = 1;                                         # not accepted                    
	}
}		
		
sub svc_crd {
	my $stat = ($CRD[STATE] >> 16);  
	
	if( $stat & WREQ)
	{
		# stop io requested (CIO stop)
    	$CRD[STATE] = $CRD[STATE] & 0xFFFF;              # reset cu state bits			
		$CRD[STATE] = $CRD[STATE] | (WAIT << 16);        # cu state = wait
		$intreg0 = $intreg0 | ICR;                       # set the ready flipflop			
	}	
	elsif( $stat == IEXE )                              # input + execute
	{
		if($CRD[FILE] eq "")
		{
			# not attached, so not operable
    	   $CRD[STATE] = $CRD[STATE] & 0xFFFF;           # reset cu state bits				
	      $CRD[STATE] = $CRD[STATE] | (WAIT << 16);     # cu state = wait
			$CRD[STATE] = $CRD[STATE] | 1;                # set not operable error bit in state
		   $intreg0 = $intreg0 | ICR;                    # set the ready flipflop	
		}
		else
		{
			# read next card into the device buffer
	      my $fc = $CRD[FC];	
			$CRD[RCLEN] = 0;                              # read length in bytes			
			$stat = read($fc, $crdbuf, 160);
			if($stat == 160)            
			{
				$CRD[BUFFER] = 0;                          # reset word buffer
    	      $CRD[STATE] = $CRD[STATE] & 0xFFFF;        # reset cu state bits					
				$CRD[STATE]  = ($CRD[STATE] | (IEXC << 16));   # state = input + exchange
				# wait for INR
				# schedule next CRD event
				activate_event(\@CRD, $CRD[TIME]);
			}
			else
			{
				# incorrect length (or no card)
    	      $CRD[STATE] = $CRD[STATE] & 0xFFFF;        # reset cu state bits						
				$CRD[STATE] = $CRD[STATE] | (WAIT << 16);  # cu state = wait
				$CRD[STATE] = $CRD[STATE] | 0x20;          # set eof bit in state
		      $intreg0 = $intreg0 | ICR;                 # set the ready flipflop				
			}
		}
	}
	elsif( $stat == IEXC )                              # input + exchange
	{
		if($CRD[BUFFER] == 0)
		{
			$brkreg = $brkreg | BCR;                      # set an mpx break request
			activate_event(\@CRD,$CRD[TIME]);             # schedule next event			
		}
		else
		{
			# throughput error (INR/break did not process)
    	   $CRD[STATE] = $CRD[STATE] & 0xFFFF;           # reset cu state bits				
			$CRD[STATE] = $CRD[STATE] | (WAIT << 16);     # cu state = wait
			$CRD[STATE] = $CRD[STATE] | 2;                # set throughput error bit in state
		   $intreg0 = $intreg0 | ICR;                    # set the ready flipflop			
		}
	}
	else
	{
		prlog("Error: CRD service request with CU in wrong state: $stat\n");
	}
}

sub inr_crd {
	# word transfer is assumed!
   my $pos = $CRD[RCLEN]; 
	my $c;
	if($pos < 159)
	{
		$c = substr($crdbuf,$pos,1);
		$CRD[BUFFER] = unpack("C", $c) << 8;
		$c = substr($crdbuf,($pos+1),1);
		$c = unpack("C", $c);
		$CRD[BUFFER] = $CRD[BUFFER] | $c;
		$CRD[RCLEN] = $CRD[RCLEN] + 2;
	}
	else
	{
		$CRD[BUFFER] = 0;
	}
}

sub sst_crd {
	if( ($CRD[STATE] >> 16) == WAIT)
	{
		# cu in wait state
		$CRD[STATE] = $CRD[STATE] & 0xFFFF;           # cu = inactive
		$R[$r3] = $CRD[STATE];                        # r3 = status
		$intreg0 = $intreg0 & (~ ICR);                # reset the ready flipflop
		$CR = 0;
	}
	else
	{
		$CR = 1;	                                     # sst no accepted
	}	
}

sub tst_crd {
	if( ($CRD[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # busy, if not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}	
	$CR = 0;
}

sub state_crd {
    $t1 = length($crdbuf);
	 prlog("CU" . prhex(20,$CRD[STATE]) . " CR" . prhex(4,$CR) . " BUFFER-LENGTH" . prhex(8,$t1) . " TRL" . prhex(8,$CRD[RCLEN]) . "\n");
    if($CRD[FILE] ne "")
	 {
		prlog("Device CRD is attached to file: $CRD[FILE]\n");
	 }
	 else
	 {
		prlog("Device CRD is not attached to a file\n");
	 }				
}

sub reset_crd {
	$intreg0 = $intreg0 & (~ ICR);                    # reset the ready flipflop
	$brkreg = $brkreg & (~ BCR);                      # reset break flipflop	
	$CRD[STATE]  = INAC << 16;                        # state = inactive + 0
	$CRD[BUFFER] = 0;                                 # reset buffer
	$CRD[RCLEN]  = 0;                                 # reset transferred length
	$crdbuf      = "";
	# if attached, reattach (set file at load point)
	if($CRD[FILE] ne "")
	{
		$file = $CRD[FILE];
		close ($CRD[FC]) || die "can't close $file: $!";
		open (CRD, $file) || die "Cannot open card reader inputfile $file: $!";
		$CRD[FC] = \*CRD;
		binmode $CRD[FC], ":raw";	
		prlog("File $file reattached to device CRD\n");
	}

}
#end crd.md =========================================================================

###insert lpt.md the lineprinter
### lpt.md
# The lineprinter
#===============================================================================
# The lpt control unit is wired to a multiplex channel; so only an interrupt when the
# cu switches to wait state. Data is transferred to the internal lineprinter buffer
# by the multiplexer/control unit by means of breaks
# The 1st 2 bytes in the buffer are interpreted as carriage control characters,
# - 0D0A => skip 1 line, after printing the line
# - 0A0A => skip 2 lines, after printing the line
# - 0D0C => print line and skip to top of next new page
# - 0A0C => print line, skip 1 line and skip to top of next new page
#
sub cio_lpt {
	my $f = shift;                                      # function bit
	my $stat = $LPT[STATE] >> 16;                       # get status/cu state
	if($f == 0)
	{
		# CIO STOP, always accepted
		if(($stat == OEXE) || ($stat == OEXC))
		{
			$LPT[STATE] = $LPT[STATE] | (WREQ << 16);     # state = wait state requested
		}
		$lpt->see('end');
		$CR = 0;
	}
	elsif($stat == INAC)
	{
		# CIO START OUTPUT, accepted if state == inactive
	   $LPT[STATE] = (OEXC << 16);                      # state = reset + output + exchange
      $lptbuf = "";                                    # reset buffer
		activate_event(\@LPT,$LPT[TIME]);                # schedule a event
		$CR = 0;
	}
	else
	{
		$CR = 1;                                         # not accepted                    
	}
}

sub svc_lpt {
	my $stat = ($LPT[STATE] >> 16); 

	if( $stat & WREQ)
    {
		$LPT[STATE] = $LPT[STATE] & 0xFFFF;              # reset cu state bits
		$LPT[STATE] = $LPT[STATE] | (WAIT << 16);        # cu state = wait
		$intreg0 = $intreg0 | ILP;                       # set the ready flipflop	
	}
	elsif( $stat == OEXC )                              # output + exchange
	{
		$brkreg = $brkreg | BLP;                         # set an mpx break request
		activate_event(\@LPT,$LPT[TIME]);                # schedule next event
	}
	elsif( $stat == OEXE )                              # output + execute	
	{
		if($LPT[FILE] eq "")
		{
			# not attached, so not operable
		   $LPT[STATE] = $LPT[STATE] & 0xFFFF;           # reset cu state bits			
	      $LPT[STATE] = $LPT[STATE] | (WAIT << 16);     # cu state = wait
			$LPT[STATE] = $LPT[STATE] | 1;                # set not operable error bit in state
			$intreg0 = $intreg0 | ILP;                    # set the ready flipflop
		}
		else
      {
			my $c1 = ord(substr($lptbuf,0,1));		       # 1st control character
			my $c2 = ord(substr($lptbuf,1,1));		       # 2nd control character
			my $l  = length($lptbuf);
         my $c3 = ord(substr($lptbuf,$l-1,1));	       # last character of the buffer
			
			# skip before printing the buffer
			if($LPT[SKIP] == SKIP_BP)
			{
				if($c1 == 0xA)
				{
					# new line
					pr_lpt("\r\n");
					$LPT[LCUR] = $LPT[LCUR] + 1;
				}
				if($c2 == 0xA)
				{
					# new line
					pr_lpt("\r\n");
					$LPT[LCUR] = $LPT[LCUR] + 1;
				}
				if(($c1== 0xC || $c2 == 0xC) && $LPT[LCUR] != 0)
				{
					# new page if not on new page position
					while( $LPT[LCUR] <=  $LPT[LMAX] + $LPT[NPAG])
					{
						pr_lpt("\r\n");
						$LPT[LCUR] = $LPT[LCUR] + 1;
					}
					$LPT[LCUR] = 0;
				}
				if($LPT[LCUR] >= $LPT[LMAX] )			# end of page ?
				{
					# new page
					while( $LPT[LCUR] <= ( $LPT[LMAX] + $LPT[NPAG]))
					{
						pr_lpt("\r\n");
						$LPT[LCUR] = $LPT[LCUR] + 1;
					}
					$LPT[LCUR] = 0;
				}
			}			
			
			if($LPT[SKIP] == SKIP_NO)
			{
				# no printer control => just print the buffer
				pr_lpt($lptbuf);
         }
			else
			{
				# printer control: either skip before or after print (set by SKIP_BP or SKIP_AP)
            if((($c1 == 0) || ($c1 == 0xA) || ($c1 == 0xD) || ($c1 == 0xC)) &&
               (($c2 == 0) || ($c2 == 0xA) || ($c2 == 0xD) || ($c2 == 0xC)))
            {
               if($l > 2)
               {
                  # strip control characters and print the line
                  $lptbuf = substr($lptbuf,2,$l-2);
                  $l = length($lptbuf);
                  if($l > 1 && ($c3 == 0xA) || ($c3 == 0xD) || ($c3 == 0xC))
                  {
                      $lptbuf = substr($lptbuf,0,$l-1); # strip last char
                      # pr_buf(); # print the buffer; hex
                      pr_lpt($lptbuf);
                  }
                  else
                  {
                    	 # pr_buf(); # print the buffer; hex
                      pr_lpt($lptbuf);
                  }
               }
            }
            else
            {
               if($l > 1 && ($c3 == 0xA) || ($c3 == 0xD) || ($c3 == 0xC))
               {
                  # just print the buffer
                  $lptbuf = substr($lptbuf,0,$l-1); # strip last char
                  pr_lpt($lptbuf);
               }
               else
               {
                  #pr_buf();
                  pr_lpt($lptbuf);
               }
				}
			}
         if($c3 == 0xA)
			{
				# new line
				pr_lpt("\n");
				$LPT[LCUR] = $LPT[LCUR] + 1;
			}            
			if($LPT[LCUR] >= $LPT[LMAX] )			# end of page ?
			{
				# new page
				while( $LPT[LCUR] <= ( $LPT[LMAX] + $LPT[NPAG]))
				{
					pr_lpt("\n");
					$LPT[LCUR] = $LPT[LCUR] + 1;
				}
				$LPT[LCUR] = 0;
			}
         ####################################################
         # remove??? only skip before print??
			# skip page after printing the buffer
			if($LPT[SKIP] == SKIP_AP)
			{
				if($c1 == 0xA)
				{
					# new line
					pr_lpt("\r\n");
					$LPT[LCUR] = $LPT[LCUR] + 1;
				}
				if($c2 == 0xA)
				{
					# new line
					pr_lpt("\r\n");
					$LPT[LCUR] = $LPT[LCUR] + 1;
				}
				if($c2 == 0xC && $LPT[LCUR] != 0)
				{
					# new page if not on new page position
					while( $LPT[LCUR] !=  $LPT[LMAX] + $LPT[NPAG])
					{
						pr_lpt("\r\n");
						$LPT[LCUR] = $LPT[LCUR] + 1;
					}
					$LPT[LCUR] = 0;
				}
				if($LPT[LCUR] == $LPT[LMAX] )			# end of page ?
				{
					# new page
					while( $LPT[LCUR] != ( $LPT[LMAX] + $LPT[NPAG]))
					{
						pr_lpt("\r\n");
						$LPT[LCUR] = $LPT[LCUR] + 1;
					}
					$LPT[LCUR] = 0;
				}
			}
         #########################################################
			$LPT[STATE] = $LPT[STATE] | (WREQ << 16);             # state = wait state requested
			activate_event(\@LPT,$LPT[PTIME]);                    # schedule next event (print time)
		}
	}
	else
	{
		prlog("LP-SVC: Lineprinter CU in unexpected state\n");
	}
}

sub otr_lpt {

	# cu in exchange state (byte transfer is assumed!)
	$lptbuf = $lptbuf . chr($LPT[BUFFER]);
}

sub sst_lpt {
	if( ($LPT[STATE] >> 16) == WAIT)
	{
		# cu in wait state
		$LPT[STATE] = $LPT[STATE] & 0xFFFF;           # cu = inactive
		$R[$r3] = $LPT[STATE];                        # r3 = status
		$intreg0 = $intreg0 & (~ ILP);                # reset the ready flipflop
		$CR = 0;
	}
	else
	{
		$CR = 1;	                                  # sst not accepted
	}	
}

sub tst_lpt {
	if( ($LPT[STATE] >> 16) )
	{
		$R[$r3] = 1;                                  # busy, if not in inactive state
	}
	else
	{
		$R[$r3] = 0;
	}
	$CR = 0;
}

sub state_lpt {
   $t1 = length($lptbuf);
	prlog("CU" . prhex(20,$LPT[STATE]) . " CR" . prhex(4,$CR) . " BUFFER-LENGTH" . prhex(8,$t1) . "\n");
	prlog("BUFFER:" . $lptbuf . "\n");
    if($LPT[FILE] ne "")
	{
		prlog("Device LPT is attached to file: $LPT[FILE]\n");
	}
	else
	{
		prlog("Device LPT is not attached to a file\n");
	}
}

sub reset_lpt {
	$intreg0 = $intreg0 & (~ ILP);                    # reset the ready flipflop
	$brkreg = $brkreg & (~ BLP);                      # reset break flipflop
	$LPT[STATE]  = INAC << 16;                        # state = inactive + 0
   $lptbuf	    = "";                                # reset buffer
	$LPT[LCUR]  = 0;                                  # set on line 0 current page 	
	# if attached, reattach
	if($LPT[FILE] ne "")
	{
		$file = $LPT[FILE];
		close ($LPT[FC]) || die "can't close $file: $!";
		open (LPT, ">$file") || die "Cannot open line printer output file $file: $!";	
		$LPT[FC] = \*LPT;
		prlog("File $file reattached to device LPT\n");
	}
}

sub pr_lpt {
    # print a string on the lpt
    # in case lpt has a window, the string is also printed to that window
    my $str = shift;
    my $fc  = $LPT[FC];
    print $fc $str;
    $lpt->configure(-state=>'normal');
    $lpt->insert('end',$str);
    $lpt->see('end');
    $lpt->update;
    $lpt->configure(-state=>'disabled');
}

# print buffer hex (for debugging)
sub pr_buf {
    my $l = length($lptbuf);
    my $i=0; my $j=0; my $c;
    prlog("\nBUFFER:" . $lptbuf . "\n");
    while($i<$l)
    {
        $c=substr($lptbuf,$i,1);
        $c=unpack("C",$c);
        prlog(prhex(8,$c));
        $i=$i+1;
        $j=$j+1;
        if($j==16)
        {
            prlog("\n");
            $j=0;
        }
    }
    prlog("\n");
}
#end lpt.md =========================================================================

###insert devsubs.md various device driver subroutines
### devsubs.md
# various device driver subroutines
sub prx { 
    my $v = shift;
    my $s = sprintf ("%x", $v);
    prlog($s);
}

sub prhex {
	# print hex
	# $n is number of bits
	# $v is value
	my $n = shift;
	my $v = shift;
	my $s;
	if($n == 0)
	{
		return "";
	}
	elsif($n<5)
	{
		$s = sprintf(" %01X", $v);	
	}
	elsif($n<9)
	{
		$s = sprintf(" %02X", $v);
	}
	elsif($n<13)
	{		
		$s = sprintf(" %03X", $v);
	}
	elsif($n<17)
	{		
		$s = sprintf(" %04X", $v);
	}
	elsif($n<21)
	{
		$s = sprintf(" %05X", $v);
	}
	elsif($n<25)
	{						
		$s = sprintf(" %06X", $v);
	}
	elsif($n<29)
	{		
		$s = sprintf(" %07X", $v);
	}
	elsif($n<33)
	{
		$s = sprintf(" %08X", $v);
	}
	return $s;
}

sub prhex0 {
    ######no spaces around the string#########
	# print hex
	# $n is number of bits
	# $v is value
	my $n = shift;
	my $v = shift;
	my $s;
	if($n == 0)
	{
		return "";
	}
	elsif($n<5)
	{
		$s = sprintf("%01X", $v);	
	}
	elsif($n<9)
	{
		$s = sprintf("%02X", $v);
	}
	elsif($n<13)
	{		
		$s = sprintf("%03X", $v);
	}
	elsif($n<17)
	{		
		$s = sprintf("%04X", $v);
	}
	elsif($n<21)
	{
		$s = sprintf("%05X", $v);
	}
	elsif($n<25)
	{						
		$s = sprintf("%06X", $v);
	}
	elsif($n<29)
	{		
		$s = sprintf("%07X", $v);
	}
	elsif($n<33)
	{
		$s = sprintf("%08X", $v);
	}
	return $s;
}

sub rtrim {
	my $s = shift;
	my $l = length($s);
	my $i = $l;
	if ($l > 0)
	{
		while($i > 0)
		{
			if((substr($s,$i-1,1)) ne " ")
			{ 
				last;
			}
			else
			{
				$i=$i-1;
			}
		}
	}
	else
	{
		return "";
	}
	if($i == 0)
	{
		return "";
	}
	else
	{
		return substr($s,0,$i);
	}
}

sub proct
{
	# convert 16 bit number into an octal string
	my $n=shift;
	$n=$n & 0xFFFF;
	my $d1=$n >> 15 + "0";
	my $d2= (($n >> 12) & 0x7) + "0";
	my $d3= (($n >>  9) & 0x7) + "0";
	my $d4= (($n >>  6) & 0x7) + "0";	
	my $d5= (($n >>  3) & 0x7) + "0";	
	my $d6= ($n & 0x7) + "0";
	return " " . $d1 . $d2 . $d3 . $d4 . $d5 . $d6;
}

sub prdec
{
	# print number
	# $n is number of digits (string)
	# $v is value
	my $n = shift;
	my $v = shift;
	my $s;
	my $format="\%0".$n."d";
	$s = sprintf($format, $v);
	return "  $s  ";
}

sub prdec0
{
   ######no spaces around the string#########
	# print number
	# $n is number of digits (string)
	# $v is value
	my $n = shift;
	my $v = shift;
	my $s;
	my $format="\%0".$n."d";
	$s = sprintf($format, $v);
	return $s;
}

# convert hex string in expression to binary
sub cvhex
{
	my $s = shift;
	my $i=0;
	my $r=0;
	my $d=0;
	my $c;
	if(($c=substr($s,$i,1)) =~ /[0-9A-F]/ )	# at least 1 hex digit required
	{
		while (($c = substr($s,$i,1)) =~ /[0-9A-F]/)
		{
			$d = $cvdig{$c};
			$r = ($r << 4) + $d;
			$i = $i + 1;
		}
		
		if ($r > MAXADDR)
		{
			return -1;
		}
		return $r;
	}
	else
	{
		return -1;
	}
}

# convert decimal string in expression to binary
sub cvdec
{
	my $s = shift;
	my $i=0;
	my $r=0;
	my $d=0;
	my $c;
	if(($c=substr($s,$i,1)) =~ /[0-9]/ )	# at least 1 digit required
	{
		while (($c = substr($s,$i,1)) =~ /[0-9]/)
		{
			$d = $cvdig{$c};
			$r = ($r * 10) + $d;
			$i = $i + 1;
		}
		
		if ($r > MAXADDR)
		{
			return -1;
		}
		return $r;
	}
	else
	{
		return -1;
	}
}

# translate string to upper case
sub UP {
	my $s = shift;
    $_ = $s;
	tr/a-z/A-Z/;
	return $s = $_;
}

# translate string to lower case
sub LOW {
	my $s = shift;
    $_ = $s;
	tr/A-Z/a-z/;
	return $s = $_;
}

sub memchksum{
    my $c = 0;
    my $i = 0;
    while($i < 0x10000)
    {
        $c = $c ^ ($M[$i] & 0xFFFF);
        $i = $i + 2;
    }
    prlog("Memory checksum: " . prhex(16,$c) . "\n");
    return
}

#end devsubs.md ===============================================================

###insert fpp.md the floating point processor
### fpp.md
# The floating point processor


sub load_2nd_operand{
	la_operand(0);				# a = logical address of operand
	$ea  = la2pa($a);           # physical effective address
	$sea = $ea;                 # save
	$FPM1=$M[$ea];
	$ea  = la2pa($a+2);
	$FPM2=$M[$ea];
	$ea  = la2pa($a+4);
	$FPM3=$M[$ea];
	$ea  = $sea;  # restore ea
}

sub store_result_fpp{
	if($ls)
	{
		$ea  = la2pa_store($a);		# physical effective address
		$M[$ea] = $FPB1;
		$ea  = la2pa_store($a+2);
		$M[$ea] = $FPB2;
		$ea  = la2pa_store($a+4);
		$M[$ea] = $FPB3;
		$ea  = $sea;  # restore ea
	}
	else
	{
		$FPA1 = $FPB1;
		$FPA2 = $FPB2;
		$FPA3 = $FPB3;
		$ea   = $sea;  # restore ea
	}
}

sub error_fpp {
	my $code =shift;
	my $s;
    if($code = 0xFFFF)
	{
		prlog("The FPP is not in the configuration\n");
	}
	else
	{
		my $f = $code >> 9;
		if    ($f == 1) { $s = "FLD" } 
		elsif ($f == 3) { $s = "FXX" } 
		elsif ($f == 4) { $s = "FAD/FADR" } 
		elsif ($f == 5) { $s = "FSU/FSUR" } 
		elsif ($f == 6) { $s = "FMU/FMUR" } 
		elsif ($f == 7) { $s = "FDV/FDVR" } 
		else            { $s = " " } 
		$f = ($code & 0x1E);
		if    ($f == 8) { $s = $s . " unnormalized operand value (" }
		elsif ($f == 4) { $s = $s . " division by zero ("}
		elsif ($f == 2) { $s = $s . " overflow ("}
		elsif ($f == 1) { $s = $s . " underflow ("}
		else            { $s = $s . " " }
	}
	$s = $s . prhex0($code) . "\n";
	prlog($s);
	$CR  = 3;
	$RUN = 0; #stop
}

sub reset_fpp
{
	$FPA1=0;
	$FPA2=0;
	$FPA3=0;
	$fppstatus=0;
}

sub fl_add {
	$FPB1=0;
	$FPB2=0;
	$FPB3=0;
	$fppstatus=0;
}

sub fl_sub {
	$FPB1=0;
	$FPB2=0;
	$FPB3=0;
	$fppstatus=0;
}

sub fl_mul {
	$FPB1=0;
	$FPB2=0;
	$FPB3=0;
	$fppstatus=0;
}

sub fl_div {
	$FPB1=0;
	$FPB2=0;
	$FPB3=0;
	$fppstatus=0;
}





#end fpp.md

###insert decode.md The instruction decoder
### decode.md
# The instruction decoder
############################# decoder data #####################################
# direct translated instruction codes

sub initdecoder {
$IDir{0xC020} = 'MUK';
$IDir{0xC820} = 'DVK';
$IDir{0xD020} = 'DAK';
$IDir{0xD820} = 'DSK';
$IDir{0x8F20} = 'ABL';
$IDir{0x8E20} = 'ABL(6)';
$IDir{0x8D20} = 'ABL(5)';
$IDir{0x8C20} = 'ABL(4)';
$IDir{0x8B20} = 'ABL(3)';
$IDir{0x8A20} = 'ABL(2)';
$IDir{0x8920} = 'ABL(1)';
$IDir{0x8820} = 'ABL(0)';
$IDir{0xF021} = 'EXK';
$IDir{0x207F} = 'HLT';
$IDir{0x20BF} = 'INH';
$IDir{0x2840} = 'ENB';
$IDir{0x2804} = 'LKM';
$IDir{0x2801} = 'SMD';
$IDir{0xC900} = 'FFL';
$IDir{0xC901} = 'FFX';
$IDir{0x6800} = 'MVS'; # P854/P858/P859
$IDir{0x6840} = 'MVA'; # P854/P858/P859
$IDir{0x6880} = 'CS';  # P854/P858/P859
$IDir{0x68A0} = 'CA';  # P854/P858/P859

$IDirl{0xC020} = 2;
$IDirl{0xC820} = 2;
$IDirl{0xD020} = 3;
$IDirl{0xD820} = 3;
$IDirl{0x8F20} = 2;
$IDirl{0x8E20} = 2;
$IDirl{0x8D20} = 2;
$IDirl{0x8C20} = 2;
$IDirl{0x8B20} = 2;
$IDirl{0x8A20} = 2;
$IDirl{0x8920} = 2;
$IDirl{0x8820} = 2;
$IDirl{0xF001} = 2;
$IDirl{0x207F} = 1;
$IDirl{0x20BF} = 1;
$IDirl{0x2840} = 1;
$IDirl{0x2804} = 2;
$IDirl{0x2801} = 1;
$IDirl{0xC900} = 1;
$IDirl{0xC901} = 1;
$IDirl{0x6800} = 1;  # P854/P858/P859
$IDirl{0x6840} = 1;  # P854/P858/P859
$IDirl{0x6880} = 1;  # P854/P858/P859
$IDirl{0x68A0} = 1;  # P854/P858/P859

# format 1 long constant instruction codes (r2=0)

$IL1{0x8020} = 'LDKL';
$IL1{0x9020} = 'ADKL';
$IL1{0x9820} = 'SUKL';
$IL1{0xE820} = 'CWK';
$IL1{0xA020} = 'ANKL';
$IL1{0xA820} = 'ORKL';
$IL1{0xB020} = 'XRKL';
$IL1{0xE020} = 'LCK';
$IL1{0xE821} = 'CCK';
$IL1{0xF021} = 'CF';   # r1 # 0 (else EXK: r1=0, r2=0)

# format 1 instructions with r1=0

$ILS{0x9821} = 'C2R';
$ILS{0x9841} = 'C2';
$ILS{0x9861} = 'C2*';
$ILS{0x9021} = 'IMR';
$ILS{0x9041} = 'IM';
$ILS{0x9061} = 'IM*';
$ILS{0xA021} = 'CMR';
$ILS{0xA041} = 'CM';
$ILS{0xA061} = 'CM*';
$ILS{0xF020} = 'RTN';
$ILS{0xF001} = 'EXR';
$ILS{0xF021} = 'EXR*';
$ILS{0xF041} = 'EX';
$ILS{0xF061} = 'EX*';
$ILS{0xB820} = 'TLR';
$ILS{0xB840} = 'TL';
$ILS{0xB860} = 'TL*';
$ILS{0xB821} = 'TSR';
$ILS{0xB841} = 'TS';
$ILS{0xB861} = 'TS*';
$ILS{0xC041} = 'TSB';
$ILS{0xC061} = 'TSB*';
$ILS{0xC021} = 'TSBR';
$ILS{0xC841} = 'TRB';
$ILS{0xC861} = 'TRB*';
$ILS{0xC821} = 'TRBR';
$ILS{0xD041} = 'TB';
$ILS{0xD061} = 'TB*';
$ILS{0xD021} = 'TBR';
$ILS{0xD840} = 'DS';
$ILS{0xD860} = 'DS*';
$ILS{0xD800} = 'DSR';
$ILS{0xD820} = 'DSR*';
$ILS{0xD040} = 'DA';
$ILS{0xD060} = 'DA*';
$ILS{0xD000} = 'DAR';
$ILS{0xD020} = 'DAR*';
$ILS{0xC840} = 'DV';
$ILS{0xC860} = 'DV*';
$ILS{0xC800} = 'DVR';
$ILS{0xC820} = 'DVR*';
$ILS{0xC040} = 'MU';
$ILS{0xC060} = 'MU*';
$ILS{0xC000} = 'MUR';
$ILS{0xC020} = 'MUR*';

$ILS{0xF821} = 'C1RS';	# r1 = 0
$ILS{0xF841} = 'C1S';	# r1 = 0
$ILS{0xF861} = 'C1S*';	# r1 = 0

# format 1 instruction codes, using r1 and r2

$I1{0x8040} = 'LD';
$I1{0x8060} = 'LD*';
$I1{0x8000} = 'LDR';
$I1{0x8020} = 'LDR*';
$I1{0x8041} = 'ST';
$I1{0x8061} = 'ST*';
$I1{0x8021} = 'STR';

$I1{0x9000} = 'ADR';
$I1{0x9020} = 'ADR*';
$I1{0x9021} = 'ADRS';	# r1 # 0
$I1{0x9040} = 'AD';
$I1{0x9041} = 'ADS';	# r1 # 0
$I1{0x9060} = 'AD*';
$I1{0x9061} = 'ADS*';	# r1 # 0

$I1{0x9800} = 'SUR';
$I1{0x9820} = 'SUR*';
$I1{0x9821} = 'SURS';	# r1 # 0
$I1{0x9840} = 'SU';
$I1{0x9841} = 'SUS';	# r1 # 0
$I1{0x9860} = 'SU*';
$I1{0x9861} = 'SUS*';	# r1 # 0

$I1{0xE800} = 'CWR';
$I1{0xE820} = 'CWR*';
$I1{0xE840} = 'CW';
$I1{0xE860} = 'CW*';

$I1{0xF800} = 'C1R';
$I1{0xF820} = 'C1R*';

$I1{0xF840} = 'C1';

$I1{0xF860} = 'C1*';

$I1{0x9801} = 'NGR';

$I1{0xA000} = 'ANR';		# r1 # 0
$I1{0xA020} = 'ANR*';
$I1{0xA021} = 'ANRS';	# r1 # 0
$I1{0xA040} = 'AN';
$I1{0xA041} = 'ANS';		# r1 # 0
$I1{0xA060} = 'AN*';
$I1{0xA061} = 'ANS*';	# r1 # 0

$I1{0xA001} = 'TM';		# r1 # 0

$I1{0xA800} = 'ORR';
$I1{0xA820} = 'ORR*';
$I1{0xA821} = 'ORRS';	# r1 # 0
$I1{0xA840} = 'OR';
$I1{0xA841} = 'ORS';		# r1 # 0
$I1{0xA860} = 'OR*';
$I1{0xA861} = 'ORS*';	# r1 # 0

$I1{0xB000} = 'XRR';		# r1 # 0
$I1{0xB020} = 'XRR*';   # r1 # 0
$I1{0xB021} = 'XRRS';	# r1 # 0
$I1{0xB040} = 'XR';     # r1 # 0
$I1{0xB041} = 'XRS';		# r1 # 0
$I1{0xB060} = 'XR*';    # r1 # 0
$I1{0xB061} = 'XRS*';	# r1 # 0

$I1{0xB001} = 'TNM';		# r1 # 0

$I1{0xE000} = 'ECR';		# r1 # 0
$I1{0xE020} = 'LCR';    # r1 # 0
$I1{0xE021} = 'SCR';		# r1 # 0
$I1{0xE040} = 'LC';     # r1 # 0
$I1{0xE041} = 'SC'; 		# r1 # 0
$I1{0xE060} = 'LC*';    # r1 # 0
$I1{0xE061} = 'SC*';		# r1 # 0

$I1{0xE821} = 'CCR';    # r1 # 0
$I1{0xE841} = 'CC'; 		# r1 # 0
$I1{0xE861} = 'CC*';		# r1 # 0

$I1{0xF001} = 'CFR';    # r1 # 0
$I1{0xF021} = 'CFR*';   # r1 # 0
$I1{0xF041} = 'CFI'; 	# r1 # 0
$I1{0xF061} = 'CFI*';	# r1 # 0

$I1{0xD040} = 'EL';
$I1{0xD060} = 'EL*';
$I1{0xD020} = 'ELR';
$I1{0xD041} = 'ES';
$I1{0xD061} = 'ES*';
$I1{0xD021} = 'ESR';

# format 1 FPP instruction codes using r2 (r1 is nonzero)
$IFPP{0xC120}  = 'FLDR';
$IFPP{0xC140}  = 'FLD';
$IFPP{0xC160}  = 'FLD*';
$IFPP{0xC121}  = 'FSTR';
$IFPP{0xC141}  = 'FST';
$IFPP{0xC161}  = 'FST*';
$IFPP{0xCC20}  = 'FADR';
$IFPP{0xCC21}  = 'FADRS';
$IFPP{0xCC40}  = 'FAD';
$IFPP{0xCC41}  = 'FADS';
$IFPP{0xCC60}  = 'FAD*';
$IFPP{0xCC61}  = 'FADS*';
$IFPP{0xCD20}  = 'FSUR';
$IFPP{0xCD21}  = 'FSURS';
$IFPP{0xCD40}  = 'FSU';
$IFPP{0xCD41}  = 'FSUS';
$IFPP{0xCD60}  = 'FSU*';
$IFPP{0xCD61}  = 'FSUS*';
$IFPP{0xCE20}  = 'FMUR';
$IFPP{0xCE21}  = 'FMURS';
$IFPP{0xCE40}  = 'FMU';
$IFPP{0xCE41}  = 'FMUS';
$IFPP{0xCE60}  = 'FMU*';
$IFPP{0xCE61}  = 'FMUS*';
$IFPP{0xCF20}  = 'FDVR';
$IFPP{0xCF21}  = 'FDVRS';
$IFPP{0xCF40}  = 'FDV';
$IFPP{0xCF41}  = 'FDVS';
$IFPP{0xCF60}  = 'FDV*';
$IFPP{0xCF61}  = 'FDVS*';

# register strings: A0..A15
$R2[0]  = 'A0';
$R2[2]  = 'A1';
$R2[4]  = 'A2';
$R2[6]  = 'A3';
$R2[8]  = 'A4';
$R2[10] = 'A5';
$R2[12] = 'A6';
$R2[14] = 'A7';
$R2[1]  = 'A8';
$R2[3]  = 'A9';
$R2[5]  = 'A10';
$R2[7]  = 'A11';
$R2[9]  = 'A12';
$R2[11] = 'A13';
$R2[13] = 'A14';
$R2[15] = 'A15';

# register strings: A0..A7
$R3[0] = 'A0';
$R3[1] = 'A1';
$R3[2] = 'A2';
$R3[3] = 'A3';
$R3[4] = 'A4';
$R3[5] = 'A5';
$R3[6] = 'A6';
$R3[7] = 'A7';

# condition codes: (0)..(7)
$CND[0] = '(0)';
$CND[1] = '(1)';
$CND[2] = '(2)';
$CND[3] = '(3)';
$CND[4] = '(4)';
$CND[5] = '(5)';
$CND[6] = '(6)';
$CND[7] = '(7)';
}


sub decode {
    # decodes the instruction at logical address $pcl
    # This also is the instruction in physical address $pcp
    # So on entrance: $pcp = physical($pcl)
    # However to extract the operands from memory for the instruction 
    # at $pcp to decode, $pcl is used ($pcp does not (always) work for that).
    #
    
    #######my $PC = la2pa($pcl);
    my $PC = $pcp; ## for RTN A15 which sometimes changes the E-bit which results in a different pcp
    my $M  = $M[$PC] & 0xFFFF;
    my $s1 = " --" . prhex(16,$pcl) . prhex(20,$PC);
    my $s2 = "    " . prhex(16,$M);
    my $str= chars($M);
    my $s;
    my $l;
	 my $nl = "\n";
    my $result1 = $s1 . $s2 . $str;
    my $result2 = "";
    $pcl=$pcl+2;
    
    if($M == 0)
    {
        $s = "DATA 0";
        $result1 = $result1 . $s;
    }
    elsif($IDir{$M} ne undef)
    {
        # direct printable instruction
        $s=$IDir{$M};
        $result1 = $result1 . $s;
        $l=$IDirl{$M};
        if($l>1)
        {
            $PC = la2pa($pcl); # physical operand address
            $M = $M[$PC];      # operand
            $str=chars($M);    # operand translated to characters
            $result1 = $result1 . ' ' . prhex(16,$M);
            $result2 = "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) . $str;
            $pcl=$pcl+2;
        }
        if($l>2)
        {
            $PC = la2pa($pcl);
            $M = $M[$PC];
            $str=chars($M);				
            $result1 = $result1 . ',' . prhex(16,$M);
            $result2 = $result2 . $nl . "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) . $str;			
            $pcl=$pcl+2;
        }
        if($ea ne undef)
        {
            $result1 = $result1 . "   Physical EA: " . prhex(20,$ea);
        }
        if($result2 ne "")
        {
            $result1 =  $result1 . $nl . $result2;
        }
    }
    else
    {
        $s = decodeformat0($M);
        if($s)
        {
            $result1 = $result1 . $s;
        }
        else
        {
            $s = decodeformat1($M);
            if($s)
            {
                $result1 = $result1 . $s;
            }
            else
            {
                $s = "DATA  " . prhex(16,$M);
                $result1 = $result1 . $s;
            }
        }
    }
    return $result1;
}

sub chars
{
	my $cc = shift;
	my $c = $cc >> 8;
	my $str = "  ";
	if($ch{$c} ne undef)
	{
		$str = $str . $ch{$c};
	}
	else
	{
		$str = $str . '.';
	}
	$c = $cc & 0xFF;
	if($ch{$c} ne undef)
	{
		$str = $str . $ch{$c};
	}
	else
	{
		$str = $str . '.';
	}
	$str = $str . '| ';
	return $str;
}

sub decodeformat0
{
	my $ir  = shift;
	if($ir & 0x8000) # format 0 ?
	{
		return "";    # no => format 1
	}
	my $opc = ($ir & 0xF800) >> 11;
	my $r3  = ($ir & 0x0700) >> 8;
	my $k   = $ir & 0xFF;
	my $r2;
	my $D;
	my $s;
	my $dev;
	my $n;
	my $sc;
	my $loc;
	
	if($opc == 0)
	{
		# LDK r3,k
		$s= 'LDK ';
		$s= $s . $R3[$r3] . ',' . prhex0(8,$k);
		#print $s;
		return $s;
	}
	elsif($opc == 1)
	{
		# AB cnd,k		
		$s = 'AB';
		$s= $s . $CND[$r3] . ' ' . prhex0(8,$k);
		#print $s;			
		return $s;	
	}
	elsif($opc == 2)
	{
		# ADK r3,k
		$s= 'ADK ';
		$s= $s . $R3[$r3] . ',' . prhex0(8,$k);
		#print $s;
		return $s;		
	}	
	elsif($opc == 3)
	{
		# SUK r3,k
		$s= 'SUK ';
		$s= $s . $R3[$r3] . ',' . prhex0(8,$k);
		#print $s;
		return $s;		
	}
	elsif($opc == 4)
	{
		# ANK r3,k
		# RIT k
		$ir=$ir & 0xFFC0;
		if($ir == 0x20C0)
		{
			$s = 'RIT ';
			$s= $s . prhex0(8,$k);
		}
		else
		{
			$s = 'ANK ';
			$s= $s . $R3[$r3] . ',' . prhex0(8,$k);
		}
		#print $s;
		return $s;			
	}	
	elsif($opc == 5)
	{
		# ORK r3,k
		$s= 'ORK ';
		$s= $s . $R3[$r3] . ',' . prhex0(8,$k);
		#print $s;
		return $s;			
	}		
	elsif($opc == 6)
	{
		# XRK r3,k
		$s= 'XRK ';
		$s= $s . $R3[$r3] . ',' . prhex0(8,$k);
		#print $s;
		return $s;			
	}
	elsif($opc == 7)
	{
		# shift instructions
		$sc = ($ir & 0xE0) >> 5;  # shift code
		$n  = $ir & 0x1F;         # nbr of shifts      
		$r2 = ($n & 0x1E) >> 1;
		# print "sc=$sc n=$n r3=$r3\n";
		if($r3 == 0)
		{
			# double shifts
			if($sc == 0)
			{
				$s = 'DLA ';
			}
			elsif($sc == 1)
			{
				$s = 'DRA ';
			}
			elsif($sc == 2)
			{
				$s = 'DLL ';
			}
			elsif($sc == 3)
			{
				$s = 'DRL ';
			}
			elsif($sc == 6)
			{
				$s = 'DLC ';
			}			
			elsif($sc == 7)
			{
				$s = 'DRC ';
			}
			else
			{
				if($sc == 4)
				{
					$s = 'DLN ';
				}
				elsif($sc == 5)
				{
					$s = 'DRN ';
				}
				else
				{
					prlog("Instruction Decode Error: Shift Double\n");
					return "";
				}
				$s=$s . $R2[$r2];
				#print $s;
				return $s;				
			}
			$s=$s . prhex(8,$n);
			#print $s;
			return $s;
		}
		else
		{
			if($sc == 0)
			{
				$s = 'SLA ';
			}
			elsif($sc == 1)
			{
				$s = 'SRA ';
			}
			elsif($sc == 2)
			{
				$s = 'SLL ';
			}
			elsif($sc == 3)
			{
				$s = 'SRL ';
			}
			elsif($sc == 6)
			{
				$s = 'SLC ';
			}			
			elsif($sc == 7)
			{
				$s = 'SRC ';
			}
			else
			{
				if($sc == 4)
				{
					$s = 'SLN ';
				}
				elsif($sc == 5)
				{
					$s = 'SRN ';
				}
				else
				{
					prlog("Instruction Decode Error: Shift Single\n");
					return "";
				}
				$s=$s . $R3[$r3] . ',' . $R2[$r2];
				#print $s;
				return $s;				
				
			}
			$s=$s . $R3[$r3] . ',' . prhex0(8,$n);
			#print $s;
			return $s;
		}
	}
	elsif($opc == 8)
	{
		# CIO r3,f,dev		
		# OTR r3,f,dev
		if($ir & 0x80)
		{
			# CIO
			$s = 'CIO ';
		}
		else
		{
			# OTR
			$s = 'OTR ';
		}
		$s = $s . $R3[$r3];
		if($ir & 0x40)
		{
			# f=1
			$s=$s . ',1';
		}
		else
		{	
			# f=0
			$s=$s . ',0';
		}
		$dev=$ir & 0x3F;
		$s=$s . ',' . prhex0(8,$dev);
		#print $s;
		return $s;		
	}		
	elsif($opc == 9)
	{
		# INR r3,f,dev
		# SST r3,dev
		# TST r3,dev
		if($ir & 0x80)
		{
			# SST r3,dev
			# TST r3,dev
			if($ir & 0x40)
			{
				$s = 'SST ';
			}
			else
			{
				$s = 'TST ';
			}
			$s = $s . $R3[$r3];	
			$dev=$ir & 0x3F;
			$s=$s . ',' . prhex0(8,$dev);
			#print $s;
			return $s;				
		}
		else
		{
			# INR r3,f,dev
			$s = 'INR ';
			$s = $s . $R3[$r3];
			if($ir & 0x40)
			{
				# f=1
				$s=$s . ',1';
			}
			else
			{	
				# f=0
				$s=$s . ',0';
			}
			$dev=$ir & 0x3F;
			$s=$s . ',' . prhex0(8,$dev);
			#print $s;
			return $s;					
		}
	}	
	elsif($opc == 0xA)
	{
		# RF cond,D	
		$s = 'RF';
		$D = $k + 2;
		$loc = $pcl + $k;		
		$s= $s . $CND[$r3] . ' ' . '*+' . prhex0(8,$D);
		$s = $s . ' [logical' . prhex(16,$loc) . ']';
		#print $s;
		return $s;			
	}		
	elsif($opc == 0xB)
	{
		# RB cond,D
		$s = 'RB';
		$D = $k - 2;
		$loc = $pcl - $k;
		$s = $s . $CND[$r3] . ' ' . '*-' . prhex0(8,$D);
		$s = $s . ' [logical:' . prhex(16,$loc) . ']';
		#print $s;
		return $s;			
	}
	elsif($opc == 0xD)
	{
		# string MVS
		# string MVA
		# string CS
		# string CA
        # printed directly
	}	
	elsif($opc == 0xE)
	{
		# WER r3,addr
		# move table forward MVF
		# move table from system to user area MVSU
		$r2=($ir & 0x1E) >> 1;
		$ir=$ir & 0xF080;
        if($r3 == 0)
        {
            if($ir == 0x7000)
            {
                # MVF
                $s = 'MVF ';
                $s = $s . $R2[$r2];
                #print $s;
                return $s;				
            }
            elsif($ir == 0x7080)
            {
                # MVSU
                $s = 'MVSU ';
                $s = $s . $R2[$r2];	
                #print $s;
                return $s;				
            }
            else
            {
                return "";
            }
        }
		else
		{
			$s = 'WER ';
			$s = $s . $R3[$r3] . ',' . prhex0(8,$k);
			#print $s;
			return $s;
		}
	}	
	elsif($opc == 0xF)
	{
		# RER r3,addr
		# move table backward MVB
		# move table from user to system area MVUS
		$r2=($ir & 0x1E) >> 1;
		$ir=$ir & 0xF080;
        if($r3 == 0)
        {
            if($ir == 0x7000)
            {
                # MVB
                $s = 'MVB ';
                $s = $s . $R2[$r2];
                #print $s;
                return $s;				
            }
            elsif($ir == 0x7080)
            {
                # MVUS
                $s = 'MVUS ';
                $s = $s . $R2[$r2];	
                #print $s;
                return $s;
			}
            else
            {
                return "";
            }
		}
		else
		{
			$s = 'RER ';
		    $s = $s . $R3[$r3] . ',' . prhex0(8,$k);
			#print $s;
			return $s;
		}			
	}	
	return "";
}

sub f1fpp
{
	# decode the floating [point instructions
   my $ir = shift;
	my $M;
	my $PC = la2pa($pcl);
   my $r2 = ($ir & 0x001E) >> 1;
	my $md  = ($ir & 0x60)   >> 5;
	my $opc= $ir & 0xFFE1;
	my $s1="";
	my $s="";
	my $nl = "\n";
	my $str;
	if($IFPP{$opc} ne undef)
	{
		$s=$IFPP{$opc};
		if($md == 2 || $md == 3)
		{
         # operand
         $PC = la2pa($pcl); # address
			$M = $M[$PC];
			$str=chars($M);
         $s=$s . ' ' . prhex0(16,$M);
			$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;				
			$pcl=$pcl+2;
			if($r2 != 0)
			{
				$s=$s . ',' . $R2[$r2];
			}
         if($ea ne undef)
         {
            $s = $s . "   Physical EA: " . prhex(20,$ea);
         }
		}
		else
		{
			$s=$s . ',' . $R2[$r2];
			if($ea ne undef)
         {
            $s = $s . "   Physical EA: " . prhex(20,$ea);
         }
			$s1="";
		}
		if($s1 ne "")
		{
         $s = $s . $nl . $s1;
		}
		return $s;
	}
}


sub decodeformat1
{
	my $ir  = shift;
   my $M;
   my $PC  = la2pa($pcl);
	my $opc = ($ir & 0x7800) >> 11;
	my $r1  = ($ir & 0x0780) >> 7;
	my $r2  = ($ir & 0x001E) >> 1;
	my $md  = ($ir & 0x60)   >> 5;
	my $iml = $ir & 0xF87F;   # long constant instr mask (mask r1)
	my $ims = $ir & 0xFFE1;   # mask instr with r1=0 (mask r2)
	my $im1 = $ir & 0xF861;   # r1-r2 instr mask
   my $nl = "\n";
   my $str;
	my $s="";
   my $s1="";

	if($s = f1exp($ir))    # exceptions
	{
		return $s;          # format 1 exeptions: ABL, LDA and ML/MS
	}
	elsif($s = f1fpp($ir)) # floating point instructions
	{
		return $s;
	}
	elsif($IL1{$iml} ne undef) # check 1st for a long constant instruction (r2 == 0)
	{
		# long constant instructions (r2==0)
		$s=$IL1{$iml};      # code
      # operand
      $PC = la2pa($pcl);  # address
		$M = $M[$PC];
		$str=chars($M);
      if($ea ne undef)
      {
          $s=$s . ' ' . $R2[$r1] . ',' . prhex0(16,$M) . "   Physical EA: " . prhex(20,$ea);
      }
      else
      {
          $s=$s . ' ' . $R2[$r1] . ',' . prhex0(16,$M);
      }
		$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) . $str;
		$pcl=$pcl+2;
		return $s . $nl . $s1;
	}
	elsif($ILS{$ims} ne undef)
	{
		# instr with r1 == 0
		$s=$ILS{$ims};
		if($md == 2 || $md == 3)
		{
         # operand
         $PC = la2pa($pcl); # address
			$M = $M[$PC];
			$str=chars($M);
         $s=$s . prhex(16,$M);
			$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) . $str;			
			$pcl=$pcl+2;
			if($r2 != 0)
			{
				$s=$s . ',' . $R2[$r2];
			}
         if($ea ne undef)
         {
            $s = $s . "   Physical EA: " . prhex(20,$ea);
         }
		}
		else
		{
			$s=$s . ' ' . $R2[$r2];
			$s1="";
		}
		if($s1 ne "")
		{
         $s = $s . $nl . $s1;
		}
		return $s;
	}
	elsif($I1{$im1} ne undef)
	{
		# normal format 1 instr with both r1 and r2
		$s=$I1{$im1};
		if($md == 2 || $md == 3)
		{
         # operand
         $PC = la2pa($pcl); # address
			$M = $M[$PC];
			$str=chars($M);
         $s=$s . ' ' . $R2[$r1] . ',' . prhex0(16,$M);
			$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;				
			$pcl=$pcl+2;
			if($r2 != 0)
			{
				$s=$s . ',' . $R2[$r2];
			}
         if($ea ne undef)
         {
            $s = $s . "   Physical EA: " . prhex(20,$ea);
         }
		}
		else
		{
			$s=$s . ' ' . $R2[$r1] . ',' . $R2[$r2];
			$s1="";
		}
		if($s1 ne "")
		{
         $s = $s . $nl . $s1;
		}
		return $s;
	}	
	return "";
}

# format 1 exceptions
sub f1exp
{
	my $ir  = shift;
   my $M;
   my $PC;
   my $str;
	my $opc = ($ir & 0x7800) >> 11;
	my $n   = ($ir & 0x0780) >> 7;
   my $r1  = ($ir & 0x0780) >> 7;
	my $r2  = ($ir & 0x001E) >> 1;
	my $md  = ($ir & 0x60)   >> 5;
	my $cnd = $n >> 1;
   my $nl  = "\n";
	my $s;	
	my $s1  = "";
	my $i;
	
	if(($opc == 1) && (($ir & 1) == 0))
	{
		# absolute conditional branch
		if($md == 0)
		{
			$s = 'ABR';
			$s = $s . $CND[$cnd] . ' ' . $R2[$r2];
		}
		elsif($md == 1)
		{
			$s = 'ABR';
         if($ea ne undef)
         {
            $s = $s . $CND[$cnd] . '* ' . $R2[$r2]. "   Physical EA: " . prhex(20,$ea);
         }
         else
         {
            $s = $s . $CND[$cnd] . '* ' . $R2[$r2];
         }
		}
		elsif($md == 2)
		{
			$s = 'ABI';
			$s = $s . $CND[$cnd];
         $PC = la2pa($pcl); # address
			$M = $M[$PC];
			$str=chars($M);			
			$s=$s . ' ' . prhex(16,$M);
			$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) . $str;				
			$pcl=$pcl+2;
			if($r2 != 0)
			{
				$s=$s . ',' . $R2[$r2];
			}
         if($ea ne undef)
         {
            $s = $s . "   Physical EA: " . prhex(20,$ea);
         }            
		}
		elsif($md == 3)
		{
			$s = 'ABI';
			$s = $s . $CND[$cnd] . '*';
         $PC = la2pa($pcl); # address
			$M = $M[$PC];
			$str=chars($M);			
			$s=$s . ' ' . prhex(16,$M);
			$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) . $str;				
			$pcl=$pcl+2;
			if($r2 != 0)
			{
				$s=$s . ',' . $R2[$r2];
			}
         if($ea ne undef)
         {
            $s = $s . "   Physical EA: " . prhex(20,$ea);
         }            
		}
		if($s1 ne "")
		{
         $s = $s . $nl . $s1;
		}		
		return $s;
	}
	elsif($opc == 7)
	{
      if($r1 == 0)
      {
         return 0;
      }
		# ML/MS
		if($ir & 1)
		{
			# MS
			if($md == 1)
			{
				$s='MSR ';
            if($ea ne undef)
            {
                $s=$s . prdec0(2,$n) . ',' . $R2[$r2] . "   Physical EA: " . prhex(20,$ea);
            }
            else
            {
                $s=$s . prdec0(2,$n) . ',' . $R2[$r2];
            }
				return $s;
			}
			elsif($md == 2)
			{
				$s='MS ';
            $PC = la2pa($pcl); # address
				$M = $M[$PC];
				$str=chars($M);				
				$s=$s . prdec0(2,$n) . ',' . prhex0(16,$M);
				$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;
				$pcl=$pcl+2;
				if($r2 != 0)
				{
					$s=$s . ',' . $R2[$r2];
				}
            if($ea ne undef)
            {
               $s = $s . "   Physical EA: " . prhex(20,$ea);
            }
				if($s1 ne "")
				{
               $s = $s . $nl . $s1;
				}
				return $s;
			}
			elsif($md == 3)
			{
				$s='MS* ';
            $PC = la2pa($pcl); # address
				$M = $M[$PC];
				$str=chars($M);				
				$s=$s . prdec0(2,$n) . ',' . prhex0(16,$M);
				$s1="   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;
				$pcl=$pcl+2;
				if($r2 != 0)
				{
					$s=$s . ',' . $R2[$r2];
				}
            if($ea ne undef)
            {
               $s = $s . "   Physical EA: " . prhex(20,$ea);
            }
				if($s1 ne "")
				{
               $s = $s . $nl . $s1;
				}
				return $s;
			}
			else
			{
				return "";
			}
		}
		else
		{
			# ML
			if($md == 1)
			{
				if($r2 == 0)
				{
					# MLK	
					$s='MLK ';
					$s=$s . prdec0(2,$n);
               if($ea ne undef)
               {
                  $s=$s . "   Physical EA: " . prhex(20,$ea);
               }
               $i=0;
					while($i<$n)
					{
						$s = $s . $nl;
                  $PC = la2pa($pcl); # address
						$M = $M[$PC];
						$str=chars($M);						
						$s=$s . "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;
						$pcl=$pcl+2;
						$i=$i+1;
					}
					return $s;
				}
				else
				{
					# MLR
					$s='MLR ';
               if($ea ne undef)
               {
                  $s=$s . prdec0(2,$n) . ',' . $R2[$r2] . "   Physical EA: " . prhex(20,$ea);
               }
               else
               {
                  $s=$s . prdec0(2,$n) . ',' . $R2[$r2];
               }
					return $s;
				}
			}
			elsif($md == 2)
			{
				# ML
				$s='ML ';
            $PC = la2pa($pcl); # address
				$M = $M[$PC];
				$str=chars($M);				
				$s=$s . prdec0(2,$n) . ',' . prhex(16,$M);
				$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;
				$pcl=$pcl+2;
				if($r2 != 0)
				{
					$s=$s . ',' . $R2[$r2];
				}
            if($ea ne undef)
            {
               $s = $s . "   Physical EA: " . prhex(20,$ea);
            }
				if($s1 ne "")
				{
		         $s = $s . $nl. $s1;
				}
				return $s;
			}
			elsif($md == 3)
			{
				# ML*
				$s='ML* ';
            $PC = la2pa($pcl); # address
				$M = $M[$PC];
				$str=chars($M);				
				$s=$s . prdec(2,$n) . ',' . prhex(16,$M);
				$s1= "   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;
				$pcl=$pcl+2;
				if($r2 != 0)
				{
					$s=$s . ',' . $R2[$r2];
				}
				if($ea ne undef)
            {
               $s = $s . "   Physical EA: " . prhex(20,$ea);
            }
            if($s1 ne "")
				{
		         $s = $s . $nl. $s1;
				}
				return $s;
			}
       }
    }
    elsif($opc == 14)
    {
        if($r1 != 0 && (($ir & 1) == 0))
        {
            # LDA (LDA r1,D,r2)
            $s='LDA ';
            $PC = la2pa($pcl); # address
            $M = $M[$PC];
            $s=$s . ' ' . $R2[$r1] . ',' . prdec(5,$M). ',' . $R2[$r2];
            $str=chars($M);
            $s1="   " . prhex(16,$pcl) . prhex(20,$PC) . '    ' . prhex(16,$M) .  $str;
            $pcl=$pcl+2;
            return $s;
        }
        return "";
    }
	 else
	 {
		 return "";
	 }
	 return "";
}
#end decode.md ==========================================================================

